
//
// @(#)btyaccpar, based on byacc 1.8 (Berkeley)
// Parser skeleton modified for use in the Firebird project by Nickolay Samofatov
//
#define YYBTYACC 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dsql.tab.h"

#define YYERROR_DETAILED

typedef int Yshort;

/* 
*	PROGRAM:	Dynamic SQL runtime support
*	MODULE:		parse.y
*	DESCRIPTION:	Dynamic SQL parser
*
* The contents of this file are subject to the Interbase Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy
* of the License at http://www.Inprise.com/IPL.html
*
* Software distributed under the License is distributed on an
* "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
* or implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The Original Code was created by Inprise Corporation
* and its predecessors. Portions created by Inprise Corporation are
* Copyright (C) Inprise Corporation.
*
* All Rights Reserved.
* Contributor(s): ______________________________________.
*
* 2002-02-24 Sean Leyne - Code Cleanup of old Win 3.1 port (WINDOWS_ONLY)
* 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
* 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
*   different node types so DDL can tell which is which.
* 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
* 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
* 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
* 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
* 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
* 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
*   in rdb$*_source fields when altering domains plus one unexpected null pointer.
* 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
*   and not in gen.c; this closes Bug #450301.
* 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
* 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
* 2002.07.05 Mark O'Donohue: change keyword DEBUG to KW_DEBUG to avoid
*			clashes with normal DEBUG macro.
* 2002.07.30 Arno Brinkman:  
* 2002.07.30 	Let IN predicate handle value_expressions
* 2002.07.30 	tokens CASE, NULLIF, COALESCE added
* 2002.07.30 	See block < CASE expression > what is added to value as case_expression
* 2002.07.30 	function is split up into aggregate_function, numeric_value_function, string_value_function, generate_value_function
* 2002.07.30 	new group_by_function and added to grp_column_elem
* 2002.07.30 	cast removed from function and added as cast_specification to value
* 2002.08.04 Claudio Valderrama: allow declaring and defining variables at the same time
* 2002.08.04 Dmitry Yemanov: ALTER VIEW
* 2002.08.06 Arno Brinkman: ordinal added to grp_column_elem for using positions in group by
* 2002.08.07 Dmitry Yemanov: INT64/LARGEINT are replaced with BIGINT and available in dialect 3 only
* 2002.08.31 Dmitry Yemanov: allowed user-defined index names for PK/FK/UK constraints
* 2002.09.01 Dmitry Yemanov: RECREATE VIEW
* 2002.09.28 Dmitry Yemanov: Reworked internal_info stuff, enhanced
*							exception handling in SPs/triggers,
*							implemented ROWS_AFFECTED system variable
* 2002.10.21 Nickolay Samofatov: Added support for explicit pessimistic locks
* 2002.10.29 Nickolay Samofatov: Added support for savepoints
* 2002.12.03 Dmitry Yemanov: Implemented ORDER BY clause in subqueries.
* 2002.12.18 Dmitry Yemanov: Added support for SQL-compliant labels and LEAVE statement
* 2002.12.28 Dmitry Yemanov: Added support for parametrized events.
* 2003.01.14 Dmitry Yemanov: Fixed bug with cursors in triggers.
* 2003.01.15 Dmitry Yemanov: Added support for runtime trigger action checks.
* 2003.02.10 Mike Nordell  : Undefined Microsoft introduced macros to get a clean compile.
* 2003.05.24 Nickolay Samofatov: Make SKIP and FIRST non-reserved keywords
* 2003.06.13 Nickolay Samofatov: Make INSERTING/UPDATING/DELETING non-reserved keywords
* 2003.07.01 Blas Rodriguez Somoza: Change DEBUG and IN to avoid conflicts in win32 build/bison
* 2003.08.11 Arno Brinkman: Changed GROUP BY to support all expressions and added "AS" support
*						   with table alias. Also removed group_by_function and ordinal.
* 2003.08.14 Arno Brinkman: Added support for derived tables.
* 2003.10.05 Dmitry Yemanov: Added support for explicit cursors in PSQL.
* 2004.01.16 Vlad Horsun: added support for default parameters and 
*   EXECUTE BLOCK statement
* Adriano dos Santos Fernandes
*/

#include "firebird.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "gen/iberror.h"
#include "../dsql/dsql.h"
#include "../jrd/ibase.h"
#include "../jrd/flags.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/keywords.h"
#include "../dsql/misc_func.h"
#include "../jrd/gds_proto.h"
#include "../jrd/thd.h"
#include "../jrd/err_proto.h"
#include "../jrd/intlobj_new.h"

/* since UNIX isn't standard, we have to define
  stuff which is in <limits.h> (which isn't available
  on all UNIXes... */

const long SHRT_POS_MAX			= 32767;
const long SHRT_UNSIGNED_MAX	= 65535;
const long SHRT_NEG_MAX			= 32768;
const long LONG_POS_MAX			= 2147483647;
const int POSITIVE	= 0;
const int NEGATIVE	= 1;
const int UNSIGNED	= 2;

/*const int MIN_CACHE_BUFFERS	= 250;*/
/*const int DEF_CACHE_BUFFERS	= 1000;*/

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE	2048
#define YYMAXDEPTH	2048

/* Make bison allocate static stack */
#define YYINITDEPTH 2048

/* Using this option causes build problems on Win32 with bison 1.28*/
/*#define YYSTACK_USE_ALLOCA 1*/

typedef dsql_nod* YYSTYPE;
#define YYSTYPE YYSTYPE
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

#define YYMALLOC gds__alloc
#define YYFREE gds__free

static const char INTERNAL_FIELD_NAME[] = "DSQL internal"; /* NTX: placeholder */

inline SLONG trigger_type_suffix(const int slot1, const int slot2, const int slot3)
{
	return ((slot1 << 1) | (slot2 << 3) | (slot3 << 5));
}


dsql_nod* DSQL_parse;


#define YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous

#include "../dsql/chars.h"

const int MAX_TOKEN_LEN = 256;

static const TEXT* lex_position();
#ifdef NOT_USED_OR_REPLACED
static bool		long_int(dsql_nod*, SLONG*);
#endif
static dsql_fld*	make_field (dsql_nod*);
static dsql_fil*	make_file();
static dsql_nod*	make_list (dsql_nod*);
static dsql_nod*	make_node (NOD_TYPE, int, ...);
static dsql_nod*	make_parameter (void);
static dsql_nod*	make_flag_node (NOD_TYPE, SSHORT, int, ...);
static void	prepare_console_debug (int, int  *);
#ifdef NOT_USED_OR_REPLACED
static bool	short_int(dsql_nod*, SLONG*, SSHORT);
#endif
static void	stack_nodes (dsql_nod*, DsqlNodStack&);
inline static int	yylex (USHORT, USHORT, USHORT, bool*);

static void	yyerror(const TEXT*);
static void	yyabandon (SLONG, ISC_STATUS);

inline void check_bound(const char* const to, const char* const string)
{
	if ((to - string) >= MAX_TOKEN_LEN)
		yyabandon (-104, isc_token_too_long);
}

inline void check_copy_incr(char*& to, const char ch, const char* const string)
{
	check_bound(to, string); 
	*to++ = ch;
}

struct LexerState {
	/* This is, in fact, parser state. Not used in lexer itself */
	dsql_fld* g_field;
	dsql_fil* g_file;
	dsql_nod* g_field_name;
	int dsql_debug;
	
	/* Actual lexer state begins from here */
	const TEXT* beginning;
	const TEXT* ptr;
	const TEXT* end;
	const TEXT* last_token;
	const TEXT* line_start;
	const TEXT* last_token_bk;
	const TEXT* line_start_bk;
	SSHORT	lines, att_charset;
	SSHORT	lines_bk;
	int  prev_keyword;
	USHORT	param_number;
	
	int yylex (
		USHORT	client_dialect,
		USHORT	db_dialect,
		USHORT	parser_version,
		bool* stmt_ambiguous);
};

/* Get ready for thread-safety. Move this to BISON object pointer when we 
  switch to generating "pure" reenterant parser. */
static LexerState lex;

static int yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,   11,   11,   11,   26,   26,
   25,   25,   25,   35,   35,   30,   36,   36,   36,   36,
   36,   29,   29,   34,   34,   31,   17,   17,   17,   39,
   39,   40,   40,   28,   28,   41,   41,   41,   41,   43,
   43,   43,   43,   42,   42,   44,   44,   44,   32,   32,
   49,   33,   33,   50,   50,    8,   51,   51,   53,   58,
   58,   58,   55,   55,   55,   62,   62,   63,   65,   65,
   65,   65,   56,   56,   66,   66,   67,   67,   67,   67,
   67,   52,   69,   69,    6,   71,   71,   71,   71,   71,
   71,   71,   71,   71,   71,   71,   71,   71,   71,   16,
   88,   88,   88,   88,   88,   88,    7,   95,   95,   95,
   72,   94,   98,  100,   73,   73,   76,   76,   76,   85,
  107,  107,  107,  108,  108,  109,  109,  110,  110,  114,
  114,   84,  117,  117,  123,  119,  119,  121,  121,  125,
  125,  126,  127,  127,  128,  129,   82,   86,   87,  134,
  134,  134,  135,  135,  137,  137,  138,  138,  138,  139,
  139,  140,  140,  141,  141,  136,  136,   83,  111,  111,
  142,  143,  143,  145,  145,  146,  146,  146,  146,  146,
  144,  144,  147,  147,  148,  148,  148,  115,  149,  150,
  150,  151,  151,  152,  152,  153,  153,  153,  113,  113,
  113,   78,   90,   79,   91,  156,  156,  156,  154,  154,
  154,  155,  155,  157,  157,  158,  158,  158,  163,  164,
  164,  103,  103,  160,  160,  122,  122,  116,  167,  168,
  168,  168,   64,  124,  124,  124,  124,  124,  124,  161,
  161,  175,  175,  176,  178,  178,  178,  178,  178,  159,
  177,  177,  181,  181,  181,  181,  183,  184,  185,  180,
  180,  179,  179,  179,  179,  179,  186,  187,  188,  188,
  188,  188,   77,   89,   96,  193,  189,  189,  190,  190,
  194,  194,  196,  195,  195,  199,  198,  198,  198,  191,
  191,  200,  200,  201,  205,  205,  206,  204,  204,  208,
  208,  208,  207,  210,  210,  192,  212,  212,  212,  213,
  213,  211,  211,  202,  203,  215,  215,  215,  215,  215,
  215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
  215,  215,  215,  216,  216,  216,  216,  222,  222,  223,
  219,  229,  230,  220,  227,  227,  224,  234,  218,  235,
  232,  232,  232,  232,  228,  231,  231,  226,  226,  226,
  233,  233,  214,  214,  239,  240,  240,  241,  241,  241,
  241,  225,  225,  225,  243,  245,  244,  246,   14,  247,
  247,  247,  248,  248,  248,   15,  250,  250,  251,  251,
  252,   81,   92,  166,  104,  106,  120,  255,  255,   80,
   80,   80,   93,   93,   93,   97,   97,   97,  256,  256,
  256,  257,  257,  262,  262,  262,  262,  262,  260,  260,
  261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
  261,  261,  261,  261,  261,  258,  258,  259,    2,  264,
  264,  264,  264,  264,  264,  264,  264,  264,  270,  270,
  274,  274,  274,  274,  274,  274,  274,  265,  265,  275,
  275,  275,  275,  275,  275,  275,  275,  275,  269,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  277,  277,  279,
  279,  278,  276,  276,  276,  271,  271,  272,  272,  272,
  273,  283,  283,  284,  284,  267,  268,  268,  285,  285,
  285,  285,  285,  266,  286,  286,  287,  287,   10,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  118,  118,  197,  197,  292,  292,  293,
  293,  162,  162,  291,  291,  297,  297,  299,  299,   59,
   59,  296,  296,  296,  296,  296,  296,  296,  296,  296,
  303,  303,  295,  295,  295,  295,  305,  305,  304,  304,
  304,   61,   61,  300,  300,  300,  298,  298,  298,  309,
  309,  309,  308,  308,  307,  307,  307,  301,  301,  310,
  310,  310,  311,  311,  302,  302,  302,  302,  312,  312,
   21,   21,   21,  314,  314,  314,   19,   19,   19,  316,
  317,  320,  320,  318,  322,  322,    5,   18,  321,  321,
  323,  323,  324,  324,  313,  325,  325,  326,  326,  327,
  327,  327,  327,  327,  327,  328,  328,  329,  329,  330,
  330,  334,  334,  334,  335,  335,  335,  336,  336,  336,
  331,  331,  331,  332,  333,  338,  338,  338,  339,  339,
  337,  337,  340,  342,  342,  341,  341,  315,    4,    4,
    4,  343,  345,  345,  345,  345,  345,  345,  345,  345,
  345,  345,  345,  345,  345,  345,  347,  347,  348,  344,
  344,   20,  349,  349,  351,  351,  350,  350,  254,  352,
  352,  352,  356,  356,  357,  360,  361,  353,  353,  353,
  362,  364,  365,  365,  365,  365,  373,  373,  373,  374,
  374,  374,  366,  366,  367,  367,  376,  376,  377,  377,
  378,  378,  368,  380,  380,  381,  381,  383,  383,  383,
  385,  386,  386,  359,  359,  387,  387,  382,  382,  382,
  388,  389,  390,  392,  392,  393,  394,  384,  384,  395,
  395,  396,  396,   27,  391,  391,  391,  391,  391,  397,
  397,  370,  370,  398,  398,  399,  371,  371,  369,  369,
  372,  372,  400,  401,  401,  401,  401,  401,  402,  402,
  403,  403,  404,  404,  405,  405,  405,  406,  406,  407,
  407,  354,  354,  408,  408,  409,   74,   74,   74,  410,
  410,  411,  411,  355,  355,  355,   12,   12,   12,   13,
  414,  414,  414,  414,  415,  416,  417,  418,    9,    9,
  420,  421,   22,   22,  423,  424,   23,  425,  425,  413,
  413,  413,  422,  419,  419,  217,  221,  221,    3,    3,
  430,  430,  430,  432,  432,  433,  431,  431,  434,  434,
   37,   37,  102,  101,  101,  412,  412,  426,  435,  435,
  237,  237,  237,  165,  427,  427,  130,  130,  130,  130,
  436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
  436,  436,  436,  437,  437,  437,  437,  437,  437,  437,
  437,  443,  443,  443,  443,  443,  443,  443,  443,  443,
  443,  443,  443,  443,  443,  443,  443,  449,  449,  438,
  438,  439,  439,  440,  440,  440,  440,  441,  441,  445,
  445,  446,  446,  446,  446,  444,  447,  442,  442,  448,
  448,  448,  450,  450,  451,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  105,  174,  174,  174,  458,  458,  452,  459,
  459,  249,  249,  169,  169,  460,  460,  460,  460,  460,
  454,  454,  454,  454,  454,  253,  170,  170,  171,  172,
  172,  172,  172,  172,   57,   57,   24,   24,  263,  461,
   60,  306,  282,  282,  112,  453,  453,  429,  429,  429,
  462,  462,  462,  462,  462,  462,  462,  462,  462,  462,
  462,  462,  462,  466,  466,  467,  467,  467,  463,  463,
  468,  469,  469,  469,  471,  472,  472,  473,  465,  465,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
  474,  474,  474,  474,  475,  475,  475,  475,  475,  475,
  475,  464,  464,  464,  464,  476,  478,  478,  477,  477,
  477,  477,  479,  479,  479,  428,  428,  455,  456,  456,
  480,  480,  480,  480,  480,  481,  481,  483,  483,  486,
  486,  484,  484,  489,  489,  488,  485,  487,  482,  482,
  457,  457,  470,  470,  470,  470,  470,  470,  470,  470,
  470,  470,  375,  375,  363,  363,  173,   54,   70,  133,
  132,  294,  182,  209,  290,   99,   68,  242,  131,   75,
  379,  238,  346,   38,   47,  358,  289,   45,   48,  236,
   46,  319,  281,  281,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
  490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
};
static int yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    8,    8,    5,    1,    0,
    1,    2,    1,    1,    3,    1,    1,    1,    1,    2,
    2,    3,    0,    3,    0,    1,    8,    8,    5,    3,
    0,    3,    0,    1,    1,    1,    3,    3,    3,    2,
    2,    2,    2,    1,    3,    1,    2,    2,    1,    3,
    1,    1,    3,    1,    2,    2,    2,    3,    8,    1,
    1,    5,    0,    1,    3,    1,    3,    3,    0,    2,
    2,    1,    1,    3,    3,    2,    0,    2,    2,    1,
    3,    9,    1,    1,    2,    2,    7,    2,    2,    4,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    4,    2,    2,    2,    4,    2,    2,    2,
    2,    2,    2,    2,    1,    0,    1,    1,    6,    6,
    1,    1,    0,    0,    1,    0,    4,    0,    1,    1,
    2,    8,    1,    0,    3,    1,    0,    1,    0,    1,
    2,    1,    1,    1,    2,    6,    1,    1,    6,    2,
    5,    0,    0,    1,    1,    2,    1,    1,    1,    2,
    2,    2,    2,    2,    2,    0,    1,    3,    0,    1,
    1,    0,    1,    1,    2,    3,    4,    2,    2,    3,
    0,    1,    1,    2,    1,    4,    3,    3,    1,    0,
    1,    1,    2,    3,    4,    0,    1,    2,    0,    1,
    1,    5,    5,    5,    5,    4,    4,    0,    3,    2,
    0,    1,    3,    1,    1,    6,    3,    2,    6,    1,
    3,    2,    1,    2,    2,    2,    0,    1,    1,    2,
    3,    1,    0,    1,    1,    1,    1,    1,    1,    0,
    1,    1,    2,    2,    1,    1,    5,    2,    3,    2,
    2,    0,    1,    1,    1,    1,    3,    4,    8,    4,
    0,    1,    1,    2,    2,    0,    3,    3,    1,    2,
    2,    2,    8,    8,    8,    8,    3,    0,    4,    0,
    1,    3,    6,    1,    3,    3,    3,    3,    0,    1,
    0,    1,    2,    6,    1,    1,    4,    1,    0,    2,
    2,    0,    6,    1,    1,    5,    1,    2,    0,    1,
    2,    4,    3,    0,    0,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    3,    1,
    3,    8,    9,    5,    8,    6,    3,    0,    3,    2,
    1,    1,    3,    3,    7,    2,    0,    1,    1,    2,
    3,    0,    1,    2,    4,    1,    3,    2,    2,    2,
    1,    1,    1,    1,    2,    2,    5,    0,    5,    1,
    3,    0,    2,    4,    0,    7,    3,    0,    1,    3,
    3,    7,    7,    0,    0,    0,    0,    3,    0,    6,
    8,    8,    6,    8,    8,    6,    8,    8,    1,    1,
    0,    2,    2,    1,    1,    2,    2,    2,    1,    1,
    1,    1,    1,    3,    3,    3,    3,    3,    3,    5,
    5,    5,    5,    5,    5,    2,    0,    4,    2,    2,
    3,    2,    2,    3,    3,    2,    2,    3,    1,    2,
    3,    3,    2,    2,    2,    2,    3,    1,    3,    3,
    3,    2,    2,    4,    4,    4,    5,    4,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    1,    0,    2,    2,    4,    4,    5,
    3,    2,    0,    2,    0,    0,    1,    2,    2,    4,
    3,    2,    2,    7,    1,    0,    1,    0,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    3,    2,    2,
    2,    2,    2,    1,    1,    1,    3,    1,    1,    3,
    1,    1,    1,    4,    5,    1,    3,    1,    3,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    4,    6,    5,    3,    0,    2,    2,
    0,    3,    0,    4,    1,    5,    4,    1,    4,    1,
    2,    2,    1,    1,    1,    2,    2,    2,    2,    0,
    3,    5,    1,    1,    2,    3,    1,    2,    3,    0,
    1,    1,    1,    5,    5,    6,    1,    1,    1,    2,
    4,    1,    0,    5,    1,    0,    3,    3,    1,    0,
    2,    0,    1,    0,    3,    1,    0,    1,    2,    1,
    1,    1,    1,    1,    1,    2,    2,    1,    2,    3,
    1,    1,    3,    3,    1,    2,    3,    1,    2,    0,
    3,    2,    2,    3,    2,    1,    1,    0,    1,    1,
    1,    3,    2,    3,    0,    1,    3,    4,    5,    6,
    7,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    2,    1,    1,    1,    2,    1,
    1,    3,    3,    0,    2,    0,    2,    0,    4,    3,
    2,    0,    1,    3,    6,    4,    4,    1,    4,    4,
    1,    9,    2,    1,    1,    0,    2,    4,    2,    2,
    4,    2,    1,    1,    1,    1,    1,    3,    1,    3,
    1,    0,    2,    1,    3,    1,    1,    1,    1,    3,
    6,    1,    0,    3,    0,    1,    3,    1,    1,    1,
    4,    5,    5,    1,    1,    2,    4,    4,    2,    3,
    0,    1,    3,    1,    1,    2,    2,    2,    0,    1,
    0,    3,    0,    1,    3,    1,    2,    0,    2,    0,
    2,    0,    4,    1,    2,    1,    1,    0,    1,    3,
    2,    1,    1,    2,    1,    4,    3,    1,    3,    4,
    0,    3,    0,    1,    3,    3,    1,    1,    0,    2,
    0,    1,    1,    2,    4,    0,    9,    6,    6,    8,
    2,    2,    1,    1,    4,    5,    3,    6,    1,    1,
    8,    4,    1,    1,    9,    5,   12,    2,    0,    2,
    4,    0,    4,    1,    3,    3,    1,    1,    7,    7,
    5,    3,    0,    1,    1,    1,    2,    0,    1,    1,
    1,    0,    3,    1,    3,    1,    0,    3,    1,    3,
    1,    3,    3,    1,    1,    3,    1,    3,    3,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    1,    1,    5,
    6,    5,    6,    3,    4,    5,    6,    3,    4,    3,
    4,    3,    4,    4,    5,    4,    4,    3,    4,    1,
    1,    1,    1,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    1,    1,    1,    3,
    1,    1,    1,    1,    2,    2,    3,    0,    4,    1,
    0,    1,    3,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    2,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    1,    2,    1,    1,
    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,
    4,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    6,    6,    2,    0,    1,    1,    1,    1,    1,
    6,    1,    1,    1,    4,    4,    4,    4,    4,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    7,    8,    8,    8,   10,    8,
    6,    1,    1,    4,    4,    7,    2,    0,    7,    6,
    6,    4,    1,    1,    1,    4,    3,    6,    1,    1,
    6,    8,    6,    6,    8,    1,    1,    4,    6,    4,
    5,    3,    5,    4,    5,    1,    1,    1,    3,    5,
    4,    6,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    0,    1,    0,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
static int yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    3,    4,    5,    6,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
   20,   21,   22,   23,   24,    0,  651,  652,  653,  657,
  658,  659,    0,  879,  880,  883,  884,  556,    0,    0,
    0,    0,    0,    0,    0,    0,  459,  669,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  135,    0,
    0,    0,    0,    0,  105,    0, 1059,    0,   25, 1057,
    0,    0,   76,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  569,    0,
    0,    0,   39,   36,   38,    0,   37,    0, 1233, 1235,
 1236, 1237, 1238, 1239, 1240, 1261, 1262, 1241, 1243, 1242,
 1254, 1255, 1248, 1244, 1249, 1245, 1247, 1250, 1246, 1251,
 1252, 1253, 1257, 1258, 1256, 1259, 1260, 1264, 1263, 1265,
 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285,
 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295,
 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305,
 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315,
 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325,
 1326, 1327, 1328, 1329, 1330,    0,    0,    0,    0,   34,
   71,   69, 1225, 1234,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  812, 1227,    0,
    0,    0, 1226,  751,    0,    0,    0,    0,    0,    0,
    0,    0,  120, 1232,  660,    0,    0,    2,    0,    0,
    0,    0,  758,  761,    0,  491,  492,  493,  494,  495,
  496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
  506,  507,  508,  509,  510,  511,  519,  513,  514,  512,
  515,  516,  517,  518,  520,  522,  525,  521,  523,  524,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,    0,  489,  490,    0,  460, 1216,    0,    0,
  466, 1220,    0,  463, 1224,    0,  814,    0,  462, 1228,
    0,  467, 1219,    0,  667, 1055,    0,  191,  115,    0,
  116,    0,  248, 1212,  924,  106,    0,  113,  167,    0,
    0,  108,    0,  117, 1061,    0,  109,    0,  111,    0,
  112, 1231,  168,  118,  114,  119,    0, 1211,    0,  857,
  858,    0, 1060, 1058,    0,   77,    0, 1217,    0, 1215,
  577,  570,    0,  576,  581,  571,  572,  579,  573,  574,
  575,  580,  582,  583,    0,    0,    0,   32,    0,   41,
  911,   40,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  668,    0,    0,
    0,    0,    0,    0,    0,  688,    0,    0,    0,  675,
    0,  678,  680,  681,  682,  683,  684,  685,  691,  692,
    0,  781,    0,    0,  750,    0,    0,    0,  126,    0,
    0,  121,    0,  122,    0,  125,    0,  124,    0,    0,
    0,  722,  723,  730,    0,  729,  731,  733,  738,  726,
  724,  727,  725,  734,  737,  732,  736,    0,    0,    0,
    0,    0,  742,    0,    0,    0,    0,  765,    0,    0,
    0,    0,    0,    0,    0,    0,  557,    0,    0,    0,
    0,  253,    0,  469,  134, 1208,    0,  468,  546,  547,
    0,    0,    0,    0,    0,    0,  478,    0,  429,  430,
    0,    0,  673,  671, 1056,    0,    0,    0,    0,    0,
    0,    0,  194,  153,    0,  131,    0,    0,    0,  127,
    0,  142,  141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   78,    0,    0,    0,    0,  882,  578,    0,
    0,    0,    0, 1019, 1052,    0, 1207,    0, 1021, 1121,
    0,    0,    0, 1135, 1053,    0, 1047, 1038, 1037, 1036,
    0,    0,    0,    0, 1024,    0,    0, 1039, 1040, 1048,
 1049,    0, 1050, 1051,    0,    0,    0, 1054,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1046,    0, 1042,    0,
  921, 1016, 1017, 1018, 1023, 1022, 1001,    0,    0,    0,
 1000,    0,    0, 1005, 1067,  997,  998,  999, 1002, 1003,
 1004, 1041, 1066, 1068, 1069, 1070, 1089, 1090, 1092, 1093,
 1094,    0, 1100, 1152, 1153, 1169, 1170, 1176, 1177,  249,
    0,    0,    0,  409,    0,    0,    0,  914,   29,    0,
    0,    0,    0,   74,   72, 1229,   70,   35,    0,    0,
    0,    0,  916,    0,    0,   50,   52,    0,    0,    0,
  665,    0,    0,  718,    0,    0,  689,    0,  686,    0,
  687,  716,    0,  711,    0,    0,    0,  703,  702,  679,
    0,  813,  925,  894,    0,    0,    0,  754, 1221,  796,
    0,    0,  132,    0,    0,    0,    0,    0,    0,  662,
  661,  735,  728,    0, 1223,    0,    0,    0,  743,  747,
 1065,    0,  767,  769,    0,  770,  772, 1203,  773,    0,
  774,  763,    0,    0, 1205,    0,    0,  749,  209,    0,
    0,  150,    0,  562,    0,  563,  558,  415,    0,  473,
  475,  474,  415,  416,  476,    0,  470,    0,    0,    0,
    0,  301,    0,    0,    0,  482,  483,    0,  539,    0,
    0,    0,    0,    0,    0,    0,  440,  439,    0,  565,
    0,    0,    0,  190,    0,    0,  199,    0,  198,    0,
    0,  205,  188,    0,  203,  195,    0,    0,  608,  643,
  611,    0,  644,    0,    0,  612,    0,    0,    0,  635,
  647,  607,  630,  609,  610,  605,  592,  415,  584,  585,
  593,    0,    0,  602,  603,  604,  606,    0,    0,    0,
    0,  130,    0,    0,  128,    0,  129,    0,  145,    0,
    0,  230,    0,    0,    0,  414,    0, 1210,    0,  110,
    0,  253,    0,    0,   86,    0,  104,    0,  103, 1209,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  927,  931,  932,  933,  934,  935,  936,  937,  938,  939,
  940,  941,  942,    0,    0,    0,    0,    0, 1043,    0,
    0,    0,    0,    0,    0,    0, 1044, 1045,    0, 1025,
 1026,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  370, 1230,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  399,
    0,    0,    0,    0,  588,    0,    0,  589,  591,  600,
    0,    0,    0,  407,    0,    0,    0,  913,    0,    0,
   46,   75,    0,    0,   28,    0,    0,  919,    0,    0,
    0,    0,    0,    0,  786,  787,  788,  789,  798,  799,
  800,    0,    0,    0,    0,  664,  655,    0, 1063,  654,
    0,  690,  701,    0,  698,  694,  693,    0,    0,    0,
  713,  697,  704,    0,    0,    0,    0,  886,    0,    0,
  794,    0,    0,    0,    0,    0,  414,    0,  123,  741,
  740,  719,    0,    0,    0,    0,    0,    0,  776,    0,
    0,    0,  777,    0,    0,  854,  760,  759,    0,    0,
  151,    0,  561,    0,  472,    0,  471,  477,  552,    0,
  551,    0,    0,  297,  414,  271, 1213,    0,    0,  240,
  415,    0,    0,  238,    0,  414,    0,    0,    0,  276,
  270,  273,  274,  275,  481,  544,  543,  480,  479,    0,
    0,    0,    0,    0,    0,  434,  435,  433,    0,    0,
    0,  432,    0,  415,  549,    0,  548,    0,  196,  200,
    0,    0,  204,    0,    0,    0,  631,  632,  648,    0,
  645,    0,    0,  638,  636,  637,    0,    0,    0,    0,
  601,    0,    0,    0,    0,  639,  133,    0,    0,    0,
  414,    0,  229,    0,  232,  234,  235,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,   81,    0,    0,
   80,    0,    0,    0,  930,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  834,  836,    0,  831,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1193, 1194, 1195, 1196,
 1197, 1198, 1201, 1202, 1199, 1200,    0,    0,    0,    0,
    0,    0,    0,    0, 1182,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1163, 1165, 1164,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1014,  401,    0, 1015, 1167,    0, 1010,    0,    0,
    0,    0,    0,    0,    0,    0,  371,  372,    0,    0,
 1020,  923,  922,    0,    0,    0,    0,  306,    0,  411,
  410,    0,  304,  334,    0,  312,  335,  915,    0,    0,
    0,   73,    0,    0,    0,  869,    0,  918,    0,  868,
    0,    0,    0,    0,    0,    0,  815,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  656, 1064,  699,  712,
  707,  706,    0,  717,    0,  926,  895,    0,    0,  797,
    0,  414,    0,    0,    0,    0,    0,  720,  739,    0,
  768,  771,    0,    0,    0,    0,    0,    0,    0,  560,
    0,    0,  208,    0,  212,    0,    0,  155,  254,  255,
  256,  257,  258,  259, 1034,  554,  415,  302,    0,  242,
    0,  244,  417,  156,    0,  237,  415,  245,    0,    0,
    0,  484,  485,  488,  416,  540,  541,  486,  437,  438,
  436,    0,    0,    0,  456,    0,  550,  220,  221,  197,
    0,  207,  619,  620, 1062,    0,    0,    0,    0,    0,
  646,    0,    0,  417,    0,    0,  596,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  222,    0,  415,    0,  416,    0,    0,  170,    0,    0,
    0,    0,    0,    0,  175,  177,  178,  179,    0,    0,
   85,    0,    0,    0,    0,   93,   87,    0,    0,   92,
   88,    0,  893, 1214,    0,    0,  943,    0,    0,    0,
  969,  968,    0,    0,    0,  978,  993,    0,  988,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  929,
    0,  835,    0,    0,    0,    0,    0,    0, 1071,    0,
    0, 1154,    0,    0,    0,    0,    0,    0,    0,    0,
 1027,    0,    0,    0,    0,    0, 1178,    0,    0,    0,
    0,    0,    0,    0, 1191, 1095, 1096, 1097, 1155, 1098,
    0, 1162,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1166, 1029,    0,    0,    0, 1099,  590,
  246,  587,    0,  299,  406,  335,  313,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   56,   64,   66,
    0,   44,    0,    0,    0,  900,    0,  920,    0,    0,
  790,    0,    0,  820,  818,  816,    0,    0,  817,    0,
    0,  899,    0,    0,  709,  710,  714,    0,    0,  755,
    0,  223,    0,    0,  416,    0,    0,  721,  780,    0,
    0,    0,    0,  778,    0,  856,  855,    0,    0,    0,
    0,  213,    0, 1035,    0,  334,  241,    0,    0,    0,
    0,    0,  277,  487,    0,    0,    0,    0,    0,    0,
  567,  416,  206,    0,    0,  614,    0,  613,  649,    0,
  641,    0,    0,    0,  594,  622,    0,    0,  624,  627,
  629,  414,    0,    0,  334,    0,  140,    0,  233,    0,
    0,    0,  420,    0,  416,    0,  180,  183,  182,  185,
  184,  181,  187,  169,  176,    0,  107,    0,  138,    0,
   96,    0,    0,    0,    0,   90,   91,    0,  986,  987,
    0,    0,    0,    0,    0,    0,    0,    0,  989,    0,
    0,    0,    0,    0,    0,    0,  979,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  842,    0,    0,    0,  881, 1077, 1076,    0,
    0,  252,    0, 1073, 1072,    0, 1081, 1080, 1079, 1078,
    0, 1075, 1074,    0,    0, 1184,    0,    0,    0, 1183,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  757,  404,  374,
  373,  305,    0,    0,   68,   60,   61,   67,   62,   63,
    0,   26,    0,    0,   27,  906,  905,    0,  904,  902,
  910,  909,  907,    0,    0,    0,  810,  808,    0,    0,
  870,    0,    0,  801,    0,   47,   48,    0,    0,  334,
    0,    0,  423,  416,    0,    0,    0,    0,  862,  863,
  860,    0,  218,  214,  416,  415,  415,  417,  416,    0,
    0,  262,    0,    0,    0,  278,    0,    0,    0,    0,
    0,    0,    0,  564,  616,    0,  617,    0,    0,    0,
    0,  160,  162,  163,  164,  599,  597,  595,  626,    0,
    0,    0,  416,  416,    0,  416,  334,  416,    0,  412,
    0,    0,  224,  415,   94,    0,    0,  100,   95,    0,
    0,    0,    0,    0,  994,    0,  995,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  844,  833,    0,
    0,  845,    0,  841,    0,  250, 1168, 1192, 1151, 1091,
    0,    0, 1180, 1179,    0, 1185, 1171, 1173,    0, 1160,
 1161,    0,    0,    0,    0,    0,    0,    0, 1174, 1086,
 1088, 1087, 1084, 1083, 1082,    0,    0,  318,    0,    0,
   57,   58,   59,   65,    0,    0,  867,  792,    0,  802,
    0,    0,    0,  871,    0,  872,    0,    0,  803,  804,
  805,    0,  885,  416,  416,  416,  413,  225,    0,    0,
    0,    0,  215,  166,    0,    0,  303,  296,  236,  263,
    0,    0,    0,  265,  266,  264,    0,    0,    0,  454,
  455,  451,  450,  453,  452,  615,  642,  165,  152,  161,
  334,    0,    0,  426,  293,  147,  421,  458,  422,  418,
  171,    0,    0,    0,   98,    0,   82,    0,  955,  963,
    0,    0,  956,  964,  959,  967,    0,    0,  957,  965,
  958,  966,  952,  960,  953,  961,  954,  962,  840,    0,
    0,  251,    0, 1156, 1181,    0, 1159, 1145,    0,    0,
    0,    0,    0,    0,  325,  335,  330,  324,    0,    0,
    0,    0,  315,  316,    0,    0,   42,  901,  791,    0,
    0,    0,    0,    0,  294,  424,  425,    0,    0,  824,
    0,  762,  307,  308,    0,    0,  268,  239,    0,  280,
  416,  416,  416,    0,    0,    0,   79,  101,  102,  756,
    0,    0,    0,  847, 1172, 1146, 1147, 1148,    0, 1175,
    0, 1150,    0,  326,    0,  331,    0,  383,    0,  314,
    0,    0,    0,  875,    0,    0,    0,    0,  269,    0,
    0,    0,    0,    0,  295,  427,  428,  227,  226,    0,
    0,  846,    0,    0,    0,    0,    0,  353,    0,    0,
    0,  352,    0,    0,    0,    0,  398,  341,  337,  338,
  343,    0,  339,  340,    0,  333,  336,  342,  344,  345,
  346,  347,  348,  349,  350,  351,  354,  355,  356,  357,
    0,    0,  392,  393,  394,    0,  897,  898,  391,    0,
    0,    0,    0,  386,  384,    0,    0,    0,  876,    0,
  807,  888,  887,  825,    0,    0,    0,  279,    0,  285,
    0,  284,  139,  849,    0, 1149,    0,    0,    0,    0,
  380, 1222,  395,  396,    0,    0,  332,    0,    0,  376,
  390,  389, 1218,  388,  334,    0,    0,    0,  317,    0,
    0,    0,  267,    0,    0,  289,  288,  287,  850,    0,
    0,    0,  367,    0,    0,    0,    0,    0,  385,  387,
  320,  321,    0,    0,  292,  290,  291,    0,    0,    0,
    0,    0,    0,  323,    0,    0,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,  878,  334,    0,
    0,  334,  375,  365,  334,  381,  362,  363,
};
static int yydgoto[] = {                                      22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
   43,   44,   45, 1866,  216,  710,  238, 1635, 1862,  217,
 1020,  218,  713, 1025,  219,  220,  400, 1033,  231,  232,
 1636, 1637, 1638, 1639,  328,  360,  221, 1640,  222,  715,
   93,  376,  553,  658,  913, 1504,  659, 1210,  877,  353,
 1181,  914,  915,  916, 1511, 1506, 1959,  377,  918,  919,
   85,  346,   86,  372, 2191, 1757,  352,  357,  910,  359,
  361,  348,  339,  341,  354,  364,  366,  253,  452,  454,
 1079,  458,  456,  449,  540,  895,  897,  892,  316,  317,
  707,  401, 1120, 1104,  929, 1107,  544,  900, 1479, 1737,
  845, 1049, 1450,  801,  802,  825,  535,  878, 1423, 1698,
 1930, 1328, 1424, 1408, 1931, 1932, 1933, 1934, 1935,  930,
  349,  367,  907, 1202, 1493, 1754, 1494, 1495, 1496, 1497,
 1498,  340,  531,  853,  532,  533,  854,  855,  803, 1403,
 1404, 1405, 1691,  546, 1194, 1953, 1195, 1196, 1197, 1122,
 1910, 1005, 1124, 1125,  661, 1200,  701, 1813, 1409,  662,
  663,  664,  665,  666, 1911, 1912,  828, 2076, 2222, 1703,
 1131, 1116, 1132, 1133, 1134, 2223, 2224, 2337,  512,  706,
 1334, 2145,  324,  821, 1332,  822, 1006, 1908,  702, 1335,
 1336, 2146, 1628, 2029, 2152, 2153, 2154, 2329, 1513, 2147,
 2148, 2149, 2150, 2207, 2255, 2256,  754, 2258, 2259, 2260,
 2261, 2262, 2263, 2264, 2265, 2266, 2267, 2268, 2269, 2270,
 2271, 1316, 2376, 2343,  667,  989,  668, 2272, 2208, 2283,
 2284, 2322, 2273, 2274, 2275, 2315,  669, 1000,  670,  397,
  703,  704,  671,   46, 1745,  521,  840, 1154, 1485,  841,
 1152, 1148,   90,   67,  516,  329,  265,  496,  313,  503,
  321,  332,  508,  504,  517, 1138,  518,  835, 1438,  314,
  672, 1465,  819, 1111,  497,  842, 1712,  109,  327,  381,
  880, 1007, 1008,  345,  881, 1010, 1466, 1011, 1467,  884,
  885,  886,  887, 1166, 1459, 1457,  888,  889,  890, 1174,
  891, 1171,   47,   48,   49,   50,   51,   52,  255,  771,
   69,  732,  335,  524,  430,  431,  432,  433,  434,  435,
  436,  437,  438,  439,  440, 1056,  743, 1373, 1667,  744,
  745, 1061,  478, 1082,  479,  776,  480, 1085,  260,  483,
  779, 1775,  262,  491,  798,  244,  245,  673,  448, 1776,
  988,  263,  796,  264,  486,  790, 1091, 1395,  557, 1898,
 2062,  945,  487,  488,  791, 1092, 1093,  443,  760, 1680,
 1034, 1035, 1036, 1037, 1038, 2039,  761, 1039, 1040, 1041,
 1363, 2049, 2050, 2051, 1355,  241, 1655, 2169, 2170, 1803,
 1240, 1804, 1805, 1806, 1994, 2192, 2194, 1095, 1096, 1686,
 1901,  722, 1346, 1881, 1882, 1883, 2214, 2289,  756,   54,
   55,  558,   56,   57, 2217,  723,  757,  674,  675, 1344,
 1646, 1868, 1869, 1873, 1029,  931,  932,  933,  934,  935,
  936,  937,  938,  939,  940,  941,  942,  943, 1524, 1526,
 1527,  676,  677,  678,  679,  680,  681,  960, 1325,  682,
  374,  683,  684,  685,  686, 1845, 2023,  687,  688, 1267,
  689,  690,  691,  692,  693,  694,  695, 2002, 1290,  696,
  697, 1843,  698,  699,  966, 1273, 1590, 1585,  967,  224,
};
static int yysindex[] = {                                  25895,
 3080, -173,25685,  114, 1171,   -7,25970,  474,38578,   34,
   18,  171,  362, -173,  615,42319,43123, 1167,43271, -104,
   74,    0,  543,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  667,    0,    0,    0,    0,
    0,    0,  419,    0,    0,    0,    0,    0,42827,43271,
  702,43271,43271,43271,43271,43271,    0,    0,  699, 1183,
43271,43271,43271,  896,43271,  739,43271,43271,    0,43271,
43271,43271,43271,  540,    0,  916,    0,  762,    0,    0,
  901,43271,    0,43271,43271,43271,  917,43271,43271,43271,
43271,  739,43271,43271,43271,43271,43271,43271,    0,43271,
 1205,  952,    0,    0,    0, 1335,    0, 1335,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1005, 1025,  191, 1367,    0,
    0,    0,    0,    0,43271,43271,43271,43271, 1069, 1117,
 1708,43271,  742,43271, 1188, 2661, 1107,    0,    0, 1263,
 1156,43271,    0,    0, 1540, 1539,43271,43271,43271,43271,
43271, 1002,    0,    0,    0,43271,36174,    0, 1177, 1159,
    0,  372,    0,    0, 1743,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1095,    0,    0, 1183,    0,    0, 1180,   23,
    0,    0, 1600,    0,    0, 1071,    0,   77,    0,    0,
 1132,    0,    0, 1249,    0,    0, 1226,    0,    0, 1531,
    0, 1471,    0,    0,    0,    0, 1183,    0,    0,  472,
 1600,    0,  746,    0,    0, 1416,    0,   73,    0, 1335,
    0,    0,    0,    0,    0,    0, 1443,    0, 1326,    0,
    0, 1427,    0,    0, 1180,    0, 1433,    0, 1366,    0,
    0,    0, 1180,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,33747,43271, 1401,    0,43271,    0,
    0,    0, 1390, 1425,42679,43271,  979, 1493,  396, 1341,
 1521, 1525, 1533, 1477, 1484,  220, 1380,    0, 1437,43271,
 1544,   -6,  682,43271, 1466,    0, 1391, 1396, 1406,    0,
 2661,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1606,    0,43271,43271,    0,43271,43271, 1684,    0, 1183,
 1600,    0, 1416,    0,  791,    0, 1335,    0, 1534, 1574,
 1552,    0,    0,    0, 1654,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1661,43271,43271,
 1608, 1504,    0,   87,  106,  854,    0,    0, 1729,  885,
 1498,  -78, 1510, 1545, 1547, 1743,    0, 1179, 1202, 1748,
43271,    0, 1095,    0,    0,    0, 1754,    0,    0,    0,
43271, 1401,41497, 1605,41647, 2038,    0,42827,    0,    0,
  573, 1639,    0,    0,    0, 2027, 2027, 1183, 1731, 1183,
  -18, 1531,    0,    0,36571,    0,43271,43271,43271,    0,
 1401,    0,    0, 1811,  663, 2067,43271,  573, 1865,43271,
43271,43271,    0, 2090,35680,26385, 1751,    0,    0, 2117,
 2122, 2132, 1706,    0,    0, 2141,    0, 2143,    0,    0,
 2146, 2151,    0,    0,    0, 2156,    0,    0,    0,    0,
    0, 2159, 1707, 1749,    0, 2164, 2164,    0,    0,    0,
    0, 2171,    0,    0,30758, 2172, 2175,    0, 2176, 1867,
 2179, 2183, 2185, 2186, 2189, 2191,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2193, 2194, 2198,    0,    0,    0,    0, 2199,
    0,    0,    0,    0,    0,    0,    0, 2203,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,34079,34079,31090,43271,    0, 2205,    0, 2713,
    0,    0,    0,    0,    0,    0,    0, 2158, 1849, 2214,
    0,    0, 2216,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2220,    0,    0,    0,    0,    0,    0,    0,    0,
41022, 2204,  768,    0, 2224, 2002, 1516,    0,    0,43271,
43271,43271,  135,    0,    0,    0,    0,    0,43271, 1835,
43271,  505,    0,35076,43271,    0,    0, 1390, 1879,42679,
    0,43271,  112,    0,  793, 1744,    0, 1845,    0, 1845,
    0,    0, 2233,    0, 1968, 1866,  739,    0,    0,    0,
43271,    0,    0,    0, 2240,  130, 2226,    0,    0,    0,
 1571, 2248,    0, 1401, 2251,43271,  573, 2029,43271,    0,
    0,    0,    0,  694,    0, 1957, 2249,43271,    0,    0,
    0,34079,    0,    0,34079,    0,    0,    0,    0,31422,
    0,    0,34079,  419,    0,  419,34079,    0,    0, 1955,
 1959,    0, 1183,    0, 1963,    0,    0,    0, 2021,    0,
    0,    0,    0,    0,    0,36571,    0, 1183, 1949,41022,
 1676,    0, 2053,43271,40368,    0,    0, 1214,    0,43271,
 1021, 1071, 1932, 1892,   15,    0,    0,    0,  771,    0,
  -27, 1935,  121,    0, 1876,  739,    0, 1183,    0, 2052,
 1990,    0,    0,  -18,    0,    0,  136, 1900,    0,    0,
    0, 1901,    0, 1952, 2300,    0, 2005, 2307,  827,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2261,  178,    0,    0,    0,    0,  131, 2313, 2315,
 2307,    0, 1183, 1600,    0, 1037,    0, 2092,    0, 1183,
 1183,    0,41497,   77, 1935,    0, 2042,    0, 2323,    0,
 1994,    0, 1966, 2321,    0,37345,    0, 1989,    0,    0,
 2001, 2338,27049, 2341,    0,    0,    0,26717,25028,   76,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  902, 2004,  942,34079,  717,    0,43271,
34079, 1068, 1393,34079, 1436, 3065,    0,    0,  739,    0,
    0,34079,27049,31090, 2713, 1946,   17,34079,34079,27049,
 2076,34079,34079,34079,34079,34079,27381,26053, 3065,34079,
 1450,34079,  696,  696, 2713, 1756,  419, 2352,    0,    0,
31754,43271,34079,34079,34079,34079,34079,34079,34621,    0,
34079,35233,34079, 2020,    0, 2125, 2028,    0,    0,    0,
 2128, 2344,43271,    0,43271,    0,43271,    0, 1981, 1982,
    0,    0, 1956,42679,    0, 2098, 1882,    0, 1763, 2381,
 1882,34769, 2383, 3083,    0,    0,    0,    0,    0,    0,
    0, 2098,43271,43271, 2380,    0,    0,  910,    0,    0,
  -28,    0,    0, 1988,    0,    0,    0,43271,  651,43271,
    0,    0,    0, 2389,43271,43271, 1751,    0,34079,43271,
    0, 1987, 2169,41497,   77, 1935,    0, 2398,    0,    0,
    0,    0,  694,43271, 2106, 2395, 2269, 2458,    0, 2877,
 2129, 2400,    0, 2429, 2403,    0,    0,    0,  805, 1183,
    0,  455,    0, 2412,    0,36152,    0,    0,    0, 1183,
    0, 2125,43271,    0,    0,    0,    0, 2180, 1924,    0,
    0, 1748,  -44,    0, 2419,    0, 2124, 2126, 1335,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  739,
43271, 2168, 1748,41349,  -79,    0,    0,    0, 2097, 2100,
 2101,    0,  739,    0,    0,  982,    0, 1360,    0,    0,
 2058, 1183,    0,35680,  101, 2063,    0,    0,    0,  739,
    0, 2300,  123,    0,    0,    0, 1748,  123, 2059,  123,
    0, 2448,  739,  739,  739,    0,    0, 1401,43271,  573,
    0, 2138,    0, 1764,    0,    0,    0,  573,  512, 1987,
41796,  329,41497,43271, 1793,  213,    0,    0, 2451,   24,
    0,35680,43271, 1987,    0, 1987,24725,  262,34079,34079,
27720, 2452, 1157,28059,34079,28398, 1053,28737,29076,32086,
29415,29754,30093,27049,27049,    0,    0, 2131,    0, 2457,
 1498,34079,34079, 3643,34079, 2461,34079, 2460, 2507,34079,
34079,34079,34079, 1728,34079,34079,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2195, 2467, 1913,   62,
 2675,34079,  568,34079,    0,27049, 1645, 2373,  190,43271,
 2700, 2707, 2762, 2796, 2826,    0,    0,    0, 1868,32418,
    0,    0,    0,    0, 1216, 2469,  293, 2687,34079,34079,
   89,    0,    0,  372,    0,    0, 1812,    0, 2237,  696,
  696, 1030, 1030,  730,35830, 2471,    0,    0, 2475, 2713,
    0,    0,    0, 2214, 2483,43271,43271,    0, 2184,    0,
    0, 1817,    0,    0,    0,    0,    0,    0,41984,41984,
 2157,    0,  -22, 2178,34079,    0,43271,    0,34079,    0,
 2492, 1838, 2502,34079, 1263, 2165,    0, 2165,  819,27049,
 2165, 2236, 2250, 2178, 2291, 2296,    0,    0,    0,    0,
    0,    0,  -67,    0, 2201,    0,    0, 2004, 2713,    0,
 2512,    0, 1844,  573,  542, 1987,41497,    0,    0,  694,
    0,    0,43271,35076, 2190,34079, 2133,34079,34079,    0,
 2027, 2363,    0,  455,    0,27049, 1881,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2370,    0,    0,    0, 1924,    0,    0,    0, 1335, 1335,
 2147,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  407,    6,   33,    0, 2378,    0,    0,    0,    0,
43271,    0,    0,    0,    0,  114, 1905, 2230, 2128, 2603,
    0, 1876, 1922,    0, 2591, 1246,    0,43271, 1290,  739,
 2611, 2613, 2616, 2397,   77, 1935,    0, 2027, 1959,41497,
    0, 1935,    0,43271,    0, 2219, 2625,    0, 2091,  405,
  736, 2075, 1183,  329,    0,    0,    0,    0, 1926,34927,
    0,  739, 2282, 2364,37345,    0,    0,  739,  308,    0,
    0, 2365,    0,    0, 2632, 2636,    0, 2916, 2713, 2638,
    0,    0, 2713, 2642,31090,    0,    0, 2366,    0,  674,
 2649, 2713, 2650, 2072, 2651, 2713, 2652,34079,34079, 2452,
34079,32750, 2653, 2713, 2656, 2657, 2713, 2660,34079, 2713,
 2662, 2713, 2663, 2664, 2713, 2667, 2669, 2713, 2670,    0,
 2439,    0,42171, 1882, 2837, 2846,43419, 2856,    0, 2890,
34079,    0, 2897, 3043, 3169, 3217,34079, 3309, 3380,34079,
    0,34079,34079, 2713, 2289,34079,    0,34079, 2713, 2414,
  631,34079,34079,34079,    0,    0,    0,    0,    0,    0,
34079,    0,34079, 1992, 2298,34079,34079,34079,34079, 4026,
 4026,34079, 1498,    0,    0, 1934,35830,35382,    0,    0,
    0,    0,43271,    0,    0,    0,    0, 2427,43271,43271,
43271,43271,43271,43271, 2281, 2683, 2689,    0,    0,    0,
 2281,    0,  107,  107,  110,    0,  215,    0, 1936, 1263,
    0, 1967,43271,    0,    0,    0, 2405,  530,    0,35076,
35076,    0,41984,41984,    0,    0,    0, 2697, 1498,    0,
    0,    0, 1935,43271,    0, 2219, 1980,    0,    0, 2695,
 1838,27049, 2428,    0,  814,    0,    0, 2713, 1876, 2376,
 1876,    0,  273,    0,  449,    0,    0, 2477,34079, 2368,
 2147,  916,    0,    0, 2390, 2391, 2392, 2394, 2396, 2399,
    0,    0,    0, 2726,  114,    0, 2324,    0,    0,  123,
    0,   60,  123,  123,    0,    0, 2128, 2746,    0,    0,
    0,    0,  573,  579,    0, 1876,    0, 1959,    0, 2378,
    0, 2378,    0, 2514,    0, 1183,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2416,    0, 2395,    0, 2754,
    0, 2775, 1183,   29, 2777,    0,    0, 1183,    0,    0,
34079, 1987, 1987, 1986,  419, 2778,34079, 2503,    0, 1987,
 1987,34079, 1987, 1987, 4344, 2713,    0, 2118,34079, 2713,
 1987, 1987, 1987, 1987, 2713, 1987, 1987, 1987, 1987, 1987,
 1987,43271,    0, 2784, 2782, 1499,    0,    0,    0, 2453,
36571,    0, 2787,    0,    0, 3387,    0,    0,    0,    0,
 3402,    0,    0, 3425,  914,    0,34079, 2525, 2406,    0,
34079, 3439, 2000, 4310, 3496, 3686,34079,34079, 4379, 1502,
 4395, 4437, 2015,  235, 2793, 2799, 2089,    0,    0,    0,
    0,    0, 2574, 2408,    0,    0,    0,    0,    0,    0,
 2522,    0,41984,41984,    0,    0,    0, 2420,    0,    0,
    0,    0,    0,35830, 1882,44011,    0,    0,35076, -180,
    0, 2409, 2410,    0, 2309,    0,    0,34079, 1882,    0,
 2378, 2378,    0,    0, 2416,35076, 2577, 2528,    0,    0,
    0, 1360,    0,    0,    0,    0,    0,    0,    0, 2125,
 2477,    0, 1034, 2713,43271,    0, 2523, 2425, 2526, 2426,
 2572, 2538, 2578,    0,    0, 2834,    0, 2836, 2533, 2125,
   60,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1935,43271,    0,    0, 1360,    0,    0,    0, 2506,    0,
 2844, 2607,    0,    0,    0, 2530,  417,    0,    0, 2128,
 2531, 2713, 2849, 2851,    0,  372,    0, 2713,34079, 2859,
 2863, 2713, 2865, 2866,34079,34079, 2713, 2868, 2869, 2870,
 2872, 2874, 2875, 2876, 2880, 2884, 2886,    0,    0,42171,
 2888,    0,43271,    0,43271,    0,    0,    0,    0,    0,
34079, 2889,    0,    0,34079,    0,    0,    0,34079,    0,
    0, 3777, 3975,34079,34079,34079,34079,34079,    0,    0,
    0,    0,    0,    0,    0,34079,    0,    0,43271, 2552,
    0,    0,    0,    0,  107, 2471,    0,    0, 1539,    0,
 2367, 2508, 2575,    0, 2374,    0,27049, 2905,    0,    0,
    0, 2045,    0,    0,    0,    0,    0,    0, 1838,34079,
27049, 1751,    0,    0,36152,36152,    0,    0,    0,    0,
 2608,43271, 2147,    0,    0,    0, 2906, 1335,43271,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2378, 2378,    0,    0,    0,    0,    0,    0,    0,
    0,  -31,34079, 1183,    0, 2493,    0, 1183,    0,    0,
 1498, 2713,    0,    0,    0,    0, 2713, 2713,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,43271,
 2620,    0, 2713,    0,    0, 3991,    0,    0, 4039, 4084,
 4130, 2713, 2212, 1740,    0,    0,    0,    0, 2644, 2513,
41022, 2901,    0,    0, 2666,    0,    0,    0,    0, 2541,
 2535,   76,43271, 2401,    0,    0,    0, 2713, 2926,    0,
   76,    0,    0,    0, 2147, 1335,    0,    0, 2597,    0,
    0,    0,    0, 2464, 2465, 2713,    0,    0,    0,    0,
 2932, 2937, 2939,    0,    0,    0,    0,    0,34079,    0,
34079,    0,40041,    0, 1006,    0, 2513,    0, 2125,    0,
 2665, 2647, 2576,    0, 2061, 2389, 1882,34079,    0, 2597,
  481, 2147, 2612, 2617,    0,    0,    0,    0,    0, 2942,
43271,    0,43271, 2713, 4250,43271,  -66,    0, 2946, 2658,
34079,    0,    0,43271,43271,43271,    0,    0,    0,    0,
    0, 2668,    0,    0, 2929,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  410, 2935,    0,    0,    0,    0,    0,    0,    0,43271,
43271,  114,  143,    0,    0,  593, 2957, 2389,    0,43271,
    0,    0,    0,    0, 2147,  984,  984,    0, 2703,    0,
 2565,    0,    0,    0, 2964,    0,34079,34079,27049, 2713,
    0,    0,    0,    0,43271,35830,    0,    3, 2966,    0,
    0,    0,    0,    0,    0, 1006,36152,36152,    0, 1987,
 2573, 2963,    0, 2556,  753,    0,    0,    0,    0, 2713,
 1626,  291,    0, 2676, 2471, 2517, 2681,27049,    0,    0,
    0,    0, 2970, 2979,    0,    0,    0,35830, 2595,35830,
34079,35830,  450,    0,34079, 2471,    0, 2471, 1851,  687,
 2723, 2096, 2721,35830, 2736, 2727,    0,    0,    0,  145,
43271,    0,    0,    0,    0,    0,    0,    0,
};
static int yyrindex[] = {                                   2619,
    0,  227,   40,    0,    0,    0,    0,    0,    0,    0,
    0,    0,38793,  148,    0,    0,    0,    0,    0,    0,
    0,    0, 3033,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  161,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  778,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2701,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -10, 2673,    0,    0,    0,  137,    0,  137,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2677,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  778,    0,    0, 1064,    0,    0,    0, 2026,
    0,    0,    0,    0, 2627, 2772,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  401,
33083,  624,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   20,    0,    0,    0,    0, 1092,    0,    0,
    0,    0,    0, 1072,    0,    0,    0,    0,    0,  201,
    0,38552,    0,    0,    0,    0,    0,    0,    0,    0,
   20,    0,  383,    0,    0, 2998,    0,  941,    0, 2776,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  591,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  156,    0, 2781,    0,    0,    0,
    0,    0,43567,    0,    0,    0,    0,    0, 1303,    0,
    0,    0,    0,    0,    0,    0,43715,    0,    0,    0,
    0,    0,    0,    0,  966,    0,    0,    0,    0,    0,
 1217,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   20,    0, 2998,    0,  941,    0, 2776,    0,    0, 1314,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  229,    0,    0,    0,    0,33415,30426,    0,    0, 2643,
  458,    0,    0,    0,    0, 1343,    0,    0,    0,    0,
    0,    0, 1350,    0,    0,    0,  256,    0,    0,    0,
    0, 2781, 1267,42975,    0, 1370,    0,    0,    0,    0,
  522,    0,    0,    0,    0, 2601, 2601,    0,    0,    0,
 1397,  257,    0,    0,    0,    0,    0,    0,    0,    0,
 2781,    0,    0, 1338,    0,    0,    0,    0,    0,    0,
    0,    0,    0,33079,    0,    0,  296,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3299,    0,    0,    0,    0, 2738, 2738,    0,    0,    0,
    0,18120,    0,    0,    0,19860,20208,    0,20556,20904,
    0,    0,    0,    0,    0,    0, 3652, 4005, 4358, 4711,
 5064, 5417, 5770, 6123, 6476, 6829, 7182, 7535, 7888, 8241,
 8594, 8947,18468,18816,21252, 9300, 9653,10006,10359,21600,
10712,11065,11418,11771,12124,12477,12830,19164,13183,13536,
13889,14242,14595,14948,15301,15654,16007,16360,16713,17066,
17419,17772,    0,    0, 2619,    0,    0,    0,    0,  888,
    0,    0,    0,    0,    0,    0,    0,21948, 1449,  222,
    0,19512,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1460,    0,    0,    0,    0,    0,    0,    0,
    0, 2619,    0,    0,    0,    0,    0,43567,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  426,    0,  426,
    0,    0, 1178,    0, 1480, 1542,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  591,    0,    0,    0,    0,
    0,    0,    0, 2781,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1464,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1461,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  946,    0,  610,    0,    0, 1186,    0,    0,    0,    0,
    0,  276,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1487,    0,    0, 1465, 3091,    0,    0,
    0,25601,    0,    0,25861,    0,    0,25873,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  224,  250,    0,    0,    0,    0,25939,25613,    0,
25873,    0,    0,   20,    0,  941,    0,    0,    0,    0,
    0,    0, 1267,  941,  616,    0,  124,    0,    0,    0,
    0,    0,    0, 2659,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,36391,36520,36695, 2619,    0, 1704,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3014,  167,34411,    0,34411,    0,    0,
    0,34411,34411,    0,34411,    0,    0,    0,    0,    0,
    0,    0,    0, 2619, 2622,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
34411,    0,23338,23684, 3018,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3017, 1657,    0, 1686, 1509,    0,    0,    0,
36652,    0,    0,    0,    0,   90,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  258, 1529,    0,    0,    0,
 1529, 2619,24673, 2729,    0,    0,    0,    0,    0,    0,
    0,  258,    0,    0, 1532,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  743,    0,
    0,    0,    0, 2635,    0,    0,  296,    0,    0,    0,
    0, 2619,    0, 1267,  941,  616,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  299,    0,    0,    0,35530,
    0, 2755,    0,  851, 1027,    0,    0,    0,  519,    0,
    0,  928,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  875,    0,    0,    0,    0,    0, 3031, 1944,    0,
    0,20918,19526,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  391,  749,
  790,    0,    0,    0,    0,    0,    0, 1538,    0,    0,
    0,    0,    0,    0,    0, 1305,    0,    0,    0,    0,
    0,25861,    0,    0,    0,    0, 1193,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2781,    0,    0,
    0,  282,    0,    0,    0,    0,    0,    0,    0, 2619,
    0,  140, 1267,    0,    0,42646,    0,    0,    0,  231,
    0,    0,    0, 2619,    0, 2619,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3040,    0,    0,
  133,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  332,  816,  953, 1710,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   81,    0,    0,    0,    0,22296,24030,
24376,22644,22992,    0,    0, 1535,    0,    0,    0, 1395,
    0,    0,    0, 3041,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1182,    0,    0,    0,    0,    0,
    0,    0,    0, 1541,    0,    0,    0,    0,    0,    0,
    0, 2729, 2119,    0,25260, 2744,    0, 2744, 2729,    0,
 2744,    0,    0, 1541,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  167,  144,    0,
    0,    0,    0,    0,    0, 2619, 1267,    0,    0,    0,
    0,    0,    0,    0, 1873,    0,  369,    0,    0,    0,
 2601, 2645,    0,  943,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   90,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1733,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1559,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1234,    0,
    0,    0,    0,    0, 1403,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  941,  616,   90, 2601, 1578, 1267,
    0, 2823,    0,    0,    0, 1590,    0,    0,    0,    0,
    0,    0, 1599,  155,    0,    0,    0,    0,    0,    0,
    0,    0,42646,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2320,    0,
    0,    0,25698,    0, 2619,    0,    0,    0,    0,    0,
    0,36814,    0,36894,    0,37037,    0,    0,    0,    0,
    0,    0,    0,37057,    0,    0,37176,    0,    0,37274,
    0,37410,    0,    0,37532,    0,    0,37567,    0,    0,
 2587,    0, 3014, 1529,    0,    0,42655,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2671,    0,    0,    0,    0,  780,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3057,
 3057,    0, 3058,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  151, 1611,  172,  196,    0,    0,    0,
 1611,    0,    0,    0,    0,    0, 1650,    0,    0,24975,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  133,    0,
   90,    0, 2823,    0,    0, 1590,    0,    0,    0, 1739,
 1953,    0,  425,    0,    0,    0,    0, 1089,    0, 2672,
    0,    0,    0,    0, 2102,    0,    0, 3104,    0,    0,
 1733, 2701,    0,    0,  839,  879,  980, 1108, 1125, 1288,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  285,    0,    0,    0,    0,20222,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1656,    0,    0,
   90,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1662,    0, 1667,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,    0,    0,
    0, 2619, 2619,    0,    0,    0,    0,    0,    0, 2619,
 2619,    0, 2619, 2619,    0,37625,    0,37769,    0,37801,
 2619, 2619, 2619, 2619,37831, 2619, 2619, 2619, 2619, 2619,
 2619, 1572,    0,    0, 3060,    0,    0,    0,    0, 3071,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3077,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,43863,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1529,30377,    0,    0,    0,    0,
    0, 1700, 1702,    0, 2729,    0,    0,    0, 1529,    0,
    0,    0,    0,    0, 1662,    0,    0,  249,    0,    0,
    0, 1993,    0,    0,    0,    0,    0,    0,    0, 1827,
 3176,    0,    0, 3079,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1705,
  289,    0,    0,    0,    0,    0,    0,    0,    0,   90,
 2823,    0,    0,    0,  300,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  868,
    0,37976,    0,    0,    0,   81,    0,38006,    0,    0,
    0,38038,    0,    0,    0,    0,38181,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3014,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,39417,    0,    0,    0,
    0,    0,    0,    0,    0, 1719,    0,    0, 3081,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2333,    0,
    0, 1772,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,21614,    0,    0,    0,    0,  204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  340,    0,    0,    0,    0,
 3058,38275,    0,    0,    0,    0,38368,38414,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2111,    0, 3088,    0,    0,    0,    0,    0,    0,    0,
    0, 2123,    0,    0,    0,    0,    0,    0,    0,39729,
    0,    0,    0,    0,    0,40695,    0,    0,    0,    0,
    0,38536,    0,  149,    0,    0,    0, 1616, 2326,    0,
 1197,    0,    0,    0,21614, 1930,    0,    0,  153,    0,
    0,    0,    0,    0,    0, 3079,    0,    0,    0,    0,
 3093,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  550,    0,    0,    0, 2801,    0,  865,    0,
    0,    0,    0,    0,    0,    0, 1529,    0,    0, 2404,
    0, 1733, 3127, 3510,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2127,    0, 3078,    0,    0,    0,    0,
    0,    0, 2051, 2065,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1823,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 3084,    0, 2635,    0,    0,
    0,    0,    0,    0,21614,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3085,    0,    0, 3087,
    0,    0,    0,    0,    0,    0,    0, 2619,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2619,
    0,  147,    0,    0,    0,    0,    0,    0,    0, 3090,
 3092,    0,    0,    0, 3094,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 3101,    0, 3102,    0, 2861,
    0,    0,39105,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yycindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2596,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1435,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2688,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3126,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2805,    0, 2814,
    0,    0,    0,    0, 3141,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3146, 3147, 3150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3159,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2696,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2698,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0, 1012,    0,
    0, 1022, 1024, 1033,    0,    0,    0,    0,    0,-1449,
    0, 1041, 1042,   -3, 3002, 2518,  -40, -876, 1614, 3026,
 2217, 3055, 2564,    0,    0, 2858, -114,  -43,    0,    0,
    0,    0,  127,  152,  -65,  -93,  -72, -367, 2857, 2277,
    0,    0,    0, 1052,    0,    0,  -55, 1826, -796,  -74,
-1329, 2435, 2130, -423,    0, 1850,    0, 3240, 2136, 2206,
    0,    0,    0, -969,  -56,    0,    0,    0,    0,    0,
    0, 3273,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -70,    0,
 -755, -674, 1862, -736,  848,-1023,    0,    0,    0,    0,
 -425, -436, -828, 1884, -489,  -60,    0, -721, 2188,-1325,
    0,-1053, -390,-1121,    0, 1438,    0, 1463, -476, -835,
  -23,  -61,-1100,    0,    0,    0,    0, 1880,    0,    0,
    0,    0,    0,    0,    0, 2841,    0, 2524,    0,    0,
    0, 1973,    0, 2930, -438, 1489, 1899, 2873, 2878,    0,
    0, -505, 2262,    0,  -50, -961, -396,    0,    0,-1077,
-1054,-1036,-1025,-1006,    0, 1476,-1454,    0, 1175,-1560,
    0, 2568,    0,    0,    0, 1176, 1184, 1105, -230, -403,
-1226,-1217,    0,    0,    0, 2292, -793,    0, -889,    0,
 2074, -852,-1483,    0,    0,    0,    0,    0,-1548, -478,
    0,    0,    0,    0,    0,    0,-1020,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,-1240,    0,    0, -968,    0, -959, 1166, 1208,    0,
 1090,    0,    0,    0,    0,    0,    0,    0, -641,    0,
    0, 2411, -468, -616, 1742, -293, -466, -844,-1262,    0,
    0,    0,  -57,    0,    0,    0,    0,    0, 2908,    0,
    0,    0,    0, 2928, 2604,    0,    0,    0,    0,    0,
   -9, -653,    0,    0, 2923,    0,    0,    0,    9,    0,
    0,    0,    0, -683,    0, -502, 2253, -500, 1714,    0,
    0,    0,    0,    0,    0,-1303,    0,    0,    0, 2549,
    0, 2270,    0,    0,    0,    0,    0,    0, -127,    0,
 3427,    0, 3221,    0,    0,    0, 3024,    0,    0,    0,
    0,    0,    0, 2722,    0, 2719,    0,    0,    0, 2407,
    0,    0,    0, -901,    0, -366,    0,    0,    0,    0,
    0,    5, -879, -885,-1136,    1,    0,  -14, 1422, 3206,
    0,  775,    0,    0,    0,    0,    0,    0, -645,    0,
    0, -989,    0, 2976, 1840,    0, 2068, -972, -890,    0,
 -925, 2441,-1462,    0,    0,    0,    0,    0,    0,    0,
 2112,    0,    0,    0,    0,  193,  675,    0, 1258, 2534,
    0, 1500,    0, 1675,    0, -604,    0,    0, 2081,    0,
    0,-1028, -990,    0, 1609, 1613,    0,    0, 1198,    0,
    0, 2735,    0,    0,    0, 1281, -608, 1298, 1300, 2462,
 2142,-1431,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1582, 1971,
    0,    0,    0, -987,    0,    0,    0, 2920,    0, 2107,
    0,    0,    0,    0,    0, 1897,    0,    0,    0, -701,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,-1423, 1925,    0,    0,
};
#define YYTABLESIZE 44609
static int yytable[] = {                                     223,
   89,  347,  246,  402,   53,  320,  239,  243,  363,  254,
  342,  391,  358,  986,  338,  784,  787, 1009,  355,  323,
  343,  810, 1086,  326,  240,  382, 1112,  388, 1410,  879,
 1317,  351,  882,  392,  883, 1375,  356,  714,  390, 1318,
 1350,  852,  331,  386,  355, 1377,  394,  783,  786,  315,
  318, 1411,  322,  325,  239,  330,  333,  387, 1417, 1241,
 1199,  344,  318,  333,  548,  325,  395,  239,  330, 1412,
  362,  223,  333,  368, 1616,  385, 1106, 1378,  816, 1050,
 1413,  905,  378,  393,  239,  380,  318, 1215,  378,  333,
  322,  325, 1218,  239,  330,  362,  223,  333,  368, 1414,
  325,  846,  240, 1121, 1564, 1031, 1352, 1304,  823,  814,
 1067,  389, 1028,  777,  820, 1386, 1625, 1393, 1415, 1211,
  541,  853, 1675,  172, 1397, 1333,  782, 1270,  460, 1718,
  996,  994,  866,  995, 1279,  997, 1009,  898, 1722,  173,
 1916, 1177, 1853,  896, 1456,  785,  877,  670,  889,  657,
 1239,   88,  286, 1419,  174,  402, 1048,  457,   88, 1826,
  744,  767, 1828, 1337, 1428, 1156,  853, 1462,  657,  657,
 1183,   54,  657, 1066,  408, 1165,  450,  411, 1024, 1380,
  912, 1388,  172, 1711,  455,  409, 2326,  896, 1617, 1157,
 2041,  866, 1696,  286, 1239,   55,  286, 1884,  173, 1439,
  192,  744,  896,  912,  451,  877,  670,  889,  453, 1239,
  419,  286, 1870,  174,  402,  344,  239,  239,  344,  744,
  764,  400,  223,  600,  333,  853,  670,  246,  746, 1477,
   54, 1385,  243, 1594,  406,  240, 1118,  318,  325,  239,
  330,  362,  445, 1913,  912,  549,  254,  912,  828,  623,
 1735,  738, 1503,  408,   55,  553,  193,  903, 1001,  192,
  505,  736,  912,  406,  600,  799, 2184,  600, 1180,  746,
 1149,   89,   68,   97,   89,  457, 1296, 1297,  850,  509,
  400,  146,  600,  298,  159,  670,  379,  746,  158,  828,
  623,  536,  656,  623, 1643,  832, 1509,  657,  745,  219,
 1076, 1957, 1517, 1707,  136,  225, 1150,  828,  623,   94,
 1108, 1101, 2346, 1905,  553,  193,  903, 1142, 1323, 1123,
 1274, 1275,  882, 1234,  883,  799, 1440,  110, 1665,  519,
 1709, 2359, 1105,  519,  457,  808, 1608, 1234,  136,  745,
  146, 1872,  768,  159, 1022,  700, 1317,  158,  708, 1307,
 1713, 1130,  510,  227,  832, 1318, 1314,  745,  219,  311,
 1073, 1324,  714,  734,  852,  992, 1710, 1726,  861,  226,
  993, 1510,  136, 1261, 1261, 1201, 1261, 1261, 1261, 1666,
   99, 1376, 1653,  742, 1422,  334,  344,  547, 2042,  344,
  443,  408,  256,  753,  763,  716,  223, 1938, 1560, 1561,
  748,  740,  520, 2003, 1644, 1151,  520, 2006, 1158,  861,
  322, 1704,  861, 1927,  239, 1351, 2040, 1446, 1613,  410,
 1671,  298, 1261, 1143,  823,  700,  800,  861,  752,  755,
 1929,  246, 2308,  243,  737,  721,  243,  759, 1708, 1235,
 1591,  748,  228, 2325, 1890, 2385,  758,   17,  257,  443,
  815, 1234, 1179, 1235, 1431, 1381, 1913,  866, 1276,  748,
  700, 1743,  343, 1641,  831,  823,  893,  833, 1681,  775,
  775, 1943,  847,  896,  849, 1144, 1848, 1946, 1909, 1948,
 2155, 1626, 1337,  823,  700, 1958,  851, 1583, 1678,  902,
 2371,  344, 1669,  172,  894,  911,  744,  192,  866,  600,
  600,  344, 1679,  344,  600,  344,  904,  600,  836, 1907,
  909,  912, 2177, 1441, 1947, 1425,  866, 1944,  864, 1463,
  600,  566,  896, 1234, 1658,  623,  623,  318,  325,  330,
  623,  896, 1889,  623, 1234,  781,  730,  239,   97,  457,
  908,  239,  322, 1330,  192,  920,  623,  670, 2185, 1455,
 1874,  917, 1234,  193,  781,   87,  402, 1164, 1455,  864,
  781,  159,   87,  828,  746,  158, 1337, 1235, 1182,  781,
 1693,  781,  556, 1807,  670,  172,  172,  864,  912, 1023,
  566, 2135, 2067, 1486,  828,  896,  896, 1047,  877,  853,
  830,  173,  173, 1605,  600, 1239, 1155, 1515, 1502, 1516,
  193,  258, 1190, 2158, 1046,  744,  174,  174, 1261, 1607,
 1198, 1368,  172, 1261, 2219,  600,   54,  405,  903,  553,
  623,  600,  400,  853, 1337,  146,  670,  828, 2055, 2056,
 2107, 1734,   89, 2036,  745, 1383,  828, 1740, 1436, 1235,
   55,  623, 1620,  219,  286,   99,  990,  623, 1850,  830,
 1235, 1893,  896, 2328,  443,  600,  714, 1851,  172,  987,
  866, 2298, 2203, 1188,  853,  143, 1612, 1021, 1235, 1019,
  753,  896, 2054,  746,  832,  853,  889, 1876, 1026,  828,
 1695,  623,  853,  861, 1042,  229,  336,  337, 1924, 1063,
 1699,  344,  720,  828,  853,  912, 2313, 2314, 1489,  172,
  239,  325,  716, 1647,  861,  192,  755, 1649, 1211,  239,
 1064, 1234, 1652, 2091,  325,  239,  820, 1389, 1081, 1368,
  716, 1950,  254, 1476, 2318, 1075,   53,  708, 1078, 2098,
 1617, 1482, 1917, 1852, 2333, 1885,  748,  996, 1648,  823,
 1705,  239,  997,  745, 1758, 1906, 1741, 1102,  441, 1683,
  489,  823, 1435, 2252, 1700, 1701,  239,  828, 1246,  239,
  823,  193, 1109,  700, 1499,  443, 2344, 2105,  344, 1676,
 1940, 1159,  866, 1001, 1126, 1483,  828,  672, 2296,  443,
  537, 1384, 1505,  600, 1474,  566, 1886, 1887,  355,  442,
 1766, 1234, 1160,  866, 1261, 1261, 1261, 1261, 1261, 1261,
 1261, 1261,  490,  823,  832, 1483, 1401,  441, 1014,  623,
  344, 1013,  823,  861, 1117,  344,  230, 1490, 1337, 1767,
 1117,  700, 1615,  832,  700, 1759,  261, 1235, 1891, 2182,
 2183,  837, 2386,  864,  143,  143,  672, 1187,  448, 1706,
  700,  838, 1483, 1626, 1192, 1193,  996,  994,  442,  995,
  859,  997,  343, 2319,  864,  823, 2069, 1262, 1262, 1202,
 1262, 1262, 1262, 1491,  377,  538,  700,  110, 2347,  823,
 2057, 1586, 1587, 2181, 1402, 2021, 2089,  861,  449,  457,
 2353, 2064, 1626, 1774, 2037, 2068, 1484, 1032, 1337, 2327,
 2077,  859, 1234,  344,  859, 1966,  861,  448, 2053, 2106,
  539, 1268,  866, 1261, 1492, 1317, 1262, 1235,  623,  859,
  566,  623,  542, 2297, 1318,  247, 1674, 1673,  247, 2094,
 2095,  700, 2097,  247, 2099,  247, 1248,  210, 1032, 1261,
 1308, 1032,  987,  823, 1323,  247,  234,  449,  853, 1030,
  333,  700,  211, 2173, 2174,  545, 1032,  839, 1677,   17,
 2375, 1833,  823, 1942,  700,  996,  994,  752,  995,  853,
  997,  738,  700,  864,  700,  695, 1338, 1748,  987,  830,
 2059, 1880,  992, 1778, 2190, 1689,  788,  993,  830,  445,
 1032,  259,  368,  111, 1319,  866,  210, 1410, 1410,  545,
  457, 1749,  344,  377, 1307, 1307, 1199, 1307, 1307, 1307,
 1021,  211, 1365,  344,  545,  344,  901,  344, 1235, 1588,
 1411, 1411,  441,  542,  716,  753, 1245,  742,  542, 1374,
  319, 1779,  325,  343,  695, 1368,  852, 1081, 1412, 1412,
 2165, 2166, 2167,  239,  325,  235,   53, 1626,  445, 1413,
 1413, 1080,  236, 1307, 1400, 1371,  864,  519,  239, 2356,
  239,  755, 1736,  442, 1416,  344, 1831,  739, 1414, 1414,
  759, 1372,  700,  677,  344, 1432, 1928,  852,  853, 1936,
  542,  674, 2172, 2063,  775, 2345,   53, 1415, 1415, 1505,
 2111,  992,  355, 1188, 1188,  852,  993, 1337,  865, 1996,
 1433,  431, 1262, 1437, 1626, 1445, 2092, 1262,  334,  830,
 2357, 1175,  448,  344,  543,  766, 1452,  444, 1471, 1472,
 1473,  740, 1460,  788,  336,  337, 2096, 2366,  830, 2368,
  520, 2370,  677,  441,  447,  355,  355,  355,  741,  865,
  674,  344,  853, 2380,  344,  369, 1356,  441,  708, 1488,
  623,  334,  449, 1811,  794,  336,  337,  865, 1475, 1357,
  431,  853,  343,  789,  920, 2286,  350, 2225, 2226, 2227,
 1453,  247, 2230, 1500,  442,  859,  444, 1176,  417, 2065,
 2066,  247, 1358,  623, 1867, 1867, 1871,  705,  442,  239,
  370, 1733, 2257,  447,  795,  210,  859,   87, 1051,  708,
  992,  368,  157,  344,  239,  993,  827,  210, 1145,  431,
  211,  788,  920, 1514,   53, 2351, 2352,  425,  917,  431,
  373, 2162,  211,  448,  371,  623,  676, 2103,   53,  375,
   53, 1188, 1361, 1032,  210, 2171, 2293,  448, 2001, 1307,
  210, 1399,  210,  623, 1307,  383,  705,  827, 1626,  211,
 1236, 1242,  660,  445,  396,  211, 2052,  211, 1101, 1410,
 1410,  157, 1902,  449, 1904,  827, 1595,  996,  994, 2331,
  995, 1855,  997, 1237, 1858, 1621, 1941,  449, 2279,  623,
  333,  210, 1411, 1411,  623,  676,  113,  623, 1262, 1262,
 1262, 1262, 1262, 1262, 1262, 1262,  211,  446, 1032, 1724,
 1412, 1412,  623,  519,  623,  859,  753, 1899, 1750, 1945,
 1319, 1413, 1413,  695,  618,  879,  992, 1900,  882,  808,
  883,  993,  115,  663, 2280,  431,  344,  368, 1238, 1146,
 1414, 1414, 1751, 1538,  623, 2281, 1147,  788,  513,  716,
  716,  514,  755, 1724, 1081,  695,  343, 1539, 1725, 1415,
 1415,  852,  464,  859,  398,  618,  446, 1317,  618,  465,
  431, 1189,  498, 2334,  445,  431, 1318, 2209,  781,  859,
  431,  695,  852,  618,  695,  618,  520, 1250,  445,  461,
  507,  444,  663,  515,  399, 2022,  116,  344,  859,  403,
  695, 1540, 1727,  759,  325, 1367,  117, 1262,  447, 1317,
   53, 1317, 2335, 1317, 1033, 1728,  201,  499, 1318,  404,
 1318,  464, 1318,  865, 1929, 1317,  695, 2215,  465, 1541,
  407,  118,  355, 1262, 1318, 1307, 1307, 1307, 1307, 1307,
 1307, 1307, 1307, 2282,  865, 2071,  554, 1761,  461,  343,
  781, 2072,  210, 1765,  559, 1033, 2075, 1753, 1033, 2336,
  441,  908,  965, 1742,  355,  412,  598,  211,  405,  708,
  355,  310, 1714, 1033,  808,  201, 1528, 1447,  908,   45,
  555,  695,  809,  559,  621, 2073,  431, 1009,  157,  157,
  344,  852, 1542, 2342,  239,  247, 1136,  334, 1137,  715,
  431,  695,  444,   91,   92,  811,  202, 1033, 1212,  808,
  344,  623,  992,  413,  695,  598,  444,  993,  812,  447,
  983,  984,  985,  500, 1529,  621, 1812,  405,  621,  623,
  623,  827, 2363,  447,  623,  705,  343,  623,   45,  555,
  420,  501,  559,  621, 1307,  621,  442, 1530,  892, 1127,
  623,   49,  827,  865,  403,  852,  623,  219,  715, 1859,
  908,  696,  272,  996,  994,  202,  995,  705,  997,  586,
 1307,  446,  586,  239,  852,  502, 1018,  344,  568, 1017,
  248, 1860,  618,  157,  444, 1857, 1867,  586, 1097,  586,
 1098, 1802,  700,  705, 1212,  827,  705,  148,  447,  618,
  618,  618,  272,  446,  827,  618, 1856,  892,  618,  419,
   49,  249,  705,  403, 1212,  250,  219,  459,  186,  908,
  696,  618, 1319,  482,  623, 1128,  251,  618,  344,  481,
   43, 1071,  490,  344, 1070,  826,  865,  568,  705,  716,
  325,  330,  716,  362,  223,  623, 2304,  827, 2305, 1087,
  506,  623, 1088, 1892,  336,  337,  148, 1090, 1878,  511,
 1094,  827,  623,  243, 1099, 1129, 1212,  522,  419,  890,
  325,  325,  788,  716,  716,  149,  826,  186,  272,  826,
  623,  228,  446,  523,  239,  623,  137,  996,  994,   43,
  995, 2206,  997,  705,  826,  618,  446,  525, 1257, 1258,
 1259, 1260, 1261, 1262, 1263, 1264,  996,  994, 1592,  995,
 1951,  997, 1252,  705,  623,  788,  618, 1240,  272,  873,
 1240,  874,  618,  829,  247,  827,  705, 1956,  890,  788,
  917, 1926, 1961,  618,  149, 1240, 1114, 1240,  891, 1113,
  228,  559,  621, 2372,  827,  137,  247,  252,  545,  247,
 1033,  618,  281,  559,  534, 1255,  618,  917,  783,  621,
  621,  621, 1448, 1449,  829,  621,  247,  917,  621, 1299,
  551, 1330, 1330, 1200, 1330, 1330, 1330,  550,  873,  552,
  874,  621,  829,  247,  555,  618,  559,  621,  559,  996,
  994,  832,  995,  281,  997, 1217,  281,  891,  992,  783,
 2202,  996,  994,  993,  995,  586,  997, 1265, 2020,  144,
  144,  281,  239,  623, 1244, 1033, 1303,  783, 1249, 1001,
 1330, 1254,  705, 1348, 1481,  586, 1347, 1480,  556, 1269,
 1802, 1271,  832, 1266,  709, 1277, 1278,  715,  711, 1281,
 1282, 1283, 1284, 1285, 1289, 1295,  247, 1298,  719, 1301,
  832, 1991,  724, 1501,  219,  621, 1207,  725,  660,  726,
 1309, 1310, 1311, 1312, 1313,  660, 2349,  727, 1320,  715,
  660,  728, 1614,  716,  716, 1001,  621, 1624,  729, 1319,
 1623, 2038,  621,  733,  618, 1992,  243,  247, 1226,  325,
  247,  621,  830,  621, 2078,  715,  731, 1993,  715,  696,
 1222,  219,  526, 1212, 1672,  247,  325, 1480, 2373,  219,
  746,  621,  996,  994,  715,  995,  621,  997, 2383,  735,
 2384, 2093,  992, 2387,  843,  239, 2388,  993, 1602,  996,
  994,  696,  995,  830,  997,  527, 1379,  528,    4,    7,
  715,  992,  219,  747,  219,  621,  993,  748, 2015,  912,
  826,  830,  239, 1240, 2132,  749, 2131,  696,  843,  529,
  696,  751,  826, 1297,  343, 1716,  219,  762, 1715,  770,
  843,  826,  784, 1240,  996,  994,  696,  995,  769,  997,
  772, 2358, 1721, 2179,  530, 1720, 1756,  112, 2151, 1480,
  912,  219,  773,  912, 1849,  715, 1875, 1617,  343, 1001,
  239,  778,  696,  322, 1297,  344, 1330, 1297,  912, 2031,
 2033, 1330,  219,  784,  826,  715,  784,  774, 1802,  780,
  492,  793, 1297,  826,  992,  113,  797, 1877,  715,  993,
 1001,  784,  493,  804, 2032, 2034,  992,  114,  829, 2156,
 1895,  993, 2180, 1480,  621,  814, 1965, 1240,  829, 1001,
  829, 2176, 1656,  996,  994, 1659,  995,  696,  997,  829,
 2008,  115,  219, 1001,  813,  494,  826,  495, 2187,  805,
  806,  219, 2189,  783, 2201, 2019, 1577,  696, 2018,  818,
  826, 2220,  239,  783,  829,  783, 1518, 1519, 1523,  322,
  696, 1532, 1534, 1536,  783, 1544, 1547, 1550, 1552, 1555,
 1558,  832,  829,  843,  814, 2164,  832,  844, 1001, 1565,
 1566,  829, 1568,  899, 1570,  848, 1241, 1573, 1574, 1575,
 1576, 2291, 1578, 1579, 1017,  116,  903,  832, 1241,  378,
 1246, 1241,  708,  996,  994,  117,  995,  783,  997, 1584,
  322, 1589, 1246,  379,  826, 1246,  783,  992,  906,  912,
  996,  994,  993,  995,  829,  997, 2378, 1604,  944, 1001,
  118,  344,  309,  826,  992,  309, 1610, 1611,  829,  993,
  832,  851,  753,  344,  851, 1356,  946,  949,  957,  996,
  994,  947,  995, 1189,  997, 2307, 1189, 1190, 1357,  783,
 1190,  948, 1330, 1330, 1330, 1330, 1330, 1330, 1330, 1330,
  950,  783,  951,  783, 1601,  952, 2374,  830,  755,  992,
  953, 1358,  660, 2276,  993,  955,  660,  830,  956,  830,
  958,  660,  832,  959, 1359,  912,  912,   53,  830, 2321,
  962,  968,  829,  912,  969,  970,  832,  971,  972, 1297,
 1297,  322,  973,  322,  974,  975,  318, 1297,  976, 1582,
  977,  829,  978,  979, 2312, 1514, 1514,  980,  981,  753,
 1297, 1361,  982, 1090,  991, 1094, 1688,  783,  998,  999,
  219,  830, 2200,  996,  994, 2199,  995, 1001,  997, 1003,
  830, 1002,  219, 1015, 1012, 1016,  783,  784,  992, 1027,
  318, 2323, 1044,  993, 1053,  755, 1058,  784, 2324,  784,
  832, 1330, 1059, 1055, 1062, 1065, 1069, 1072,  784,  219,
 1074,  819, 1077, 1083, 1084,  219,  808,  219, 1100,  832,
  912, 1319,  799,  830,  912, 1514, 1103, 1330, 1837, 1391,
  996,  994, 1110,  995, 1297,  997, 1115,  830, 1141,  980,
 1140,  912,   53, 1153,  781,  822, 1161,  912,  578,  579,
  580,  784,  785, 1162,   53, 1297,  219, 1167, 1168, 1170,
  784, 1297, 1169, 1319,  219, 1319, 1173, 1319,  992, 1172,
 1362, 1178, 1184,  993, 1185, 1191,  588,  589, 1201, 1319,
  980,  912, 1203,  980, 1207,  992,  822, 1206, 1204, 1212,
  993, 1514,  660,  785, 1213, 1297,  785, 1214,  980, 1782,
 1216,  830,  489,  784,  822, 1785, 1786, 1272, 1788, 1790,
 1280,  785, 1305, 1326,  992,  784, 1795,  784, 1329,  993,
  830, 1327, 1179,  286,  814, 2026,  657, 1339, 1340, 1345,
 1341, 1343,  219,  814,  996,  994, 1593,  995, 1816,  997,
 1349,  912, 1354, 1024, 1821, 1976, 1369, 1824,  721, 1825,
 1589,   17, 1382, 1589,  814, 1584,  786, 1387, 1017, 1832,
  660, 1834, 1390, 1396,  286, 1394, 1398,  286, 1835,  786,
 1836, 1406, 1420, 1839, 1840, 1841, 1842,  786, 1427, 1847,
 1421,  784,  286, 1429, 1434, 1430, 1451, 1468,  814, 1458,
  996,  994,  786,  995, 1442,  997,  782, 1443, 1444,  782,
  784,  782,  782,  782,  782,  786,  782, 1470,  992, 1478,
 1508, 1525, 1562,  993,  782,  782, 1563,  219, 1392,  996,
  994, 1569,  995, 1571,  997,  782,  782, 1581,  782,  782,
  782, 1580, 1606,  992, 1617,  782,  782,  814,  782,  782,
 1618,  782,  786, 1619,  782,  782,  782,  782,  782,  782,
  782, 1622, 1650, 1642,  814,  782,  782,  782, 1645,  782,
  782,  782, 1651,  782, 1654,  992, 1914, 1572,  996,  994,
  993,  995, 1670,  997,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782, 1660,  782,  782,  782,  782,  782,
  782,  980,  782,  782,  782,  782,  928,  782, 1661,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782, 1663,  782,  782,
  782,  782, 1664,  782,  782,  782,  782,  782, 1962,  782,
  782,  782,  782,  782, 1968, 1685, 1356,  928, 1690, 1972,
  928,  786, 1682, 1697,  980, 1668, 1977,  980, 1702, 1357,
  822, 1483, 1717, 1719,  980,  928,  980,  785, 1723,  992,
  980, 1729,  822, 1730,  993,  980, 1731,  785,  980,  785,
 1732,  822, 1358, 1744, 1746, 1752, 1747, 1502,  785, 1763,
 1768,  819, 1769,  980, 1589, 1359, 1770, 1772, 1589,  286,
  286, 1773, 1777, 2047, 2012, 2013,  980,  286, 1780, 1781,
 1783, 1784, 1791,  370,  980, 1792, 1793,  980,  980, 1794,
 1234, 1796, 1797, 1798,  822,  992, 1799,  980, 1800, 1801,
  993,  785, 1361,  822, 1827, 1302,  996,  994, 1830,  995,
  785,  997, 1854,  980, 1838, 1861, 1863,  371,  996,  994,
 1609,  995, 1864,  997,  992,  660, 1888, 1028, 1896,  993,
 1596,  996,  994, 1879,  995,  980,  997, 1597,  996,  994,
  980,  995, 1897,  997,  996,  994,  822,  995, 1903,  997,
  824,  980,  980,  785,  980, 1915, 1925, 1918, 1919, 1920,
  822, 1921, 1455, 1922,  286,  785, 1923,  785, 1028, 1028,
 1028, 1028, 1028,  992, 1028, 1243, 1939, 1247,  993, 1949,
 1952, 1251, 1253, 1954, 1256,  286, 1028, 1028, 1028, 1028,
 2048,  286, 1598,  996,  994, 1533,  995, 1537,  997, 1545,
 1548,  980, 1553, 1556, 1559, 1955, 2112, 1960, 1967, 1969,
 1300, 1362, 2117, 2118, 1989, 1990, 1995, 1997,  980, 2004,
 1028, 2005,  980, 2024,  822,  286, 1599,  996,  994, 2025,
  995,  785,  997, 2027, 2028, 2030, 2035,  980, 2133, 2060,
 2043, 2045, 1589,  822, 2061, 2079, 2136, 2080, 2082, 2081,
  785, 2139, 2140, 2141, 2142, 2143, 1600,  996,  994, 2083,
  995, 2084,  997, 2144, 2086, 2085, 2087, 1808,  996,  994,
 2088,  995, 2100,  997, 2101, 2102, 1809,  996,  994, 2109,
  995, 2110,  997, 2104, 2108,  286, 1814,  996,  994, 2113,
  995,  928,  997, 2114,  928, 2115, 2116, 2168, 2119, 2120,
 2121,  928, 2122,  928, 2123, 2124, 2125,  928,  996,  994,
 2126,  995,  928,  997, 2127,  928, 2128, 2130, 2157, 2134,
 1815,  996,  994, 2161,  995, 2160,  997, 1817,  996,  994,
  928,  995, 2042,  997, 2163, 2041, 2178, 2175, 2204, 2188,
 2186,  992, 2193,  928, 2205, 2211,  993,  996,  994, 2210,
  995,  928,  997,  992,  928,  928, 2212, 2213,  993, 2218,
 2216, 2221, 2228, 2229,  928, 2231,  992, 2232, 2233, 2287,
 2288,  993, 2303,  992, 2290, 2309, 2299, 2317,  993,  992,
  928, 2301, 2320,  226,  993, 1028, 2330, 2297,  421, 1028,
 2296, 1028, 1028, 2316, 2339, 2348, 1066, 2354, 1028, 2355,
 2364, 2360,  928, 1028, 1028, 2361, 2362,  928, 2365, 1028,
 2367, 1028, 1028, 2377, 2379, 2381,  752, 2382,  928,  928,
  422,  928,    1,  859,  753,  795, 1028,  231,  992,  912,
 1028, 1028, 1028,  993,  300, 1028, 2234,   31, 2235,  189,
 1206,   33, 1028,  838, 1028, 1028,  423, 1031, 1028,  424,
   84, 1032, 1028, 1187, 1028, 2168, 1028,  819, 1028,  917,
  243,  775,  992, 1028, 1028,  425, 1028,  993,  928,  837,
  795, 1030,  821, 1818,  996,  994,  457,  995, 2310,  997,
  633, 1028, 1028,  216, 1028,  928, 1186, 1085,  866,  928,
  839,  426,  992,  260, 1028,  328, 1028,  993, 1028, 1028,
 1028, 1240, 1028,  992,  928, 1028, 1028, 1158,  993,  416,
  217,  795,  992,    0,  795, 1028,  282,  993, 1157, 1028,
  633,  633,  992,  848,  633, 1028,  360,  993, 1028,  795,
  442, 1028,  322,  358,  260,  368, 1028,  260,  359,  633,
  361,  633,  369,  992, 2340, 2341,  427, 1028,  993,  364,
  397,  382,  260, 1028, 1028,   13,  992,  282, 1028, 1028,
  282,  993,   10,  992,   16,  261,  428, 1771,  993, 1028,
 1028,  633, 1028,   16,   19,  282,   21,   24, 1028,  429,
   27, 1028,  992, 1028, 1028, 1028, 1028,  993, 1028,   31,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 2369, 1819,
  996,  994,  660,  995, 2248,  997,  261, 1028, 1028,  261,
 1028, 1028, 1028,   33, 2249,   37, 2250, 1028, 1028, 1028,
 1028, 1028,  414, 1028,  261, 2251, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 2253, 2254, 1043, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1865, 1028,  415, 1820,  996,  994,
 1366,  995,  717,  997,  718, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028,  416, 1028, 1028, 1028,
 1028, 1028, 1028, 1045, 1028, 1028, 1028, 1028, 1233, 1028,
 1342, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,  992,
 1028, 1028, 1028, 1028,  993, 1028, 1028, 1028, 1028, 1028,
 1764, 1028, 1028, 1028, 1028, 1028, 1507,  384, 1208, 1233,
 1233, 1233, 1233, 1233, 1233, 1233, 1205, 1512,  633, 1822,
  996,  994, 1762,  995,  365,  997, 1233, 1233, 1233, 1233,
 1233, 1760, 1738,  633, 1464,  633,  633,  633, 2090, 1454,
   58,  633,  856, 1755,  633, 2074, 1692, 1163, 1739,  272,
  260,   59,  765, 2058, 1426,  826, 2070,  633,   60, 1233,
  827, 1233,   61,  633, 2295,  795,  633, 1135,  795, 2302,
 1356, 2338,  282,  282, 1418,  795, 2300,  795, 1627, 2311,
  282,  795,   62, 1357, 2285, 2350,  795, 1894,  807,  795,
 1823,  996,  994, 1331,  995,  834,  997, 1998,  996,  994,
  817,  995, 1469,  997,  795, 1139, 1358, 1937,  633, 1186,
  233, 1461, 1999,  996,  994,  992,  995,  795,  997, 1359,
  993,  272,  261,  418,  750,  795, 1052, 1360, 1057,  795,
 2159,  633,  792, 1684, 1370, 2000,  996,  994,  795,  995,
 1657,  997, 1353,   63,  272, 2294, 1988, 1239, 1687, 2007,
  996,  994,  633,  995,  795,  997, 1361, 2332,  633, 2129,
 1068, 2046,  633,  992, 2044,  272, 2292,  282,  993,  633,
 2277,  272, 2278, 1364,   64, 1662,  961, 1846,   65,  283,
 1787,  795, 1829, 1694,    0,    0,    0,  633,  282,    0,
    0,    0,  633,  795,  282,  795,    0, 1257, 1258, 1259,
 1260, 1261, 1262, 1263, 1264,  272, 2010,  996,  994,    0,
  995,    0,  997,    0,    0,    0,  272,  633,    0,    0,
  283,  633,    0,  283,    0,    0,    0,    0,  282,    0,
 1233,    0, 1233, 1233,    0,    0,    0,  272,  283, 1233,
    0,    0,  795,  272,    0, 1233,    0,    0,    0,    0,
 1233,    0,    0, 1233,    0,  992,    0,    0,    0,  795,
  993,    0,    0,  795,   66, 1362,    0, 1233,    0,    0,
    0,    0, 1233, 1233,    0,    0, 1233,  272,  795,    0,
    0,    0,    0, 1233,    0, 1233, 1233,    0,  282, 1233,
    0,    0,    0, 1233,    0, 1233,    0, 1233,    0, 1233,
    0,    0,    0,    0, 1233, 1233, 1265, 1233,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  633, 1273, 1233, 1233,    0, 1233,  992,    0,    0,    0,
    0,  993, 1266,  992,    0, 1233,    0, 1233,  993, 1233,
 1233, 1233,    0, 1233,    0,    0, 1233, 1233,  992,    0,
    0,    0,    0,  993,  996,  994, 1233,  995,    0,  997,
    0, 1101, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1233,
    0,  992, 1233,    0,    0,    0,  993,    0,    0, 1273,
 1273, 1273, 1273, 1273,    0,  992,    0,    0, 1233,    0,
  993,    0,    0,    0, 1233, 1233, 2011,  996,  994, 1233,
  995,    0,  997,    0,    0,    0,    0,    0,    0,    0,
 1233, 1233, 1273, 1233, 1273,    0,    0,    0,    0, 1233,
    0,    0, 1233,    0, 1233, 1233, 1233, 1233,    0, 1233,
    0, 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233,    0,
    0,    0,  992,    0,    0,    0,    0,  993, 1233, 1233,
    0, 1233, 1233, 1233,    0,  283,  283,    0, 1233, 1233,
 1233, 1233, 1233,  283, 1233,    0,    0, 1233, 1233, 1233,
 1233, 1233, 1233, 1233,    0,    0,    0, 1233, 1233, 1233,
 1233, 1233, 1233, 1233, 1233,    0, 1233, 2137,  996,  994,
    0,  995,    0,  997,    0,    0, 1233, 1233, 1233, 1233,
 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233,
 1233, 1233, 1233, 1233, 1233, 1233, 1233,    0, 1233, 1233,
 1233, 1233, 1233, 1233,    0, 1233, 1233, 1233, 1233,    0,
 1233,    0, 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233,
 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233, 1233,
  283, 1233, 1233, 1233, 1233,    0, 1233, 1233, 1233, 1233,
 1233,    0, 1233, 1233, 1233, 1233, 1233,    0,    0,    0,
    0,  283,    0,    0,    0,    0, 1567,  283,    0,    0,
    0,    0,    0, 1273,    0, 1273, 1273,    0,    0,  992,
    0,    0, 1273,    0,  993,    0,    0,    0, 1273,    0,
    0,    0,    0, 1273,    0,    0, 1273,    0,    0,    0,
    0,  283,    0,    0,    0,    0,    0,    0,    0,    0,
 1273,    0,    0,    0,    0, 1273, 1273,    0,    0, 1273,
    0,    0,  992,    0,    0,    0, 1273,  993, 1273, 1273,
    0,    0, 1273,    0,    0,    0, 1273,    0, 1273,    0,
 1273,    0, 1273,    0,    0,    0,    0, 1273, 1273,    0,
 1273,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  283,    0,    0, 1275, 1273, 1273,    0, 1273,    0,
    0,    0,    0,    0,    0, 2138,  996,  994, 1273,  995,
 1273,  997, 1273, 1273, 1273,    0, 1273,    0,    0, 1273,
 1273, 2195,  996,  994,    0,  995,    0,  997,    0, 1273,
    0,    0,    0,    0, 1102, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1273,  992,    0, 1273,    0,    0,  993,    0,
    0,    0, 1275, 1275, 1275, 1275, 1275,  996,  994, 1844,
  995, 1273,  997,    0,    0,    0,    0, 1273, 1273, 2196,
  996,  994, 1273,  995,    0,  997,    0,    0,    0,    0,
    0,    0,    0, 1273, 1273, 1275, 1273, 1275,    0,    0,
    0,    0, 1273,    0,    0, 1273,    0, 1273, 1273, 1273,
 1273,    0, 1273,    0, 1273, 1273, 1273, 1273, 1273, 1273,
 1273, 1273,    0,    0, 2197,  996,  994,    0,  995,    0,
  997, 1273, 1273,    0, 1273, 1273, 1273,    0,    0,    0,
    0, 1273, 1273, 1273, 1273, 1273,    0, 1273,    0,    0,
 1273, 1273, 1273, 1273, 1273, 1273, 1273,    0,    0,    0,
 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,    0, 1273,
 2198,  996,  994,    0,  995,    0,  997,    0,    0, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
    0, 1273, 1273, 1273, 1273, 1273, 1273,    0, 1273, 1273,
 1273, 1273,    0, 1273,    0, 1273, 1273, 1273, 1273, 1273,
 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273, 1273,
 1273, 1273, 1273,    0, 1273, 1273, 1273, 1273,    0, 1273,
 1273, 1273, 1273, 1273,    0, 1273, 1273, 1273, 1273, 1273,
    0,  992,    0,    0,    0,    0,  993,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1275,  992, 1275, 1275,
    0,    0,  993,    0,    0, 1275,    0,    0,    0,    0,
    0, 1275,    0,    0,    0,    0, 1275,    0,    0, 1275,
 2306,  996,  994,    0,  995,    0,  997,    0,    0,    0,
    0,    0,  992, 1275,    0,    0,    0,  993, 1275, 1275,
    0,    0, 1275,    0,    0,  992,    0,    0,    0, 1275,
  993, 1275, 1275,    0,    0, 1275,    0,    0,    0, 1275,
    0, 1275,    0, 1275,    0, 1275,    0,    0,    0,    0,
 1275, 1275,    0, 1275,    0,    0,    0,    0,    0,    0,
    0,  996,  994, 2009,  995,    0,  997, 1277, 1275, 1275,
  992, 1275,    0,    0,    0,  993,    0,    0,    0,    0,
    0, 1275,    0, 1275,    0, 1275, 1275, 1275,    0, 1275,
    0,    0, 1275, 1275,    0,  996,  994,    0,  995,    0,
  997,    0, 1275,    0,    0,    0,    0, 1103, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1275,  992,    0, 1275,    0,
    0,  993,    0,    0,    0, 1277, 1277, 1277, 1277, 1277,
  996,  994, 2014,  995, 1275,  997,    0,    0,    0,    0,
 1275, 1275,    0,    0,    0, 1275,  996,  994, 2016,  995,
    0,  997,    0,    0,    0,    0, 1275, 1275, 1277, 1275,
 1277,    0,    0,    0,    0, 1275,    0,    0, 1275,    0,
 1275, 1275, 1275, 1275,    0, 1275,    0, 1275, 1275, 1275,
 1275, 1275, 1275, 1275, 1275,    0,    0,    0,  996,  994,
 2017,  995,    0,  997, 1275, 1275,    0, 1275, 1275, 1275,
    0,    0,    0,    0, 1275, 1275, 1275, 1275, 1275,    0,
 1275,    0,    0, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
    0,    0,    0, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
 1275,    0, 1275,    0,    0,    0,  992,    0,    0,    0,
    0,  993, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1275,    0, 1275, 1275, 1275, 1275, 1275, 1275,
    0, 1275, 1275, 1275, 1275,    0, 1275,    0, 1275, 1275,
 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275, 1275,
 1275, 1275, 1275, 1275, 1275, 1275,  992, 1275, 1275, 1275,
 1275,  993, 1275, 1275, 1275, 1275, 1275,    0, 1275, 1275,
 1275, 1275, 1275,    0,    0, 1975,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1277,
  992, 1277, 1277,    0,    0,  993,    0,    0, 1277,    0,
    0,    0,    0,    0, 1277,    0,    0,    0,    0, 1277,
    0,    0, 1277,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  992, 1277,    0,    0,    0,
  993, 1277, 1277,    0,    0, 1277,    0,    0,    0,    0,
    0,  992, 1277,    0, 1277, 1277,  993,    0, 1277,    0,
    0,    0, 1277,    0, 1277,    0, 1277,    0, 1277,    0,
    0,    0,    0, 1277, 1277,    0, 1277,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1278, 1277, 1277,  992, 1277,    0,    0,    0,  993,    0,
    0,    0,    0,    0, 1277,    0, 1277,    0, 1277, 1277,
 1277,    0, 1277,    0,    0, 1277, 1277,    0,    0,    0,
    0,    0,    0,    0,    0, 1277,    0,    0,    0,    0,
 1104, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1277,    0,
    0, 1277,    0,    0,    0,    0,    0,    0, 1278, 1278,
 1278, 1278, 1278,    0,    0,    0,    0, 1277,    0,    0,
    0,    0,    0, 1277, 1277,    0,    0,    0, 1277,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1277,
 1277, 1278, 1277, 1278,    0,    0,    0,    0, 1277,    0,
    0, 1277,    0, 1277, 1277, 1277, 1277,    0, 1277,    0,
 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1277, 1277,    0,
 1277, 1277, 1277,    0,    0,    0,    0, 1277, 1277, 1277,
 1277, 1277,    0, 1277,    0,    0, 1277, 1277, 1277, 1277,
 1277, 1277, 1277,    0,    0,    0, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277,    0, 1277,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1277, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1277,    0, 1277, 1277, 1277,
 1277, 1277, 1277,    0, 1277, 1277, 1277, 1277,    0, 1277,
    0, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,
 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,    0,
 1277, 1277, 1277, 1277,    0, 1277, 1277, 1277, 1277, 1277,
    0, 1277, 1277, 1277, 1277, 1277,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1278,    0, 1278, 1278,    0, 1963, 1964,    0,
    0, 1278,    0,    0,    0, 1970, 1971, 1278, 1973, 1974,
    0,    0, 1278,    0,    0, 1278, 1978, 1979, 1980, 1981,
    0, 1982, 1983, 1984, 1985, 1986, 1987,    0,    0, 1278,
    0,    0,    0,    0, 1278, 1278,    0,    0, 1278,    0,
    0,    0,    0,    0,    0, 1278,    0, 1278, 1278,    0,
    0, 1278,    0,    0,    0, 1278,    0, 1278,    0, 1278,
    0, 1278,    0,    0,    0,    0, 1278, 1278,    0, 1278,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1279, 1278, 1278,    0, 1278,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1278,    0, 1278,
    0, 1278, 1278, 1278,    0, 1278,    0,    0, 1278, 1278,
    0,    0,    0,    0,    0,    0,    0,    0, 1278,    0,
    0,    0,    0, 1105, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1278,    0,    0, 1278,    0,    0,    0,    0,    0,
    0, 1279, 1279, 1279, 1279, 1279,    0,    0,    0,    0,
 1278,    0,    0,    0,    0,    0, 1278, 1278,    0,    0,
    0, 1278,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1278, 1278, 1279, 1278, 1279,    0,    0,    0,
    0, 1278,    0,    0, 1278,    0, 1278, 1278, 1278, 1278,
    0, 1278,    0, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1278, 1278,    0, 1278, 1278, 1278,    0,    0,    0,    0,
 1278, 1278, 1278, 1278, 1278,    0, 1278,    0,    0, 1278,
 1278, 1278, 1278, 1278, 1278, 1278,    0,    0,    0, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278,    0, 1278,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,    0,
 1278, 1278, 1278, 1278, 1278, 1278,    0, 1278, 1278, 1278,
 1278,    0, 1278,    0, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278, 1278,
 1278, 1278,    0, 1278, 1278, 1278, 1278,    0, 1278, 1278,
 1278, 1278, 1278,    0, 1278, 1278, 1278, 1278, 1278,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1279,    0, 1279, 1279,    0,
    0,    0,    0,    0, 1279,    0,    0,    0,    0,    0,
 1279,    0,    0,    0,    0, 1279,    0,    0, 1279,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1279,    0,    0,    0,    0, 1279, 1279,    0,
    0, 1279,    0,    0,    0,    0,    0,    0, 1279,    0,
 1279, 1279,    0,    0, 1279,    0,    0,    0, 1279,    0,
 1279,    0, 1279,    0, 1279,    0,    0,    0,    0, 1279,
 1279,    0, 1279,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1280, 1279, 1279,    0,
 1279,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1279,    0, 1279,    0, 1279, 1279, 1279,    0, 1279,    0,
    0, 1279, 1279,    0,    0,    0,    0,    0,    0,    0,
    0, 1279,    0,    0,    0,    0, 1106, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1279,    0,    0, 1279,    0,    0,
    0,    0,    0,    0, 1280, 1280, 1280, 1280, 1280,    0,
    0,    0,    0, 1279,    0,    0,    0,    0,    0, 1279,
 1279,    0,    0,    0, 1279,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1279, 1279, 1280, 1279, 1280,
    0,    0,    0,    0, 1279,    0,    0, 1279,    0, 1279,
 1279, 1279, 1279,    0, 1279,    0, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1279, 1279,    0, 1279, 1279, 1279,    0,
    0,    0,    0, 1279, 1279, 1279, 1279, 1279,    0, 1279,
    0,    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0,
    0,    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
    0, 1279,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279, 1279,    0,
 1279, 1279, 1279, 1279,    0, 1279,    0, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279,
    0, 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279,
 1279, 1279,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1280,    0,
 1280, 1280,    0,    0,    0,    0,    0, 1280,    0,    0,
    0,    0,    0, 1280,    0,    0,    0,    0, 1280,    0,
    0, 1280,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1280,    0,    0,    0,    0,
 1280, 1280,    0,    0, 1280,    0,    0,    0,    0,    0,
    0, 1280,    0, 1280, 1280,    0,    0, 1280,    0,    0,
    0, 1280,    0, 1280,    0, 1280,    0, 1280,    0,    0,
    0,    0, 1280, 1280,    0, 1280,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1281,
 1280, 1280,    0, 1280,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1280,    0, 1280,    0, 1280, 1280, 1280,
    0, 1280,    0,    0, 1280, 1280,    0,    0,    0,    0,
    0,    0,    0,    0, 1280,    0,    0,    0,    0, 1107,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1280,    0,    0,
 1280,    0,    0,    0,    0,    0,    0, 1281, 1281, 1281,
 1281, 1281,    0,    0,    0,    0, 1280,    0,    0,    0,
    0,    0, 1280, 1280,    0,    0,    0, 1280,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1280, 1280,
 1281, 1280, 1281,    0,    0,    0,    0, 1280,    0,    0,
 1280,    0, 1280, 1280, 1280, 1280,    0, 1280,    0, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1280, 1280,    0, 1280,
 1280, 1280,    0,    0,    0,    0, 1280, 1280, 1280, 1280,
 1280,    0, 1280,    0,    0, 1280, 1280, 1280, 1280, 1280,
 1280, 1280,    0,    0,    0, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280,    0, 1280,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280,    0, 1280, 1280, 1280, 1280,
 1280, 1280,    0, 1280, 1280, 1280, 1280,    0, 1280,    0,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,    0, 1280,
 1280, 1280, 1280,    0, 1280, 1280, 1280, 1280, 1280,    0,
 1280, 1280, 1280, 1280, 1280,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1281,    0, 1281, 1281,    0,    0,    0,    0,    0,
 1281,    0,    0,    0,    0,    0, 1281,    0,    0,    0,
    0, 1281,    0,    0, 1281,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1281,    0,
    0,    0,    0, 1281, 1281,    0,    0, 1281,    0,    0,
    0,    0,    0,    0, 1281,    0, 1281, 1281,    0,    0,
 1281,    0,    0,    0, 1281,    0, 1281,    0, 1281,    0,
 1281,    0,    0,    0,    0, 1281, 1281,    0, 1281,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1282, 1281, 1281,    0, 1281,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1281,    0, 1281,    0,
 1281, 1281, 1281,    0, 1281,    0,    0, 1281, 1281,    0,
    0,    0,    0,    0,    0,    0,    0, 1281,    0,    0,
    0,    0, 1108, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1281,    0,    0, 1281,    0,    0,    0,    0,    0,    0,
 1282, 1282, 1282, 1282, 1282,    0,    0,    0,    0, 1281,
    0,    0,    0,    0,    0, 1281, 1281,    0,    0,    0,
 1281,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1281, 1281, 1282, 1281, 1282,    0,    0,    0,    0,
 1281,    0,    0, 1281,    0, 1281, 1281, 1281, 1281,    0,
 1281,    0, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1281,
 1281,    0, 1281, 1281, 1281,    0,    0,    0,    0, 1281,
 1281, 1281, 1281, 1281,    0, 1281,    0,    0, 1281, 1281,
 1281, 1281, 1281, 1281, 1281,    0,    0,    0, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281,    0, 1281,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,    0, 1281,
 1281, 1281, 1281, 1281, 1281,    0, 1281, 1281, 1281, 1281,
    0, 1281,    0, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
 1281,    0, 1281, 1281, 1281, 1281,    0, 1281, 1281, 1281,
 1281, 1281,    0, 1281, 1281, 1281, 1281, 1281,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1282,    0, 1282, 1282,    0,    0,
    0,    0,    0, 1282,    0,    0,    0,    0,    0, 1282,
    0,    0,    0,    0, 1282,    0,    0, 1282,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1282,    0,    0,    0,    0, 1282, 1282,    0,    0,
 1282,    0,    0,    0,    0,    0,    0, 1282,    0, 1282,
 1282,    0,    0, 1282,    0,    0,    0, 1282,    0, 1282,
    0, 1282,    0, 1282,    0,    0,    0,    0, 1282, 1282,
    0, 1282,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1283, 1282, 1282,    0, 1282,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1282,
    0, 1282,    0, 1282, 1282, 1282,    0, 1282,    0,    0,
 1282, 1282,    0,    0,    0,    0,    0,    0,    0,    0,
 1282,    0,    0,    0,    0, 1109, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1282,    0,    0, 1282,    0,    0,    0,
    0,    0,    0, 1283, 1283, 1283, 1283, 1283,    0,    0,
    0,    0, 1282,    0,    0,    0,    0,    0, 1282, 1282,
    0,    0,    0, 1282,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1282, 1282, 1283, 1282, 1283,    0,
    0,    0,    0, 1282,    0,    0, 1282,    0, 1282, 1282,
 1282, 1282,    0, 1282,    0, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1282, 1282,    0, 1282, 1282, 1282,    0,    0,
    0,    0, 1282, 1282, 1282, 1282, 1282,    0, 1282,    0,
    0, 1282, 1282, 1282, 1282, 1282, 1282, 1282,    0,    0,
    0, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,    0,
 1282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282,    0, 1282, 1282, 1282, 1282, 1282, 1282,    0, 1282,
 1282, 1282, 1282,    0, 1282,    0, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
 1282, 1282, 1282, 1282,    0, 1282, 1282, 1282, 1282,    0,
 1282, 1282, 1282, 1282, 1282,    0, 1282, 1282, 1282, 1282,
 1282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1283,    0, 1283,
 1283,    0,    0,    0,    0,    0, 1283,    0,    0,    0,
    0,    0, 1283,    0,    0,    0,    0, 1283,    0,    0,
 1283,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1283,    0,    0,    0,    0, 1283,
 1283,    0,    0, 1283,    0,    0,    0,    0,    0,    0,
 1283,    0, 1283, 1283,    0,    0, 1283,    0,    0,    0,
 1283,    0, 1283,    0, 1283,    0, 1283,    0,    0,    0,
    0, 1283, 1283,    0, 1283,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1284, 1283,
 1283,    0, 1283,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1283,    0, 1283,    0, 1283, 1283, 1283,    0,
 1283,    0,    0, 1283, 1283,    0,    0,    0,    0,    0,
    0,    0,    0, 1283,    0,    0,    0,    0, 1110, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1283,    0,    0, 1283,
    0,    0,    0,    0,    0,    0, 1284, 1284, 1284, 1284,
 1284,    0,    0,    0,    0, 1283,    0,    0,    0,    0,
    0, 1283, 1283,    0,    0,    0, 1283,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1283, 1283, 1284,
 1283, 1284,    0,    0,    0,    0, 1283,    0,    0, 1283,
    0, 1283, 1283, 1283, 1283,    0, 1283,    0, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1283, 1283,    0, 1283, 1283,
 1283,    0,    0,    0,    0, 1283, 1283, 1283, 1283, 1283,
    0, 1283,    0,    0, 1283, 1283, 1283, 1283, 1283, 1283,
 1283,    0,    0,    0, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283,    0, 1283,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283,    0, 1283, 1283, 1283, 1283, 1283,
 1283,    0, 1283, 1283, 1283, 1283,    0, 1283,    0, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
 1283, 1283, 1283, 1283, 1283, 1283, 1283,    0, 1283, 1283,
 1283, 1283,    0, 1283, 1283, 1283, 1283, 1283,    0, 1283,
 1283, 1283, 1283, 1283,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1284,    0, 1284, 1284,    0,    0,    0,    0,    0, 1284,
    0,    0,    0,    0,    0, 1284,    0,    0,    0,    0,
 1284,    0,    0, 1284,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1284,    0,    0,
    0,    0, 1284, 1284,    0,    0, 1284,    0,    0,    0,
    0,    0,    0, 1284,    0, 1284, 1284,    0,    0, 1284,
    0,    0,    0, 1284,    0, 1284,    0, 1284,    0, 1284,
    0,    0,    0,    0, 1284, 1284,    0, 1284,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1285, 1284, 1284,    0, 1284,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1284,    0, 1284,    0, 1284,
 1284, 1284,    0, 1284,    0,    0, 1284, 1284,    0,    0,
    0,    0,    0,    0,    0,    0, 1284,    0,    0,    0,
    0, 1111, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1284,
    0,    0, 1284,    0,    0,    0,    0,    0,    0, 1285,
 1285, 1285, 1285, 1285,    0,    0,    0,    0, 1284,    0,
    0,    0,    0,    0, 1284, 1284,    0,    0,    0, 1284,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1284, 1284, 1285, 1284, 1285,    0,    0,    0,    0, 1284,
    0,    0, 1284,    0, 1284, 1284, 1284, 1284,    0, 1284,
    0, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1284, 1284,
    0, 1284, 1284, 1284,    0,    0,    0,    0, 1284, 1284,
 1284, 1284, 1284,    0, 1284,    0,    0, 1284, 1284, 1284,
 1284, 1284, 1284, 1284,    0,    0,    0, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284,    0, 1284,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284,    0, 1284, 1284,
 1284, 1284, 1284, 1284,    0, 1284, 1284, 1284, 1284,    0,
 1284,    0, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284, 1284,
    0, 1284, 1284, 1284, 1284,    0, 1284, 1284, 1284, 1284,
 1284,    0, 1284, 1284, 1284, 1284, 1284,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1285,    0, 1285, 1285,    0,    0,    0,
    0,    0, 1285,    0,    0,    0,    0,    0, 1285,    0,
    0,    0,    0, 1285,    0,    0, 1285,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1285,    0,    0,    0,    0, 1285, 1285,    0,    0, 1285,
    0,    0,    0,    0,    0,    0, 1285,    0, 1285, 1285,
    0,    0, 1285,    0,    0,    0, 1285,    0, 1285,    0,
 1285,    0, 1285,    0,    0,    0,    0, 1285, 1285,    0,
 1285,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1286, 1285, 1285,    0, 1285,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1285,    0,
 1285,    0, 1285, 1285, 1285,    0, 1285,    0,    0, 1285,
 1285,    0,    0,    0,    0,    0,    0,    0,    0, 1285,
    0,    0,    0,    0, 1112, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1285,    0,    0, 1285,    0,    0,    0,    0,
    0,    0, 1286, 1286, 1286, 1286, 1286,    0,    0,    0,
    0, 1285,    0,    0,    0,    0,    0, 1285, 1285,    0,
    0,    0, 1285,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1285, 1285, 1286, 1285, 1286,    0,    0,
    0,    0, 1285,    0,    0, 1285,    0, 1285, 1285, 1285,
 1285,    0, 1285,    0, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1285, 1285,    0, 1285, 1285, 1285,    0,    0,    0,
    0, 1285, 1285, 1285, 1285, 1285,    0, 1285,    0,    0,
 1285, 1285, 1285, 1285, 1285, 1285, 1285,    0,    0,    0,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,    0, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
    0, 1285, 1285, 1285, 1285, 1285, 1285,    0, 1285, 1285,
 1285, 1285,    0, 1285,    0, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
 1285, 1285, 1285,    0, 1285, 1285, 1285, 1285,    0, 1285,
 1285, 1285, 1285, 1285,    0, 1285, 1285, 1285, 1285, 1285,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1286,    0, 1286, 1286,
    0,    0,    0,    0,    0, 1286,    0,    0,    0,    0,
    0, 1286,    0,    0,    0,    0, 1286,    0,    0, 1286,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1286,    0,    0,    0,    0, 1286, 1286,
    0,    0, 1286,    0,    0,    0,    0,    0,    0, 1286,
    0, 1286, 1286,    0,    0, 1286,    0,    0,    0, 1286,
    0, 1286,    0, 1286,    0, 1286,    0,    0,    0,    0,
 1286, 1286,    0, 1286,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1287, 1286, 1286,
    0, 1286,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1286,    0, 1286,    0, 1286, 1286, 1286,    0, 1286,
    0,    0, 1286, 1286,    0,    0,    0,    0,    0,    0,
    0,    0, 1286,    0,    0,    0,    0, 1113, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1286,    0,    0, 1286,    0,
    0,    0,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,
    0,    0,    0,    0, 1286,    0,    0,    0,    0,    0,
 1286, 1286,    0,    0,    0, 1286,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1286, 1286, 1287, 1286,
 1287,    0,    0,    0,    0, 1286,    0,    0, 1286,    0,
 1286, 1286, 1286, 1286,    0, 1286,    0, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1286, 1286,    0, 1286, 1286, 1286,
    0,    0,    0,    0, 1286, 1286, 1286, 1286, 1286,    0,
 1286,    0,    0, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
    0,    0,    0, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286,    0, 1286,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286,    0, 1286, 1286, 1286, 1286, 1286, 1286,
    0, 1286, 1286, 1286, 1286,    0, 1286,    0, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
 1286, 1286, 1286, 1286, 1286, 1286,    0, 1286, 1286, 1286,
 1286,    0, 1286, 1286, 1286, 1286, 1286,    0, 1286, 1286,
 1286, 1286, 1286,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1287,
    0, 1287, 1287,    0,    0,    0,    0,    0, 1287,    0,
    0,    0,    0,    0, 1287,    0,    0,    0,    0, 1287,
    0,    0, 1287,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1287,    0,    0,    0,
    0, 1287, 1287,    0,    0, 1287,    0,    0,    0,    0,
    0,    0, 1287,    0, 1287, 1287,    0,    0, 1287,    0,
    0,    0, 1287,    0, 1287,    0, 1287,    0, 1287,    0,
    0,    0,    0, 1287, 1287,    0, 1287,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1288, 1287, 1287,    0, 1287,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1287,    0, 1287,    0, 1287, 1287,
 1287,    0, 1287,    0,    0, 1287, 1287,    0,    0,    0,
    0,    0,    0,    0,    0, 1287,    0,    0,    0,    0,
 1114, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1287,    0,
    0, 1287,    0,    0,    0,    0,    0,    0, 1288, 1288,
 1288, 1288, 1288,    0,    0,    0,    0, 1287,    0,    0,
    0,    0,    0, 1287, 1287,    0,    0,    0, 1287,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1287,
 1287, 1288, 1287, 1288,    0,    0,    0,    0, 1287,    0,
    0, 1287,    0, 1287, 1287, 1287, 1287,    0, 1287,    0,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1287, 1287,    0,
 1287, 1287, 1287,    0,    0,    0,    0, 1287, 1287, 1287,
 1287, 1287,    0, 1287,    0,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287,    0,    0,    0, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287,    0, 1287,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287,
 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287,    0, 1287,
    0, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,
 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287, 1287,    0,
 1287, 1287, 1287, 1287,    0, 1287, 1287, 1287, 1287, 1287,
    0, 1287, 1287, 1287, 1287, 1287,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1288,    0, 1288, 1288,    0,    0,    0,    0,
    0, 1288,    0,    0,    0,    0,    0, 1288,    0,    0,
    0,    0, 1288,    0,    0, 1288,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1288,
    0,    0,    0,    0, 1288, 1288,    0,    0, 1288,    0,
    0,    0,    0,    0,    0, 1288,    0, 1288, 1288,    0,
    0, 1288,    0,    0,    0, 1288,    0, 1288,    0, 1288,
    0, 1288,    0,    0,    0,    0, 1288, 1288,    0, 1288,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1289, 1288, 1288,    0, 1288,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1288,    0, 1288,
    0, 1288, 1288, 1288,    0, 1288,    0,    0, 1288, 1288,
    0,    0,    0,    0,    0,    0,    0,    0, 1288,    0,
    0,    0,    0, 1115, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1288,    0,    0, 1288,    0,    0,    0,    0,    0,
    0, 1289, 1289, 1289, 1289, 1289,    0,    0,    0,    0,
 1288,    0,    0,    0,    0,    0, 1288, 1288,    0,    0,
    0, 1288,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1288, 1288, 1289, 1288, 1289,    0,    0,    0,
    0, 1288,    0,    0, 1288,    0, 1288, 1288, 1288, 1288,
    0, 1288,    0, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1288, 1288,    0, 1288, 1288, 1288,    0,    0,    0,    0,
 1288, 1288, 1288, 1288, 1288,    0, 1288,    0,    0, 1288,
 1288, 1288, 1288, 1288, 1288, 1288,    0,    0,    0, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0,
 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288, 1288, 1288,
 1288,    0, 1288,    0, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288,    0, 1288, 1288, 1288, 1288,    0, 1288, 1288,
 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1289,    0, 1289, 1289,    0,
    0,    0,    0,    0, 1289,    0,    0,    0,    0,    0,
 1289,    0,    0,    0,    0, 1289,    0,    0, 1289,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1289,    0,    0,    0,    0, 1289, 1289,    0,
    0, 1289,    0,    0,    0,    0,    0,    0, 1289,    0,
 1289, 1289,    0,    0, 1289,    0,    0,    0, 1289,    0,
 1289,    0, 1289,    0, 1289,    0,    0,    0,    0, 1289,
 1289,    0, 1289,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1290, 1289, 1289,    0,
 1289,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1289,    0, 1289,    0, 1289, 1289, 1289,    0, 1289,    0,
    0, 1289, 1289,    0,    0,    0,    0,    0,    0,    0,
    0, 1289,    0,    0,    0,    0, 1116, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1289,    0,    0, 1289,    0,    0,
    0,    0,    0,    0, 1290, 1290, 1290, 1290, 1290,    0,
    0,    0,    0, 1289,    0,    0,    0,    0,    0, 1289,
 1289,    0,    0,    0, 1289,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1289, 1289, 1290, 1289, 1290,
    0,    0,    0,    0, 1289,    0,    0, 1289,    0, 1289,
 1289, 1289, 1289,    0, 1289,    0, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1289, 1289,    0, 1289, 1289, 1289,    0,
    0,    0,    0, 1289, 1289, 1289, 1289, 1289,    0, 1289,
    0,    0, 1289, 1289, 1289, 1289, 1289, 1289, 1289,    0,
    0,    0, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
    0, 1289,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289,    0, 1289, 1289, 1289, 1289, 1289, 1289,    0,
 1289, 1289, 1289, 1289,    0, 1289,    0, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289, 1289,
 1289, 1289, 1289, 1289, 1289,    0, 1289, 1289, 1289, 1289,
    0, 1289, 1289, 1289, 1289, 1289,    0, 1289, 1289, 1289,
 1289, 1289,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1290,    0,
 1290, 1290,    0,    0,    0,    0,    0, 1290,    0,    0,
    0,    0,    0, 1290,    0,    0,    0,    0, 1290,    0,
    0, 1290,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1290,    0,    0,    0,    0,
 1290, 1290,    0,    0, 1290,    0,    0,    0,    0,    0,
    0, 1290,    0, 1290, 1290,    0,    0, 1290,    0,    0,
    0, 1290,    0, 1290,    0, 1290,    0, 1290,    0,    0,
    0,    0, 1290, 1290,    0, 1290,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1290, 1290,    0, 1290,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1290,    0, 1290,    0, 1290, 1290, 1290,
    0, 1290,    0,    0, 1290, 1290,    0,    0,    0,    0,
    0,    0,    0,    0, 1290,    0,    0,    0,    0, 1117,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1290,    0,    0,
 1290,    0,    0,    0,    0,    0,    0, 1294, 1294, 1294,
 1294, 1294,    0,    0,    0,    0, 1290,    0,    0,    0,
    0,    0, 1290, 1290,    0,    0,    0, 1290,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1290, 1290,
 1294, 1290, 1294,    0,    0,    0,    0, 1290,    0,    0,
 1290,    0, 1290, 1290, 1290, 1290,    0, 1290,    0, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1290, 1290,    0, 1290,
 1290, 1290,    0,    0,    0,    0, 1290, 1290, 1290, 1290,
 1290,    0, 1290,    0,    0, 1290, 1290, 1290, 1290, 1290,
 1290, 1290,    0,    0,    0, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290,    0, 1290,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290,    0, 1290, 1290, 1290, 1290,
 1290, 1290,    0, 1290, 1290, 1290, 1290,    0, 1290,    0,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,
 1290, 1290, 1290, 1290, 1290, 1290, 1290, 1290,    0, 1290,
 1290, 1290, 1290,    0, 1290, 1290, 1290, 1290, 1290,    0,
 1290, 1290, 1290, 1290, 1290,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1294,    0, 1294, 1294,    0,    0,    0,    0,    0,
 1294,    0,    0,    0,    0,    0, 1294,    0,    0,    0,
    0, 1294,    0,    0, 1294,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1294,    0,
    0,    0,    0, 1294, 1294,    0,    0, 1294,    0,    0,
    0,    0,    0,    0, 1294,    0, 1294, 1294,    0,    0,
 1294,    0,    0,    0, 1294,    0, 1294,    0, 1294,    0,
 1294,    0,    0,    0,    0, 1294, 1294,    0, 1294,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1295, 1294, 1294,    0, 1294,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1294,    0, 1294,    0,
 1294, 1294, 1294,    0, 1294,    0,    0, 1294, 1294,    0,
    0,    0,    0,    0,    0,    0,    0, 1294,    0,    0,
    0,    0, 1118, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1294,    0,    0, 1294,    0,    0,    0,    0,    0,    0,
 1295, 1295, 1295, 1295, 1295,    0,    0,    0,    0, 1294,
    0,    0,    0,    0,    0, 1294, 1294,    0,    0,    0,
 1294,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1294, 1294, 1295, 1294, 1295,    0,    0,    0,    0,
 1294,    0,    0, 1294,    0, 1294, 1294, 1294, 1294,    0,
 1294,    0, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1294,    0, 1294, 1294, 1294,    0,    0,    0,    0, 1294,
 1294, 1294, 1294, 1294,    0, 1294,    0,    0, 1294, 1294,
 1294, 1294, 1294, 1294, 1294,    0,    0,    0, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294,    0, 1294,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,    0, 1294,
 1294, 1294, 1294, 1294, 1294,    0, 1294, 1294, 1294, 1294,
    0, 1294,    0, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294, 1294,
 1294,    0, 1294, 1294, 1294, 1294,    0, 1294, 1294, 1294,
 1294, 1294,    0, 1294, 1294, 1294, 1294, 1294,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1295,    0, 1295, 1295,    0,    0,
    0,    0,    0, 1295,    0,    0,    0,    0,    0, 1295,
    0,    0,    0,    0, 1295,    0,    0, 1295,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1295,    0,    0,    0,    0, 1295, 1295,    0,    0,
 1295,    0,    0,    0,    0,    0,    0, 1295,    0, 1295,
 1295,    0,    0, 1295,    0,    0,    0, 1295,    0, 1295,
    0, 1295,    0, 1295,    0,    0,    0,    0, 1295, 1295,
    0, 1295,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1296, 1295, 1295,    0, 1295,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1295,
    0, 1295,    0, 1295, 1295, 1295,    0, 1295,    0,    0,
 1295, 1295,    0,    0,    0,    0,    0,    0,    0,    0,
 1295,    0,    0,    0,    0, 1119, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1295,    0,    0, 1295,    0,    0,    0,
    0,    0,    0, 1296, 1296, 1296, 1296, 1296,    0,    0,
    0,    0, 1295,    0,    0,    0,    0,    0, 1295, 1295,
    0,    0,    0, 1295,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1295, 1295, 1296, 1295, 1296,    0,
    0,    0,    0, 1295,    0,    0, 1295,    0, 1295, 1295,
 1295, 1295,    0, 1295,    0, 1295, 1295, 1295, 1295, 1295,
 1295, 1295, 1295,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1295, 1295,    0, 1295, 1295, 1295,    0,    0,
    0,    0, 1295, 1295, 1295, 1295, 1295,    0, 1295,    0,
    0, 1295, 1295, 1295, 1295, 1295, 1295, 1295,    0,    0,
    0, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,    0,
 1295,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1295,    0, 1295, 1295, 1295, 1295, 1295, 1295,    0, 1295,
 1295, 1295, 1295,    0, 1295,    0, 1295, 1295, 1295, 1295,
 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
 1295, 1295, 1295, 1295,    0, 1295, 1295, 1295, 1295,    0,
 1295, 1295, 1295, 1295, 1295,    0, 1295, 1295, 1295, 1295,
 1295,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1296,    0, 1296,
 1296,    0,    0,    0,    0,    0, 1296,    0,    0,    0,
    0,    0, 1296,    0,    0,    0,    0, 1296,    0,    0,
 1296,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1296,    0,    0,    0,    0, 1296,
 1296,    0,    0, 1296,    0,    0,    0,    0,    0,    0,
 1296,    0, 1296, 1296,    0,    0, 1296,    0,    0,    0,
 1296,    0, 1296,    0, 1296,    0, 1296,    0,    0,    0,
    0, 1296, 1296,    0, 1296,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1298, 1296,
 1296,    0, 1296,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1296,    0, 1296,    0, 1296, 1296, 1296,    0,
 1296,    0,    0, 1296, 1296,    0,    0,    0,    0,    0,
    0,    0,    0, 1296,    0,    0,    0,    0, 1120, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1296,    0,    0, 1296,
    0,    0,    0,    0,    0,    0, 1298, 1298, 1298, 1298,
 1298,    0,    0,    0,    0, 1296,    0,    0,    0,    0,
    0, 1296, 1296,    0,    0,    0, 1296,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1296, 1296, 1298,
 1296, 1298,    0,    0,    0,    0, 1296,    0,    0, 1296,
    0, 1296, 1296, 1296, 1296,    0, 1296,    0, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1296, 1296,    0, 1296, 1296,
 1296,    0,    0,    0,    0, 1296, 1296, 1296, 1296, 1296,
    0, 1296,    0,    0, 1296, 1296, 1296, 1296, 1296, 1296,
 1296,    0,    0,    0, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296,    0, 1296,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296,    0, 1296, 1296, 1296, 1296, 1296,
 1296,    0, 1296, 1296, 1296, 1296,    0, 1296,    0, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296, 1296,
 1296, 1296, 1296, 1296, 1296, 1296, 1296,    0, 1296, 1296,
 1296, 1296,    0, 1296, 1296, 1296, 1296, 1296,    0, 1296,
 1296, 1296, 1296, 1296,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1298,    0, 1298, 1298,    0,    0,    0,    0,    0, 1298,
    0,    0,    0,    0,    0, 1298,    0,    0,    0,    0,
 1298,    0,    0, 1298,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1298,    0,    0,
    0,    0, 1298, 1298,    0,    0, 1298,    0,    0,    0,
    0,    0,    0, 1298,    0, 1298, 1298,    0,    0, 1298,
    0,    0,    0, 1298,    0, 1298,    0, 1298,    0, 1298,
    0,    0,    0,    0, 1298, 1298,    0, 1298,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1300, 1298, 1298,    0, 1298,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1298,    0, 1298,    0, 1298,
 1298, 1298,    0, 1298,    0,    0, 1298, 1298,    0,    0,
    0,    0,    0,    0,    0,    0, 1298,    0,    0,    0,
    0, 1122, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1298,
    0,    0, 1298,    0,    0,    0,    0,    0,    0, 1300,
 1300, 1300, 1300, 1300,    0,    0,    0,    0, 1298,    0,
    0,    0,    0,    0, 1298, 1298,    0,    0,    0, 1298,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1298, 1298, 1300, 1298, 1300,    0,    0,    0,    0, 1298,
    0,    0, 1298,    0, 1298, 1298, 1298, 1298,    0, 1298,
    0, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1298, 1298,
    0, 1298, 1298, 1298,    0,    0,    0,    0, 1298, 1298,
 1298, 1298, 1298,    0, 1298,    0,    0, 1298, 1298, 1298,
 1298, 1298, 1298, 1298,    0,    0,    0, 1298, 1298, 1298,
 1298, 1298, 1298, 1298, 1298,    0, 1298,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1298,    0, 1298, 1298,
 1298, 1298, 1298, 1298,    0, 1298, 1298, 1298, 1298,    0,
 1298,    0, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298, 1298,
    0, 1298, 1298, 1298, 1298,    0, 1298, 1298, 1298, 1298,
 1298,    0, 1298, 1298, 1298, 1298, 1298,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1300,    0, 1300, 1300,    0,    0,    0,
    0,    0, 1300,    0,    0,    0,    0,    0, 1300,    0,
    0,    0,    0, 1300,    0,    0, 1300,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1300,    0,    0,    0,    0, 1300, 1300,    0,    0, 1300,
    0,    0,    0,    0,    0,    0, 1300,    0, 1300, 1300,
    0,    0, 1300,    0,    0,    0, 1300,    0, 1300,    0,
 1300,    0, 1300,    0,    0,    0,    0, 1300, 1300,    0,
 1300,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1301, 1300, 1300,    0, 1300,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1300,    0,
 1300,    0, 1300, 1300, 1300,    0, 1300,    0,    0, 1300,
 1300,    0,    0,    0,    0,    0,    0,    0,    0, 1300,
    0,    0,    0,    0, 1123, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1300,    0,    0, 1300,    0,    0,    0,    0,
    0,    0, 1301, 1301, 1301, 1301, 1301,    0,    0,    0,
    0, 1300,    0,    0,    0,    0,    0, 1300, 1300,    0,
    0,    0, 1300,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1300, 1300, 1301, 1300, 1301,    0,    0,
    0,    0, 1300,    0,    0, 1300,    0, 1300, 1300, 1300,
 1300,    0, 1300,    0, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1300, 1300,    0, 1300, 1300, 1300,    0,    0,    0,
    0, 1300, 1300, 1300, 1300, 1300,    0, 1300,    0,    0,
 1300, 1300, 1300, 1300, 1300, 1300, 1300,    0,    0,    0,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,    0, 1300,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
    0, 1300, 1300, 1300, 1300, 1300, 1300,    0, 1300, 1300,
 1300, 1300,    0, 1300,    0, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300, 1300,
 1300, 1300, 1300,    0, 1300, 1300, 1300, 1300,    0, 1300,
 1300, 1300, 1300, 1300,    0, 1300, 1300, 1300, 1300, 1300,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1301,    0, 1301, 1301,
    0,    0,    0,    0,    0, 1301,    0,    0,    0,    0,
    0, 1301,    0,    0,    0,    0, 1301,    0,    0, 1301,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1301,    0,    0,    0,    0, 1301, 1301,
    0,    0, 1301,    0,    0,    0,    0,    0,    0, 1301,
    0, 1301, 1301,    0,    0, 1301,    0,    0,    0, 1301,
    0, 1301,    0, 1301,    0, 1301,    0,    0,    0,    0,
 1301, 1301,    0, 1301,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1302, 1301, 1301,
    0, 1301,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1301,    0, 1301,    0, 1301, 1301, 1301,    0, 1301,
    0,    0, 1301, 1301,    0,    0,    0,    0,    0,    0,
    0,    0, 1301,    0,    0,    0,    0, 1124, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1301,    0,    0, 1301,    0,
    0,    0,    0,    0,    0, 1302, 1302, 1302, 1302, 1302,
    0,    0,    0,    0, 1301,    0,    0,    0,    0,    0,
 1301, 1301,    0,    0,    0, 1301,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1301, 1301, 1302, 1301,
 1302,    0,    0,    0,    0, 1301,    0,    0, 1301,    0,
 1301, 1301, 1301, 1301,    0, 1301,    0, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1301, 1301,    0, 1301, 1301, 1301,
    0,    0,    0,    0, 1301, 1301, 1301, 1301, 1301,    0,
 1301,    0,    0, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
    0,    0,    0, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301,    0, 1301,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301,    0, 1301, 1301, 1301, 1301, 1301, 1301,
    0, 1301, 1301, 1301, 1301,    0, 1301,    0, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301,
 1301, 1301, 1301, 1301, 1301, 1301,    0, 1301, 1301, 1301,
 1301,    0, 1301, 1301, 1301, 1301, 1301,    0, 1301, 1301,
 1301, 1301, 1301,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1302,
    0, 1302, 1302,    0,    0,    0,    0,    0, 1302,    0,
    0,    0,    0,    0, 1302,    0,    0,    0,    0, 1302,
    0,    0, 1302,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1302,    0,    0,    0,
    0, 1302, 1302,    0,    0, 1302,    0,    0,    0,    0,
    0,    0, 1302,    0, 1302, 1302,    0,    0, 1302,    0,
    0,    0, 1302,    0, 1302,    0, 1302,    0, 1302,    0,
    0,    0,    0, 1302, 1302,    0, 1302,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1303, 1302, 1302,    0, 1302,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1302,    0, 1302,    0, 1302, 1302,
 1302,    0, 1302,    0,    0, 1302, 1302,    0,    0,    0,
    0,    0,    0,    0,    0, 1302,    0,    0,    0,    0,
 1125, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1302,    0,
    0, 1302,    0,    0,    0,    0,    0,    0, 1303, 1303,
 1303, 1303, 1303,    0,    0,    0,    0, 1302,    0,    0,
    0,    0,    0, 1302, 1302,    0,    0,    0, 1302,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1302,
 1302, 1303, 1302, 1303,    0,    0,    0,    0, 1302,    0,
    0, 1302,    0, 1302, 1302, 1302, 1302,    0, 1302,    0,
 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1302, 1302,    0,
 1302, 1302, 1302,    0,    0,    0,    0, 1302, 1302, 1302,
 1302, 1302,    0, 1302,    0,    0, 1302, 1302, 1302, 1302,
 1302, 1302, 1302,    0,    0,    0, 1302, 1302, 1302, 1302,
 1302, 1302, 1302, 1302,    0, 1302,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1302,    0, 1302, 1302, 1302,
 1302, 1302, 1302,    0, 1302, 1302, 1302, 1302,    0, 1302,
    0, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,
 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302,    0,
 1302, 1302, 1302, 1302,    0, 1302, 1302, 1302, 1302, 1302,
    0, 1302, 1302, 1302, 1302, 1302,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1303,    0, 1303, 1303,    0,    0,    0,    0,
    0, 1303,    0,    0,    0,    0,    0, 1303,    0,    0,
    0,    0, 1303,    0,    0, 1303,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1303,
    0,    0,    0,    0, 1303, 1303,    0,    0, 1303,    0,
    0,    0,    0,    0,    0, 1303,    0, 1303, 1303,    0,
    0, 1303,    0,    0,    0, 1303,    0, 1303,    0, 1303,
    0, 1303,    0,    0,    0,    0, 1303, 1303,    0, 1303,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1306, 1303, 1303,    0, 1303,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1303,    0, 1303,
    0, 1303, 1303, 1303,    0, 1303,    0,    0, 1303, 1303,
    0,    0,    0,    0,    0,    0,    0,    0, 1303,    0,
    0,    0,    0, 1126, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1303,    0,    0, 1303,    0,    0,    0,    0,    0,
    0, 1306, 1306, 1306, 1306, 1306,    0,    0,    0,    0,
 1303,    0,    0,    0,    0,    0, 1303, 1303,    0,    0,
    0, 1303,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1303, 1303, 1306, 1303, 1306,    0,    0,    0,
    0, 1303,    0,    0, 1303,    0, 1303, 1303, 1303, 1303,
    0, 1303,    0, 1303, 1303, 1303, 1303, 1303, 1303, 1303,
 1303,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1303, 1303,    0, 1303, 1303, 1303,    0,    0,    0,    0,
 1303, 1303, 1303, 1303, 1303,    0, 1303,    0,    0, 1303,
 1303, 1303, 1303, 1303, 1303, 1303,    0,    0,    0, 1303,
 1303, 1303, 1303, 1303, 1303, 1303, 1303,    0, 1303,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,    0,
 1303, 1303, 1303, 1303, 1303, 1303,    0, 1303, 1303, 1303,
 1303,    0, 1303,    0, 1303, 1303, 1303, 1303, 1303, 1303,
 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303, 1303,
 1303, 1303,    0, 1303, 1303, 1303, 1303,    0, 1303, 1303,
 1303, 1303, 1303,    0, 1303, 1303, 1303, 1303, 1303,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1306,    0, 1306, 1306,    0,
    0,    0,    0,    0, 1306,    0,    0,    0,    0,    0,
 1306,    0,    0,    0,    0, 1306,    0,    0, 1306,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1306,    0,    0,    0,    0, 1306, 1306,    0,
    0, 1306,    0,    0,    0,    0,    0,    0, 1306,    0,
 1306, 1306,    0,    0, 1306,    0,    0,    0, 1306,    0,
 1306,    0, 1306,    0, 1306,    0,    0,    0,    0, 1306,
 1306,    0, 1306,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1308, 1306, 1306,    0,
 1306,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1306,    0, 1306,    0, 1306, 1306, 1306,    0, 1306,    0,
    0, 1306, 1306,    0,    0,    0,    0,    0,    0,    0,
    0, 1306,    0,    0,    0,    0, 1127, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1306,    0,    0, 1306,    0,    0,
    0,    0,    0,    0, 1308, 1308, 1308, 1308, 1308,    0,
    0,    0,    0, 1306,    0,    0,    0,    0,    0, 1306,
 1306,    0,    0,    0, 1306,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1306, 1306, 1308, 1306, 1308,
    0,    0,    0,    0, 1306,    0,    0, 1306,    0, 1306,
 1306, 1306, 1306,    0, 1306,    0, 1306, 1306, 1306, 1306,
 1306, 1306, 1306, 1306,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1306, 1306,    0, 1306, 1306, 1306,    0,
    0,    0,    0, 1306, 1306, 1306, 1306, 1306,    0, 1306,
    0,    0, 1306, 1306, 1306, 1306, 1306, 1306, 1306,    0,
    0,    0, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
    0, 1306,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1306,    0, 1306, 1306, 1306, 1306, 1306, 1306,    0,
 1306, 1306, 1306, 1306,    0, 1306,    0, 1306, 1306, 1306,
 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306, 1306,
 1306, 1306, 1306, 1306, 1306,    0, 1306, 1306, 1306, 1306,
    0, 1306, 1306, 1306, 1306, 1306,    0, 1306, 1306, 1306,
 1306, 1306,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1308,    0,
 1308, 1308,    0,    0,    0,    0,    0, 1308,    0,    0,
    0,    0,    0, 1308,    0,    0,    0,    0, 1308,    0,
    0, 1308,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1308,    0,    0,    0,    0,
 1308, 1308,    0,    0, 1308,    0,    0,    0,    0,    0,
    0, 1308,    0, 1308, 1308,    0,    0, 1308,    0,    0,
    0, 1308,    0, 1308,    0, 1308,    0, 1308,    0,    0,
    0,    0, 1308, 1308,    0, 1308,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1309,
 1308, 1308,    0, 1308,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1308,    0, 1308,    0, 1308, 1308, 1308,
    0, 1308,    0,    0, 1308, 1308,    0,    0,    0,    0,
    0,    0,    0,    0, 1308,    0,    0,    0,    0, 1128,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1308,    0,    0,
 1308,    0,    0,    0,    0,    0,    0, 1309, 1309, 1309,
 1309, 1309,    0,    0,    0,    0, 1308,    0,    0,    0,
    0,    0, 1308, 1308,    0,    0,    0, 1308,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1308, 1308,
 1309, 1308, 1309,    0,    0,    0,    0, 1308,    0,    0,
 1308,    0, 1308, 1308, 1308, 1308,    0, 1308,    0, 1308,
 1308, 1308, 1308, 1308, 1308, 1308, 1308,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1308, 1308,    0, 1308,
 1308, 1308,    0,    0,    0,    0, 1308, 1308, 1308, 1308,
 1308,    0, 1308,    0,    0, 1308, 1308, 1308, 1308, 1308,
 1308, 1308,    0,    0,    0, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308,    0, 1308,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1308, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1308,    0, 1308, 1308, 1308, 1308,
 1308, 1308,    0, 1308, 1308, 1308, 1308,    0, 1308,    0,
 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,
 1308, 1308, 1308, 1308, 1308, 1308, 1308, 1308,    0, 1308,
 1308, 1308, 1308,    0, 1308, 1308, 1308, 1308, 1308,    0,
 1308, 1308, 1308, 1308, 1308,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1309,    0, 1309, 1309,    0,    0,    0,    0,    0,
 1309,    0,    0,    0,    0,    0, 1309,    0,    0,    0,
    0, 1309,    0,    0, 1309,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1309,    0,
    0,    0,    0, 1309, 1309,    0,    0, 1309,    0,    0,
    0,    0,    0,    0, 1309,    0, 1309, 1309,    0,    0,
 1309,    0,    0,    0, 1309,    0, 1309,    0, 1309,    0,
 1309,    0,    0,    0,    0, 1309, 1309,    0, 1309,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1312, 1309, 1309,    0, 1309,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1309,    0, 1309,    0,
 1309, 1309, 1309,    0, 1309,    0,    0, 1309, 1309,    0,
    0,    0,    0,    0,    0,    0,    0, 1309,    0,    0,
    0,    0, 1129, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1309,    0,    0, 1309,    0,    0,    0,    0,    0,    0,
 1312, 1312, 1312, 1312, 1312,    0,    0,    0,    0, 1309,
    0,    0,    0,    0,    0, 1309, 1309,    0,    0,    0,
 1309,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1309, 1309, 1312, 1309, 1312,    0,    0,    0,    0,
 1309,    0,    0, 1309,    0, 1309, 1309, 1309, 1309,    0,
 1309,    0, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1309,
 1309,    0, 1309, 1309, 1309,    0,    0,    0,    0, 1309,
 1309, 1309, 1309, 1309,    0, 1309,    0,    0, 1309, 1309,
 1309, 1309, 1309, 1309, 1309,    0,    0,    0, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309,    0, 1309,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,    0, 1309,
 1309, 1309, 1309, 1309, 1309,    0, 1309, 1309, 1309, 1309,
    0, 1309,    0, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309,    0, 1309, 1309, 1309, 1309,    0, 1309, 1309, 1309,
 1309, 1309,    0, 1309, 1309, 1309, 1309, 1309,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1312,    0, 1312, 1312,    0,    0,
    0,    0,    0, 1312,    0,    0,    0,    0,    0, 1312,
    0,    0,    0,    0, 1312,    0,    0, 1312,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1312,    0,    0,    0,    0, 1312, 1312,    0,    0,
 1312,    0,    0,    0,    0,    0,    0, 1312,    0, 1312,
 1312,    0,    0, 1312,    0,    0,    0, 1312,    0, 1312,
    0, 1312,    0, 1312,    0,    0,    0,    0, 1312, 1312,
    0, 1312,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1314, 1312, 1312,    0, 1312,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1312,
    0, 1312,    0, 1312, 1312, 1312,    0, 1312,    0,    0,
 1312, 1312,    0,    0,    0,    0,    0,    0,    0,    0,
 1312,    0,    0,    0,    0, 1131, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1312,    0,    0, 1312,    0,    0,    0,
    0,    0,    0, 1314, 1314, 1314, 1314, 1314,    0,    0,
    0,    0, 1312,    0,    0,    0,    0,    0, 1312, 1312,
    0,    0,    0, 1312,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1312, 1312, 1314, 1312, 1314,    0,
    0,    0,    0, 1312,    0,    0, 1312,    0, 1312, 1312,
 1312, 1312,    0, 1312,    0, 1312, 1312, 1312, 1312, 1312,
 1312, 1312, 1312,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1312, 1312,    0, 1312, 1312, 1312,    0,    0,
    0,    0, 1312, 1312, 1312, 1312, 1312,    0, 1312,    0,
    0, 1312, 1312, 1312, 1312, 1312, 1312, 1312,    0,    0,
    0, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,    0,
 1312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1312,    0, 1312, 1312, 1312, 1312, 1312, 1312,    0, 1312,
 1312, 1312, 1312,    0, 1312,    0, 1312, 1312, 1312, 1312,
 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312, 1312,
 1312, 1312, 1312, 1312,    0, 1312, 1312, 1312, 1312,    0,
 1312, 1312, 1312, 1312, 1312,    0, 1312, 1312, 1312, 1312,
 1312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1314,    0, 1314,
 1314,    0,    0,    0,    0,    0, 1314,    0,    0,    0,
    0,    0, 1314,    0,    0,    0,    0, 1314,    0,    0,
 1314,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1314,    0,    0,    0,    0, 1314,
 1314,    0,    0, 1314,    0,    0,    0,    0,    0,    0,
 1314,    0, 1314, 1314,    0,    0, 1314,    0,    0,    0,
 1314,    0, 1314,    0, 1314,    0, 1314,    0,    0,    0,
    0, 1314, 1314,    0, 1314,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1316, 1314,
 1314,    0, 1314,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1314,    0, 1314,    0, 1314, 1314, 1314,    0,
 1314,    0,    0, 1314, 1314,    0,    0,    0,    0,    0,
    0,    0,    0, 1314,    0,    0,    0,    0, 1132, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1314,    0,    0, 1314,
    0,    0,    0,    0,    0,    0, 1316, 1316, 1316, 1316,
 1316,    0,    0,    0,    0, 1314,    0,    0,    0,    0,
    0, 1314, 1314,    0,    0,    0, 1314,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1314, 1314, 1316,
 1314, 1316,    0,    0,    0,    0, 1314,    0,    0, 1314,
    0, 1314, 1314, 1314, 1314,    0, 1314,    0, 1314, 1314,
 1314, 1314, 1314, 1314, 1314, 1314,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1314, 1314,    0, 1314, 1314,
 1314,    0,    0,    0,    0, 1314, 1314, 1314, 1314, 1314,
    0, 1314,    0,    0, 1314, 1314, 1314, 1314, 1314, 1314,
 1314,    0,    0,    0, 1314, 1314, 1314, 1314, 1314, 1314,
 1314, 1314,    0, 1314,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1314,    0, 1314, 1314, 1314, 1314, 1314,
 1314,    0, 1314, 1314, 1314, 1314,    0, 1314,    0, 1314,
 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314, 1314,
 1314, 1314, 1314, 1314, 1314, 1314, 1314,    0, 1314, 1314,
 1314, 1314,    0, 1314, 1314, 1314, 1314, 1314,    0, 1314,
 1314, 1314, 1314, 1314,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1316,    0, 1316, 1316,    0,    0,    0,    0,    0, 1316,
    0,    0,    0,    0,    0, 1316,    0,    0,    0,    0,
 1316,    0,    0, 1316,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1316,    0,    0,
    0,    0, 1316, 1316,    0,    0, 1316,    0,    0,    0,
    0,    0,    0, 1316,    0, 1316, 1316,    0,    0, 1316,
    0,    0,    0, 1316,    0, 1316,    0, 1316,    0, 1316,
    0,    0,    0,    0, 1316, 1316,    0, 1316,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1317, 1316, 1316,    0, 1316,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1316,    0, 1316,    0, 1316,
 1316, 1316,    0, 1316,    0,    0, 1316, 1316,    0,    0,
    0,    0,    0,    0,    0,    0, 1316,    0,    0,    0,
    0, 1133, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1316,
    0,    0, 1316,    0,    0,    0,    0,    0,    0, 1317,
 1317, 1317, 1317, 1317,    0,    0,    0,    0, 1316,    0,
    0,    0,    0,    0, 1316, 1316,    0,    0,    0, 1316,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1316, 1316, 1317, 1316, 1317,    0,    0,    0,    0, 1316,
    0,    0, 1316,    0, 1316, 1316, 1316, 1316,    0, 1316,
    0, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1316, 1316,
    0, 1316, 1316, 1316,    0,    0,    0,    0, 1316, 1316,
 1316, 1316, 1316,    0, 1316,    0,    0, 1316, 1316, 1316,
 1316, 1316, 1316, 1316,    0,    0,    0, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316,    0, 1316,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1316, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1316,    0, 1316, 1316,
 1316, 1316, 1316, 1316,    0, 1316, 1316, 1316, 1316,    0,
 1316,    0, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316, 1316,
    0, 1316, 1316, 1316, 1316,    0, 1316, 1316, 1316, 1316,
 1316,    0, 1316, 1316, 1316, 1316, 1316,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1317,    0, 1317, 1317,    0,    0,    0,
    0,    0, 1317,    0,    0,    0,    0,    0, 1317,    0,
    0,    0,    0, 1317,    0,    0, 1317,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1317,    0,    0,    0,    0, 1317, 1317,    0,    0, 1317,
    0,    0,    0,    0,    0,    0, 1317,    0, 1317, 1317,
    0,    0, 1317,    0,    0,    0, 1317,    0, 1317,    0,
 1317,    0, 1317,    0,    0,    0,    0, 1317, 1317,    0,
 1317,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1318, 1317, 1317,    0, 1317,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1317,    0,
 1317,    0, 1317, 1317, 1317,    0, 1317,    0,    0, 1317,
 1317,    0,    0,    0,    0,    0,    0,    0,    0, 1317,
    0,    0,    0,    0, 1134, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1317,    0,    0, 1317,    0,    0,    0,    0,
    0,    0, 1318, 1318, 1318, 1318, 1318,    0,    0,    0,
    0, 1317,    0,    0,    0,    0,    0, 1317, 1317,    0,
    0,    0, 1317,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1317, 1317, 1318, 1317, 1318,    0,    0,
    0,    0, 1317,    0,    0, 1317,    0, 1317, 1317, 1317,
 1317,    0, 1317,    0, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1317, 1317,    0, 1317, 1317, 1317,    0,    0,    0,
    0, 1317, 1317, 1317, 1317, 1317,    0, 1317,    0,    0,
 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0,    0,    0,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
    0, 1317, 1317, 1317, 1317, 1317, 1317,    0, 1317, 1317,
 1317, 1317,    0, 1317,    0, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317, 1317,
 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317,    0, 1317,
 1317, 1317, 1317, 1317,    0, 1317, 1317, 1317, 1317, 1317,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1318,    0, 1318, 1318,
    0,    0,    0,    0,    0, 1318,    0,    0,    0,    0,
    0, 1318,    0,    0,    0,    0, 1318,    0,    0, 1318,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1318,    0,    0,    0,    0, 1318, 1318,
    0,    0, 1318,    0,    0,    0,    0,    0,    0, 1318,
    0, 1318, 1318,    0,    0, 1318,    0,    0,    0, 1318,
    0, 1318,    0, 1318,    0, 1318,    0,    0,    0,    0,
 1318, 1318,    0, 1318,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1319, 1318, 1318,
    0, 1318,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1318,    0, 1318,    0, 1318, 1318, 1318,    0, 1318,
    0,    0, 1318, 1318,    0,    0,    0,    0,    0,    0,
    0,    0, 1318,    0,    0,    0,    0, 1136, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1318,    0,    0, 1318,    0,
    0,    0,    0,    0,    0, 1319, 1319, 1319, 1319, 1319,
    0,    0,    0,    0, 1318,    0,    0,    0,    0,    0,
 1318, 1318,    0,    0,    0, 1318,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1318, 1318, 1319, 1318,
 1319,    0,    0,    0,    0, 1318,    0,    0, 1318,    0,
 1318, 1318, 1318, 1318,    0, 1318,    0, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1318, 1318,    0, 1318, 1318, 1318,
    0,    0,    0,    0, 1318, 1318, 1318, 1318, 1318,    0,
 1318,    0,    0, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
    0,    0,    0, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318,    0, 1318,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318,    0, 1318, 1318, 1318, 1318, 1318, 1318,
    0, 1318, 1318, 1318, 1318,    0, 1318,    0, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318, 1318,
 1318, 1318, 1318, 1318, 1318, 1318,    0, 1318, 1318, 1318,
 1318,    0, 1318, 1318, 1318, 1318, 1318,    0, 1318, 1318,
 1318, 1318, 1318,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1319,
    0, 1319, 1319,    0,    0,    0,    0,    0, 1319,    0,
    0,    0,    0,    0, 1319,    0,    0,    0,    0, 1319,
    0,    0, 1319,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1319,    0,    0,    0,
    0, 1319, 1319,    0,    0, 1319,    0,    0,    0,    0,
    0,    0, 1319,    0, 1319, 1319,    0,    0, 1319,    0,
    0,    0, 1319,    0, 1319,    0, 1319,    0, 1319,    0,
    0,    0,    0, 1319, 1319,    0, 1319,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1320, 1319, 1319,    0, 1319,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1319,    0, 1319,    0, 1319, 1319,
 1319,    0, 1319,    0,    0, 1319, 1319,    0,    0,    0,
    0,    0,    0,    0,    0, 1319,    0,    0,    0,    0,
 1137, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1319,    0,
    0, 1319,    0,    0,    0,    0,    0,    0, 1320, 1320,
 1320, 1320, 1320,    0,    0,    0,    0, 1319,    0,    0,
    0,    0,    0, 1319, 1319,    0,    0,    0, 1319,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1319,
 1319, 1320, 1319, 1320,    0,    0,    0,    0, 1319,    0,
    0, 1319,    0, 1319, 1319, 1319, 1319,    0, 1319,    0,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1319, 1319,    0,
 1319, 1319, 1319,    0,    0,    0,    0, 1319, 1319, 1319,
 1319, 1319,    0, 1319,    0,    0, 1319, 1319, 1319, 1319,
 1319, 1319, 1319,    0,    0,    0, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319,    0, 1319,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319,    0, 1319, 1319, 1319,
 1319, 1319, 1319,    0, 1319, 1319, 1319, 1319,    0, 1319,
    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,
 1319, 1319, 1319, 1319,    0, 1319, 1319, 1319, 1319, 1319,
    0, 1319, 1319, 1319, 1319, 1319,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1320,    0, 1320, 1320,    0,    0,    0,    0,
    0, 1320,    0,    0,    0,    0,    0, 1320,    0,    0,
    0,    0, 1320,    0,    0, 1320,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1320,
    0,    0,    0,    0, 1320, 1320,    0,    0, 1320,    0,
    0,    0,    0,    0,    0, 1320,    0, 1320, 1320,    0,
    0, 1320,    0,    0,    0, 1320,    0, 1320,    0, 1320,
    0, 1320,    0,    0,    0,    0, 1320, 1320,    0, 1320,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1321, 1320, 1320,    0, 1320,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1320,    0, 1320,
    0, 1320, 1320, 1320,    0, 1320,    0,    0, 1320, 1320,
    0,    0,    0,    0,    0,    0,    0,    0, 1320,    0,
    0,    0,    0, 1138, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1320,    0,    0, 1320,    0,    0,    0,    0,    0,
    0, 1321, 1321, 1321, 1321, 1321,    0,    0,    0,    0,
 1320,    0,    0,    0,    0,    0, 1320, 1320,    0,    0,
    0, 1320,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1320, 1320, 1321, 1320, 1321,    0,    0,    0,
    0, 1320,    0,    0, 1320,    0, 1320, 1320, 1320, 1320,
    0, 1320,    0, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1320, 1320,    0, 1320, 1320, 1320,    0,    0,    0,    0,
 1320, 1320, 1320, 1320, 1320,    0, 1320,    0,    0, 1320,
 1320, 1320, 1320, 1320, 1320, 1320,    0,    0,    0, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0, 1320,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0,
 1320, 1320, 1320, 1320, 1320, 1320,    0, 1320, 1320, 1320,
 1320,    0, 1320,    0, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320,    0, 1320, 1320, 1320, 1320,    0, 1320, 1320,
 1320, 1320, 1320,    0, 1320, 1320, 1320, 1320, 1320,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1321,    0, 1321, 1321,    0,
    0,    0,    0,    0, 1321,    0,    0,    0,    0,    0,
 1321,    0,    0,    0,    0, 1321,    0,    0, 1321,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1321,    0,    0,    0,    0, 1321, 1321,    0,
    0, 1321,    0,    0,    0,    0,    0,    0, 1321,    0,
 1321, 1321,    0,    0, 1321,    0,    0,    0, 1321,    0,
 1321,    0, 1321,    0, 1321,    0,    0,    0,    0, 1321,
 1321,    0, 1321,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1322, 1321, 1321,    0,
 1321,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1321,    0, 1321,    0, 1321, 1321, 1321,    0, 1321,    0,
    0, 1321, 1321,    0,    0,    0,    0,    0,    0,    0,
    0, 1321,    0,    0,    0,    0, 1139, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1321,    0,    0, 1321,    0,    0,
    0,    0,    0,    0, 1322, 1322, 1322, 1322, 1322,    0,
    0,    0,    0, 1321,    0,    0,    0,    0,    0, 1321,
 1321,    0,    0,    0, 1321,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1321, 1321, 1322, 1321, 1322,
    0,    0,    0,    0, 1321,    0,    0, 1321,    0, 1321,
 1321, 1321, 1321,    0, 1321,    0, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1321, 1321,    0, 1321, 1321, 1321,    0,
    0,    0,    0, 1321, 1321, 1321, 1321, 1321,    0, 1321,
    0,    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321,    0,
    0,    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
    0, 1321,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321,    0, 1321, 1321, 1321, 1321, 1321, 1321,    0,
 1321, 1321, 1321, 1321,    0, 1321,    0, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321, 1321,
 1321, 1321, 1321, 1321, 1321,    0, 1321, 1321, 1321, 1321,
    0, 1321, 1321, 1321, 1321, 1321,    0, 1321, 1321, 1321,
 1321, 1321,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1322,    0,
 1322, 1322,    0,    0,    0,    0,    0, 1322,    0,    0,
    0,    0,    0, 1322,    0,    0,    0,    0, 1322,    0,
    0, 1322,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1322,    0,    0,    0,    0,
 1322, 1322,    0,    0, 1322,    0,    0,    0,    0,    0,
    0, 1322,    0, 1322, 1322,    0,    0, 1322,    0,    0,
    0, 1322,    0, 1322,    0, 1322,    0, 1322,    0,    0,
    0,    0, 1322, 1322,    0, 1322,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1323,
 1322, 1322,    0, 1322,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1322,    0, 1322,    0, 1322, 1322, 1322,
    0, 1322,    0,    0, 1322, 1322,    0,    0,    0,    0,
    0,    0,    0,    0, 1322,    0,    0,    0,    0, 1140,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1322,    0,    0,
 1322,    0,    0,    0,    0,    0,    0, 1323, 1323, 1323,
 1323, 1323,    0,    0,    0,    0, 1322,    0,    0,    0,
    0,    0, 1322, 1322,    0,    0,    0, 1322,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1322, 1322,
 1323, 1322, 1323,    0,    0,    0,    0, 1322,    0,    0,
 1322,    0, 1322, 1322, 1322, 1322,    0, 1322,    0, 1322,
 1322, 1322, 1322, 1322, 1322, 1322, 1322,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1322, 1322,    0, 1322,
 1322, 1322,    0,    0,    0,    0, 1322, 1322, 1322, 1322,
 1322,    0, 1322,    0,    0, 1322, 1322, 1322, 1322, 1322,
 1322, 1322,    0,    0,    0, 1322, 1322, 1322, 1322, 1322,
 1322, 1322, 1322,    0, 1322,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1322,    0, 1322, 1322, 1322, 1322,
 1322, 1322,    0, 1322, 1322, 1322, 1322,    0, 1322,    0,
 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,
 1322, 1322, 1322, 1322, 1322, 1322, 1322, 1322,    0, 1322,
 1322, 1322, 1322,    0, 1322, 1322, 1322, 1322, 1322,    0,
 1322, 1322, 1322, 1322, 1322,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1323,    0, 1323, 1323,    0,    0,    0,    0,    0,
 1323,    0,    0,    0,    0,    0, 1323,    0,    0,    0,
    0, 1323,    0,    0, 1323,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1323,    0,
    0,    0,    0, 1323, 1323,    0,    0, 1323,    0,    0,
    0,    0,    0,    0, 1323,    0, 1323, 1323,    0,    0,
 1323,    0,    0,    0, 1323,    0, 1323,    0, 1323,    0,
 1323,    0,    0,    0,    0, 1323, 1323,    0, 1323,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1325, 1323, 1323,    0, 1323,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1323,    0, 1323,    0,
 1323, 1323, 1323,    0, 1323,    0,    0, 1323, 1323,    0,
    0,    0,    0,    0,    0,    0,    0, 1323,    0,    0,
    0,    0, 1141, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1323,    0,    0, 1323,    0,    0,    0,    0,    0,    0,
 1325, 1325, 1325, 1325, 1325,    0,    0,    0,    0, 1323,
    0,    0,    0,    0,    0, 1323, 1323,    0,    0,    0,
 1323,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1323, 1323, 1325, 1323, 1325,    0,    0,    0,    0,
 1323,    0,    0, 1323,    0, 1323, 1323, 1323, 1323,    0,
 1323,    0, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1323,
 1323,    0, 1323, 1323, 1323,    0,    0,    0,    0, 1323,
 1323, 1323, 1323, 1323,    0, 1323,    0,    0, 1323, 1323,
 1323, 1323, 1323, 1323, 1323,    0,    0,    0, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323,    0, 1323,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,    0, 1323,
 1323, 1323, 1323, 1323, 1323,    0, 1323, 1323, 1323, 1323,
    0, 1323,    0, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323, 1323,
 1323,    0, 1323, 1323, 1323, 1323,    0, 1323, 1323, 1323,
 1323, 1323,    0, 1323, 1323, 1323, 1323, 1323,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1325,    0, 1325, 1325,    0,    0,
    0,    0,    0, 1325,    0,    0,    0,    0,    0, 1325,
    0,    0,    0,    0, 1325,    0,    0, 1325,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1325,    0,    0,    0,    0, 1325, 1325,    0,    0,
 1325,    0,    0,    0,    0,    0,    0, 1325,    0, 1325,
 1325,    0,    0, 1325,    0,    0,    0, 1325,    0, 1325,
    0, 1325,    0, 1325,    0,    0,    0,    0, 1325, 1325,
    0, 1325,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1326, 1325, 1325,    0, 1325,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1325,
    0, 1325,    0, 1325, 1325, 1325,    0, 1325,    0,    0,
 1325, 1325,    0,    0,    0,    0,    0,    0,    0,    0,
 1325,    0,    0,    0,    0, 1142, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1325,    0,    0, 1325,    0,    0,    0,
    0,    0,    0, 1326, 1326, 1326, 1326, 1326,    0,    0,
    0,    0, 1325,    0,    0,    0,    0,    0, 1325, 1325,
    0,    0,    0, 1325,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1325, 1325, 1326, 1325, 1326,    0,
    0,    0,    0, 1325,    0,    0, 1325,    0, 1325, 1325,
 1325, 1325,    0, 1325,    0, 1325, 1325, 1325, 1325, 1325,
 1325, 1325, 1325,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1325, 1325,    0, 1325, 1325, 1325,    0,    0,
    0,    0, 1325, 1325, 1325, 1325, 1325,    0, 1325,    0,
    0, 1325, 1325, 1325, 1325, 1325, 1325, 1325,    0,    0,
    0, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,    0,
 1325,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1325,    0, 1325, 1325, 1325, 1325, 1325, 1325,    0, 1325,
 1325, 1325, 1325,    0, 1325,    0, 1325, 1325, 1325, 1325,
 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325, 1325,
 1325, 1325, 1325, 1325,    0, 1325, 1325, 1325, 1325,    0,
 1325, 1325, 1325, 1325, 1325,    0, 1325, 1325, 1325, 1325,
 1325,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1326,    0, 1326,
 1326,    0,    0,    0,    0,    0, 1326,    0,    0,    0,
    0,    0, 1326,    0,    0,    0,    0, 1326,    0,    0,
 1326,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1326,    0,    0,    0,    0, 1326,
 1326,    0,    0, 1326,    0,    0,    0,    0,    0,    0,
 1326,    0, 1326, 1326,    0,    0, 1326,    0,    0,    0,
 1326,    0, 1326,    0, 1326,    0, 1326,    0,    0,    0,
    0, 1326, 1326,    0, 1326,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1327, 1326,
 1326,    0, 1326,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1326,    0, 1326,    0, 1326, 1326, 1326,    0,
 1326,    0,    0, 1326, 1326,    0,    0,    0,    0,    0,
    0,    0,    0, 1326,    0,    0,    0,    0, 1143, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1326,    0,    0, 1326,
    0,    0,    0,    0,    0,    0, 1327, 1327, 1327, 1327,
 1327,    0,    0,    0,    0, 1326,    0,    0,    0,    0,
    0, 1326, 1326,    0,    0,    0, 1326,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1326, 1326, 1327,
 1326, 1327,    0,    0,    0,    0, 1326,    0,    0, 1326,
    0, 1326, 1326, 1326, 1326,    0, 1326,    0, 1326, 1326,
 1326, 1326, 1326, 1326, 1326, 1326,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1326, 1326,    0, 1326, 1326,
 1326,    0,    0,    0,    0, 1326, 1326, 1326, 1326, 1326,
    0, 1326,    0,    0, 1326, 1326, 1326, 1326, 1326, 1326,
 1326,    0,    0,    0, 1326, 1326, 1326, 1326, 1326, 1326,
 1326, 1326,    0, 1326,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1326,    0, 1326, 1326, 1326, 1326, 1326,
 1326,    0, 1326, 1326, 1326, 1326,    0, 1326,    0, 1326,
 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326, 1326,
 1326, 1326, 1326, 1326, 1326, 1326, 1326,    0, 1326, 1326,
 1326, 1326,    0, 1326, 1326, 1326, 1326, 1326,    0, 1326,
 1326, 1326, 1326, 1326,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1327,    0, 1327, 1327,    0,    0,    0,    0,    0, 1327,
    0,    0,    0,    0,    0, 1327,    0,    0,    0,    0,
 1327,    0,    0, 1327,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1327,    0,    0,
    0,    0, 1327, 1327,    0,    0, 1327,    0,    0,    0,
    0,    0,    0, 1327,    0, 1327, 1327,    0,    0, 1327,
    0,    0,    0, 1327,    0, 1327,    0, 1327,    0, 1327,
    0,    0,    0,    0, 1327, 1327,    0, 1327,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1329, 1327, 1327,    0, 1327,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1327,    0, 1327,    0, 1327,
 1327, 1327,    0, 1327,    0,    0, 1327, 1327,    0,    0,
    0,    0,    0,    0,    0,    0, 1327,    0,    0,    0,
    0, 1144, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1327,
    0,    0, 1327,    0,    0,    0,    0,    0,    0, 1329,
 1329, 1329, 1329, 1329,    0,    0,    0,    0, 1327,    0,
    0,    0,    0,    0, 1327, 1327,    0,    0,    0, 1327,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1327, 1327, 1329, 1327, 1329,    0,    0,    0,    0, 1327,
    0,    0, 1327,    0, 1327, 1327, 1327, 1327,    0, 1327,
    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1327, 1327,
    0, 1327, 1327, 1327,    0,    0,    0,    0, 1327, 1327,
 1327, 1327, 1327,    0, 1327,    0,    0, 1327, 1327, 1327,
 1327, 1327, 1327, 1327,    0,    0,    0, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327,    0, 1327,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327,    0, 1327, 1327,
 1327, 1327, 1327, 1327,    0, 1327, 1327, 1327, 1327,    0,
 1327,    0, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327, 1327,
    0, 1327, 1327, 1327, 1327,    0, 1327, 1327, 1327, 1327,
 1327,    0, 1327, 1327, 1327, 1327, 1327,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1329,    0, 1329, 1329,    0,    0,    0,
    0,    0, 1329,    0,    0,    0,    0,    0, 1329,    0,
    0,    0,    0, 1329,    0,    0, 1329,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1329,    0,    0,    0,    0, 1329, 1329,    0,    0, 1329,
    0,    0,    0,    0,    0,    0, 1329,    0, 1329, 1329,
    0,    0, 1329,    0,    0,    0, 1329,    0, 1329,    0,
 1329,    0, 1329,    0,    0,    0,    0, 1329, 1329,    0,
 1329,    0,    0,    0,    0,    0,    0,    0,    0, 1243,
    0,    0,    0,    0,    0, 1329, 1329,    0, 1329,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1329,    0,
 1329,    0, 1329, 1329, 1329,    0, 1329,    0,    0, 1329,
 1329,    0,    0,    0,    0,    0,    0,    0,    0, 1329,
 1243, 1243, 1243, 1243, 1243, 1243, 1243,    0,    0,    0,
    0,    0, 1329,    0,    0, 1329,    0, 1243, 1243, 1243,
 1243, 1243,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1329,    0,    0,    0,    0,    0, 1329, 1329,    0,
    0,    0, 1329,    0,    0,    0,    0,    0,    0,    0,
 1243,    0, 1243, 1329, 1329,    0, 1329,    0,    0,    0,
    0,    0, 1329,    0,    0, 1329,    0, 1329, 1329, 1329,
 1329,    0, 1329,    0, 1329, 1329, 1329, 1329, 1329, 1329,
 1329, 1329,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1329, 1329,    0, 1329, 1329, 1329,    0,    0,    0,
    0, 1329, 1329, 1329, 1329, 1329,    0, 1329,    0,    0,
 1329, 1329, 1329, 1329, 1329, 1329, 1329,    0,    0,    0,
 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329,    0, 1329,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1329,
 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329,
 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329,
    0, 1329, 1329, 1329, 1329, 1329, 1329,    0, 1329, 1329,
 1329, 1329,    0, 1329,    0, 1329, 1329, 1329, 1329, 1329,
 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329, 1329,
 1329, 1329, 1329,    0, 1329, 1329, 1329, 1329,    0, 1329,
 1329, 1329, 1329, 1329,    0, 1329, 1329, 1329, 1329, 1329,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1243,    0, 1243, 1243,    0,    0,    0,    0,    0,
 1243,    0,    0,    0,    0,    0, 1243,    0,    0,    0,
    0, 1243,    0,    0, 1243,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1243,    0,
    0,    0,    0, 1243, 1243,    0,    0, 1243,    0,    0,
    0,    0,    0,    0, 1243,    0, 1243, 1243,    0,    0,
 1243,    0,    0,    0, 1243,    0, 1243,    0, 1243,    0,
 1243,    0,    0,    0,    0, 1243, 1243,    0, 1243,    0,
    0,    0,    0,    0,    0,    0,    0, 1291,    0,    0,
    0,    0,    0, 1243, 1243,    0, 1243,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1243,    0, 1243,    0,
 1243, 1243, 1243,    0, 1243,    0,    0, 1243, 1243,    0,
    0,    0,    0,    0,    0,    0,    0, 1243, 1291, 1291,
 1291, 1291, 1291, 1291, 1291,    0,    0,    0,    0,    0,
 1243,    0,    0, 1243,    0, 1291, 1291, 1291, 1291, 1291,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1243,
    0,    0,    0,    0,    0, 1243, 1243,    0,    0,    0,
 1243,    0,    0,    0,    0,    0,    0,    0, 1291,    0,
 1291, 1243, 1243,    0, 1243,    0,    0,    0,    0,    0,
 1243,    0,    0, 1243,    0, 1243, 1243, 1243, 1243,    0,
 1243,    0, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1243,
 1243,    0, 1243, 1243, 1243,    0,    0,    0,    0, 1243,
 1243, 1243, 1243, 1243,    0, 1243,    0,    0, 1243, 1243,
 1243, 1243, 1243, 1243, 1243,    0,    0,    0, 1243, 1243,
 1243, 1243, 1243, 1243, 1243, 1243,    0, 1243,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1243, 1243, 1243,
 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243,    0, 1243,
 1243, 1243, 1243, 1243, 1243,    0, 1243, 1243, 1243, 1243,
    0, 1243,    0, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
 1243,    0, 1243, 1243, 1243, 1243,    0, 1243, 1243, 1243,
 1243, 1243,    0, 1243, 1243, 1243, 1243, 1243,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1291,
    0, 1291, 1291,    0,    0,    0,    0,    0, 1291,    0,
    0,    0,    0,    0, 1291,    0,    0,    0,    0, 1291,
    0,    0, 1291,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1291,    0,    0,    0,
    0, 1291, 1291,    0,    0, 1291,    0,    0,    0,    0,
    0,    0, 1291,    0, 1291, 1291,    0,    0, 1291,    0,
    0,    0, 1291,    0, 1291,    0, 1291,    0, 1291,    0,
    0,    0,    0, 1291, 1291,    0, 1291,    0,    0,    0,
    0,    0,    0,    0,    0, 1292,    0,    0,    0,    0,
    0, 1291, 1291,    0, 1291,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1291,    0, 1291,    0, 1291, 1291,
 1291,    0, 1291,    0,    0, 1291, 1291,    0,    0,    0,
    0,    0,    0,    0,    0, 1291, 1292, 1292, 1292, 1292,
 1292, 1292, 1292,    0,    0,    0,    0,    0, 1291,    0,
    0, 1291,    0, 1292, 1292, 1292, 1292, 1292,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1291,    0,    0,
    0,    0,    0, 1291, 1291,    0,    0,    0, 1291,    0,
    0,    0,    0,    0,    0,    0, 1292,    0, 1292, 1291,
 1291,    0, 1291,    0,    0,    0,    0,    0, 1291,    0,
    0, 1291,    0, 1291, 1291, 1291, 1291,    0, 1291,    0,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1291, 1291,    0,
 1291, 1291, 1291,    0,    0,    0,    0, 1291, 1291, 1291,
 1291, 1291,    0, 1291,    0,    0, 1291, 1291, 1291, 1291,
 1291, 1291, 1291,    0,    0,    0, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291,    0, 1291,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291,    0, 1291, 1291, 1291,
 1291, 1291, 1291,    0, 1291, 1291, 1291, 1291,    0, 1291,
    0, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,
 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291, 1291,    0,
 1291, 1291, 1291, 1291,    0, 1291, 1291, 1291, 1291, 1291,
    0, 1291, 1291, 1291, 1291, 1291,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1292,    0, 1292,
 1292,    0,    0,    0,    0,    0, 1292,    0,    0,    0,
    0,    0, 1292,    0,    0,    0,    0, 1292,    0,    0,
 1292,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1292,    0,    0,    0,    0, 1292,
 1292,    0,    0, 1292,    0,    0,    0,    0,    0,    0,
 1292,    0, 1292, 1292,    0,    0, 1292,    0,    0,    0,
 1292,    0, 1292,    0, 1292,    0, 1292,    0,    0,    0,
    0, 1292, 1292,    0, 1292,    0,    0,    0,    0,    0,
    0,    0,    0, 1310,    0,    0,    0,    0,    0, 1292,
 1292,    0, 1292,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1292,    0, 1292,    0, 1292, 1292, 1292,    0,
 1292,    0,    0, 1292, 1292,    0,    0,    0,    0,    0,
    0,    0,    0, 1292, 1310, 1310, 1310, 1310, 1310, 1310,
 1310,    0,    0,    0,    0,    0, 1292,    0,    0, 1292,
    0, 1310, 1310, 1310, 1310, 1310,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1292,    0,    0,    0,    0,
    0, 1292, 1292,    0,    0,    0, 1292,    0,    0,    0,
    0,    0,    0,    0, 1310,    0, 1310, 1292, 1292,    0,
 1292,    0,    0,    0,    0,    0, 1292,    0,    0, 1292,
    0, 1292, 1292, 1292, 1292,    0, 1292,    0, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1292, 1292,    0, 1292, 1292,
 1292,    0,    0,    0,    0, 1292, 1292, 1292, 1292, 1292,
    0, 1292,    0,    0, 1292, 1292, 1292, 1292, 1292, 1292,
 1292,    0,    0,    0, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292,    0, 1292,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292,    0, 1292, 1292, 1292, 1292, 1292,
 1292,    0, 1292, 1292, 1292, 1292,    0, 1292,    0, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292, 1292,
 1292, 1292, 1292, 1292, 1292, 1292, 1292,    0, 1292, 1292,
 1292, 1292,    0, 1292, 1292, 1292, 1292, 1292,    0, 1292,
 1292, 1292, 1292, 1292,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1310,    0, 1310, 1310,    0,
    0,    0,    0,    0, 1310,    0,    0,    0,    0,    0,
 1310,    0,    0,    0,    0, 1310,    0,    0, 1310,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1310,    0,    0,    0,    0, 1310, 1310,    0,
    0, 1310,    0,    0,    0,    0,    0,    0, 1310,    0,
 1310, 1310,    0,    0, 1310,    0,    0,    0, 1310,    0,
 1310,    0, 1310,    0, 1310,    0,    0,    0,    0, 1310,
 1310,    0, 1310,    0,    0,    0,    0,    0,    0,    0,
    0, 1212,    0,    0,    0,    0,    0, 1310, 1310,    0,
 1310,    0,    0,    0,    0,  584,    0,    0,    0,    0,
 1310,    0, 1310,    0, 1310, 1310, 1310,    0, 1310,    0,
    0, 1310, 1310,    0,    0,    0,    0,    0,    0,    0,
    0, 1310, 1212, 1212, 1212, 1212, 1212, 1226, 1212,    0,
    0,    0,    0,    0, 1310,    0,  584, 1310,    0,  584,
 1212, 1212, 1212, 1212,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1310,  584,    0,    0,    0,    0, 1310,
 1310,    0,    0,    0, 1310,    0,    0,    0,    0,    0,
    0,    0, 1212,    0, 1212, 1310, 1310,    0, 1310,    0,
    0,    0,    0,    0, 1310,    0,    0, 1310,    0, 1310,
 1310, 1310, 1310,    0, 1310,    0, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1310, 1310,    0, 1310, 1310, 1310,    0,
    0,    0,    0, 1310, 1310, 1310, 1310, 1310,    0, 1310,
    0,    0, 1310, 1310, 1310, 1310, 1310, 1310, 1310,    0,
    0,    0, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
    0, 1310,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310,    0, 1310, 1310, 1310, 1310, 1310, 1310,    0,
 1310, 1310, 1310, 1310,    0, 1310,    0, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310, 1310,
 1310, 1310, 1310, 1310, 1310,    0, 1310, 1310, 1310, 1310,
    0, 1310, 1310, 1310, 1310, 1310,    0, 1310, 1310, 1310,
 1310, 1310,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1212,    0, 1212, 1212,    0,    0,    0,
    0,    0, 1212,    0,    0,    0,    0,    0, 1212,    0,
    0,    0,    0, 1212,    0,    0, 1212,    0,    0,    0,
    0,  584,  584,    0,    0,    0,    0,    0,    0,  584,
 1212,    0, 1212,    0,    0, 1212, 1212,    0,    0, 1212,
    0,    0,  584,    0,    0,    0, 1212,    0, 1212, 1212,
    0,    0, 1212,    0,    0,    0, 1212,    0, 1212,    0,
 1212,    0, 1212,    0,    0,    0,    0, 1212, 1212,    0,
 1212,    0,    0,    0,    0,    0,    0,    0,    0, 1248,
    0,    0,    0,    0,    0, 1212, 1212,    0, 1212,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1212,    0,
 1212,    0, 1212, 1212, 1212,    0, 1212,    0,    0, 1212,
 1212,    0,    0,    0,    0,    0,  584,    0,    0, 1212,
 1248, 1248, 1248, 1248, 1248, 1248, 1248,    0,    0,    0,
    0,    0, 1212,    0,    0, 1212,    0,  584, 1248, 1248,
 1248, 1248,    0,  584,    0,    0,    0,    0,    0,    0,
    0, 1212,    0,    0,    0,    0,    0, 1212, 1212,    0,
    0,    0, 1212,    0,    0,    0,    0,    0,    0,    0,
 1248,    0, 1248, 1212, 1212,    0, 1212,  584,    0,    0,
    0,    0, 1212,    0,    0, 1212,    0, 1212, 1212, 1212,
 1212,    0, 1212,    0, 1212, 1212, 1212, 1212, 1212, 1212,
 1212, 1212,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1212, 1212,    0, 1212, 1212, 1212,    0,    0,    0,
    0, 1212, 1212, 1212, 1212, 1212,    0, 1212,    0,    0,
 1212, 1212, 1212, 1212, 1212, 1212, 1212,    0,    0,    0,
 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,    0, 1212,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1212,
 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
    0, 1212, 1212, 1212, 1212, 1212, 1212,    0, 1212, 1212,
 1212, 1212,    0, 1212,    0, 1212, 1212, 1212, 1212, 1212,
 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
 1212, 1212, 1212,    0, 1212, 1212, 1212, 1212,    0, 1212,
 1212, 1212, 1212, 1212,    0, 1212, 1212, 1212, 1212, 1212,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1248,    0, 1248, 1248,    0,    0,    0,    0,    0,
 1248,    0,    0,    0,    0,    0, 1248,    0,    0,    0,
    0, 1248,    0,    0, 1248,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1248,    0,
    0,    0,    0, 1248, 1248,    0,    0, 1248,    0,    0,
    0,    0,    0,    0, 1248,    0, 1248, 1248,    0,    0,
 1248,    0,    0,    0, 1248,    0, 1248,    0, 1248,    0,
 1248,    0,    0,    0,    0, 1248, 1248,    0, 1248,    0,
    0,    0,    0,    0,    0,    0,    0, 1244,    0,    0,
    0,    0,    0, 1248, 1248,    0, 1248,    0,    0,    0,
    0,  623,    0,    0,    0,    0, 1248,    0, 1248,    0,
 1248, 1248, 1248,    0, 1248,    0,    0, 1248, 1248,    0,
    0,    0,    0,    0,    0,    0,    0, 1248, 1244, 1244,
 1244, 1244, 1244, 1244, 1244,    0,    0,    0,    0,    0,
 1248,    0,  623, 1248,    0,  623, 1244, 1244, 1244, 1244,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1248,
  623,    0,    0,    0,    0, 1248, 1248,    0,    0,    0,
 1248,    0,    0,    0,    0,    0,    0,    0, 1244,    0,
 1244, 1248, 1248,    0, 1248,    0,    0,    0,    0,    0,
 1248,    0,    0, 1248,    0, 1248, 1248, 1248, 1248,    0,
 1248,    0, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1248,
 1248,    0, 1248, 1248, 1248,    0,    0,    0,    0, 1248,
 1248, 1248, 1248, 1248,    0, 1248,    0,    0, 1248, 1248,
 1248, 1248, 1248, 1248, 1248,    0,    0,    0, 1248, 1248,
 1248, 1248, 1248, 1248, 1248, 1248,    0, 1248,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1248, 1248, 1248,
 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,    0, 1248,
 1248, 1248, 1248, 1248, 1248,    0, 1248, 1248, 1248, 1248,
    0, 1248,    0, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248, 1248,
 1248,    0, 1248, 1248, 1248, 1248,    0, 1248, 1248, 1248,
 1248, 1248,    0, 1248, 1248, 1248, 1248, 1248,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1244,
    0, 1244, 1244,    0,    0,    0,    0,    0, 1244,    0,
    0,    0,    0,    0, 1244,    0,    0,    0,    0, 1244,
    0,    0, 1244,    0,    0,    0,    0,  623,  623,    0,
    0,    0,    0,    0,    0,  623, 1244,    0,    0,    0,
    0, 1244, 1244,    0,    0, 1244,    0,    0,  623,    0,
    0,    0, 1244,    0, 1244, 1244,    0,    0, 1244,    0,
    0,    0, 1244,    0, 1244,    0, 1244,    0, 1244,    0,
    0,    0,    0, 1244, 1244,    0, 1244,    0,    0,    0,
    0,    0,    0,    0,    0, 1259,    0,    0,    0,    0,
    0, 1244, 1244,    0, 1244,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1244,    0, 1244,    0, 1244, 1244,
 1244,    0, 1244,    0,    0, 1244, 1244,    0,    0,    0,
    0,    0,  623,    0,    0, 1244, 1259, 1259, 1259, 1259,
 1259, 1259, 1259,    0,    0,    0,    0,    0, 1244,    0,
    0, 1244,    0,  623, 1259, 1259, 1259, 1259,    0,  623,
    0,    0,    0,    0,    0,    0,    0, 1244,    0,    0,
    0,    0,    0, 1244, 1244,    0,    0,    0, 1244,    0,
    0,    0,    0,    0,    0,    0, 1259,    0, 1259, 1244,
 1244,    0, 1244,  623,    0,    0,    0,    0, 1244,    0,
    0, 1244,    0, 1244, 1244, 1244, 1244,    0, 1244,    0,
 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1244, 1244,    0,
 1244, 1244, 1244,    0,    0,    0,    0, 1244, 1244, 1244,
 1244, 1244,    0, 1244,    0,    0, 1244, 1244, 1244, 1244,
 1244, 1244, 1244,    0,    0,    0, 1244, 1244, 1244, 1244,
 1244, 1244, 1244, 1244,    0, 1244,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1244, 1244, 1244, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244,    0, 1244, 1244, 1244,
 1244, 1244, 1244,    0, 1244, 1244, 1244, 1244,    0, 1244,
    0, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,
 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244, 1244,    0,
 1244, 1244, 1244, 1244,    0, 1244, 1244, 1244, 1244, 1244,
    0, 1244, 1244, 1244, 1244, 1244,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1259,    0, 1259,
 1259,    0,    0,    0,    0,    0, 1259,    0,    0,    0,
    0,    0, 1259,    0,    0,    0,    0, 1259,    0,    0,
 1259,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1259,    0,    0,    0,    0, 1259,
 1259,    0,    0, 1259,    0,    0,    0,    0,    0,    0,
 1259,    0, 1259, 1259,    0,    0, 1259,    0,    0,    0,
 1259,    0, 1259,    0, 1259,    0, 1259,    0,    0,    0,
    0, 1259, 1259,    0, 1259,    0,    0,    0,    0,    0,
    0,    0,    0, 1264,    0,    0,    0,    0,    0, 1259,
 1259,    0, 1259,    0,    0,    0,    0,  157,    0,    0,
    0,    0, 1259,    0, 1259,    0, 1259, 1259, 1259,    0,
 1259,    0,    0, 1259, 1259,    0,    0,    0,    0,    0,
    0,    0,    0, 1259, 1264, 1264, 1264, 1264, 1264, 1264,
 1264,    0,    0,    0,    0,    0, 1259,    0,  157, 1259,
    0,  157, 1264, 1264, 1264, 1264,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1259,  157,    0,    0,    0,
    0, 1259, 1259,    0,    0,    0, 1259,    0,    0,    0,
    0,    0,    0,    0, 1264,    0, 1264, 1259, 1259,    0,
 1259,    0,    0,    0,    0,    0, 1259,    0,    0, 1259,
    0, 1259, 1259, 1259, 1259,    0, 1259,    0, 1259, 1259,
 1259, 1259, 1259, 1259, 1259, 1259,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1259, 1259,    0, 1259, 1259,
 1259,    0,    0,    0,    0, 1259, 1259, 1259, 1259, 1259,
    0, 1259,    0,    0, 1259, 1259, 1259, 1259, 1259, 1259,
 1259,    0,    0,    0, 1259, 1259, 1259, 1259, 1259, 1259,
 1259, 1259,    0, 1259,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1259, 1259, 1259, 1259, 1259, 1259, 1259,
 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259,
 1259, 1259, 1259, 1259,    0, 1259, 1259, 1259, 1259, 1259,
 1259,    0, 1259, 1259, 1259, 1259,    0, 1259,    0, 1259,
 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259, 1259,
 1259, 1259, 1259, 1259, 1259, 1259, 1259,    0, 1259, 1259,
 1259, 1259,    0, 1259, 1259, 1259, 1259, 1259,    0, 1259,
 1259, 1259, 1259, 1259,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1264,    0, 1264, 1264,    0,
    0,    0,    0,    0, 1264,    0,    0,    0,    0,    0,
 1264,    0,    0,    0,    0, 1264,    0,    0, 1264,    0,
    0,    0,    0,  157,  157,    0,    0,    0,    0,    0,
    0,  157, 1264,    0,    0,    0,    0, 1264, 1264,    0,
    0, 1264,    0,    0,    0,    0,    0,    0, 1264,    0,
 1264, 1264,    0,    0, 1264,    0,    0,    0, 1264,    0,
 1264,    0, 1264,    0, 1264,    0,    0,    0,    0, 1264,
 1264,    0, 1264,    0,    0,    0,    0,    0,    0,    0,
    0, 1293,    0,    0,    0,    0,    0, 1264, 1264,    0,
 1264,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1264,    0, 1264,    0, 1264, 1264, 1264,    0, 1264,    0,
    0, 1264, 1264,    0,    0,    0,    0,    0,  157,    0,
    0, 1264, 1293, 1293, 1293, 1293, 1293, 1293, 1293,    0,
    0,    0,    0,    0, 1264,    0,    0, 1264,    0,  157,
 1293, 1293, 1293, 1293,    0,  157,    0,    0,    0,    0,
    0,    0,    0, 1264,    0,    0,    0,    0,    0, 1264,
 1264,    0,    0,    0, 1264,    0,    0,    0,    0,    0,
    0,    0, 1293,    0, 1293, 1264, 1264,    0, 1264,  157,
    0,    0,    0,    0, 1264,    0,    0, 1264,    0, 1264,
 1264, 1264, 1264,    0, 1264,    0, 1264, 1264, 1264, 1264,
 1264, 1264, 1264, 1264,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1264, 1264,    0, 1264, 1264, 1264,    0,
    0,    0,    0, 1264, 1264, 1264, 1264, 1264,    0, 1264,
    0,    0, 1264, 1264, 1264, 1264, 1264, 1264, 1264,    0,
    0,    0, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
    0, 1264,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
 1264, 1264,    0, 1264, 1264, 1264, 1264, 1264, 1264,    0,
 1264, 1264, 1264, 1264,    0, 1264,    0, 1264, 1264, 1264,
 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264, 1264,
 1264, 1264, 1264, 1264, 1264,    0, 1264, 1264, 1264, 1264,
    0, 1264, 1264, 1264, 1264, 1264,    0, 1264, 1264, 1264,
 1264, 1264,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1293,    0, 1293, 1293,    0,    0,    0,
    0,    0, 1293,    0,    0,    0,    0,    0, 1293,    0,
    0,    0,    0, 1293,    0,    0, 1293,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1293,    0,    0,    0,    0, 1293, 1293,    0,    0, 1293,
    0,    0,    0,    0,    0,    0, 1293,    0, 1293, 1293,
    0,    0, 1293,    0,    0,    0, 1293,    0, 1293,    0,
 1293,    0, 1293,    0,    0,    0,    0, 1293, 1293,    0,
 1293,    0,    0,    0,    0,    0,    0,    0,    0, 1299,
    0,    0,    0,    0,    0, 1293, 1293,    0, 1293,    0,
    0,    0,    0,  281,    0,    0,    0,    0, 1293,    0,
 1293,    0, 1293, 1293, 1293,    0, 1293,    0,    0, 1293,
 1293,    0,    0,    0,    0,    0,    0,    0,    0, 1293,
 1299, 1299, 1299, 1299, 1299, 1299, 1299,    0,    0,    0,
    0,    0, 1293,    0,  281, 1293,    0,  281, 1299, 1299,
 1299, 1299,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1293,  281,    0,    0,    0,    0, 1293, 1293,    0,
    0,    0, 1293,    0,    0,    0,    0,    0,    0,    0,
 1299,    0, 1299, 1293, 1293,    0, 1293,    0,    0,    0,
    0,    0, 1293,    0,    0, 1293,    0, 1293, 1293, 1293,
 1293,    0, 1293,    0, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1293, 1293,    0, 1293, 1293, 1293,    0,    0,    0,
    0, 1293, 1293, 1293, 1293, 1293,    0, 1293,    0,    0,
 1293, 1293, 1293, 1293, 1293, 1293, 1293,    0,    0,    0,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,    0, 1293,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
    0, 1293, 1293, 1293, 1293, 1293, 1293,    0, 1293, 1293,
 1293, 1293,    0, 1293,    0, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293, 1293,
 1293, 1293, 1293,    0, 1293, 1293, 1293, 1293,    0, 1293,
 1293, 1293, 1293, 1293,    0, 1293, 1293, 1293, 1293, 1293,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1299,    0, 1299, 1299,    0,    0,    0,    0,    0,
 1299,    0,    0,    0,    0,    0, 1299,    0,    0,    0,
    0, 1299,    0,    0, 1299,    0,    0,    0,    0,  281,
  281,    0,    0,    0,    0,    0,    0,  281, 1299,    0,
    0,    0,    0, 1299, 1299,    0,    0, 1299,    0,    0,
    0,    0,    0,    0, 1299,    0, 1299, 1299,    0,    0,
 1299,    0,    0,    0, 1299,    0, 1299,    0, 1299,    0,
 1299,    0,    0,    0,    0, 1299, 1299,    0, 1299,    0,
    0,    0,    0,    0,    0,    0,    0,  996,    0,    0,
    0,    0,    0, 1299, 1299,    0, 1299,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1299,    0, 1299,    0,
 1299, 1299, 1299,    0, 1299,    0,    0, 1299, 1299,    0,
    0,    0,    0,    0,  281,    0,    0, 1299,  996,  996,
  996,  996,  996,    0,  996,    0,    0,    0,    0,    0,
 1299,    0,    0, 1299,    0,  281,  996,  996,  996,  996,
    0,  281,    0,    0,    0,    0,    0,    0,    0, 1299,
    0,    0,    0,    0,    0, 1299, 1299,    0,    0,    0,
 1299,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  996, 1299, 1299,    0, 1299,  281,    0,    0,    0,    0,
 1299,    0,    0, 1299,    0, 1299, 1299, 1299, 1299,    0,
 1299,    0, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1299,
 1299,    0, 1299, 1299, 1299,    0,    0,    0,    0, 1299,
 1299, 1299, 1299, 1299,    0, 1299,    0,    0, 1299, 1299,
 1299, 1299, 1299, 1299, 1299,    0,    0,    0, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299,    0, 1299,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,    0, 1299,
 1299, 1299, 1299, 1299, 1299,    0, 1299, 1299, 1299, 1299,
    0, 1299,    0, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299, 1299,
 1299,    0, 1299, 1299, 1299, 1299,    0, 1299, 1299, 1299,
 1299, 1299,    0, 1299, 1299, 1299, 1299, 1299,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  996,
    0,  996,  996,    0,    0,    0,    0,    0,  996,    0,
    0,    0,    0,    0,  996,    0,    0,    0,    0,  996,
    0,    0,  996,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  996,    0,    0,    0,
    0,  996,  996,    0,    0,  996,    0,    0,    0,    0,
    0,    0,  996,    0,  996,  996,    0,    0,  996,    0,
    0,    0,  996,    0,  996,    0,  996,    0,  996,    0,
    0,    0,    0,  996,  996,    0,  996,    0,    0,    0,
    0,    0,    0,    0,    0, 1009,    0,    0,    0,    0,
    0,  996,  996,    0,  996,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  996,    0,  996,    0,  996,  996,
  996,    0,  996,    0,    0,  996,  996,    0,    0,    0,
    0,    0,    0,    0,    0,  996, 1009, 1009, 1009, 1009,
 1009,    0, 1009,    0,    0,    0,    0,    0,  996,    0,
    0,  996,    0,    0, 1009, 1009, 1009, 1009,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  996,    0,    0,
    0,    0,    0,  996,  996,    0,    0,    0,  996,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1009,  996,
  996,    0,  996,    0,    0,    0,    0,    0,  996,    0,
    0,  996,    0,  996,  996,  996,  996,    0,  996,    0,
  996,  996,  996,  996,  996,  996,  996,  996,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  996,  996,    0,
  996,  996,  996,    0,    0,    0,    0,  996,  996,  996,
  996,  996,    0,  996,    0,    0,  996,  996,  996,  996,
  996,  996,  996,    0,    0,    0,  996,  996,  996,  996,
  996,  996,  996,  996,    0,  996,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,    0,  996,  996,  996,
  996,  996,  996,    0,  996,  996,  996,  996,    0,  996,
    0,  996,  996,  996,  996,  996,  996,  996,  996,  996,
  996,  996,  996,  996,  996,  996,  996,  996,  996,    0,
  996,  996,  996,  996,    0,  996,  996,  996,  996,  996,
    0,  996,  996,  996,  996,  996,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1009,    0, 1009,
 1009,    0,    0,    0,    0,    0, 1009,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1009,    0,    0,
 1009,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1009,    0,    0,    0,    0, 1009,
 1009,    0,    0, 1009,    0,    0,    0,    0,    0,    0,
 1009,    0, 1009, 1009,    0,    0, 1009,    0,    0,    0,
 1009,    0, 1009,    0, 1009,    0, 1009,    0,    0,    0,
    0, 1009, 1009,    0, 1009,    0,    0,    0,    0,    0,
    0,    0,    0, 1012,    0,    0,    0,    0,    0, 1009,
 1009,    0, 1009,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1009,    0, 1009,    0, 1009, 1009, 1009,    0,
 1009,    0,    0, 1009, 1009,    0,    0,    0,    0,    0,
    0,    0,    0, 1009, 1012, 1012, 1012, 1012, 1012,    0,
 1012,    0,    0,    0,    0,    0, 1009,    0,    0, 1009,
    0,    0, 1012, 1012, 1012, 1012,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1009,    0,    0,    0,    0,
    0, 1009, 1009,    0,    0,    0, 1009,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1012, 1009, 1009,    0,
 1009,    0,    0,    0,    0,    0, 1009,    0,    0, 1009,
    0, 1009, 1009, 1009, 1009,    0, 1009,    0, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1009, 1009,    0, 1009, 1009,
 1009,    0,    0,    0,    0, 1009, 1009, 1009, 1009, 1009,
    0, 1009,    0,    0, 1009, 1009, 1009, 1009, 1009, 1009,
 1009,    0,    0,    0, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009,    0, 1009,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009,    0, 1009, 1009, 1009, 1009, 1009,
 1009,    0, 1009, 1009, 1009, 1009,    0, 1009,    0, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009, 1009,
 1009, 1009, 1009, 1009, 1009, 1009, 1009,    0, 1009, 1009,
 1009, 1009,    0, 1009, 1009, 1009, 1009, 1009,    0, 1009,
 1009, 1009, 1009, 1009,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1012,    0, 1012, 1012,    0,
    0,    0,    0,    0, 1012,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1012,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1012,    0,    0,    0,    0, 1012, 1012,    0,
    0, 1012,    0,    0,    0,    0,    0,    0, 1012,    0,
 1012, 1012,    0,    0, 1012,    0,    0,    0, 1012,    0,
 1012,    0, 1012,    0, 1012,    0,    0,    0,    0, 1012,
 1012,    0, 1012,    0,    0,    0,    0,    0,    0,    0,
    0, 1013,    0,    0,    0,    0,    0, 1012, 1012,    0,
 1012,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1012,    0, 1012,    0, 1012, 1012, 1012,    0, 1012,    0,
    0, 1012, 1012,    0,    0,    0,    0,    0,    0,    0,
    0, 1012, 1013, 1013, 1013, 1013, 1013,    0, 1013,    0,
    0,    0,    0,    0, 1012,    0,    0, 1012,    0,    0,
 1013, 1013, 1013, 1013,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1012,    0,    0,    0,    0,    0, 1012,
 1012,    0,    0,    0, 1012,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1013, 1012, 1012,    0, 1012,    0,
    0,    0,    0,    0, 1012,    0,    0, 1012,    0, 1012,
 1012, 1012, 1012,    0, 1012,    0, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1012, 1012,    0, 1012, 1012, 1012,    0,
    0,    0,    0, 1012, 1012, 1012, 1012, 1012,    0, 1012,
    0,    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012,    0,
    0,    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
    0, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012,    0, 1012, 1012, 1012, 1012, 1012, 1012,    0,
 1012, 1012, 1012, 1012,    0, 1012,    0, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012, 1012,
 1012, 1012, 1012, 1012, 1012,    0, 1012, 1012, 1012, 1012,
    0, 1012, 1012, 1012, 1012, 1012,    0, 1012, 1012, 1012,
 1012, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1013,    0, 1013, 1013,    0,    0,    0,
    0,    0, 1013,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1013,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1013,    0,    0,    0,    0, 1013, 1013,    0,    0, 1013,
    0,    0,    0,    0,    0,    0, 1013,    0, 1013, 1013,
    0,    0, 1013,    0,    0,    0, 1013,    0, 1013,    0,
 1013,    0, 1013,    0,    0,    0,    0, 1013, 1013,    0,
 1013,    0,    0,    0,    0,    0,    0, 1007,    0,    0,
    0,    0,    0,    0,    0, 1013, 1013,    0, 1013,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1013,    0,
 1013,    0, 1013, 1013, 1013,    0, 1013,    0,    0, 1013,
 1013,    0,    0,    0,    0,    0,    0,    0, 1007, 1013,
 1007, 1007, 1007,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1013,    0,    0, 1013, 1007, 1007, 1007, 1007,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1013,    0,    0,    0,    0,    0, 1013, 1013,    0,
    0,    0, 1013,    0,    0,    0,    0,    0,    0,    0,
 1007,    0,    0, 1013, 1013,    0, 1013,    0,    0,    0,
    0,    0, 1013,    0,    0, 1013,    0, 1013, 1013, 1013,
 1013,    0, 1013,    0, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1013, 1013,    0, 1013, 1013, 1013,    0,    0,    0,
    0, 1013, 1013, 1013, 1013, 1013,    0, 1013,    0,    0,
 1013, 1013, 1013, 1013, 1013, 1013, 1013,    0,    0,    0,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,    0, 1013,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
    0, 1013, 1013, 1013, 1013, 1013, 1013,    0, 1013, 1013,
 1013, 1013,    0, 1013,    0, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013, 1013,
 1013, 1013, 1013,    0, 1013, 1013, 1013, 1013,    0, 1013,
 1013, 1013, 1013, 1013,    0, 1013, 1013, 1013, 1013, 1013,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1007,
    0, 1007, 1007,    0,    0,    0,    0,    0, 1007,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1007,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1007,    0,    0,    0,
    0, 1007, 1007,    0,    0, 1007,    0,    0,    0,    0,
    0,    0, 1007,    0, 1007, 1007,    0,    0, 1007,    0,
    0,    0, 1007,    0, 1007,    0, 1007,    0, 1007,    0,
    0,    0,    0, 1007, 1007,    0, 1007,    0,    0,    0,
    0,    0,    0, 1006,    0,    0,    0,    0,    0,    0,
    0, 1007, 1007,    0, 1007,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1007,    0, 1007,    0, 1007, 1007,
 1007,    0, 1007,    0,    0, 1007, 1007,    0,    0,    0,
    0,    0,    0,    0, 1006, 1007, 1006, 1006, 1006,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1007,    0,
    0, 1007, 1006, 1006, 1006, 1006,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1007,    0,    0,
    0,    0,    0, 1007, 1007,    0,    0,    0, 1007,    0,
    0,    0,    0,    0,    0,    0, 1006,    0,    0, 1007,
 1007,    0, 1007,    0,    0,    0,    0,    0, 1007,    0,
    0, 1007,    0, 1007, 1007, 1007, 1007,    0, 1007,    0,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1007, 1007,    0,
 1007, 1007, 1007,    0,    0,    0,    0, 1007, 1007, 1007,
 1007, 1007,    0, 1007,    0,    0, 1007, 1007, 1007, 1007,
 1007, 1007, 1007,    0,    0,    0, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007,    0, 1007,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007,    0, 1007, 1007, 1007,
 1007, 1007, 1007,    0, 1007, 1007, 1007, 1007,    0, 1007,
    0, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,
 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007, 1007,    0,
 1007, 1007, 1007, 1007,    0, 1007, 1007, 1007, 1007, 1007,
    0, 1007, 1007, 1007, 1007, 1007,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1006,    0, 1006, 1006,    0,
    0,    0,    0,    0, 1006,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1006,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1006,    0,    0,    0,    0, 1006, 1006,    0,
    0, 1006,    0,    0,    0,    0,    0,    0, 1006,    0,
 1006, 1006,    0,    0, 1006,    0,    0,    0, 1006,    0,
 1006,    0, 1006,    0, 1006,    0,    0,    0,    0, 1006,
 1006,    0, 1006,    0,    0,    0,    0,    0,    0, 1008,
    0,    0,    0,    0,    0,    0,    0, 1006, 1006,    0,
 1006,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1006,    0, 1006,    0, 1006, 1006, 1006,    0, 1006,    0,
    0, 1006, 1006,    0,    0,    0,    0,    0,    0,    0,
 1008, 1006, 1008, 1008, 1008,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1006,    0,    0, 1006, 1008, 1008,
 1008, 1008,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1006,    0,    0,    0,    0,    0, 1006,
 1006,    0,    0,    0, 1006,    0,    0,    0,    0,    0,
    0,    0, 1008,    0,    0, 1006, 1006,    0, 1006,    0,
    0,    0,    0,    0, 1006,    0,    0, 1006,    0, 1006,
 1006, 1006, 1006,    0, 1006,    0, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1006, 1006,    0, 1006, 1006, 1006,    0,
    0,    0,    0, 1006, 1006, 1006, 1006, 1006,    0, 1006,
    0,    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006,    0,
    0,    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
    0, 1006,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006,    0, 1006, 1006, 1006, 1006, 1006, 1006,    0,
 1006, 1006, 1006, 1006,    0, 1006,    0, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
 1006, 1006, 1006, 1006, 1006,    0, 1006, 1006, 1006, 1006,
    0, 1006, 1006, 1006, 1006, 1006,    0, 1006, 1006, 1006,
 1006, 1006,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1008,    0, 1008, 1008,    0,    0,    0,    0,    0,
 1008,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1008,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1008,    0,
    0,    0,    0, 1008, 1008,    0,    0, 1008,    0,    0,
    0,    0,    0,    0, 1008,    0, 1008, 1008,    0,    0,
 1008,    0,    0,    0, 1008,    0, 1008,    0, 1008,    0,
 1008,    0,    0,    0,    0, 1008, 1008,    0, 1008,    0,
    0,    0,    0,    0,    0, 1011,    0,    0,    0,    0,
    0,    0,    0, 1008, 1008,    0, 1008,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1008,    0, 1008,    0,
 1008, 1008, 1008,    0, 1008,    0,    0, 1008, 1008,    0,
    0,    0,    0,    0,    0,    0, 1011, 1008, 1011, 1011,
 1011,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1008,    0,    0, 1008, 1011, 1011, 1011, 1011,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1008,
    0,    0,    0,    0,    0, 1008, 1008,    0,    0,    0,
 1008,    0,    0,    0,    0,    0,    0,    0, 1011,    0,
    0, 1008, 1008,    0, 1008,    0,    0,    0,    0,    0,
 1008,    0,    0, 1008,    0, 1008, 1008, 1008, 1008,    0,
 1008,    0, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1008,
 1008,    0, 1008, 1008, 1008,    0,    0,    0,    0, 1008,
 1008, 1008, 1008, 1008,    0, 1008,    0,    0, 1008, 1008,
 1008, 1008, 1008, 1008, 1008,    0,    0,    0, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008,    0, 1008,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,    0, 1008,
 1008, 1008, 1008, 1008, 1008,    0, 1008, 1008, 1008, 1008,
    0, 1008,    0, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008, 1008,
 1008,    0, 1008, 1008, 1008, 1008,    0, 1008, 1008, 1008,
 1008, 1008,    0, 1008, 1008, 1008, 1008, 1008,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1011,    0, 1011,
 1011,    0,    0,    0,    0,    0, 1011,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1011,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  811,    0, 1011,    0,    0,    0,    0, 1011,
 1011,    0,    0, 1011,    0,    0,    0,    0,    0,    0,
 1011,    0, 1011, 1011,    0,    0, 1011,    0,    0,    0,
 1011,    0, 1011,    0, 1011,    0, 1011,    0,    0,    0,
    0, 1011, 1011,  811, 1011,    0,  811,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1011,
 1011,  811, 1011,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1011,    0, 1011,    0, 1011, 1011, 1011,    0,
 1011,    0,    0, 1011, 1011,    0,    0,    0,    0,    0,
    0,    0,    0, 1011,    0, 1302,  996,  994,    0,  995,
    0,  997,    0,    0,    0,    0, 1011,    0,    0, 1011,
    0,    0,    0,    0, 1232, 1231, 1233,    0,    0,    0,
    0,    0,    0,    0,    0, 1011,    0,    0,    0,    0,
    0, 1011, 1011,    0,    0,    0, 1011,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1011, 1011,    0,
 1011,    0,    0,    0,    0,    0, 1011,    0,    0, 1011,
    0, 1011, 1011, 1011, 1011,    0, 1011,    0, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1011, 1011,    0, 1011, 1011,
 1011,    0,    0,    0,    0, 1011, 1011, 1011, 1011, 1011,
    0, 1011,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011,
 1011,    0,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011,    0, 1011,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011,    0, 1011, 1011, 1011, 1011, 1011,
 1011,    0, 1011, 1011, 1011, 1011,  811, 1011,    0, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
 1011, 1011, 1011, 1011, 1011, 1011, 1011,    0, 1011, 1011,
 1011, 1011,    0, 1011, 1011, 1011, 1011, 1011,    0, 1011,
 1011, 1011, 1011, 1011,  782,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  811,    0,    0,
  811,    0,    0,    0,    0, 1219,    0,  811,    0,  811,
    0,  992,    0,  811,    0,    0,  993,    0,  811, 1220,
    0,  811,    0,    0,  782,  782,    0,    0,  782,    0,
    0,    0,    0,    0,    0,    0,  811,    0,    0,    0,
    0,    0,    0,  782,    0,    0,    0,    0,    0,  811,
    0,    0,    0,    0,    0, 1221,    0,  811,    0,    0,
    0,  811,    0, 1222,    0,    0,    0,    0,    0,    0,
  811, 1223,    0,    0,    0,    0,    0,    0,    0,  996,
  994,    0,  995,    0,  997,    0,  811,    0,    0, 1224,
    0, 1225,    0,    0,    0,    0,    0, 1232, 1231, 1233,
    0,    0,    0, 1226,    0, 1227, 1228, 1229,    0,    0,
    0,    0,    0,  811,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  811,    0,  811,    0,    0,
    0,    0,    0,  811,    0,    0,  811,    0,  811,  811,
  811,  811,    0,  811,    0,    0,    0,    0,    0,    0,
    0,  811,  811,    0, 1230,    0,    0,    0,    0,    0,
    0,    0,  811,  811,    0,  811,  811,  811,    0,    0,
    0,    0,  811,  811,  811,  811,  811,    0,  811,    0,
    0,  811,  811,  811,  811,  811,  811,  811,    0,    0,
    0,  811,  811,  811,  811,  811,  811,  811,  811,    0,
  811,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,    0,  811,  811,  811,  811,  811,  811,    0,  811,
  811,  811,  811,    0,  811,    0,  811,  811,  811,  811,
  811,  811,  811,  811,  811,  811,  811,  811,  811,  811,
  811,  811,  811,  811,    0,  811,  811,  811,  811,  809,
  811,  811,  811,  811,  811,    0,  811,  811,  811,  811,
  811,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  782,
    0,    0,  782,    0,    0,    0,    0,    0, 1219,  782,
  809,  782,    0,  809,  992,  782,    0,    0,    0,  993,
  782,    0, 1220,  782,    0,    0,    0,    0,  809,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  782,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  782,    0,    0,    0,    0,    0,    0, 1221,  782,
    0,    0,    0,  782,    0,    0, 1222,    0,    0,    0,
    0,    0,  782,    0, 1223,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  782,    0,
    0,    0, 1224,    0, 1225,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1226,    0, 1227, 1228,
 1229,    0,    0,    0,    0,  782,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  782,    0,  782,
    0,    0,    0,    0,    0,  782,    0,    0,  782,    0,
  782,  782,  782,  782,    0,  782,    0,    0,    0,    0,
    0,    0,    0,  782,  782,    0,    0, 1230,    0,    0,
    0,    0,    0,    0,  782,  782,    0,  782,  782,  782,
    0,    0,    0,    0,  782,  782,  782,  782,  782,    0,
  782,    0,    0,  782,  782,  782,  782,  782,  782,  782,
    0,    0,    0,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,    0,  782,  782,  782,  782,  782,  782,
    0,  782,  782,  782,  782,    0,  782,    0,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,    0,  782,  782,  782,
  782,    0,  782,  782,  782,  782,  782,    0,  782,  782,
  782,  782,  782,    0,  809,    0,    0,  809,    0,    0,
    0,    0,    0,    0,  809,    0,  809,    0,    0,    0,
  809,    0,    0,    0,    0,  809,    0,    0,  809,    0,
  634,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  628,  809,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  809,    0,    0,    0,
    0,    0,    0,    0,  809,    0,    0,    0,  809,    0,
  634,  634,    0,    0,  634,    0,    0,  809,    0,    0,
    0,    0,    0,  628,    0,    0,  628,    0,    0,  634,
    0,  634,    0,  809,    0,    0,    0,    0,    0,    0,
    0,  628,    0,  628,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  809,  634,    0,    0,    0,    0,    0,  947,    0,    0,
    0,    0,  809,  628,  809,    0,    0,    0,    0,    0,
  782,    0,    0,  782,    0,  782,  782,  782,  782,    0,
  782,    0,    0,    0,    0,    0,    0,    0,  782,  782,
    0,    0,    0,    0,    0,    0,    0,    0,  947,  782,
  782,  947,  782,  782,  782,    0,    0,    0,    0,  782,
  782,  809,  782,  782,    0,  782,  947,    0,  782,  782,
  782,  782,  782,  782,  782,    0,    0,    0,  809,  782,
  782,  782,  809,  782,  782,  782,    0,  782,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,    0,  782,
  782,  782,  782,  782,  782,    0,  782,  782,  782,  782,
    0,  782,    0,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,  782,  782,  782,    0,  782,  782,  782,
  782,  782,    0,  782,  782,  782,  782,  782,  634,    0,
  650,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  628,    0,  640,  634,    0,  634,  634,  634,    0,    0,
    0,  634,    0,    0,  634,  628,    0,  628,  628,  628,
    0,    0,    0,  628,    0,    0,  628,  634,    0,    0,
    0,  650,    0,  634,  650,    0,  634,    0,    0,  628,
    0,    0,    0,  640,    0,  628,  640,    0,  628,  650,
    0,  650,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  640,    0,  640,    0,    0,    0,    0,  625,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  634,    0,
    0,  650,    0,    0,    0,    0,    0,    0,    0,  947,
  628,    0,    0,  640,    0,    0,    0,    0,    0,    0,
    0,  634,    0,    0,    0,   70,    0,    0,    0,  625,
    0,    0,  625,  628,    0,    0,   71,    0,    0,    0,
    0,    0,  634,   72,    0,    0,    0,  625,  634,  625,
    0,    0,  634,    0,  628,    0,   73,    0,    0,  634,
  628,    0,  947,    0,  628,  947,    0,    0,    0,    0,
    0,  628,  947,    0,  947,    0,    0,  634,  947,  625,
    0,    0,  634,  947,    0,    0,  947,    0,    0,  628,
    0,    0,    0,    0,  628,    0,    0,    0,    0,    0,
    0,  947,    0,    0,    0,    0,    0,  634,    0,    0,
    0,  634,   74,    0,  947,    0,    0,    0,    0,  628,
    0,    0,  947,  628,    0,  947,  947,    0,   75,    0,
    0,    0,    0,    0,    0,  947,    0,    0,    0,    0,
    0,    0,  964,    0,   76,  653,    0,  654,    0,    0,
    0,  947,    0,    0,    0,    0,    0,    0,    0,   77,
  656,    0,    0,   78,    0,  657,   79,    0,  650,    0,
    0,    0,    0,  947,   80,    0,    0,    0,  947,    0,
  640,    0,    0,  650,    0,    0,  650,  650,    0,  947,
  947,  650,  947,   81,  650,  640,    0,    0,  640,  640,
    0,    0,    0,  640,    0,    1,  640,  650,    0,    0,
  634,    0,    0,  650,    0,    0,  650,    0,    0,  640,
    0,    0,  628,    2,    0,  640,    0,    0,  640,    0,
    0,    3,    0,    0,    0,    0,    0,    0,    4,  947,
    5,    0,    6,    0,    0,    0,  625,    7,    0,   82,
    0,    0,   83,    0,    8,    0,  947,    0,  650,    0,
  947,  625,    0,    0,  625,  625,    0,    0,    9,  625,
  640,    0,  625,    0,    0,  947,    0,    0,   10,    0,
    0,  650,    0,    0,    0,  625,    0,    0,    0,    0,
    0,  625,    0,  640,  625,   84,    0,    0,    0,    0,
    0,    0,  650,    0,    0,    0,   11,    0,  650,    0,
    0,    0,  650,    0,  640,    0,    0,    0,    0,  650,
  640,   95,    0,    0,  640,    0,    0,    0,   96,    0,
    0,  640,   97,   98,    0,    0,  625,  650,    0,    0,
   12,   99,  650,    0,    0,    0,    0,   13,    0,  640,
   14,    0,  100,   15,  640,    0,    0,    0,    0,  625,
    0,    0,    0,    0,    0,    0,    0,  650,    0,  560,
    0,  650,    0,    0,    0,    0,  561,   16,    0,  640,
  625,    0,    0,  640,    0,    0,  625,    0,  562,   17,
  625,    0,    0,    0,  563,  564,    0,  625,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  101,    0,  625,    0,    0,    0,    0,
  625,    0,  565,    0,    0,  566,   18,    0,    0,  102,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   19,   20,    0,  103,  625,    0,    0,  104,  625,
  567,    0,  568,  569,    0,    0,  570,    0,    0,  105,
    0,    0,  571,   21,    0,  572,    0,    0,    0,    0,
  650,    0,    0,    0,  928,    0,    0,  653,  106,  654,
    0,    0,  640,    0,    0,    0,    0,    0,    0,    0,
    0,  573,  656,    0,    0,    0,    0,  657,    0,    0,
    0,    0,    0,    0,    0,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,  107,    0,  577,  108,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  625,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582, 1257, 1258, 1259, 1260, 1261,
 1262, 1291, 1292,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635, 1293,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,    0,  650,  651,  213,  652,
 1294,  560,    0,    0,    0,    0,    0,    0,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  562,    0,    0,  921,    0,    0,  563,  564,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  922,    0,    0,    0,    0,
    0,    0,    0,    0,  565,    0,    0,  566,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  567,    0,  568,  569,    0,    0,  570,    0,
    0,    0,    0,    0,  571,    0,    0,  572,    0,    0,
    0,    0,    0,    0,    0,  923,  928,    0,    0,  653,
    0,  654,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  573,  656,    0,    0,    0,    0,  657,
    0,    0,    0,    0,    0,    0,    0,    0,  574,    0,
    0,    0,    0,    0,    0,    0,  924,    0,    0,    0,
    0,    0,  575,    0,    0,    0,    0,    0,  576,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  578,  579,  580,  581,  336,  337,  120,    0,
  121,  122,  123,  124,    0,  125,  582,    0,    0,    0,
    0,    0,    0,  126,  127,  583,  584,  585,  586,  587,
  588,  589,  590,  591,  128,  592,    0,  130,  131,  132,
  593,  594,    0,  595,  596,  597,    0,  135,  136,  598,
  137,    0,    0,  138,  139,  925,  926,  927,  143,  144,
    0,    0,    0,    0,  145,  599,  147,    0,  600,  149,
  150,    0,  151,    0,  601,  602,  603,    0,  604,  605,
    0,  606,  152,  153,  154,  155,  156,  157,  607,  159,
  608,  161,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,  619,    0,  620,  621,  622,  623,  624,  625,
    0,  626,  627,  628,  182,    0,  629,    0,  630,  631,
  632,  633,  634,  189,  190,  635,  192,  636,  637,  638,
  196,  639,  198,  640,  200,  641,    0,  642,  643,  644,
  645,    0,  646,  647,  648,  209,  649,    0,  650,  651,
  213,  652,  215,  560,    0,    0,    0,    0,    0,    0,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  562,    0,    0,    0,    0,    0,  563,  564,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  922,    0,    0,
    0,    0,    0,    0,    0,    0,  565,    0,    0,  566,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  567,    0,  568,  569,    0,    0,
  570,    0,    0,    0,    0,    0,  571,    0,    0,  572,
    0,    0,    0,    0,    0,    0,    0,  923,  928,    0,
    0,  653,    0,  654,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  573,  656,    0,    0,    0,
    0,  657,    0,    0,    0,    0,    0,    0,    0,    0,
  574,    0,    0,    0,    0,    0,    0,    0,  924,    0,
    0,    0,    0,    0,  575,    0,    0,    0,    0,    0,
  576,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   17,    0,    0,  578,  579,  580,  581,  336,  337,
  120,    0,  121,  122,  123,  124,    0,  125,  582,    0,
    0,    0,    0,    0,    0,  126,  127,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  128,  592,    0,  130,
  131,  132,  593,  594,    0,  595,  596,  597,    0,  135,
  136,  598,  137,    0,    0,  138,  139,  925,  926,  927,
  143,  144,    0,    0,    0,    0,  145,  599,  147,    0,
  600,  149,  150,    0,  151,    0,  601,  602,  603,    0,
  604,  605,    0,  606,  152,  153,  154,  155,  156,  157,
  607,  159,  608,  161,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,  619,    0,  620,  621,  622,  623,
  624,  625,    0,  626,  627,  628,  182,    0,  629,    0,
  630,  631,  632,  633,  634,  189,  190,  635,  192,  636,
  637,  638,  196,  639,  198,  640,  200,  641,    0,  642,
  643,  644,  645,    0,  646,  647,  648,  209,  649,    0,
  650,  651,  213,  652,  215,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  922,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,  923,
  964,    0,    0,  653,    0,  654,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  573,  656,    0,
    0,    0,    0,  657,    0,    0,    0,    0,    0,    0,
    0,    0,  574,    0,    0,    0,    0,    0,    0,    0,
  924,    0,    0,    0,    0,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  925,
  926,  927,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
    0,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215,  560,    0,    0,
    0,    0,    0,    0,  561,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  562,    0,    0,    0,
    0,    0,  563,  564,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  565,    0,    0,  566,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  567,    0,
  568,  569,    0,    0,  570,    0,    0,    0,    0,    0,
  571,    0,    0,  572,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  964,
    0,    0,  653,    0,  654,    0,    0,    0,    0,  573,
    0,    0,    0,    0,    0,    0,    0,  656,    0,    0,
    0,    0,  657,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  575,    0,
    0,    0,    0,    0,  576,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  577,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  578,  579,
  580,  581,  336,  337,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,  583,  584,  585,  586,  587,  588,  589,  590,  591,
  128,  592,    0,  130,  131,  132,  593,  594,    0,  595,
  596,  597,    0,  135,  136,  598,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  599,  147,    0,  600,  149,  150, 1286,  151,    0,
  601,  602,  603, 1287,  604,  605, 1288,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  625,    0,  626,  627,  628,
  182,    0,  629,    0,  630,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215, 1520,
    0,    0, 1521,    0,    0,    0,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  964,    0,
    0,  653,    0,  654,    0,    0,    0,    0,  573,    0,
    0,    0,    0,    0,    0,    0,  656,    0,    0,    0,
    0,  657,    0,  574,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1522,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215, 1531,    0,
    0, 1521,    0,    0,    0,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  964,    0,    0,
  653,    0,  654,    0,    0,    0,    0,  573,    0,    0,
    0,    0,    0,    0,    0,  656,    0,    0,    0,    0,
  657,    0,  574,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1522,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
    0,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215, 1535,    0,    0,
 1521,    0,    0,    0,  560,    0,    0,    0,    0,    0,
    0,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  562,    0,    0,    0,    0,    0,  563,
  564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  565,    0,    0,
  566,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  567,    0,  568,  569,    0,
    0,  570,    0,    0,    0,    0,    0,  571,    0,    0,
  572,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  964,    0,    0,  653,
    0,  654,    0,    0,    0,    0,  573,    0,    0,    0,
    0,    0,    0,    0,  656,    0,    0,    0,    0,  657,
    0,  574,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1522,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  577,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
    0,    0,    0,    0,    0,    0,  126,  127,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635,  192,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
    0,  650,  651,  213,  652,  215, 1543,    0,    0, 1521,
    0,    0,    0,  560,    0,    0,    0,    0,    0,    0,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  562,    0,    0,    0,    0,    0,  563,  564,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  565,    0,    0,  566,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  567,    0,  568,  569,    0,    0,
  570,    0,    0,    0,    0,    0,  571,    0,    0,  572,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  964,    0,    0,  653,    0,
  654,    0,    0,    0,    0,  573,    0,    0,    0,    0,
    0,    0,    0,  656,    0,    0,    0,    0,  657,    0,
  574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1522,    0,  575,    0,    0,    0,    0,    0,
  576,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  578,  579,  580,  581,  336,  337,
  120,    0,  121,  122,  123,  124,    0,  125,  582,    0,
    0,    0,    0,    0,    0,  126,  127,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  128,  592,    0,  130,
  131,  132,  593,  594,    0,  595,  596,  597,    0,  135,
  136,  598,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  599,  147,    0,
  600,  149,  150,    0,  151,    0,  601,  602,  603,    0,
  604,  605,    0,  606,  152,  153,  154,  155,  156,  157,
  607,  159,  608,  161,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,  619,    0,  620,  621,  622,  623,
  624,  625,    0,  626,  627,  628,  182,    0,  629,    0,
  630,  631,  632,  633,  634,  189,  190,  635,  192,  636,
  637,  638,  196,  639,  198,  640,  200,  641,    0,  642,
  643,  644,  645,    0,  646,  647,  648,  209,  649,    0,
  650,  651,  213,  652,  215, 1546,    0,    0, 1521,    0,
    0,    0,  560,    0,    0,    0,    0,    0,    0,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  562,    0,    0,    0,    0,    0,  563,  564,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  565,    0,    0,  566,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  567,    0,  568,  569,    0,    0,  570,
    0,    0,    0,    0,    0,  571,    0,    0,  572,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  964,    0,    0,  653,    0,  654,
    0,    0,    0,    0,  573,    0,    0,    0,    0,    0,
    0,    0,  656,    0,    0,    0,    0,  657,    0,  574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1522,    0,  575,    0,    0,    0,    0,    0,  576,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  578,  579,  580,  581,  336,  337,  120,
    0,  121,  122,  123,  124,    0,  125,  582,    0,    0,
    0,    0,    0,    0,  126,  127,  583,  584,  585,  586,
  587,  588,  589,  590,  591,  128,  592,    0,  130,  131,
  132,  593,  594,    0,  595,  596,  597,    0,  135,  136,
  598,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  599,  147,    0,  600,
  149,  150,    0,  151,    0,  601,  602,  603,    0,  604,
  605,    0,  606,  152,  153,  154,  155,  156,  157,  607,
  159,  608,  161,  609,  610,  611,  612,  613,  614,  615,
  616,  617,  618,  619,    0,  620,  621,  622,  623,  624,
  625,    0,  626,  627,  628,  182,    0,  629,    0,  630,
  631,  632,  633,  634,  189,  190,  635,  192,  636,  637,
  638,  196,  639,  198,  640,  200,  641,    0,  642,  643,
  644,  645,    0,  646,  647,  648,  209,  649,    0,  650,
  651,  213,  652,  215, 1551,    0,    0, 1521,    0,    0,
    0,  560,    0,    0,    0,    0,    0,    0,  561,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  562,    0,    0,    0,    0,    0,  563,  564,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  565,    0,    0,  566,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  567,    0,  568,  569,    0,    0,  570,    0,
    0,    0,    0,    0,  571,    0,    0,  572,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  964,    0,    0,  653,    0,  654,    0,
    0,    0,    0,  573,    0,    0,    0,    0,    0,    0,
    0,  656,    0,    0,    0,    0,  657,    0,  574,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1522,    0,  575,    0,    0,    0,    0,    0,  576,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  577,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  578,  579,  580,  581,  336,  337,  120,    0,
  121,  122,  123,  124,    0,  125,  582,    0,    0,    0,
    0,    0,    0,  126,  127,  583,  584,  585,  586,  587,
  588,  589,  590,  591,  128,  592,    0,  130,  131,  132,
  593,  594,    0,  595,  596,  597,    0,  135,  136,  598,
  137,    0,    0,  138,  139,  140,  141,  142,  143,  144,
    0,    0,    0,    0,  145,  599,  147,    0,  600,  149,
  150,    0,  151,    0,  601,  602,  603,    0,  604,  605,
    0,  606,  152,  153,  154,  155,  156,  157,  607,  159,
  608,  161,  609,  610,  611,  612,  613,  614,  615,  616,
  617,  618,  619,    0,  620,  621,  622,  623,  624,  625,
    0,  626,  627,  628,  182,    0,  629,    0,  630,  631,
  632,  633,  634,  189,  190,  635,  192,  636,  637,  638,
  196,  639,  198,  640,  200,  641,    0,  642,  643,  644,
  645,    0,  646,  647,  648,  209,  649,    0,  650,  651,
  213,  652,  215, 1554,    0,    0, 1521,    0,    0,    0,
  560,    0,    0,    0,    0,    0,    0,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  562,
    0,    0,    0,    0,    0,  563,  564,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  565,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  567,    0,  568,  569,    0,    0,  570,    0,    0,
    0,    0,    0,  571,    0,    0,  572,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  653,    0,  654,    0,    0,
    0,    0,  573,    0,    0,    0,    0,    0,    0,    0,
  656,    0,    0,    0,    0,  657,    0,  574,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1522,
    0,  575,    0,    0,    0,    0,    0,  576,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  577,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578,  579,  580,  581,  336,  337,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  128,  592,    0,  130,  131,  132,  593,
  594,    0,  595,  596,  597,    0,  135,  136,  598,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  599,  147,    0,  600,  149,  150,
    0,  151,    0,  601,  602,  603,    0,  604,  605,    0,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  625,    0,
  626,  627,  628,  182,    0,  629,    0,  630,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641,    0,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215, 1557,    0,    0, 1521,    0,    0,    0,  560,
    0,    0,    0,    0,    0,    0,  561,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  793,    0,  562,    0,
    0,    0,    0,    0,  563,  564,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  565,    0,    0,  566,  793,  793,    0,    0,
  793,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  793,    0,    0,    0,    0,
  567,    0,  568,  569,    0,    0,  570,    0,    0,    0,
    0,    0,  571,    0,    0,  572,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  764,    0,  764,  764,    0,
  764,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  573,    0,  764,    0,    0,    0,    0,  764,    0,
    0,    0,    0,    0,    0,    0,  574,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1522,    0,
  575,    0,    0,    0,    0,    0,  576,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  578,  579,  580,  581,  336,  337,  120,    0,  121,  122,
  123,  124,    0,  125,  582,    0,    0,    0,    0,    0,
    0,  126,  127,  583,  584,  585,  586,  587,  588,  589,
  590,  591,  128,  592,    0,  130,  131,  132,  593,  594,
    0,  595,  596,  597,    0,  135,  136,  598,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  599,  147,    0,  600,  149,  150,    0,
  151,    0,  601,  602,  603,    0,  604,  605,    0,  606,
  152,  153,  154,  155,  156,  157,  607,  159,  608,  161,
  609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
  619,    0,  620,  621,  622,  623,  624,  625,    0,  626,
  627,  628,  182,    0,  629,    0,  630,  631,  632,  633,
  634,  189,  190,  635,  192,  636,  637,  638,  196,  639,
  198,  640,  200,  641,    0,  642,  643,  644,  645,    0,
  646,  647,  648,  209,  649,  764,  650,  651,  213,  652,
  215,  793,  764,    0,  793,    0,    0,    0,    0,  764,
    0,  793,    0,  793,    0,    0,    0,  793,    0,    0,
    0,  764,  793,    0,    0,  793,    0,  764,  764,    0,
    0,    0,    0,    0,    0,  764,    0,    0,    0,    0,
  793,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  793,    0,  764,    0,    0,  764,    0,
    0,  793,    0,    0,    0,  793,    0,    0,    0,    0,
    0,    0,    0,    0,  793,    0,    0,    0,    0,    0,
    0,    0,    0,  764,    0,  764,  764,    0,    0,  764,
  793,    0,    0,    0,    0,  764,    0,    0,  764,    0,
    0,    0,    0,    0,    0,    0,    0,  964,    0,    0,
  653,    0,  654,    0,    0,    0,    0,  793,    0,    0,
    0,    0,    0,    0,  764,  656,    0,    0,    0,  793,
  657,  793,    0,    0,    0,    0,    0,    0,    0,  764,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  764,    0,    0,    0,    0,    0,  764,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  764,
    0,    0,    0,    0,    0,    0,    0,    0,  793,    0,
    0,    0,    0,  764,  764,  764,  764,  764,  764,  764,
    0,  764,  764,  764,  764,  793,  764,  764,    0,  793,
    0,    0,    0,    0,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,    0,  764,  764,
    0,  764,  764,    0,  764,  764,  764,    0,  764,  764,
  764,  764,    0,    0,  764,  764,  764,  764,  764,  764,
  764,    0,    0,    0,    0,  764,  764,  764,    0,  764,
  764,  764,    0,  764,    0,  764,  764,  764,    0,  764,
  764,    0,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,    0,  764,  764,  764,  764,  764,
  764,    0,  764,  764,  764,  764,    0,  764,    0,  764,
  764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
  764,  764,  764,  764,  764,  764,  764,    0,  764,  764,
  764,  764,    0,  764,  764,  764,  764,  764,    0,  764,
  764,  764,  764,  764,  560,    0,    0,    0,    0,    0,
    0,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  562,    0,    0,    0,    0,    0,  563,
  564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  565,    0,    0,
  566,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  567,    0,  568,  569,    0,
    0,  570,    0,    0,    0,    0,    0,  571,    0,    0,
  572,    0,    0,    0,    0,    0,    0,    0,    0,  964,
    0,    0,  653,    0,  654,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  573,  656,    0,    0,
    0,    0,  657,    0,    0,    0,    0,    0,    0,    0,
    0,  574,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  577,    0,    0,    0,    0,    0,    0,    0,  963,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
    0,    0,    0,    0,    0,    0,  126,  127,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635,  192,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
    0,  650,  651,  213,  652,  215,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
    0,  964,    0, 1089,  653,    0,  654,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  573,  656,
    0,    0,    0,    0,  657,    0,    0,    0,    0,    0,
    0,    0,    0,  574,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   17,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,    0,  650,  651,  213,  652,  215,  560,    0,
    0,    0,    0,    0,    0,  561,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  562,    0,    0,
    0,    0,    0,  563,  564,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  565,    0,    0,  566,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  567,
    0,  568,  569,    0,    0,  570,    0,    0,    0,    0,
    0,  571,    0,    0,  572,    0,    0,    0,    0,    0,
    0,    0,    0,  964, 1306,    0,  653,    0,  654,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  573,  656,    0,    0,    0,    0,  657,    0,    0,    0,
    0,    0,    0,    0,    0,  574,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  575,
    0,    0,    0,    0,    0,  576,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  578,
  579,  580,  581,  336,  337,  120,    0,  121,  122,  123,
  124,    0,  125,  582,    0,    0,    0,    0,    0,    0,
  126,  127,  583,  584,  585,  586,  587,  588,  589,  590,
  591,  128,  592,    0,  130,  131,  132,  593,  594,    0,
  595,  596,  597,    0,  135,  136,  598,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  599,  147,    0,  600,  149,  150,    0,  151,
    0,  601,  602,  603,    0,  604,  605,    0,  606,  152,
  153,  154,  155,  156,  157,  607,  159,  608,  161,  609,
  610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
    0,  620,  621,  622,  623,  624,  625,    0,  626,  627,
  628,  182,    0,  629,    0,  630,  631,  632,  633,  634,
  189,  190,  635,  192,  636,  637,  638,  196,  639,  198,
  640,  200,  641,    0,  642,  643,  644,  645,    0,  646,
  647,  648,  209,  649,    0,  650,  651,  213,  652,  215,
  560,    0,    0,    0,    0,    0,    0,  561,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  562,
    0,    0,    0,    0,    0,  563,  564,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  565,    0,    0,  566,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  567,    0,  568,  569,    0,    0,  570,    0,    0,
    0,    0,    0,  571,    0,    0,  572,    0,    0,    0,
    0,    0,    0,    0,    0,  964,    0,    0,  653,    0,
  654,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  573,  656,    0,    0,    0,    0,  657,    0,
    0,    0,    0,    0,    0,    0,    0,  574,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  575,    0,    0,    0,    0,    0,  576,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  577,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  578,  579,  580,  581,  336,  337,  120,    0,  121,
  122,  123,  124,    0,  125,  582,    0,    0,    0,    0,
    0,    0,  126,  127,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  128,  592,    0,  130,  131,  132,  593,
  594,    0,  595,  596,  597,    0,  135,  136,  598,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  599,  147,    0,  600,  149,  150,
    0,  151,    0,  601,  602,  603,    0,  604,  605,    0,
  606,  152,  153,  154,  155,  156,  157,  607,  159,  608,
  161,  609,  610,  611,  612,  613,  614,  615,  616,  617,
  618,  619,    0,  620,  621,  622,  623,  624,  625,    0,
  626,  627,  628,  182,    0,  629,    0,  630,  631,  632,
  633,  634,  189,  190,  635,  192,  636,  637,  638,  196,
  639,  198,  640,  200,  641,    0,  642,  643,  644,  645,
    0,  646,  647,  648,  209,  649,    0,  650,  651,  213,
  652,  215,  560,    0,    0,    0,    0,    0,    0,  561,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  562,    0,    0,    0,    0,    0,  563,  564,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  565,    0,    0,  566,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  567,    0,  568,  569,    0,    0,  570,
    0,    0,    0,    0,    0,  571,    0,    0,  572,    0,
    0,    0,    0,    0,    0,    0,    0,  964,    0,    0,
  653,    0,  654,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  573,  656,    0,    0,    0,    0,
  657,    0,    0,    0,    0,    0,    0,    0,    0,  574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  575,    0,    0,    0,    0,    0,  576,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  577,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1549,    0,    0,  578,  579,  580,  581,  336,  337,  120,
    0,  121,  122,  123,  124,    0,  125,  582,    0,    0,
    0,    0,    0,    0,  126,  127,  583,  584,  585,  586,
  587,  588,  589,  590,  591,  128,  592,    0,  130,  131,
  132,  593,  594,    0,  595,  596,  597,    0,  135,  136,
  598,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  599,  147,    0,  600,
  149,  150,    0,  151,    0,  601,  602,  603,    0,  604,
  605,    0,  606,  152,  153,  154,  155,  156,  157,  607,
  159,  608,  161,  609,  610,  611,  612,  613,  614,  615,
  616,  617,  618,  619,    0,  620,  621,  622,  623,  624,
  625,    0,  626,  627,  628,  182,    0,  629,    0,  630,
  631,  632,  633,  634,  189,  190,  635,  192,  636,  637,
  638,  196,  639,  198,  640,  200,  641,    0,  642,  643,
  644,  645,    0,  646,  647,  648,  209,  649,    0,  650,
  651,  213,  652,  215,  560,    0,    0,    0,    0,    0,
    0,  561,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  562,    0,    0,    0,    0,    0,  563,
  564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1603,    0,    0,  565,    0,    0,
  566,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  567,    0,  568,  569,    0,
    0,  570,    0,    0,    0,    0,    0,  571,    0,    0,
  572,    0,    0,    0,    0,    0,    0,    0,    0,  964,
    0,    0,  653,    0,  654,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  573,  656,    0,    0,
    0,    0,  657,    0,    0,    0,    0,    0,    0,    0,
    0,  574,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  575,    0,    0,    0,    0,
    0,  576,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  577,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  578,  579,  580,  581,  336,
  337,  120,    0,  121,  122,  123,  124,    0,  125,  582,
    0,    0,    0,    0,    0,    0,  126,  127,  583,  584,
  585,  586,  587,  588,  589,  590,  591,  128,  592,    0,
  130,  131,  132,  593,  594,    0,  595,  596,  597,    0,
  135,  136,  598,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  599,  147,
    0,  600,  149,  150,    0,  151,    0,  601,  602,  603,
    0,  604,  605,    0,  606,  152,  153,  154,  155,  156,
  157,  607,  159,  608,  161,  609,  610,  611,  612,  613,
  614,  615,  616,  617,  618,  619,    0,  620,  621,  622,
  623,  624,  625,    0,  626,  627,  628,  182,    0,  629,
    0,  630,  631,  632,  633,  634,  189,  190,  635,  192,
  636,  637,  638,  196,  639,  198,  640,  200,  641,    0,
  642,  643,  644,  645,    0,  646,  647,  648,  209,  649,
    0,  650,  651,  213,  652,  215,  560,    0,    0,    0,
    0,    0,    0,  561,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  562,    0,    0,    0,    0,
    0,  563,  564,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  565,
    0,    0,  566,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  567,    0,  568,
  569,    0,    0,  570,    0,    0,    0,    0,    0,  571,
    0,    0,  572,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  766,    0,  766,  766,    0,  766,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  573,    0,
  766,    0,    0,    0,    0,  766,    0,    0,    0,    0,
    0,    0,    0,  574,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  575,    0,    0,
    0,    0,    0,  576,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1789,    0,    0,  578,  579,  580,
  581,  336,  337,  120,    0,  121,  122,  123,  124,    0,
  125,  582,    0,    0,    0,    0,    0,    0,  126,  127,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  128,
  592,    0,  130,  131,  132,  593,  594,    0,  595,  596,
  597,    0,  135,  136,  598,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  599,  147,    0,  600,  149,  150,    0,  151,    0,  601,
  602,  603,    0,  604,  605,    0,  606,  152,  153,  154,
  155,  156,  157,  607,  159,  608,  161,  609,  610,  611,
  612,  613,  614,  615,  616,  617,  618,  619,    0,  620,
  621,  622,  623,  624,  625,    0,  626,  627,  628,  182,
    0,  629,    0,  630,  631,  632,  633,  634,  189,  190,
  635,  192,  636,  637,  638,  196,  639,  198,  640,  200,
  641,    0,  642,  643,  644,  645,    0,  646,  647,  648,
  209,  649,  766,  650,  651,  213,  652,  215,    0,  766,
  253,    0,    0,  253,    0,    0,  766,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,    0,  766,    0,
  253,    0,    0,  253,  766,  766,    0,    0,    0,    0,
    0,    0,  766,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  766,    0,    0,  766,    0,    0,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,    0,  253,
  253,  253,    0,  253,  253,  253,    0,  253,    0,    0,
  766,    0,  766,  766,    0,    0,  766,    0,    0,    0,
    0,    0,  766,    0,  253,  766,  253,    0,    0,    0,
    0,    0,    0,    0, 1204,    0, 1204, 1204,    0, 1204,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  766, 1204,    0,    0,  253,    0, 1204,    0,    0,
   83,    0,    0,    0,    0,    0,  766,    0,    0,    0,
    0,    0,  253,    0,    0,    0,    0,    0,    0,    0,
  766,    0,    0,    0,    0,    0,  766,    0,    0,    0,
    0,    0,    0,    0,  253,    0,  766,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  766,  766,  766,  766,  766,  766,  766,    0,  766,  766,
  766,  766,    0,  766,  766,    0,    0,    0,    0,  253,
  253,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,    0,  766,  253,    0,  766,  766,
    0,  766,  766,  766,    0,  766,  766,  766,  766,    0,
    0,  766,  766,  766,  766,  766,  766,  766,    0,    0,
    0,    0,  766,  766,  766,    0,  766,  766,  766,    0,
  766,    0,  766,  766,  766,    0,  766,  766,    0,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,    0,  766,  766,  766,  766,  766,  766,    0,  766,
  766,  766,  766,    0,  766,    0,  766,  766,  766,  766,
  766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
  766,  766,  766,  766,    0,  766,  766,  766,  766,    0,
  766,  766,  766,  766,  766,    0,  766,  766,  766,  766,
  766, 1204,    0,    0,    0,    0,    0,    0, 1204,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1204,    0,    0,    0,    0,    0, 1204, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1204,    0,    0, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1204,    0, 1204, 1204,    0,    0, 1204,    0,
    0,    0,    0,    0, 1204,    0,    0, 1204,    0,    0,
    0,    0,    0,    0,    0,    0,  655,    0,    0,  653,
    0,  654,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1204,  656,    0,    0,    0,    0,  657,
    0,    0,    0,    0,    0,    0,    0,    0, 1204,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1204,    0,    0,    0,    0,    0, 1204,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1204,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204,    0,
 1204, 1204, 1204, 1204,    0, 1204, 1204,    0,    0,    0,
    0,    0,    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204,
 1204, 1204,    0, 1204, 1204, 1204,    0, 1204, 1204, 1204,
 1204,    0,    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
    0,    0,    0,    0, 1204, 1204, 1204,    0, 1204, 1204,
 1204,    0, 1204,    0, 1204, 1204, 1204,    0, 1204, 1204,
    0, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204, 1204, 1204,
    0, 1204, 1204, 1204, 1204,    0, 1204,    0, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204,
 1204,    0, 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204,
 1204, 1204, 1204,  560,    0,    0,    0,    0,    0,    0,
  561,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  562,    0,    0,    0,    0,    0,  563,  564,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  565,    0,    0,  566,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  567,    0,  568,  569,    0,    0,
  570,    0,    0,    0,    0,    0,  571,    0,    0,  572,
    0,    0,    0,    0,    0,    0,    0,    0,  964,    0,
    0,  653,    0,  654,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  573,  656,    0,    0,    0,
    0,  657,    0,    0,    0,    0,    0,    0,    0,    0,
  574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  575,    0,    0,    0,    0,    0,
  576,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  578,  579,  580,  581,  336,  337,
  120,    0,  121,  122,  123,  124,    0,  125,  582,    0,
    0,    0,    0,    0,    0,  126,  127,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  128,  592,    0,  130,
  131,  132,  593,  594,    0,  595,  596,  597,    0,  135,
  136,  598,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  599,  147,    0,
  600,  149,  150,    0,  151,    0,  601,  602,  603,    0,
  604,  605,    0,  606,  152,  153,  154,  155,  156,  157,
  607,  159,  608,  161,  609,  610,  611,  612,  613,  614,
  615,  616,  617,  618,  619,    0,  620,  621,  622,  623,
  624,  625,    0,  626,  627,  628,  182,    0,  629,    0,
  630,  631,  632,  633,  634,  189,  190,  635,  192,  636,
  637,  638,  196,  639,  198,  640,  200,  641,    0,  642,
  643,  644,  645,    0,  646,  647,  648,  209,  649,    0,
  650,  651,  213,  652,  215,  560,    0,    0,    0,    0,
    0,    0,  561,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  562,    0,    0,    0,    0,    0,
  563,  564,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  565,    0,
    0,  566,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  567,    0,  568,  569,
    0,    0,  570,    0,    0,    0,    0,    0,  571,    0,
    0,  572,    0,    0,    0,    0,    0,    0,    0,    0,
 1204,    0,    0, 1204,    0, 1204,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  573, 1204,    0,
    0,    0,    0, 1204,    0,    0,    0,    0,    0,    0,
    0,    0,  574,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  575,    0,    0,    0,
    0,    0,  576,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  577,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  578,  579,  580,  581,
  336,  337,  120,    0,  121,  122,  123,  124,    0,  125,
  582,    0,    0,    0,    0,    0,    0,  126,  127,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  128,  592,
    0,  130,  131,  132,  593,  594,    0,  595,  596,  597,
    0,  135,  136,  598,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  599,
  147,    0,  600,  149,  150,    0,  151,    0,  601,  602,
  603,    0,  604,  605,    0,  606,  152,  153,  154,  155,
  156,  157,  607,  159,  608,  161,  609,  610,  611,  612,
  613,  614,  615,  616,  617,  618,  619,    0,  620,  621,
  622,  623,  624,  625,    0,  626,  627,  628,  182,    0,
  629,    0,  630,  631,  632,  633,  634,  189,  190,  635,
  192,  636,  637,  638,  196,  639,  198,  640,  200,  641,
 1315,  642,  643,  644,  645,    0,  646,  647,  648,  209,
  649,    0,  650,  651,  213,  652,  215, 1204,  656,    0,
    0,    0,    0,    0, 1204,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1204,    0,    0,    0,
    0,    0, 1204, 1204,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1204,    0,    0, 1204,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1204,    0,
 1204, 1204,    0,    0, 1204,    0,    0,    0,    0,    0,
 1204,    0,    0, 1204,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1204,
    0,    0,    0,    0,    0,    0,    0,    0, 1032,    0,
    0,    0,    0,    0, 1204,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1204,    0,
    0,    0,    0,    0, 1204,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1204,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1204, 1204,
 1204, 1204, 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204,
    0, 1204, 1204,    0,    0,    0,    0,    0,    0, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204,    0, 1204, 1204, 1204, 1204, 1204,    0, 1204,
 1204, 1204,    0, 1204, 1204, 1204, 1204,    0,    0, 1204,
 1204, 1204, 1204, 1204, 1204, 1204,    0,    0,    0,    0,
 1204, 1204, 1204,    0, 1204, 1204, 1204,    0, 1204,    0,
 1204, 1204, 1204,    0, 1204, 1204,    0, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,    0,
 1204, 1204, 1204, 1204, 1204, 1204,  399, 1204, 1204, 1204,
 1204,    0, 1204,    0, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
 1204, 1204,    0, 1204, 1204, 1204, 1204,    0, 1204, 1204,
 1204, 1204, 1204,    0, 1204, 1204, 1204, 1204, 1204,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,    0,    0,    0,    0,
  133,  134,    0,  135,  136, 1032,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,    0,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
  182,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205, 1118,  206,  207,
  208,  209,  210,   17,  211,  212,  213,  214,  215,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,    0,    0,  126,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144, 1322,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,    0,    0,
  120,    0,  121,  122,  123,  124,    0,  125,    0,    0,
    0,    0,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137, 1322,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  146,  147,    0,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,    0,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,    0,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215, 1321,  119,    0,    0,  120,
    0,  121,  122,  123,  124,    0,  125,    0,    0,    0,
    0,    0,    0,    0,  126,  127,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  128,  129,    0,  130,  131,
  132,    0,    0,    0,    0,  133,  134,    0,  135,  136,
    0,  137,    0,  779,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  146,  147,    0,  148,
  149,  150,    0,  151,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
  169,  170,  171,  172,    0,  173,  174,  175,  176,  177,
  178,    0,  179,  180,  181,  182,    0,  183,    0,  184,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,  197,  198,  199,  200,  201,    0,  202,  203,
  204,  205,    0,  206,  207,  208,  209,  210,    0,  211,
  212,  213,  214,  215,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0,  125,    0,    0,    0,    0,    0,    0,
    0,  126,  127,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
    0,    0,  133,  134,   88,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,    0,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,    0,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,    0,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0,  125,    0,    0,    0,  779,    0,    0,    0,
  126,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,    0,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,  656,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,    0,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
  782,    0,    0,  782,    0,  782,  782,  782,  782,    0,
  782,    0,    0,    0,    0,    0,    0,    0,  782,  782,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  782,
  782,    0,  782,  782,  782,    0,    0,    0,    0,  782,
  782,    0,  782,  782,    0,  782,    0,    0,  782,  782,
  782,  782,  782,  782,  782,    0,    0,    0,    0,  782,
  782,  782,    0,  782,  782,  782,    0,  782,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,    0,  782,
  782,  782,  782,  782,  782,    0,  782,  782,  782,  782,
    0,  782,    0,  782,  782,  782,  782,  782,  782,  782,
  782,  782,  782,  782,  782,  782,  782,  782,  782,  782,
  782,    0,  782,  782,  782,  782,    0,  782,  782,  782,
  782,  782,    0,  782,  782,  782,  782,  782,   87,    0,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150, 1407,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
    0,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,    0,    0,
  119,    0,    0,  120,    0,  121,  122,  123,  124,    0,
  125,    0,    0,    0,    0,    0,    0,    0,  126,  127,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  128,
  129,    0,  130,  131,  132,    0,    0,    0,    0,  133,
  134,    0,  135,  136,    0,  137,    0,    0,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,    0,  148,  149,  150,    0,  151,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,  153,  154,
  155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
  165,  166,  167,  168,  169,  170,  171,  172,    0,  173,
  174,  175,  176,  177,  178,    0,  179,  180,  181,  182,
  990,  183,    0,  184,  185,  186,  187,  188,  189,  190,
  191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
  201,    0,  202,  203,  204,  205,    0,  206,  207,  208,
  209,  210,    0,  211,  212,  213,  214,  215,    0,    0,
    0,    0, 1251, 1251,  990, 1251, 1251, 1251,    0,    0,
    0,    0,    0,  563,    0,    0,    0,    0,  461,  990,
 1251, 1251, 1251,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  462,    0,    0,    0,    0,    0,
    0,  565,    0,    0,    0,  463,    0,    0,    0,    0,
    0, 1251,  464,    0,    0,    0,  465,  466,    0,    0,
    0,    0,    0,    0,    0,  467,    0,    0,    0,  567,
    0,    0,    0,    0,    0,    0,  468,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  991,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  469,
    0, 1252, 1252,  991, 1252, 1252, 1252,  470,    0,  575,
    0,    0,    0,    0,    0,    0,    0,    0,  991, 1252,
 1252, 1252,    0,    0,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  471,  578,
  579,  580,  472,  336,  337,    0,    0,    0,    0,    0,
 1252,    0,    0,  473,    0,    0,    0,    0,    0,    0,
    0,    0,  583,  584,  585,  586,  587,  588,  589,  590,
  591,    0,  474,  475,    0,    0,    0,  593,  594,    0,
    0,    0,    0,    0,    0,    0,  598,    0,    0,    0,
    0,  623,  990,    0,    0,    0,    0,    0,    0,    0,
    0, 1251,    0,    0,    0,    0,    0, 1251,    0,    0,
    0,    0, 1251,    0,    0, 1251,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  476,    0,
    0,  477,  623,    0,  992,  623,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  990,    0,    0,  990,    0,
  623, 1251,  623,    0,    0,  990,    0,  990,    0, 1251,
    0,  990,    0,    0,    0,    0,  990, 1251,    0,  990,
    0,    0,    0,    0,    0,    0, 1253, 1253,  992, 1253,
 1253, 1253,    0,    0,  990, 1251,    0, 1251,    0,    0,
    0,    0,    0,  992, 1253, 1253, 1253,  990,    0, 1251,
    0, 1251, 1251, 1251,    0,  990,    0,    0,  990,  990,
    0,    0,    0,    0,    0,    0,    0,    0,  990,    0,
    0,  991,    0,    0,    0, 1253,    0,    0,    0,    0,
 1252,    0,    0,    0,  990,    0, 1252,    0,    0,    0,
    0, 1252,    0,    0, 1252,    0,    0,    0,    0,    0,
 1251,    0,    0,  948,    0,    0,  990,    0,    0,    0,
    0,  990,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  990,  990,  991,  990,    0,  991,    0,    0,
 1252,    0,  857,    0,  991,  858,  991,    0, 1252,    0,
  991,    0,    0,    0,  948,  991, 1252,  948,  991,    0,
    0,    0,  859,    0,    0,  860,    0,    0,    0,    0,
    0,    0,  948,  991, 1252,    0, 1252,    0,    0,    0,
    0,    0,  990,    0,    0,    0,  991,    0, 1252,    0,
 1252, 1252, 1252,  974,  991,    0,    0,  991,  991,  990,
    0,    0,    0,  990,    0,  861,    0,  991,    0,  623,
    0,  862,  863,  864,    0,  865,  866,  867,  990,  868,
    0,    0,    0,  991,  623,    0,    0,    0,  623,    0,
    0,    0,    0,    0,  974,    0,  869,  974,  870, 1252,
    0,    0,    0,    0,    0,  991,    0,    0,  623,    0,
  991,    0,  974,    0,  623,    0,  992,  623,    0,    0,
    0,  991,  991,    0,  991, 1253,    0,  871,    0,    0,
    0, 1253,    0,    0,    0,    0, 1253,    0,    0, 1253,
    0,    0,    0,    0,  872,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  623,
    0,    0,    0,    0,    0,    0,  873,    0,    0,  992,
    0,  991,  992,    0,    0, 1253,    0,    0,    0,  992,
    0,  992,  623, 1253,    0,  992,    0,    0,  991,    0,
  992, 1253,  991,  992,    0,    0,  951,    0,    0,    0,
    0,  874,  875,    0,    0,    0,    0,  991,  992, 1253,
    0, 1253,    0,  623,    0,    0,  949,    0,  876,    0,
  623,  992,    0, 1253,    0, 1253, 1253, 1253,    0,  992,
    0,    0,  992,  992,    0,  948,    0,  951,  623,    0,
  951,    0,  992,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  951,    0,  949,  992,    0,
  949,    0,    0,    0,    0,    0,    0,    0,  623,    0,
    0,    0,  623,    0, 1253,  949,    0,    0,    0,    0,
  992,    0,    0,    0,    0,  992,    0,    0,  948,    0,
    0,  948,    0,    0,    0,    0,  992,  992,  948,  992,
  948,    0,    0,    0,  948,    0,    0,    0,    0,  948,
    0,    0,  948,    0,    0,  974,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  948,    0,    0,
    0,    0,    0,    0,    0,  950,    0,    0,    0,    0,
  948,    0,    0,    0,    0,    0,  992,    0,  948,    0,
    0,  948,  948,    0,    0,    0,    0,    0,    0,    0,
    0,  948,    0,  992,    0,    0,    0,  992,  974,    0,
    0,  974,    0,    0,    0,    0,  950,  948,  974,  950,
  974,    0,  992,    0,  974,    0,    0,    0,    0,  974,
    0,    0,  974,    0,  950,    0,    0,    0,    0,  948,
    0,    0,    0,    0,  948,    0,    0,  974,    0,    0,
    0,    0,    0,    0,    0,  948,  948,    0,  948,    0,
  974,    0,    0,    0,    0,    0,    0,    0,  974,    0,
    0,  974,  974,  982,    0,    0,    0,    0,    0,    0,
    0,  974,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  974,  951,    0,
    0,    0,    0,    0,    0,  948,    0,    0,    0,    0,
    0,    0,    0,    0,  982,    0,    0,  982,  949,  974,
    0,    0,  948,    0,  974,    0,  948,    0,    0,    0,
    0,    0,  982,    0,    0,  974,  974,    0,  974,    0,
    0,  948,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  951,    0,    0,  951,    0,    0,    0,    0,    0,
    0,  951,    0,  951,    0,    0,    0,  951,    0,    0,
    0,  949,  951,    0,  949,  951,    0,    0,    0,    0,
    0,  949,    0,  949,    0,  974,    0,  949,    0,    0,
  951,    0,  949,    0,    0,  949,    0,    0,    0,    0,
    0,    0,  974,  951,    0,    0,  974,    0,    0,  944,
  949,  951,    0,    0,  951,  951,    0,    0,    0,    0,
    0,  974,    0,  949,  951,    0,    0,    0,    0,    0,
    0,  949,    0,    0,  949,  949,    0,  950,    0,    0,
  951,    0,    0,    0,  949,    0,    0,    0,    0,    0,
  944,    0,    0,  944,    0,    0,    0,    0,    0,    0,
  949,    0,  951,    0,    0,    0,    0,  951,  944,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  951,  951,
    0,  951,  949,    0,    0,    0,    0,  949,    0,    0,
  950,    0,    0,  950,    0,    0,    0,    0,  949,  949,
  950,  949,  950,    0,    0,    0,  950,    0,    0,    0,
    0,  950,    0,    0,  950,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  951,  950,
    0,  945,    0,    0,    0,  982,    0,    0,    0,    0,
    0,    0,  950,    0,    0,  951,    0,    0,  949,  951,
  950,    0,    0,  950,  950,    0,    0,    0,    0,    0,
    0,    0,    0,  950,  951,  949,  946,    0,    0,  949,
    0,    0,  945,    0,    0,  945,    0,    0,    0,  950,
    0,    0,    0,    0,  949,    0,    0,    0,  982,    0,
  945,  982,    0,    0,    0,    0,    0,    0,  982,    0,
  982,  950,    0,    0,  982,    0,  950,  946,    0,  982,
  946,    0,  982,    0,    0,    0, 1208,  950,  950,  858,
  950,    0,    0,    0,  981,  946,    0,  982,    0,    0,
    0,    0, 1209,    0,    0,    0,  859,    0,    0,  860,
  982,    0,    0,    0,    0,    0,    0,    0,  982,    0,
    0,  982,  982,    0,    0,    0,    0,    0,    0,    0,
    0,  982,    0,    0,    0,  981,    0,  950,  981,    0,
    0,  944,    0,    0,    0,    0,    0,  982,    0,  861,
    0,    0,    0,  981,  950,  862,  863,  864,  950,  865,
  866,  867,    0,  868,    0,    0,    0,    0,    0,  982,
    0,    0,    0,  950,  982,    0,    0,    0,    0,    0,
  869,    0,  870,    0,    0,  982,  982,    0,  982,    0,
    0,    0,    0,    0,  944,    0,    0,  944,    0,    0,
    0,    0,    0,    0,  944,    0,  944,    0,    0,    0,
  944,  871,    0,    0,    0,  944,    0,    0,  944,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  872,    0,
    0,    0,    0,  944,    0,  982,    0,    0,  975,    0,
    0,    0,    0,    0,    0,    0,  944,    0,    0,    0,
  873,    0,  982,    0,  944,    0,  982,  944,  944,    0,
    0,    0,    0,  945,    0,    0,    0,  944,    0,    0,
  983,  982,    0,    0,    0,    0,    0,    0,    0,  975,
    0,    0,  975,  944,    0,  874,  875,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  975,  946,    0,
  984,    0,  876,    0,    0,  944,    0,    0,    0,    0,
  944,  983,    0,    0,  983,    0,  945,    0,    0,  945,
    0,  944,  944,    0,  944,    0,  945,    0,  945,  983,
    0,    0,  945,    0,    0,    0,    0,  945,    0,    0,
  945,  984,    0,    0,  984,    0,    0,    0,    0,    0,
    0,  946,    0,    0,  946,  945,  981,    0,    0,  984,
    0,  946,    0,  946,    0,    0,    0,  946,  945,    0,
    0,  944,  946,    0,    0,  946,  945,    0,    0,  945,
  945,    0,    0,    0,    0,    0,    0,    0,  944,  945,
  946,    0,  944,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  946,    0,  945,    0,  944,    0,  981,
    0,  946,  981,    0,  946,  946,    0,    0,    0,  981,
    0,  981,    0,    0,  946,  981,    0,  945,    0,    0,
  981,    0,  945,  981,    0,    0,    0,    0,    0,    0,
  946,    0,    0,  945,  945,  972,  945,    0,  981,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  981,  946,    0,    0,    0,    0,  946,    0,  981,
    0,    0,  981,  981,    0,  970,    0,    0,  946,  946,
    0,  946,  981,    0,    0,    0,  972,    0,    0,  972,
    0,    0,    0,  945,    0,    0,    0,    0,  981,    0,
  975,    0,    0,    0,  972,    0,    0,  976,    0,    0,
  945,    0,    0,    0,  945,    0,  970,    0,    0,  970,
  981,    0,    0,    0,    0,  981,    0,    0,  946,  945,
    0,    0,  983,    0,  970,    0,  981,  981,    0,  981,
    0,    0,    0,    0,    0,  946,    0,    0,  976,  946,
    0,  976,    0,  975,    0,    0,  975,    0,    0,    0,
    0,    0,  984,  975,  946,  975,  976,    0,    0,  975,
    0,    0,    0,    0,  975,    0,    0,  975,    0,    0,
    0,    0,    0,    0,    0,  983,  981,    0,  983,    0,
    0,    0,  975,    0,    0,  983,    0,  983,    0,    0,
    0,  983,    0,  981,    0,  975,  983,  981,    0,  983,
    0,    0,    0,  975,    0,  984,  975,  975,  984,    0,
    0,    0,  981,    0,  983,  984,  975,  984,    0,    0,
    0,  984,    0,    0,    0,    0,  984,  983,    0,  984,
    0,    0,  975,    0,    0,  983,    0,    0,  983,  983,
  985,    0,    0,    0,  984,    0,    0,    0,  983,    0,
    0,    0,    0,    0,  975,    0,    0,  984,    0,  975,
    0,    0,    0,    0,  983,  984,    0,    0,  984,  984,
  975,  975,    0,  975,    0,    0,    0,    0,  984,    0,
    0,  985,    0,    0,  985,    0,  983,    0,    0,    0,
    0,  983,    0,    0,  984,    0,    0,  972,    0,  985,
    0,    0,  983,  983,    0,  983,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  984,    0,    0,    0,
  975,  984,    0,    0,    0,    0,    0,  970,    0,    0,
    0,    0,  984,  984,  971,  984,    0,  975,    0,    0,
    0,  975,    0,    0,    0,    0,    0,    0,    0,    0,
  972,    0,  983,  972,    0,    0,  975,    0,    0,  976,
  972,    0,  972,    0,    0,    0,  972,    0,    0,  983,
    0,  972,    0,  983,  972,  971,    0,    0,  971,    0,
  970,    0,  984,  970,    0,    0,    0,    0,  983,  972,
  970,    0,  970,  971,    0,    0,  970,    0,    0,  984,
    0,  970,  972,  984,  970,    0,    0,    0,    0,    0,
  972,    0,  976,  972,  972,  976,    0,    0,  984,  970,
    0,    0,  976,  972,  976,    0,    0,  973,  976,    0,
    0,    0,  970,  976,    0,    0,  976,    0,    0,  972,
  970,    0,    0,  970,  970,    0,    0,    0,    0,    0,
    0,  976,    0,  970,    0,    0,    0,    0,    0,    0,
    0,  972,    0,    0,  976,    0,  972,    0,  973,  970,
    0,  973,  976,  977,    0,  976,  976,  972,  972,    0,
  972,    0,    0,    0,    0,  976,  973,    0,    0,    0,
    0,  970,    0,    0,    0,    0,  970,    0,    0,    0,
    0,  976,  985,    0,    0,    0,    0,  970,  970,    0,
  970,    0,    0,    0,  977,    0,    0,  977,    0,    0,
    0,    0,    0,  976,    0,    0,    0,  972,  976,    0,
    0,    0,  977,    0,    0,    0,    0,    0,    0,  976,
  976,    0,  976,    0,  972,    0,    0,    0,  972,    0,
    0,    0,    0,    0,    0,  985,    0,  970,  985,    0,
    0,    0,    0,  972,    0,  985,    0,  985,    0,    0,
    0,  985,    0,    0,  970,    0,  985,    0,  970,  985,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  976,
    0,    0,    0,  970,  985,  806,  971,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  976,  985,    0,    0,
  976,    0,    0,    0,    0,  985,    0,    0,  985,  985,
    0,    0,    0,    0,    0,  976,    0,    0,  985,    0,
    0,    0,    0,    0,    0,    0,  806,    0,    0,  806,
    0,    0,    0,    0,  985,    0,    0,    0,    0,  971,
    0,    0,  971,    0,  806,    0,    0,    0,    0,  971,
    0,  971,    0,    0,    0,  971,  985,    0,    0,    0,
  971,  985,    0,  971,    0,    0,    0,    0,    0,    0,
    0,    0,  985,  985,    0,  985,    0,    0,  971,  973,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  971,    0,    0,    0,    0,    0,    0,    0,  971,
    0,    0,  971,  971,    0,    0,    0,    0,    0,    0,
    0,    0,  971,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  985,    0,    0,  977,    0,    0,  971,    0,
    0,    0,  973,    0,    0,  973,    0,    0,    0,  985,
    0,    0,  973,  985,  973,    0,    0,    0,  973,    0,
  971,    0,    0,  973,    0,  971,  973,    0,  985,    0,
    0,    0,    0,    0,    0,    0,  971,  971,    0,  971,
    0,  973,    0,    0,    0,    0,    0,    0,  977,    0,
    0,  977,    0,    0,  973,    0,    0,    0,  977,    0,
  977,    0,  973,    0,  977,  973,  973,    0,    0,  977,
    0,    0,  977,    0,    0,  973,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  971,  977,    0,    0,
    0,  973,    0,    0,    0,    0,    0,    0,    0,    0,
  977,    0,    0,  971,    0,    0,    0,  971,  977,    0,
    0,  977,  977,  973,    0,    0,    0,    0,  973,    0,
    0,  977,  971,    0,    0,    0,    0,    0,    0,  973,
  973,    0,  973,    0,    0,    0,    0,  977,    0,    0,
    0,    0,    0,  154,    0,    0,  154,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  112,    0,  977,
    0,    0,    0,  154,  977,    0,  154,    0,    0,    0,
  806,    0,    0,  806,    0,  977,  977,    0,  977,  973,
  806,    0,  806,    0,    0,    0,  806,    0,    0,    0,
    0,  806,    0,    0,  806,  113,  973,    0,    0,    0,
  973,    0,    0,    0,    0,    0,  154,  114,    0,  806,
    0,    0,  154,  154,  154,  973,  154,  154,  154,    0,
  154,    0,  806,    0,    0,  977,    0,    0,    0,    0,
  806,  115,    0,    0,  806,    0,    0,  154,    0,  154,
    0,    0,  977,  806,    0,    0,  977,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  806,
    0,  977,    0,    0,    0,    0,    0,    0,  154,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  154,  806,    0,    0,    0,
    0,    0,    0,    0,    0,  116,    0,    0,  806,    0,
  806,    0,    0,    0,    0,  117,    0,  154,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  154,  154,    0,    0,    0,  806,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0,  125,  154,
    0,    0,    0,    0,  806,    0,  126,  127,  806,    0,
    0,    0,   51,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,  806,    0,    0,    0,  133,  134,    0,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
   51,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,   51,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,   51,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181,  182,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   51,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   51,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   51,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   53,    0,    0,   53,    0,   53,   53,
   53,   53,    0,   53,    0,    0,    0,    0,    0,    0,
    0,   53,   53,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   53,   53,    0,   53,   53,   53,    0,    0,
    0,    0,   53,   53,    0,   53,   53,    0,   53,    0,
    0,   53,   53,   53,   53,   53,   53,   53,    0,    0,
    0,    0,   53,   53,   53,    0,   53,   53,   53,    0,
   53,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,    0,   53,   53,   53,   53,   53,   53,    0,   53,
   53,   53,   53,    0,   53,    0,   53,   53,   53,   53,
   53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
   53,   53,   53,   53,  366,   53,   53,   53,   53,    0,
   53,   53,   53,   53,   53,    0,   53,   53,   53,   53,
   53,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  366,    0,    0,    0,    0,    0,    0,  366,
    0,    0,    0,  366,  366,    0,  366,    0,    0,  366,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  366,    0,    0,    0,    0,    0,  366,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  366,    0,    0,    0,  366,    0,
    0,    0,    0,    0,    0,    0,  366,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  366,  366,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  366,    0,
    0,    0,  366,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  366,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  366,    0,    0,
    0,    0,    0,    0,    0,    0,  366,    0,  366,  366,
    0,    0,    0,    0,    0,  366,    0,    0,  366,    0,
  366,  366,  366,  366,    0,  366,  366,    0,    0,    0,
    0,    0,    0,  366,  366,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  366,  366,    0,  366,  366,  366,
    0,    0,    0,    0,  366,  366,    0,  366,  366,    0,
  366,    0,    0,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,    0,  366,  366,  366,    0,  366,  366,
  366,    0,  366,    0,  366,  366,  366,    0,  366,  366,
    0,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,    0,  366,  366,  366,  366,  366,  366,
    0,  366,  366,  366,  366,    0,  366,    0,  366,  366,
  366,  366,  366,  366,  366,  366,  366,  366,  366,  366,
  366,  366,  366,  366,  366,  366,  334,  366,  366,  366,
  366,    0,  366,  366,  366,  366,  366,    0,  366,  366,
  366,  366,  366,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  334,    0,    0,    0,    0,    0,
    0,  329,    0,    0,    0,  334,  334,    0,  334,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  334,    0,    0,    0,    0,    0,
  334,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,    0,    0,    0,
  334,    0,    0,    0,    0,    0,    0,    0,  334,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  334,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  334,    0,    0,    0,  334,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  334,  334,    0,    0,    0,    0,    0,  334,    0,    0,
  334,    0,  334,  334,  334,  334,    0,  334,  334,    0,
    0,    0,    0,    0,    0,  334,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,  334,    0,  334,
  334,  334,    0,    0,    0,    0,  334,  334,    0,  334,
  334,    0,  334,    0,    0,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,    0,  334,  334,  334,    0,
  334,  334,  334,    0,  334,    0,  334,  334,  334,    0,
  334,  334,    0,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,    0,  334,  334,  334,  334,
  334,  334,    0,  334,  334,  334,  334,    0,  334,    0,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,    0,  334,  334,  334,  334,  334,    0,
  334,  334,  334,  334,  334,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,    0,    0,    0,
    0,    0,    0,  327,    0,    0,    0,  334,  334,    0,
  334,    0,    0,  334,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  334,    0,    0,    0,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  334,    0,
    0,    0,  334,    0,    0,    0,    0,    0,    0,    0,
  334,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  334,  334,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  334,    0,    0,    0,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  334,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  334,  334,    0,    0,    0,    0,    0,  334,
    0,    0,  334,    0,  334,  334,  334,  334,    0,  334,
  334,    0,    0,    0,    0,    0,    0,  334,  334,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  334,  334,
    0,  334,  334,  334,    0,    0,    0,    0,  334,  334,
    0,  334,  334,    0,  334,    0,    0,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,    0,  334,  334,
  334,    0,  334,  334,  334,    0,  334,    0,  334,  334,
  334,    0,  334,  334,    0,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,    0,  334,  334,
  334,  334,  334,  334,    0,  334,  334,  334,  334,    0,
  334,    0,  334,  334,  334,  334,  334,  334,  334,  334,
  334,  334,  334,  334,  334,  334,  334,  334,  334,  334,
 2027,  334,  334,  334,  334,    0,  334,  334,  334,  334,
  334,    0,  334,  334,  334,  334,  334,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    6,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2236,
 2237,    0, 2238,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2239,    0,
    0,    0,    0,    0, 2240,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  568,    0,    0,    0,  570,    0,    0,    0,    0,    0,
    0,    0,   11,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  573,
 2241,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  574,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2242,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   16,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   17,    0,    0,    0,    0,
    0,  581,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,  582,    0,    0,    0,    0,    0,    0,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2243,  592,    0,  130,  131,  132,    0,    0,    0,    0,
  133,  134,    0,  135,  136,    0,  137,    0,    0,  138,
 2244,  140,  141,  142,  143,  144, 2245, 2246, 2247,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
  601,  602,  603,    0,  604,  605,    0,  606,  152,  153,
  154,  155,  156,  157,  607,  159,  608,  161,  609,  610,
  611,  612,  613,  614,  615,  616,  617,  618,  619,    0,
  620,  621,  622,  623,  624,  178,    0,  626,  627,  628,
  182,    0,  629,    0,  184,  631,  632,  633,  634,  189,
  190,  635,  192,  636,  637,  638,  196,  639,  198,  640,
  200,  641,    0,  642,  643,  644,  645,    0,  646,  647,
  648,  209,  649,    0,  650,  651,  213,  652,  215,  857,
    0,    0,  858,    0,    0,    0,    0,    0, 1118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  859,
    0,    0,  860,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  861,    0,    0,    0,    0,    0,  862,  863,
  864,    0,  865,  866,  867,    0,  868,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  869,    0,  870,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  871,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  872,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  873,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  119,    0,
    0,  120,    0,  121,  122,  123,  124,    0,  125,    0,
    0,    0,    0,    0,    0,    0,  126,  127,  874,  875,
    0,    0,    0,    0,    0,    0,    0,  128,  129,    0,
  130,  131,  132,    0,    0,  876,    0,  133,  134,    0,
  135,  136,    0,  137,    0,    0,  138,  139,  140,  141,
  142,  143,  144,    0,    0,    0,    0,  145,  146,  147,
    0,  148,  149,  150,    0,  151,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  152,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,  169,  170,  171,  172,    0,  173,  174,  175,
  176,  177,  178,    0,  179,  180,  181, 1119,    0,  183,
    0,  184,  185,  186,  187,  188,  189,  190,  191,  192,
  193,  194,  195,  196,  197,  198,  199,  200,  201,    0,
  202,  203,  204,  205,    0,  206,  207,  208,  209,  210,
    0,  211,  212,  213,  214,  215, 1212,    0,    0, 1212,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1214,    0, 1212,    0,    0, 1212,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1212,
    0,    0,    0,    0,    0, 1212, 1212, 1212,    0, 1212,
 1212, 1212,    0, 1212,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1212,    0, 1212,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1212,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1212,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1212,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1212,    0,    0, 1212,    0,
 1212, 1212, 1212, 1212,    0, 1212,    0,    0,    0,    0,
    0,    0,    0, 1212, 1212, 1212, 1212,    0,    0,    0,
    0,    0,    0,    0, 1212, 1212,    0, 1212, 1212, 1212,
    0,    0, 1212,    0, 1212, 1212,    0, 1212, 1212,    0,
 1212,    0,    0, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
    0,    0,    0,    0, 1212, 1212, 1212,    0, 1212, 1212,
 1212,    0, 1212,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
 1212, 1212, 1212,    0, 1212, 1212, 1212, 1212, 1212, 1212,
    0, 1212, 1212, 1212, 1212,    0, 1212,    0, 1212, 1212,
 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
 1212, 1212, 1212, 1212, 1212, 1212,    0, 1212, 1212, 1212,
 1212,    0, 1212, 1212, 1212, 1212, 1212,    0, 1212, 1212,
 1212, 1212, 1212,  857,    0,    0,  858,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  859,    0,    0,  860,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  861,    0,    0,    0,
    0,    0,  862,  863,  864,    0,  865,  866,  867,    0,
  868,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  869,    0,  870,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  871,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  872,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  873,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,    0,    0,  120,    0,  121,  122,  123,
  124,    0, 1004,    0,    0,    0,    0,    0,    0,    0,
  126,  127,  874,  875,    0,    0,    0,    0,    0,    0,
    0,  128,  129,    0,  130,  131,  132,    0,    0,  876,
    0,  133,  134,    0,  135,  136,    0,  137,    0,    0,
  138,  139,  140,  141,  142,  143,  144,    0,    0,    0,
    0,  145,  146,  147,    0,  148,  149,  150,    0,  151,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  152,
  153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
  163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
    0,  173,  174,  175,  176,  177,  178,    0,  179,  180,
  181,  182,    0,  183,    0,  184,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
  199,  200,  201,    0,  202,  203,  204,  205,    0,  206,
  207,  208,  209,  210,    0,  211,  212,  213,  214,  215,
  857,    0,    0,  858,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  859,    0,    0,  860,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  861,    0,    0,    0,    0,    0,  862,
  863,  864,    0,  865,  866,  867,    0,  868,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  869,    0,  870,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  871,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  872,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  824,    0,    0,    0,  873,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,    0,    0,  126,  127,  874,
  875,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,  876,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
  830,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,  119,    0,    0,
  120,    0,  121,  122,  123,  124,    0,  125,    0,    0,
    0,    0,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  146,  147,    0,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,    0,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,    0,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215,    0,    0,  119,    0,    0,
  120,    0,  121,  122,  123,  124,    0,  125, 1487,    0,
    0,    0,    0,    0,    0,  126,  127,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,  129,    0,  130,
  131,  132,    0,    0,    0,    0,  133,  134,    0,  135,
  136,    0,  137,    0,    0,  138,  139,  140,  141,  142,
  143,  144,    0,    0,    0,    0,  145,  146,  147,    0,
  148,  149,  150,    0,  151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,    0,  173,  174,  175,  176,
  177,  178,    0,  179,  180,  181,  182,    0,  183,    0,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,    0,  202,
  203,  204,  205,    0,  206,  207,  208,  209,  210,    0,
  211,  212,  213,  214,  215,    0,  119,    0,    0,  120,
    0,  121,  122,  123,  124,    0,  125,    0,    0,    0,
    0,    0,    0,    0,  126,  127,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  128,  129,    0,  130,  131,
  132,    0,    0,    0,    0,  133,  134,    0,  135,  136,
    0,  137,    0,    0,  138,  139,  140,  141,  142,  143,
  144,    0,    0,    0,    0,  145,  146,  147, 1629,  148,
  149,  150,    0,  151,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  152,  153,  154,  155,  156,  157,  158,
  159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
  169,  170,  171,  172,    0,  173,  174,  175,  176,  177,
  178,    0,  179,  180,  181,  182,    0,  183,    0,  184,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,  197,  198,  199,  200,  201, 1630,  202,  203,
  204,  205,    0,  206,  207,  208,  209,  210,    0,  211,
  212,  213,  214,  215,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1631,    0,    0,    0,    0, 1632,    0,    0,
    0,    0,    0, 1633,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,    0,    0,  120,    0,  121,
  122,  123, 1634,    0,  125,    0,    0,    0,    0,    0,
    0,    0,  126,  127,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  128,  129,    0,  130,  131,  132,    0,
    0,    0,    0,  133,  134,    0,  135,  136,    0,  137,
    0,    0,  138,  139,  140,  141,  142,  143,  144,    0,
    0,    0,    0,  145,  146,  147,    0,  148,  149,  150,
    0,  151,    0,    0,    0,    0,    0,    0,    0, 1236,
    0,  152,  153,  154,  155,  156,  157,  158,  159,  160,
  161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
  171,  172, 1237,  173,  174,  175,  176,  177,  178,    0,
  179,  180,  181,  182,    0,  183,    0,  184,  185,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
  197,  198,  199,  200,  201,    0,  202,  203,  204,  205,
    0,  206,  207,  208,  209,  210,    0,  211,  212,  213,
  214,  215,    0,    0,    0,    0,    0, 1238,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,    0,    0,    0,    0,
  133,  134,    0,  135,  136,    0,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,    0,  237,    0,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,    0,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
  182,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205,    0,  206,  207,
  208,  209,  210,    0,  211,  212,  213,  214,  215,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0,  125,
    0,    0,    0,    0,    0,    0,    0,  126,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,  253,    0,    0,
  253,    0,    0,    0,    0,    0,  253,    0,    0,  253,
    0,    0,    0,  253,    0,    0,    0,  253,    0,    0,
  253,    0,    0,    0,    0,    0,  253,    0,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  253,    0,    0,    0,    0,    0,  253,  253,  253,  253,
  253,  253,  253,    0,  253,  253,  253,  253,    0,  253,
  253,  253,    0,  253,    0,    0,    0,    0,    0,    0,
    0,  253,    0,  253,    0,    0,    0,    0,    0,    0,
  253,    0,  253,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  253,    0,    0,    0,    0,    0,    0,    0,
    0,  253,    0,    0,    0,    0,    0,    0,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,  253,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  253,    0,    0,    0,    0,    0,    0,    0,    0,
  253,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  712,    0,    0,    0,  253,  253,    0,    0,
    0,    0,    0,    0,    0,  253,  253,    0,    0,  119,
    0,    0,  120,  253,  121,  122,  123,  124,    0,  125,
    0,    0,  253,    0,    0,    0,    0,  126,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,  119,    0,    0,
  120,  266,  121,  122,  123,  124,  267,  125,  268,  269,
  270,  271,  272,  273,  274,  126,  127,  275,  276,  277,
  278,  279,    0,    0,  280,  281,  128,  129,  282,  130,
  131,  132,  283,  284,  285,  286,  133,  134,  287,  135,
  136,  288,  137,  289,  290,  138,  139,  140,  141,  142,
  143,  144,  291,  292,  293,  294,  145,  146,  147,  295,
  148,  149,  150,  296,  151,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  152,  153,  154,  155,  156,  157,
  158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  171,  172,  306,  173,  174,  175,  176,
  177,  178,  307,  179,  180,  181,  182,  308,  183,  309,
  184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,  200,  201,  310,  202,
  203,  204,  205,  311,  206,  207,  208,  209,  210,  312,
  211,  212,  213,  214,  215,  538,    0,    0,  538,  538,
  538,  538,  538,  538,    0,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
    0,    0,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  538,  538,  538,  538,  538,  538,  538,
  538,  538,  538,  119,    0,    0,  120,    0,  121,  122,
  123,  124,    0,  125,    0,    0,    0,    0,    0,    0,
    0,  126,  127,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  128,  129,    0,  130,  131,  132,    0,    0,
    0,    0,  133,  134,    0,  135,  136,    0,  137,    0,
    0,  138,  139,  140,  141,  142,  143,  144,    0,    0,
    0,    0,  145,  146,  147,    0,  148,  149,  150,    0,
  151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,    0,  173,  174,  175,  176,  177,  178,    0,  179,
  180,  181,  182,    0,  183,    0,  184,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  242,  202,  203,  204,  205,    0,
  206,  207,  208,  209,  210,    0,  211,  212,  213,  214,
  215,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,    0,    0,    0,    0,
  133,  134,    0,  135,  136,    0,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  152,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,    0,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
  182,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205,    0,  206,  207,
  208,  209,  210,    0,  211,  212,  213,  214,  215,  119,
    0,    0,  120,    0,  121,  122,  123,  124,    0, 1810,
    0,    0,    0,    0,    0,    0,    0,  126,  127,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  128,  129,
    0,  130,  131,  132,    0,    0,    0,    0,  133,  134,
    0,  135,  136,    0,  137,    0,    0,  138,  139,  140,
  141,  142,  143,  144,    0,    0,    0,    0,  145,  146,
  147,    0,  148,  149,  150,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,    0,  173,  174,
  175,  176,  177,  178,    0,  179,  180,  181,  182,    0,
  183,    0,  184,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
    0,  202,  203,  204,  205,    0,  206,  207,  208,  209,
  210,    0,  211,  212,  213,  214,  215,   30,    0,    0,
   30,    0,   30,   30,   30,   30,    0,   30,    0,    0,
    0,    0,    0,    0,    0,   30,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   30,   30,    0,   30,
   30,   30,    0,    0,    0,    0,   30,   30,    0,   30,
   30,    0,   30,    0,    0,   30,   30,   30,   30,   30,
   30,   30,    0,    0,    0,    0,   30,   30,   30,    0,
   30,   30,   30,    0,   30,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,    0,   30,   30,   30,   30,
   30,   30,    0,   30,   30,   30,   30,    0,   30,    0,
   30,   30,   30,   30,   30,   30,   30,   30,   30,   30,
   30,   30,   30,   30,   30,   30,   30,   30,    0,   30,
   30,   30,   30,    0,   30,   30,   30,   30,   30,    0,
   30,   30,   30,   30,   30,  666,    0,    0,  666,    0,
  666,  666,  666,  666,    0,  666,    0,    0,    0,    0,
    0,    0,    0,  666,  666,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  666,  666,    0,  666,  666,  666,
    0,    0,    0,    0,  666,  666,    0,  666,  666,    0,
  666,    0,    0,  666,  666,  666,  666,  666,  666,  666,
    0,    0,    0,    0,  666,  666,  666,    0,  666,  666,
  666,    0,  666,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,    0,  666,  666,  666,  666,  666,  666,
    0,  666,  666,  666,  666,    0,  666,    0,  666,  666,
  666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
  666,  666,  666,  666,  666,  666,    0,  666,  666,  666,
  666,    0,  666,  666,  666,  666,  666,    0,  666,  666,
  666,  666,  666,  319,    0,    0,  319,    0,  319,  319,
  319,  319,    0,  319,    0,    0,    0,    0,    0,    0,
    0,  319,  319,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  319,  319,    0,  319,  319,  319,    0,    0,
    0,    0,  319,  319,    0,  319,  319,    0,  319,    0,
    0,  319,  319,  319,  319,  319,  319,  319,    0,    0,
    0,    0,  319,  319,  319,    0,  319,  319,  319,    0,
  319,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,    0,  319,  319,  319,  319,  319,  319,    0,  319,
  319,  319,  319,    0,  319,    0,  319,  319,  319,  319,
  319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
  319,  319,  319,  319,    0,  319,  319,  319,  319,    0,
  319,  319,  319,  319,  319,    0,  319,  319,  319,  319,
  319,  119,    0,    0,  120,    0,  121,  122,  123,  124,
    0,  125,    0,    0,    0,    0,    0,    0,    0,  126,
  127,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  128,  129,    0,  130,  131,  132,    0,    0,    0,    0,
  133,  134,    0,  135,  136,    0,  137,    0,    0,  138,
  139,  140,  141,  142,  143,  144,    0,    0,    0,    0,
  145,  146,  147,    0,  148,  149,  150,    0,  151,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  153,
  154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,    0,
  173,  174,  175,  176,  177,  178,    0,  179,  180,  181,
  182,    0,  183,    0,  184,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,    0,  202,  203,  204,  205,    0,  206,  207,
  208,  209,  210,    0,  211,  212,  213,  214,  215,
};
static int yycheck[] = {                                       9,
    4,   72,   17,  118,    0,   62,   16,   17,   81,   19,
   71,  105,   78,  655,   70,  484,  485,  701,   76,   63,
   71,  498,  778,   64,   16,   96,  820,  102, 1106,  535,
  999,   75,  535,  106,  535, 1064,   77,  405,  104,  999,
 1031,  531,   66,  100,  102, 1066,  108,  484,  485,   59,
   60, 1106,   62,   63,   64,   65,   66,  101, 1112,  945,
  905,   71,   72,   73,  358,   75,  110,   77,   78, 1106,
   80,   81,   82,   83, 1315,   99,  813, 1067,  502,  733,
 1106,  548,   92,  107,   94,   95,   96,  923,   98,   99,
  100,  101,  928,  103,  104,  105,  106,  107,  108, 1106,
  110,  527,   94,  825, 1241,  722, 1032,  987,  512,  500,
  756,  103,  721,  480,  511, 1077, 1334, 1090, 1106,  916,
  351,   41, 1385,    0, 1094, 1015,   40,  963,  256, 1459,
   42,   43,    0,   45,  970,   47,  820,  541, 1464,    0,
 1701,  878, 1626,    0,   44,   40,    0,    0,    0,   63,
    0,   45,    0, 1115,    0,    0,   45,  251,   45, 1583,
    0,  455, 1586, 1016, 1126,   45,    0,   45,   63,   63,
   40,    0,   63,   44,  225,   40,  247,  228,   44, 1070,
   44, 1083,   59, 1446,  250,  226,   44,   44,   44,  843,
  371,   59, 1419,   41,   44,    0,   44, 1660,   59,  279,
    0,   41,   59,    0,  248,   59,   59,   59,  249,   59,
  234,   59, 1644,   59,   59,  225,  226,  227,  228,   59,
  451,    0,  232,    0,  234,   59,    0,  242,    0, 1191,
   59, 1076,  242,   44,   44,  227,  281,  247,  248,  249,
  250,  251,  242, 1698,   41,  360,  256,   44,    0,    0,
 1477,  280,   40,  264,   59,    0,    0,    0,   44,   59,
  316,  268,   59,   44,   41,  344,  298,   44,   91,   41,
  298,   41,  446,   41,   44,    0,  978,  979,  297,  257,
   59,    0,   59,  264,    0,   59,   94,   59,    0,   41,
   41,  347,   58,   44,  317,    0,  273,   63,    0,    0,
  767,  273,   41,  298,  265,  272,  334,   59,   59,  317,
  816,  801,  310,   41,   59,   59,   59,  303, 1002,  825,
  304,  305,  825,  262,  825,  344,  406,  394,  396,  257,
  298,   41,  809,  257,   59,  276,   44,  262,  299,   41,
   59, 1645,  457,   59,  712,  396, 1315,   59,  399,  991,
 1451,  828,  330,  336,   59, 1315,  998,   59,   59,  270,
  764, 1003,  730,  420,  854,  277,  334, 1468,    0,  336,
  282,  348,  333,   42,   43,   44,   45,   46,   47,  447,
   41, 1065, 1355,  424, 1121,  296,  396,  315,  569,  399,
    0,  402,  497,  444,  450,  405,  406, 1727, 1234, 1235,
    0,  430,  330, 1827,  427,  433,  330, 1831,  845,   41,
  420, 1435,   44, 1717,  424, 1032, 1879, 1154, 1304,  227,
 1382,  402,   91,  409,    0,    0,  505,   59,  443,  444,
  371,  446,  499,  443,  441,   40,  446,  447,  433,  378,
 1276,   41,  272,  301, 1671,  301,  446,  445,  375,   59,
  501,  262,  275,  378, 1129, 1072, 1911,    0,  442,   59,
  511, 1485,  513, 1340,  515,   41,  537,  518, 1394,  479,
  480, 1734,  528,  539,  530,  461, 1613, 1740, 1696, 1742,
 2029, 1334, 1335,   59,   59,  457,  505,  426, 1390,  545,
   41,  501, 1378,  370,  538,  552,  336,  297,   41,  276,
  277,  511, 1393,  513,  281,  515,  547,  284,  518,   61,
  551,  375, 2073,  593, 1741,  560,   59, 1735,    0, 1173,
  297,    0,  379,  262, 1360,  276,  277,  537,  538,  539,
  281,  388, 1669,  284,  262,  449,  317,  547,  306,  264,
  550,  551,  552, 1012,  344,  555,  297,  400,  580,  449,
  336,  555,  262,  297,  449,  449,  401,  422,  449,   41,
  449,  277,  449,  315,  336,  277, 1419,  378,  438,  449,
 1406,  449,  443, 1564,  427,  452,  453,   59,  375,  445,
   59, 2005, 1908, 1200,  336,  442,  443,  476,  442,  509,
    0,  452,  453, 1295,  371,  445,  476, 1214,  386, 1216,
  344,   59,  896, 2035,  732,  445,  452,  453,  277,  317,
  904, 1048,  489,  282, 2175,  392,  445,  427,  361,  364,
  371,  398,  401,    0, 1477,  344,  400,  379, 1891, 1892,
 1960, 1476,  402, 1874,  336, 1074,  388, 1482, 1144,  378,
  445,  392, 1326,  344,  492,  306,  656,  398, 1617,   59,
  378, 1675,  509,   61,  264,  432, 1024, 1617,  535,  655,
  528, 2222, 2146,  894,   41,  283,  578,  711,  378,  710,
  721,  528, 1890,  445,  379,  509,  528, 1650,  719,  431,
 1417,  432,   59,  315,  725,  324,  452,  453, 1712,  747,
 1427,  701,  297,  445,  528,  492, 2245, 2246,  370,  576,
  710,  711,  712, 1345,  336,  505,  721, 1349, 1505,  719,
  751,  262, 1354, 1940,  724,  725, 1113, 1084,  774, 1156,
  730, 1745,  732, 1190,  315,  766,  722,  778,  769, 1947,
   44, 1198, 1702, 1623, 2295, 1661,  336,   42, 1347,  315,
  334,  751,   47,  445, 1500,  297, 1483,  803,    0, 1395,
  379,  327, 1143, 2203, 1429, 1430,  766,  509,   42,  769,
  336,  505,  818,  338, 1203,  375, 2315,  351,  778, 1386,
 1732,  846,  315,   44,  825,  264,  528,    0,  298,  389,
  309, 1075, 1206,  560, 1188,  264, 1663, 1664,  846,    0,
  483,  262,  848,  336,  463,  464,  465,  466,  467,  468,
  469,  470,  431,  379,  509,  264,  352,   59,   41,  560,
  820,   44,  388,  445,  824,  825,  455,  489, 1671,  512,
  830,  396,   93,  528,  399, 1500,  408,  378, 1673, 2092,
 2093,  259, 2381,  315,  452,  453,   59,  893,    0,  433,
  415,  269,  264, 1696,  900,  901,   42,   43,   59,   45,
    0,   47,  903,  444,  336,  431, 1910,   42,   43,   44,
   45,   46,   47,  535,  315,  394,  441,  394, 2318,  445,
 1894,  304,  305, 2091,  420, 1844, 1930,  509,    0,  264,
 2330, 1905, 1735, 1525, 1875, 1909,  375,    0, 1741,  297,
 1914,   41,  262,  903,   44, 1775,  528,   59, 1889,  483,
  429,  959,  445,  572,  576, 1874,   91,  378,   41,   59,
  389,   44,  303,  433, 1874,   41,  375, 1384,   44, 1943,
 1944,  496, 1946,   59, 1948,   61,  950,    0,   41,  598,
  992,   44,  928,  509, 1618,   61,  322,   59,  315,  435,
  950,  516,    0, 2065, 2066,    0,   59,  375, 1387,  445,
  264, 1593,  528,  375,  529,   42,   43,  408,   45,  336,
   47,  280, 1013,  445, 1015,    0, 1017,  563,  964,  379,
 1896,  442,  277,  300, 2111, 1401,  260,  282,  388,    0,
   93,  315,  992,  510,  999,  528,   59, 2065, 2066,   44,
  375,  587, 1002,  444,   42,   43,   44,   45,   46,   47,
 1044,   59, 1043, 1013,   59, 1015,  344, 1017,  378,  442,
 2065, 2066,  264,  268, 1024, 1066,  300, 1058,  409, 1060,
  319,  348, 1032, 1074,   59, 1462,    0, 1083, 2065, 2066,
 2054, 2055, 2056, 1043, 1044,  421, 1032, 1890,   59, 2065,
 2066,  348,  428,   91, 1100,  395,  528,  257, 1058,  297,
 1060, 1066, 1478,  264, 1110, 1065,  426,  376, 2065, 2066,
 1070,  411, 1113,    0, 1074, 1140, 1720,   41,  445, 1723,
  461,    0, 2062, 1902, 1084, 2316, 1072, 2065, 2066, 1503,
 1966,  277, 1140,  304,  305,   59,  282, 1940,    0, 1811,
 1141,    0,  277, 1144, 1947, 1153, 1941,  282,  400,  509,
  348,  275,  264, 1113,  359,  315, 1162,    0, 1183, 1184,
 1185,  430, 1170,  260,  452,  453, 1945, 2358,  528, 2360,
  330, 2362,   59,  375,    0, 1183, 1184, 1185,  447,   41,
   59, 1141,  509, 2374, 1144,  596,  318,  389,  396, 1201,
  273,  400,  264, 1567,  260,  452,  453,   59, 1189,  331,
   59,  528, 1203,  300, 1164, 2209,  261, 2181, 2182, 2183,
 1164,  297, 2186, 1204,  375,  315,   59,  341,  427, 1906,
 1907,  297,  354,  306, 1643, 1644, 1645,    0,  389, 1189,
  265, 1475, 2203,   59,  300,  258,  336,  449,  396,  447,
  277, 1201,    0, 1203, 1204,  282,    0,  270,  428,  259,
  258,  260, 1212, 1213, 1200, 2327, 2328,  415, 1212,  269,
  449, 2047,  270,  375,  299,  348,    0, 1954, 1214,  319,
 1216,  442,  404,  336,  297, 2061, 2217,  389,  315,  277,
  303,  427,  305,    0,  282,  319,   59,   41, 2091,  297,
  339,  300,  395,  264,   40,  303, 1888,  305, 1738, 2327,
 2328,   59, 1689,  375, 1691,   59, 1280,   42,   43, 2288,
   45, 1629,   47,  362, 1632, 1327, 1733,  389,  263,  402,
 1280,  344, 2327, 2328,   41,   59,  298,   44,  463,  464,
  465,  466,  467,  468,  469,  470,  344,    0,  401,   44,
 2327, 2328,   59,  257,   61,  445, 1347,  484,  563, 1736,
 1315, 2327, 2328,  338,    0, 1811,  277,  494, 1811,  276,
 1811,  282,  334,    0,  309,  375, 1326, 1327,  417,  549,
 2327, 2328,  587,  271,  457,  320,  556,  260,  258, 1339,
 1340,  261, 1347,   44, 1390,  370, 1387,  285,   93, 2327,
 2328,  315,    0,  493,  393,   41,   59, 2316,   44,    0,
  259,  315,  258,  370,  375,  264, 2316, 2151,  449,  509,
  269,  396,  336,   59,  399,   61,  330,  300,  389,    0,
  319,  264,   59,  303,   40, 1844,  398, 1387,  528,  375,
  415,  329,   93, 1393, 1394,  476,  408,  572,  264, 2358,
 1386, 2360,  409, 2362,    0, 1470,    0,  303, 2358,  375,
 2360,   59, 2362,  315,  371, 2374,  441, 2163,   59,  357,
   44,  433, 1470,  598, 2374,  463,  464,  465,  466,  467,
  468,  469,  470,  418,  336,  392,  375, 1502,   59, 1480,
  449,  398,  505, 1508,  383,   41, 1913, 1493,   44,  456,
  334, 1451,  595, 1484, 1502,  377,   44,  505,    0, 1500,
 1508,  270, 1456,   59,  276,   59,  300,  476, 1468,    0,
    0,  496,  284,    0,    0,  432,  375, 2151,  276,  277,
 1480,  445,  420, 2309, 1484,  309,  456,  296,  458,    0,
  389,  516,  375,  313,  314,  284,    0,   93,  303,  276,
 1500,  258,  277,  377,  529,   93,  389,  282,  297,  375,
  653,  654,  655,  409,  348,   41, 1567,   59,   44,  276,
  277,  315, 2348,  389,  281,  338, 1567,  284,   59,   59,
  333,  427,   59,   59,  572,   61,  264,  371,    0,  316,
  297,    0,  336,  445,    0,  509,  303,    0,   59, 1633,
    0,    0,  276,   42,   43,   59,   45,  370,   47,   41,
  598,  264,   44, 1563,  528,  461,   41, 1567,    0,   44,
  394, 1634,  258,  371,  409, 1631, 2035,   59,  794,   61,
  796, 1563, 1623,  396,  389,  379,  399,    0,   40,  275,
  276,  277,  316,   44,  388,  281, 1630,   59,  284,    0,
   59,  425,  415,   59,  409,  429,   59,  596,    0,   59,
   59,  297, 1617,  445,  371,  392,  440,  303, 1618,  433,
    0,   41,  427, 1623,   44,    0,  528,   59,  441, 1629,
 1630, 1631, 1632, 1633, 1634,  392, 2231,  431, 2233,  782,
  451,  398,  785, 1674,  452,  453,   59,  790, 1653,   40,
  793,  445,  409, 1653,  797,  432,  461,  516,   59,    0,
 1660, 1661,  260, 1663, 1664,    0,   41,   59,  392,   44,
  427,    0,  375,  415, 1674,  432,    0,   42,   43,   59,
   45, 2150,   47,  496,   59,  371,  389,  452,  463,  464,
  465,  466,  467,  468,  469,  470,   42,   43,   44,   45,
 1746,   47,  300,  516,  461,  260,  392,   41,  432,    0,
   44,    0,  398,    0,    0,  509,  529, 1763,   59,  260,
  408, 1715, 1768,  409,   59,   59,   41,   61,    0,   44,
   59,  258,  258, 2365,  528,   59,   41,  561,  313,   44,
  336,  427,    0,  270,  264,  300,  432,  435,    0,  275,
  276,  277,  383,  384,   41,  281,   61,  445,  284,  300,
  425,   42,   43,   44,   45,   46,   47,  315,   59,  333,
   59,  297,   59,   59,  332,  461,  303,  303,  305,   42,
   43,    0,   45,   41,   47,  928,   44,   59,  277,   41,
   41,   42,   43,  282,   45,  277,   47,  572, 1844,  452,
  453,   59, 1802,  560,  947,  401,   41,   59,  951,   44,
   91,  954,  402,   41,   41,  297,   44,   44,  443,  962,
 1802,  964,   41,  598,  425,  968,  969,  338,  394,  972,
  973,  974,  975,  976,  977,  978,    0,  980,  336,  982,
   59,  333,  492,   41,  297,  371,   44,  317,  991,  315,
  993,  994,  995,  996,  997,  998, 2325,  315, 1001,  370,
 1003,  375,   41, 1863, 1864,   44,  392,   41,  375, 1874,
   44, 1876,  398,  427,  560,  367, 1876,   41,   46, 1879,
   44,  407,    0,  409, 1915,  396,  497,  379,  399,  338,
   58,  344,  352,   61,   41,   59, 1896,   44, 2367,  352,
  425,  427,   42,   43,  415,   45,  432,   47, 2377,  356,
 2379, 1942,  277, 2382,  333, 1915, 2385,  282,   41,   42,
   43,  370,   45,   41,   47,  385, 1069,  387,  484,  485,
  441,  277,  385,  533,  387,  461,  282,  532,  427,    0,
  315,   59, 1942,  277, 1995,  530, 1993,  396,  367,  409,
  399,  336,  327,    0, 1995,   41,  409,  264,   44,  376,
  379,  336,    0,  297,   42,   43,  415,   45,  425,   47,
  409,  336,   41, 2078,  434,   44,   41,  260, 2029,   44,
   41,  434,  319,   44,   41,  496,   41,   44, 2029,   44,
 1990,  374,  441, 1993,   41, 1995,  277,   44,   59, 1863,
 1864,  282,    0,   41,  379,  516,   44,  337, 1990,  496,
  258,  273,   59,  388,  277,  298,  509,   41,  529,  282,
   44,   59,  270,  504, 1863, 1864,  277,  310,  315, 2029,
   41,  282, 2079,   44,  560,    0,   41,  371,  325,   44,
  327, 2072, 1358,   42,   43, 1361,   45,  496,   47,  336,
   41,  334,  505,   44,  297,  303,  431,  305, 2104,  505,
  504,   59, 2108,  315,  315,   41,  329,  516,   44,  306,
  445, 2176, 2072,  325,  460,  327, 1219, 1220, 1221, 2079,
  529, 1224, 1225, 1226,  336, 1228, 1229, 1230, 1231, 1232,
 1233,   44,  379,  445,   59,   41,  315,   61,   44, 1242,
 1243,  388, 1245,  283, 1247,  365,   46, 1250, 1251, 1252,
 1253,   41, 1255, 1256,   44,  398,   40,  336,   58,   59,
   46,   61, 2163,   42,   43,  408,   45,  379,   47, 1272,
 2130, 1274,   58,   59,  509,   61,  388,  277,  264,   40,
   42,   43,  282,   45,  431,   47,   41, 1290,  388,   44,
  433, 2151,   41,  528,  277,   44, 1299, 1300,  445,  282,
  379,   41, 2203, 2163,   44,  318,   40,  452,  452,   42,
   43,   40,   45,   41,   47, 2236,   44,   41,  331,  431,
   44,   40,  463,  464,  465,  466,  467,  468,  469,  470,
   40,  443,   40,  445,  317,   40,  336,  315, 2203,  277,
   40,  354, 1345, 2203,  282,   40, 1349,  325,   40,  327,
  452, 1354,  431,   40,  367,  276,  277, 2203,  336, 2280,
   40,   40,  509,  284,   40,   40,  445,  351,   40,  276,
  277, 2231,   40, 2233,   40,   40, 2236,  284,   40,  317,
   40,  528,   40,   40, 2244, 2245, 2246,   40,   40, 2290,
  297,  404,   40, 1396,   40, 1398, 1399,  509,   91,  401,
  258,  379,   41,   42,   43,   44,   45,   44,   47,   40,
  388,   46,  270,   40,   61,  264,  528,  315,  277,  435,
 2280, 2281,  394,  282,  531, 2290,   44,  325, 2282,  327,
  509,  572,  315,  439,  419,   46,   61,   40,  336,  297,
   40,  339,  264,  337,   46,  303,  276,  305,  344,  528,
  371, 2316,  344,  431,  375, 2315,  344,  598,  317,   41,
   42,   43,  364,   45,  371,   47,  264,  445,  427,    0,
  389,  392, 2318,  389,  449,    0,  275,  398,  448,  449,
  450,  379,    0,  344, 2330,  392,  344,  438,  438,   40,
  388,  398,  391, 2358,  352, 2360,   40, 2362,  277,  345,
  513,   91,   40,  282,   40,  264,  476,  477,  317, 2374,
   41,  432,   40,   44,   44,  277,   41,  402,  375,  381,
  282, 2381, 1525,   41,  374,  432,   44,   40,   59,  308,
   40,  509,  379,  431,   59, 1538, 1539,  442, 1541, 1542,
  315,   59,   41,  374,  277,  443, 1549,  445,  371,  282,
  528,  277,  275,    0,  379,  317,   63,  427,  427,  528,
  455,  314,  420,  388,   42,   43,   44,   45, 1571,   47,
   40,  492,   40,   44, 1577,  308,  439, 1580,   40, 1582,
 1583,  445,  264, 1586,  409, 1588,  318,   40,   44, 1592,
 1593, 1594,  337,   44,   41,  317,   44,   44, 1601,  331,
 1603,   40,  273, 1606, 1607, 1608, 1609,  339,   40, 1612,
  537,  509,   59,  340,  297,  340,  409,  409,  443,  407,
   42,   43,  354,   45,  378,   47,  451,  378,  378,  454,
  528,  456,  457,  458,  459,  367,  461,   40,  277,  352,
   40,   40,  362,  282,  469,  470,   40,  505,   41,   42,
   43,   41,   45,   44,   47,  480,  481,   41,  483,  484,
  485,  317,   44,  277,   44,  490,  491,  492,  493,  494,
   46,  496,  404,   41,  499,  500,  501,  502,  503,  504,
  505,  348,   41,  377,  509,  510,  511,  512,  361,  514,
  515,  516,   41,  518,  380,  277, 1699,   41,   42,   43,
  282,   45,   41,   47,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,  339,  550,  551,  552,  553,  554,
  555,  262,  557,  558,  559,  560,    0,  562,  339,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,  317,  583,  584,
  585,  586,  317,  588,  589,  590,  591,  592, 1771,  594,
  595,  596,  597,  598, 1777,  493,  318,   41,  266, 1782,
   44,  513,  443,  264,  315,  435, 1789,  318,  492,  331,
  315,  264,  413,   41,  325,   59,  327,  315,   58,  277,
  331,   41,  327,   41,  282,  336,   41,  325,  339,  327,
  264,  336,  354,  445,   40,  591,  576,  386,  336,  306,
  306,  339,   41,  354, 1827,  367,   41,   40, 1831,  276,
  277,   40,  317,  375, 1837, 1838,  367,  284,   40,   40,
   40,   40,   40,  265,  375,   40,   40,  378,  379,   40,
  262,   40,   40,   40,  379,  277,   40,  388,   40,   40,
  282,  379,  404,  388,  426,   41,   42,   43,  305,   45,
  388,   47,  296,  404,  427,  445,   44,  299,   42,   43,
   44,   45,   44,   47,  277, 1888,   40,    0,   44,  282,
   41,   42,   43,  339,   45,  426,   47,   41,   42,   43,
  431,   45,  325,   47,   42,   43,  431,   45,  383,   47,
  284,  442,  443,  431,  445,  398,   41,  378,  378,  378,
  445,  378,  449,  378,  371,  443,  378,  445,   41,   42,
   43,   44,   45,  277,   47,  946,   41,  948,  282,  276,
  375,  952,  953,   40,  955,  392,   59,   60,   61,   62,
  492,  398,   41,   42,   43, 1224,   45, 1226,   47, 1228,
 1229,  492, 1231, 1232, 1233,   41, 1969,   41,   41,  317,
  981,  513, 1975, 1976,   41,   44,  374,   41,  509,  305,
   93,  426,  513,   41,  509,  432,   41,   42,   43,   41,
   45,  509,   47,  270,  437,  324,  427,  528, 2001,  273,
  442,  442, 2005,  528,  327,  333, 2009,  433,  433,  334,
  528, 2014, 2015, 2016, 2017, 2018,   41,   42,   43,  298,
   45,  334,   47, 2026,   41,  298,   41,   41,   42,   43,
  348,   45,  377,   47,   41,  279,   41,   42,   43,   41,
   45,   41,   47,  364,  364,  492,   41,   42,   43,   41,
   45,  315,   47,   41,  318,   41,   41, 2060,   41,   41,
   41,  325,   41,  327,   41,   41,   41,  331,   42,   43,
   41,   45,  336,   47,   41,  339,   41,   40,  377,   41,
   41,   42,   43,  426,   45,  569,   47,   41,   42,   43,
  354,   45,  569,   47,   40,  371,   41,  340,  305,  457,
 2103,  277,  333,  367,  442,  290,  282,   42,   43,   59,
   45,  375,   47,  277,  378,  379,  426,  433,  282,   44,
  570,  375,  509,  509,  388,   44,  277,   41,   40,  315,
  334,  282,   41,  277,  409,   40,  375,   59,  282,  277,
  404,  375,   58,  336,  282,  258,   40,  433,  338,  262,
  298,  264,  265,  336,   41,   40,   44,  435,  271,  454,
   41,  336,  426,  276,  277,  499,  336,  431,   40,  282,
  426,  284,  285,  301,  304,  290,  408,  301,  442,  443,
  370,  445,    0,  333,  408,  264,  299,   40,  277,  264,
  303,  304,  305,  282,  264,  308, 2199,  375, 2201,  449,
  408,  375,  315,   40,  317,  318,  396,   41,  321,  399,
  402,   44,  325,  442,  327, 2218,  329,  339,  331,  435,
   40,  317,  277,  336,  337,  415,  339,  282,  492,   40,
    0,   41,  339,   41,   42,   43,  264,   45, 2241,   47,
    0,  354,  355,  449,  357,  509,  426,   41,   41,  513,
   41,  441,  277,    0,  367,  305,  369,  282,  371,  372,
  373,   41,  375,  277,  528,  378,  379,   41,  282,   41,
  449,   41,  277,  528,   44,  388,    0,  282,   41,  392,
   40,   41,  277,   41,   44,  398,   59,  282,  401,   59,
  264,  404,   59,   59,   41,   59,  409,   44,   59,   59,
   59,   61,   59,  277, 2307, 2308,  496,  420,  282,   59,
   59,  301,   59,  426,  427,   40,  277,   41,  431,  432,
   44,  282,  485,  277,  370,    0,  516,  262,  282,  442,
  443,   91,  445,  370,   44,   59,   41,   41,  451,  529,
   41,  454,  277,  456,  457,  458,  459,  282,  461,   41,
  463,  464,  465,  466,  467,  468,  469,  470, 2361,   41,
   42,   43, 2365,   45, 2203,   47,   41,  480,  481,   44,
  483,  484,  485,  528, 2203,  528, 2203,  490,  491,  492,
  493,  494,  231,  496,   59, 2203,  499,  500,  501,  502,
  503,  504,  505, 2203, 2203,  728,  509,  510,  511,  512,
  513,  514,  515,  516, 1641,  518,  231,   41,   42,   43,
 1044,   45,  406,   47,  407,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,  232,  550,  551,  552,
  553,  554,  555,  730,  557,  558,  559,  560,    0,  562,
 1024,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  277,
  583,  584,  585,  586,  282,  588,  589,  590,  591,  592,
 1505,  594,  595,  596,  597,  598, 1207,   98,   40,   41,
   42,   43,   44,   45,   46,   47,  912, 1212,  258,   41,
   42,   43, 1503,   45,   82,   47,   58,   59,   60,   61,
   62, 1500, 1479,  273, 1177,  275,  276,  277, 1931, 1164,
  291,  281,  532, 1494,  284, 1913, 1404,  854, 1480,  276,
  277,  302,  453, 1895, 1123,  513, 1911,  297,  309,   91,
  513,   93,  313,  303, 2220,  315,  306,  830,  318, 2224,
  318, 2297,  276,  277, 1113,  325, 2223,  327, 1335, 2244,
  284,  331,  333,  331, 2207, 2326,  336, 1676,  496,  339,
   41,   42,   43, 1013,   45,  518,   47,   41,   42,   43,
  503,   45, 1180,   47,  354,  832,  354, 1724,  348,  891,
   14, 1172,   41,   42,   43,  277,   45,  367,   47,  367,
  282,  276,  277,  233,  431,  375,  735,  375,  740,  379,
 2039,  371,  487, 1396, 1058,   41,   42,   43,  388,   45,
 1359,   47, 1032,  394,  371, 2218, 1802,  944, 1398,   41,
   42,   43,  392,   45,  404,   47,  404, 2290,  398, 1990,
  756, 1883,  402,  277, 1882,  392, 2216,  371,  282,  409,
 2203,  398, 2203, 1042,  425, 1364,  587, 1611,  429,    0,
 1540,  431, 1588, 1407,   -1,   -1,   -1,  427,  392,   -1,
   -1,   -1,  432,  443,  398,  445,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,  432,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,  371,  457,   -1,   -1,
   41,  461,   -1,   44,   -1,   -1,   -1,   -1,  432,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,  392,   59,  271,
   -1,   -1,  492,  398,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,  277,   -1,   -1,   -1,  509,
  282,   -1,   -1,  513,  515,  513,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,  432,  528,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,  492,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,  572,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  560,    0,  354,  355,   -1,  357,  277,   -1,   -1,   -1,
   -1,  282,  598,  277,   -1,  367,   -1,  369,  282,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,  277,   -1,
   -1,   -1,   -1,  282,   42,   43,  388,   45,   -1,   47,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,  277,  404,   -1,   -1,   -1,  282,   -1,   -1,   58,
   59,   60,   61,   62,   -1,  277,   -1,   -1,  420,   -1,
  282,   -1,   -1,   -1,  426,  427,   41,   42,   43,  431,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,  480,  481,
   -1,  483,  484,  485,   -1,  276,  277,   -1,  490,  491,
  492,  493,  494,  284,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  371,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,  392,   -1,   -1,   -1,   -1,  264,  398,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  277,
   -1,   -1,  271,   -1,  282,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,  277,   -1,   -1,   -1,  315,  282,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  492,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,  367,   45,
  369,   47,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   41,   42,   43,   -1,   45,   -1,   47,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,  277,   -1,  404,   -1,   -1,  282,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   42,   43,   44,
   45,  420,   47,   -1,   -1,   -1,   -1,  426,  427,   41,
   42,   43,  431,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,  277,  264,  265,
   -1,   -1,  282,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,  277,  299,   -1,   -1,   -1,  282,  304,  305,
   -1,   -1,  308,   -1,   -1,  277,   -1,   -1,   -1,  315,
  282,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   42,   43,   44,   45,   -1,   47,    0,  354,  355,
  277,  357,   -1,   -1,   -1,  282,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   42,   43,   -1,   45,   -1,
   47,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,  277,   -1,  404,   -1,
   -1,  282,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   42,   43,   44,   45,  420,   47,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,  277,  583,  584,  585,
  586,  282,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,  262,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  277,  264,  265,   -1,   -1,  282,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  277,  299,   -1,   -1,   -1,
  282,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,  277,  315,   -1,  317,  318,  282,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,  277,  357,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1, 1772, 1773,   -1,
   -1,  271,   -1,   -1,   -1, 1780, 1781,  277, 1783, 1784,
   -1,   -1,  282,   -1,   -1,  285, 1791, 1792, 1793, 1794,
   -1, 1796, 1797, 1798, 1799, 1800, 1801,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,
   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,
  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,
   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,  463,  464,  465,
  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,  401,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,
   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,  463,  464,  465,  466,  467,  468,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,
  510,  511,  512,  513,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,
  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,
   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,
   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,  401,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,
   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   91,  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,
  464,  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
  401,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,
  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,
   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,  354,  355,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,
  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  388,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,  401,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  442,  443,   91,  445,   93,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,  463,  464,  465,  466,  467,
  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   91,
  445,   93,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,
  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,
   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,
   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,
  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,  401,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,  420,   -1,
   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  442,  443,   91,  445,   93,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,  463,  464,  465,  466,  467,  468,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,
  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   41,  404,   -1,   44,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   59,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,  284,
  299,   -1,  301,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,  297,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,  371,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   -1,  392,   59,   60,
   61,   62,   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,  432,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   41,  404,   -1,   44,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   59,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,  276,  277,   -1,
   -1,   -1,   -1,   -1,   -1,  284,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,  297,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,  371,   -1,   -1,  388,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,  392,   59,   60,   61,   62,   -1,  398,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,  442,
  443,   -1,  445,  432,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   41,  404,
   -1,   44,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   59,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,
   -1,   -1,   -1,  276,  277,   -1,   -1,   -1,   -1,   -1,
   -1,  284,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,  371,   -1,
   -1,  388,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,  392,
   59,   60,   61,   62,   -1,  398,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,  442,  443,   -1,  445,  432,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   41,  404,   -1,   44,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   59,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,  276,
  277,   -1,   -1,   -1,   -1,   -1,   -1,  284,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,  371,   -1,   -1,  388,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   -1,  392,   59,   60,   61,   62,
   -1,  398,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,  442,  443,   -1,  445,  432,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   -1,   -1,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,
  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,   -1,   -1,   -1,   -1,  304,  305,   -1,   -1,  308,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,  318,
   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,
  339,   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,
  369,   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,  388,
   43,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,  404,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,
   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,  442,  443,   -1,  445,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,  463,  464,  465,  466,  467,  468,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
  509,  510,  511,  512,  513,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,   -1,   -1,
   -1,  304,  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,
   -1,   -1,  315,   -1,  317,  318,   -1,   -1,  321,   -1,
   -1,   -1,  325,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,  336,  337,   -1,  339,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,  371,  372,
  373,   -1,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,  388,   43,   44,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,  404,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,  431,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
  463,  464,  465,  466,  467,  468,  469,  470,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,  492,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,  509,  510,  511,  512,
  513,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  285,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,   -1,   -1,   -1,  304,  305,   -1,
   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,  336,
  337,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,  388,   43,   44,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,   -1,  426,
  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,  463,  464,  465,  466,
  467,  468,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,  509,  510,  511,  512,  513,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,   -1,
   -1,   -1,   -1,  304,  305,   -1,   -1,  308,   -1,   -1,
   -1,   -1,   -1,   -1,  315,   -1,  317,  318,   -1,   -1,
  321,   -1,   -1,   -1,  325,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,  388,   43,   44,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,  404,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  420,
   -1,   -1,   -1,   -1,   -1,  426,  427,   -1,   -1,   -1,
  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,  463,  464,  465,  466,  467,  468,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,   -1,   -1,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,   -1,  299,   -1,   -1,   -1,   -1,  304,
  305,   -1,   -1,  308,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  317,  318,   -1,   -1,  321,   -1,   -1,   -1,
  325,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,  336,  337,   41,  339,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,
  355,   59,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,  369,   -1,  371,  372,  373,   -1,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,  401,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  420,   -1,   -1,   -1,   -1,
   -1,  426,  427,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,  463,  464,
  465,  466,  467,  468,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,  264,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,    0,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,
  318,   -1,   -1,   -1,   -1,  271,   -1,  325,   -1,  327,
   -1,  277,   -1,  331,   -1,   -1,  282,   -1,  336,  285,
   -1,  339,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,  367,
   -1,   -1,   -1,   -1,   -1,  321,   -1,  375,   -1,   -1,
   -1,  379,   -1,  329,   -1,   -1,   -1,   -1,   -1,   -1,
  388,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,  404,   -1,   -1,  355,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   60,   61,   62,
   -1,   -1,   -1,  369,   -1,  371,  372,  373,   -1,   -1,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  443,   -1,  445,   -1,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,  420,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,  492,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,  509,  510,  511,  512,  513,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,    0,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,   -1,  318,   -1,   -1,   -1,   -1,   -1,  271,  325,
   41,  327,   -1,   44,  277,  331,   -1,   -1,   -1,  282,
  336,   -1,  285,  339,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,  321,  375,
   -1,   -1,   -1,  379,   -1,   -1,  329,   -1,   -1,   -1,
   -1,   -1,  388,   -1,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,  355,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  369,   -1,  371,  372,
  373,   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  443,   -1,  445,
   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,  492,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,  509,  510,  511,  512,  513,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,  315,   -1,   -1,  318,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,  354,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  375,   -1,   -1,   -1,  379,   -1,
   40,   41,   -1,   -1,   44,   -1,   -1,  388,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   59,
   -1,   61,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  431,   91,   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,
   -1,   -1,  443,   91,  445,   -1,   -1,   -1,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,  480,
  481,   44,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,  492,  493,  494,   -1,  496,   59,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,  509,  510,
  511,  512,  513,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  258,   -1,
    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  258,   -1,    0,  273,   -1,  275,  276,  277,   -1,   -1,
   -1,  281,   -1,   -1,  284,  273,   -1,  275,  276,  277,
   -1,   -1,   -1,  281,   -1,   -1,  284,  297,   -1,   -1,
   -1,   41,   -1,  303,   44,   -1,  306,   -1,   -1,  297,
   -1,   -1,   -1,   41,   -1,  303,   44,   -1,  306,   59,
   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   -1,   61,   -1,   -1,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
   -1,   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,
  348,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  371,   -1,   -1,   -1,  291,   -1,   -1,   -1,   41,
   -1,   -1,   44,  371,   -1,   -1,  302,   -1,   -1,   -1,
   -1,   -1,  392,  309,   -1,   -1,   -1,   59,  398,   61,
   -1,   -1,  402,   -1,  392,   -1,  322,   -1,   -1,  409,
  398,   -1,  315,   -1,  402,  318,   -1,   -1,   -1,   -1,
   -1,  409,  325,   -1,  327,   -1,   -1,  427,  331,   91,
   -1,   -1,  432,  336,   -1,   -1,  339,   -1,   -1,  427,
   -1,   -1,   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  457,   -1,   -1,
   -1,  461,  378,   -1,  367,   -1,   -1,   -1,   -1,  457,
   -1,   -1,  375,  461,   -1,  378,  379,   -1,  394,   -1,
   -1,   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,  410,   43,   -1,   45,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  425,
   58,   -1,   -1,  429,   -1,   63,  432,   -1,  258,   -1,
   -1,   -1,   -1,  426,  440,   -1,   -1,   -1,  431,   -1,
  258,   -1,   -1,  273,   -1,   -1,  276,  277,   -1,  442,
  443,  281,  445,  459,  284,  273,   -1,   -1,  276,  277,
   -1,   -1,   -1,  281,   -1,  261,  284,  297,   -1,   -1,
  560,   -1,   -1,  303,   -1,   -1,  306,   -1,   -1,  297,
   -1,   -1,  560,  279,   -1,  303,   -1,   -1,  306,   -1,
   -1,  287,   -1,   -1,   -1,   -1,   -1,   -1,  294,  492,
  296,   -1,  298,   -1,   -1,   -1,  258,  303,   -1,  515,
   -1,   -1,  518,   -1,  310,   -1,  509,   -1,  348,   -1,
  513,  273,   -1,   -1,  276,  277,   -1,   -1,  324,  281,
  348,   -1,  284,   -1,   -1,  528,   -1,   -1,  334,   -1,
   -1,  371,   -1,   -1,   -1,  297,   -1,   -1,   -1,   -1,
   -1,  303,   -1,  371,  306,  561,   -1,   -1,   -1,   -1,
   -1,   -1,  392,   -1,   -1,   -1,  362,   -1,  398,   -1,
   -1,   -1,  402,   -1,  392,   -1,   -1,   -1,   -1,  409,
  398,  302,   -1,   -1,  402,   -1,   -1,   -1,  309,   -1,
   -1,  409,  313,  314,   -1,   -1,  348,  427,   -1,   -1,
  396,  322,  432,   -1,   -1,   -1,   -1,  403,   -1,  427,
  406,   -1,  333,  409,  432,   -1,   -1,   -1,   -1,  371,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  457,   -1,  267,
   -1,  461,   -1,   -1,   -1,   -1,  274,  433,   -1,  457,
  392,   -1,   -1,  461,   -1,   -1,  398,   -1,  286,  445,
  402,   -1,   -1,   -1,  292,  293,   -1,  409,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  394,   -1,  427,   -1,   -1,   -1,   -1,
  432,   -1,  320,   -1,   -1,  323,  482,   -1,   -1,  410,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  497,  498,   -1,  425,  457,   -1,   -1,  429,  461,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,  440,
   -1,   -1,  360,  519,   -1,  363,   -1,   -1,   -1,   -1,
  560,   -1,   -1,   -1,   40,   -1,   -1,   43,  459,   45,
   -1,   -1,  560,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  515,   -1,  434,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  560,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,  463,  464,  465,  466,  467,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,  289,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  371,   40,   -1,   -1,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  412,   -1,   -1,   -1,
   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  412,   -1,
   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,
  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  445,   -1,   -1,  448,  449,  450,  451,  452,  453,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,   -1,  483,
  484,  485,  486,  487,   -1,  489,  490,  491,   -1,  493,
  494,  495,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  412,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,  389,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,
   -1,   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,  517,  518,   -1,
  520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  260,
   -1,   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,
   -1,   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  260,   -1,
   -1,  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   63,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  260,   -1,   -1,
  263,   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,
   -1,   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  260,   -1,   -1,  263,
   -1,   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,   -1,
  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,   -1,  483,
  484,  485,  486,  487,   -1,  489,  490,  491,   -1,  493,
  494,  495,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  260,   -1,   -1,  263,   -1,
   -1,   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,
   -1,   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  416,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
  485,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  260,   -1,   -1,  263,   -1,   -1,
   -1,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  416,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  260,   -1,   -1,  263,   -1,   -1,   -1,
  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,   -1,
   -1,   -1,  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   -1,   -1,   63,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  260,   -1,   -1,  263,   -1,   -1,   -1,  267,
   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,    0,   -1,  286,   -1,
   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   40,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   -1,   58,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  416,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  484,  485,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,  260,  594,  595,  596,  597,
  598,  315,  267,   -1,  318,   -1,   -1,   -1,   -1,  274,
   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,
   -1,  286,  336,   -1,   -1,  339,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,  300,   -1,   -1,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  320,   -1,   -1,  323,   -1,
   -1,  375,   -1,   -1,   -1,  379,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
  404,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,  431,   -1,   -1,
   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,  443,
   63,  445,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  492,   -1,
   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,  509,  461,  462,   -1,  513,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
   -1,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  267,   -1,
   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,
   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,
   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  389,   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,
   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,
  449,  450,  451,  452,  453,  454,   -1,  456,  457,  458,
  459,   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,  481,   -1,  483,  484,  485,  486,  487,   -1,
  489,  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  286,
   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  448,  449,  450,  451,  452,  453,  454,   -1,  456,
  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,  481,   -1,  483,  484,  485,  486,
  487,   -1,  489,  490,  491,   -1,  493,  494,  495,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,   -1,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,
   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  445,   -1,   -1,  448,  449,  450,  451,  452,  453,  454,
   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,   -1,  483,  484,
  485,  486,  487,   -1,  489,  490,  491,   -1,  493,  494,
  495,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,
  525,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,
  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  317,   -1,   -1,  320,   -1,   -1,
  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,
   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,
  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,
  453,  454,   -1,  456,  457,  458,  459,   -1,  461,  462,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,  481,   -1,
  483,  484,  485,  486,  487,   -1,  489,  490,  491,   -1,
  493,  494,  495,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,  522,
   -1,  524,  525,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,
   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,
   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,
  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,
   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   -1,
   58,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,  449,  450,
  451,  452,  453,  454,   -1,  456,  457,  458,  459,   -1,
  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
  481,   -1,  483,  484,  485,  486,  487,   -1,  489,  490,
  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,
  521,  522,   -1,  524,  525,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,  260,  594,  595,  596,  597,  598,   -1,  267,
  272,   -1,   -1,  275,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  288,   -1,  286,   -1,
  292,   -1,   -1,  295,  292,  293,   -1,   -1,   -1,   -1,
   -1,   -1,  300,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,
  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,
  348,   -1,  350,  351,   -1,   -1,  354,   -1,   -1,   -1,
   -1,   -1,  360,   -1,  366,  363,  368,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  389,   58,   -1,   -1,  397,   -1,   63,   -1,   -1,
  402,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  436,   -1,  434,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  448,  449,  450,  451,  452,  453,  454,   -1,  456,  457,
  458,  459,   -1,  461,  462,   -1,   -1,   -1,   -1,  471,
  472,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,  481,   -1,  483,  488,   -1,  486,  487,
   -1,  489,  490,  491,   -1,  493,  494,  495,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,  520,  521,  522,   -1,  524,  525,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  286,   -1,   -1,   -1,   -1,   -1,  292,  293,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  348,   -1,  350,  351,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  434,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  448,  449,  450,  451,  452,  453,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,  481,   -1,  483,  484,  485,
  486,  487,   -1,  489,  490,  491,   -1,  493,  494,  495,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  267,   -1,   -1,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,  292,  293,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  348,   -1,  350,  351,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,   -1,  363,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,   -1,   -1,
  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  448,  449,  450,  451,  452,  453,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,  481,   -1,  483,
  484,  485,  486,  487,   -1,  489,  490,  491,   -1,  493,
  494,  495,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  267,   -1,   -1,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,   -1,   -1,
  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  320,   -1,
   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,  350,  351,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,  360,   -1,
   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,   58,   -1,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,  450,  451,
  452,  453,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
   -1,  483,  484,  485,  486,  487,   -1,  489,  490,  491,
   -1,  493,  494,  495,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   40,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  267,   58,   -1,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  286,   -1,   -1,   -1,
   -1,   -1,  292,  293,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  320,   -1,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,   -1,
  350,  351,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
  360,   -1,   -1,  363,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  418,   -1,
   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  448,  449,
  450,  451,  452,  453,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,   -1,  483,  484,  485,  486,  487,   -1,  489,
  490,  491,   -1,  493,  494,  495,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   40,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   40,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,  281,  588,  589,
  590,  591,  592,  445,  594,  595,  596,  597,  598,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   42,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   42,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  293,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,
   -1,  496,   -1,   44,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,   -1,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   45,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,  317,   -1,   -1,   -1,
  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   58,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,  449,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   45,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
   -1,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,
  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,
  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,
  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,
  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,
  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,  548,   -1,  550,
  551,  552,  553,  554,  555,   -1,  557,  558,  559,  560,
    0,  562,   -1,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
  581,   -1,  583,  584,  585,  586,   -1,  588,  589,  590,
  591,  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,  292,   -1,   -1,   -1,   -1,  275,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  320,   -1,   -1,   -1,  302,   -1,   -1,   -1,   -1,
   -1,   91,  309,   -1,   -1,   -1,  313,  314,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  322,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,   -1,  333,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   42,   43,   44,   45,   46,   47,  394,   -1,  418,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   61,   62,   -1,   -1,   -1,  434,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  425,  448,
  449,  450,  429,  452,  453,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,  440,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  471,  472,  473,  474,  475,  476,  477,  478,
  479,   -1,  459,  460,   -1,   -1,   -1,  486,  487,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  495,   -1,   -1,   -1,
   -1,    0,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  515,   -1,
   -1,  518,   41,   -1,    0,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,
   59,  321,   61,   -1,   -1,  325,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,  336,  337,   -1,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,   44,   45,
   46,   47,   -1,   -1,  354,  355,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,  367,   -1,  369,
   -1,  371,  372,  373,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  388,   -1,
   -1,  262,   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,  404,   -1,  277,   -1,   -1,   -1,
   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,
  420,   -1,   -1,    0,   -1,   -1,  426,   -1,   -1,   -1,
   -1,  431,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,  315,  445,   -1,  318,   -1,   -1,
  321,   -1,  272,   -1,  325,  275,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   41,  336,  337,   44,  339,   -1,
   -1,   -1,  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,
   -1,   -1,   59,  354,  355,   -1,  357,   -1,   -1,   -1,
   -1,   -1,  492,   -1,   -1,   -1,  367,   -1,  369,   -1,
  371,  372,  373,    0,  375,   -1,   -1,  378,  379,  509,
   -1,   -1,   -1,  513,   -1,  335,   -1,  388,   -1,  258,
   -1,  341,  342,  343,   -1,  345,  346,  347,  528,  349,
   -1,   -1,   -1,  404,  273,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,   -1,   41,   -1,  366,   44,  368,  420,
   -1,   -1,   -1,   -1,   -1,  426,   -1,   -1,  297,   -1,
  431,   -1,   59,   -1,  303,   -1,  262,  306,   -1,   -1,
   -1,  442,  443,   -1,  445,  271,   -1,  397,   -1,   -1,
   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  285,
   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  348,
   -1,   -1,   -1,   -1,   -1,   -1,  436,   -1,   -1,  315,
   -1,  492,  318,   -1,   -1,  321,   -1,   -1,   -1,  325,
   -1,  327,  371,  329,   -1,  331,   -1,   -1,  509,   -1,
  336,  337,  513,  339,   -1,   -1,    0,   -1,   -1,   -1,
   -1,  471,  472,   -1,   -1,   -1,   -1,  528,  354,  355,
   -1,  357,   -1,  402,   -1,   -1,    0,   -1,  488,   -1,
  409,  367,   -1,  369,   -1,  371,  372,  373,   -1,  375,
   -1,   -1,  378,  379,   -1,  262,   -1,   41,  427,   -1,
   44,   -1,  388,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   -1,   41,  404,   -1,
   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  457,   -1,
   -1,   -1,  461,   -1,  420,   59,   -1,   -1,   -1,   -1,
  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,  315,   -1,
   -1,  318,   -1,   -1,   -1,   -1,  442,  443,  325,  445,
  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,   -1,   -1,  262,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
  367,   -1,   -1,   -1,   -1,   -1,  492,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,  509,   -1,   -1,   -1,  513,  315,   -1,
   -1,  318,   -1,   -1,   -1,   -1,   41,  404,  325,   44,
  327,   -1,  528,   -1,  331,   -1,   -1,   -1,   -1,  336,
   -1,   -1,  339,   -1,   59,   -1,   -1,   -1,   -1,  426,
   -1,   -1,   -1,   -1,  431,   -1,   -1,  354,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,  445,   -1,
  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,
   -1,  378,  379,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,  262,   -1,
   -1,   -1,   -1,   -1,   -1,  492,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,  262,  426,
   -1,   -1,  509,   -1,  431,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   59,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,  528,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,   -1,   -1,
   -1,  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,
   -1,  315,  336,   -1,  318,  339,   -1,   -1,   -1,   -1,
   -1,  325,   -1,  327,   -1,  492,   -1,  331,   -1,   -1,
  354,   -1,  336,   -1,   -1,  339,   -1,   -1,   -1,   -1,
   -1,   -1,  509,  367,   -1,   -1,  513,   -1,   -1,    0,
  354,  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,
   -1,  528,   -1,  367,  388,   -1,   -1,   -1,   -1,   -1,
   -1,  375,   -1,   -1,  378,  379,   -1,  262,   -1,   -1,
  404,   -1,   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,  426,   -1,   -1,   -1,   -1,  431,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,
   -1,  445,  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,
  315,   -1,   -1,  318,   -1,   -1,   -1,   -1,  442,  443,
  325,  445,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  492,  354,
   -1,    0,   -1,   -1,   -1,  262,   -1,   -1,   -1,   -1,
   -1,   -1,  367,   -1,   -1,  509,   -1,   -1,  492,  513,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  388,  528,  509,    0,   -1,   -1,  513,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,  528,   -1,   -1,   -1,  315,   -1,
   59,  318,   -1,   -1,   -1,   -1,   -1,   -1,  325,   -1,
  327,  426,   -1,   -1,  331,   -1,  431,   41,   -1,  336,
   44,   -1,  339,   -1,   -1,   -1,  272,  442,  443,  275,
  445,   -1,   -1,   -1,    0,   59,   -1,  354,   -1,   -1,
   -1,   -1,  288,   -1,   -1,   -1,  292,   -1,   -1,  295,
  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  375,   -1,
   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  388,   -1,   -1,   -1,   41,   -1,  492,   44,   -1,
   -1,  262,   -1,   -1,   -1,   -1,   -1,  404,   -1,  335,
   -1,   -1,   -1,   59,  509,  341,  342,  343,  513,  345,
  346,  347,   -1,  349,   -1,   -1,   -1,   -1,   -1,  426,
   -1,   -1,   -1,  528,  431,   -1,   -1,   -1,   -1,   -1,
  366,   -1,  368,   -1,   -1,  442,  443,   -1,  445,   -1,
   -1,   -1,   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,
   -1,   -1,   -1,   -1,  325,   -1,  327,   -1,   -1,   -1,
  331,  397,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,
   -1,   -1,   -1,  354,   -1,  492,   -1,   -1,    0,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,   -1,   -1,   -1,
  436,   -1,  509,   -1,  375,   -1,  513,  378,  379,   -1,
   -1,   -1,   -1,  262,   -1,   -1,   -1,  388,   -1,   -1,
    0,  528,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,  404,   -1,  471,  472,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,  262,   -1,
    0,   -1,  488,   -1,   -1,  426,   -1,   -1,   -1,   -1,
  431,   41,   -1,   -1,   44,   -1,  315,   -1,   -1,  318,
   -1,  442,  443,   -1,  445,   -1,  325,   -1,  327,   59,
   -1,   -1,  331,   -1,   -1,   -1,   -1,  336,   -1,   -1,
  339,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,  315,   -1,   -1,  318,  354,  262,   -1,   -1,   59,
   -1,  325,   -1,  327,   -1,   -1,   -1,  331,  367,   -1,
   -1,  492,  336,   -1,   -1,  339,  375,   -1,   -1,  378,
  379,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  509,  388,
  354,   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,   -1,  404,   -1,  528,   -1,  315,
   -1,  375,  318,   -1,  378,  379,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,  388,  331,   -1,  426,   -1,   -1,
  336,   -1,  431,  339,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,   -1,  442,  443,    0,  445,   -1,  354,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,  426,   -1,   -1,   -1,   -1,  431,   -1,  375,
   -1,   -1,  378,  379,   -1,    0,   -1,   -1,  442,  443,
   -1,  445,  388,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,  492,   -1,   -1,   -1,   -1,  404,   -1,
  262,   -1,   -1,   -1,   59,   -1,   -1,    0,   -1,   -1,
  509,   -1,   -1,   -1,  513,   -1,   41,   -1,   -1,   44,
  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,  492,  528,
   -1,   -1,  262,   -1,   59,   -1,  442,  443,   -1,  445,
   -1,   -1,   -1,   -1,   -1,  509,   -1,   -1,   41,  513,
   -1,   44,   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,
   -1,   -1,  262,  325,  528,  327,   59,   -1,   -1,  331,
   -1,   -1,   -1,   -1,  336,   -1,   -1,  339,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  492,   -1,  318,   -1,
   -1,   -1,  354,   -1,   -1,  325,   -1,  327,   -1,   -1,
   -1,  331,   -1,  509,   -1,  367,  336,  513,   -1,  339,
   -1,   -1,   -1,  375,   -1,  315,  378,  379,  318,   -1,
   -1,   -1,  528,   -1,  354,  325,  388,  327,   -1,   -1,
   -1,  331,   -1,   -1,   -1,   -1,  336,  367,   -1,  339,
   -1,   -1,  404,   -1,   -1,  375,   -1,   -1,  378,  379,
    0,   -1,   -1,   -1,  354,   -1,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   -1,  426,   -1,   -1,  367,   -1,  431,
   -1,   -1,   -1,   -1,  404,  375,   -1,   -1,  378,  379,
  442,  443,   -1,  445,   -1,   -1,   -1,   -1,  388,   -1,
   -1,   41,   -1,   -1,   44,   -1,  426,   -1,   -1,   -1,
   -1,  431,   -1,   -1,  404,   -1,   -1,  262,   -1,   59,
   -1,   -1,  442,  443,   -1,  445,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,
  492,  431,   -1,   -1,   -1,   -1,   -1,  262,   -1,   -1,
   -1,   -1,  442,  443,    0,  445,   -1,  509,   -1,   -1,
   -1,  513,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  315,   -1,  492,  318,   -1,   -1,  528,   -1,   -1,  262,
  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,  509,
   -1,  336,   -1,  513,  339,   41,   -1,   -1,   44,   -1,
  315,   -1,  492,  318,   -1,   -1,   -1,   -1,  528,  354,
  325,   -1,  327,   59,   -1,   -1,  331,   -1,   -1,  509,
   -1,  336,  367,  513,  339,   -1,   -1,   -1,   -1,   -1,
  375,   -1,  315,  378,  379,  318,   -1,   -1,  528,  354,
   -1,   -1,  325,  388,  327,   -1,   -1,    0,  331,   -1,
   -1,   -1,  367,  336,   -1,   -1,  339,   -1,   -1,  404,
  375,   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,
   -1,  354,   -1,  388,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  426,   -1,   -1,  367,   -1,  431,   -1,   41,  404,
   -1,   44,  375,    0,   -1,  378,  379,  442,  443,   -1,
  445,   -1,   -1,   -1,   -1,  388,   59,   -1,   -1,   -1,
   -1,  426,   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,  404,  262,   -1,   -1,   -1,   -1,  442,  443,   -1,
  445,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,  426,   -1,   -1,   -1,  492,  431,   -1,
   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   -1,  445,   -1,  509,   -1,   -1,   -1,  513,   -1,
   -1,   -1,   -1,   -1,   -1,  315,   -1,  492,  318,   -1,
   -1,   -1,   -1,  528,   -1,  325,   -1,  327,   -1,   -1,
   -1,  331,   -1,   -1,  509,   -1,  336,   -1,  513,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  492,
   -1,   -1,   -1,  528,  354,    0,  262,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  509,  367,   -1,   -1,
  513,   -1,   -1,   -1,   -1,  375,   -1,   -1,  378,  379,
   -1,   -1,   -1,   -1,   -1,  528,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,  315,
   -1,   -1,  318,   -1,   59,   -1,   -1,   -1,   -1,  325,
   -1,  327,   -1,   -1,   -1,  331,  426,   -1,   -1,   -1,
  336,  431,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,  443,   -1,  445,   -1,   -1,  354,  262,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  375,
   -1,   -1,  378,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  388,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  492,   -1,   -1,  262,   -1,   -1,  404,   -1,
   -1,   -1,  315,   -1,   -1,  318,   -1,   -1,   -1,  509,
   -1,   -1,  325,  513,  327,   -1,   -1,   -1,  331,   -1,
  426,   -1,   -1,  336,   -1,  431,  339,   -1,  528,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,  443,   -1,  445,
   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,
   -1,  318,   -1,   -1,  367,   -1,   -1,   -1,  325,   -1,
  327,   -1,  375,   -1,  331,  378,  379,   -1,   -1,  336,
   -1,   -1,  339,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  492,  354,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  367,   -1,   -1,  509,   -1,   -1,   -1,  513,  375,   -1,
   -1,  378,  379,  426,   -1,   -1,   -1,   -1,  431,   -1,
   -1,  388,  528,   -1,   -1,   -1,   -1,   -1,   -1,  442,
  443,   -1,  445,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,   -1,  426,
   -1,   -1,   -1,  292,  431,   -1,  295,   -1,   -1,   -1,
  315,   -1,   -1,  318,   -1,  442,  443,   -1,  445,  492,
  325,   -1,  327,   -1,   -1,   -1,  331,   -1,   -1,   -1,
   -1,  336,   -1,   -1,  339,  298,  509,   -1,   -1,   -1,
  513,   -1,   -1,   -1,   -1,   -1,  335,  310,   -1,  354,
   -1,   -1,  341,  342,  343,  528,  345,  346,  347,   -1,
  349,   -1,  367,   -1,   -1,  492,   -1,   -1,   -1,   -1,
  375,  334,   -1,   -1,  379,   -1,   -1,  366,   -1,  368,
   -1,   -1,  509,  388,   -1,   -1,  513,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,  528,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  414,  431,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  398,   -1,   -1,  443,   -1,
  445,   -1,   -1,   -1,   -1,  408,   -1,  436,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  471,  472,   -1,   -1,   -1,  492,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,  488,
   -1,   -1,   -1,   -1,  509,   -1,  469,  470,  513,   -1,
   -1,   -1,  260,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,  528,   -1,   -1,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
  298,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,  310,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,  334,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  398,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  408,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,  270,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,   -1,   -1,   -1,   -1,   -1,  305,
   -1,   -1,   -1,  309,  310,   -1,  312,   -1,   -1,  315,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  328,   -1,   -1,   -1,   -1,   -1,  334,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  350,   -1,   -1,   -1,  354,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  362,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  389,  390,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,  408,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  423,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  433,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  442,   -1,  444,  445,
   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,  462,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
  506,  507,  508,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,  520,  521,  522,   -1,  524,  525,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,  270,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,   -1,   -1,   -1,   -1,
   -1,  305,   -1,   -1,   -1,  309,  310,   -1,  312,   -1,
   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,   -1,
  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,   -1,
  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  362,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  389,  390,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  404,   -1,   -1,   -1,  408,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  423,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  433,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  444,  445,   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,  462,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,  506,  507,  508,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,  520,  521,  522,   -1,
  524,  525,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,  270,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,   -1,   -1,
   -1,   -1,   -1,  305,   -1,   -1,   -1,  309,  310,   -1,
  312,   -1,   -1,  315,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  328,   -1,   -1,   -1,
   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  350,   -1,
   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  362,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,  390,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,  408,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  423,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  444,  445,   -1,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,  506,  507,  508,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,  520,  521,
  522,   -1,  524,  525,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  270,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
  310,   -1,  312,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,   -1,
   -1,   -1,   -1,   -1,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  350,   -1,   -1,   -1,  354,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  362,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  389,
  390,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,  462,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,  506,  507,  508,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
  520,  521,  522,   -1,  524,  525,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,  281,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  292,
   -1,   -1,  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,  342,
  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  436,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,   -1,
   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,  472,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,
  483,  484,  485,   -1,   -1,  488,   -1,  490,  491,   -1,
  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,
  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,
   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,   -1,  550,  551,  552,
  553,  554,  555,   -1,  557,  558,  559,  560,   -1,  562,
   -1,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,   -1,
  583,  584,  585,  586,   -1,  588,  589,  590,  591,  592,
   -1,  594,  595,  596,  597,  598,  272,   -1,   -1,  275,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  290,   -1,  292,   -1,   -1,  295,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
   -1,   -1,   -1,   -1,   -1,  341,  342,  343,   -1,  345,
  346,  347,   -1,  349,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  366,   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  436,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,  471,  472,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,  488,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  272,   -1,   -1,  275,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  292,   -1,   -1,  295,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,   -1,
   -1,   -1,  341,  342,  343,   -1,  345,  346,  347,   -1,
  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,  368,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  436,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,
  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  469,  470,  471,  472,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,  488,
   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,
  499,  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,
   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,  518,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
   -1,  550,  551,  552,  553,  554,  555,   -1,  557,  558,
  559,  560,   -1,  562,   -1,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,   -1,  583,  584,  585,  586,   -1,  588,
  589,  590,  591,  592,   -1,  594,  595,  596,  597,  598,
  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  292,   -1,   -1,  295,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,   -1,   -1,   -1,   -1,   -1,  341,
  342,  343,   -1,  345,  346,  347,   -1,  349,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,   -1,  368,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  414,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  284,   -1,   -1,   -1,  436,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,  471,
  472,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,  488,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
  284,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,   -1,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,  313,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,   -1,  451,   -1,   -1,  454,
   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,
  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,
   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,  504,
  505,   -1,   -1,   -1,   -1,  510,  511,  512,  325,  514,
  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,  548,   -1,  550,  551,  552,  553,  554,
  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,  581,  394,  583,  584,
  585,  586,   -1,  588,  589,  590,  591,  592,   -1,  594,
  595,  596,  597,  598,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  429,   -1,   -1,   -1,   -1,  434,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  451,   -1,   -1,  454,   -1,  456,
  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,
   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,
   -1,   -1,  499,  500,  501,  502,  503,  504,  505,   -1,
   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,
   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  339,
   -1,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,  548,  362,  550,  551,  552,  553,  554,  555,   -1,
  557,  558,  559,  560,   -1,  562,   -1,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,  581,   -1,  583,  584,  585,  586,
   -1,  588,  589,  590,  591,  592,   -1,  594,  595,  596,
  597,  598,   -1,   -1,   -1,   -1,   -1,  417,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  378,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  272,   -1,   -1,
  275,   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,  275,
   -1,   -1,   -1,  288,   -1,   -1,   -1,  292,   -1,   -1,
  295,   -1,   -1,   -1,   -1,   -1,  292,   -1,   -1,  295,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,   -1,   -1,   -1,  341,  342,  343,  335,
  345,  346,  347,   -1,  349,  341,  342,  343,   -1,  345,
  346,  347,   -1,  349,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  366,   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,
  366,   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  414,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  436,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  436,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  434,   -1,   -1,   -1,  471,  472,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  471,  472,   -1,   -1,  451,
   -1,   -1,  454,  488,  456,  457,  458,  459,   -1,  461,
   -1,   -1,  488,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  451,   -1,   -1,
  454,  455,  456,  457,  458,  459,  460,  461,  462,  463,
  464,  465,  466,  467,  468,  469,  470,  471,  472,  473,
  474,  475,   -1,   -1,  478,  479,  480,  481,  482,  483,
  484,  485,  486,  487,  488,  489,  490,  491,  492,  493,
  494,  495,  496,  497,  498,  499,  500,  501,  502,  503,
  504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
  514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
  524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,  549,  550,  551,  552,  553,
  554,  555,  556,  557,  558,  559,  560,  561,  562,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
  584,  585,  586,  587,  588,  589,  590,  591,  592,  593,
  594,  595,  596,  597,  598,  451,   -1,   -1,  454,  455,
  456,  457,  458,  459,   -1,  461,  462,  463,  464,  465,
  466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
   -1,   -1,  478,  479,  480,  481,  482,  483,  484,  485,
  486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
  496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
  506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
  516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
  556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
  586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
  596,  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,  582,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,  451,
   -1,   -1,  454,   -1,  456,  457,  458,  459,   -1,  461,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,
   -1,  483,  484,  485,   -1,   -1,   -1,   -1,  490,  491,
   -1,  493,  494,   -1,  496,   -1,   -1,  499,  500,  501,
  502,  503,  504,  505,   -1,   -1,   -1,   -1,  510,  511,
  512,   -1,  514,  515,  516,   -1,  518,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,  548,   -1,  550,  551,
  552,  553,  554,  555,   -1,  557,  558,  559,  560,   -1,
  562,   -1,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
   -1,  583,  584,  585,  586,   -1,  588,  589,  590,  591,
  592,   -1,  594,  595,  596,  597,  598,  451,   -1,   -1,
  454,   -1,  456,  457,  458,  459,   -1,  461,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  480,  481,   -1,  483,
  484,  485,   -1,   -1,   -1,   -1,  490,  491,   -1,  493,
  494,   -1,  496,   -1,   -1,  499,  500,  501,  502,  503,
  504,  505,   -1,   -1,   -1,   -1,  510,  511,  512,   -1,
  514,  515,  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,  548,   -1,  550,  551,  552,  553,
  554,  555,   -1,  557,  558,  559,  560,   -1,  562,   -1,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,  581,   -1,  583,
  584,  585,  586,   -1,  588,  589,  590,  591,  592,   -1,
  594,  595,  596,  597,  598,  451,   -1,   -1,  454,   -1,
  456,  457,  458,  459,   -1,  461,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  480,  481,   -1,  483,  484,  485,
   -1,   -1,   -1,   -1,  490,  491,   -1,  493,  494,   -1,
  496,   -1,   -1,  499,  500,  501,  502,  503,  504,  505,
   -1,   -1,   -1,   -1,  510,  511,  512,   -1,  514,  515,
  516,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,  548,   -1,  550,  551,  552,  553,  554,  555,
   -1,  557,  558,  559,  560,   -1,  562,   -1,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,  581,   -1,  583,  584,  585,
  586,   -1,  588,  589,  590,  591,  592,   -1,  594,  595,
  596,  597,  598,  451,   -1,   -1,  454,   -1,  456,  457,
  458,  459,   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  469,  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  480,  481,   -1,  483,  484,  485,   -1,   -1,
   -1,   -1,  490,  491,   -1,  493,  494,   -1,  496,   -1,
   -1,  499,  500,  501,  502,  503,  504,  505,   -1,   -1,
   -1,   -1,  510,  511,  512,   -1,  514,  515,  516,   -1,
  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
  548,   -1,  550,  551,  552,  553,  554,  555,   -1,  557,
  558,  559,  560,   -1,  562,   -1,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,  581,   -1,  583,  584,  585,  586,   -1,
  588,  589,  590,  591,  592,   -1,  594,  595,  596,  597,
  598,  451,   -1,   -1,  454,   -1,  456,  457,  458,  459,
   -1,  461,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  469,
  470,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,  481,   -1,  483,  484,  485,   -1,   -1,   -1,   -1,
  490,  491,   -1,  493,  494,   -1,  496,   -1,   -1,  499,
  500,  501,  502,  503,  504,  505,   -1,   -1,   -1,   -1,
  510,  511,  512,   -1,  514,  515,  516,   -1,  518,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,  548,   -1,
  550,  551,  552,  553,  554,  555,   -1,  557,  558,  559,
  560,   -1,  562,   -1,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,  581,   -1,  583,  584,  585,  586,   -1,  588,  589,
  590,  591,  592,   -1,  594,  595,  596,  597,  598,
};
static int yyctable[] = {                                     -1,
  782,  814,   -1,  484,  766,   -1,  485,  766,   -1,  485,
  764,   -1,  954, 1130,   -1, 1054,  700,   -1, 1060,  715,
   -1,  990, 1251,   -1,  991, 1252,   -1,  992, 1253,   -1,
 1302, 1032,   -1,  782,  809,   -1,  152,  793,   -1,
};
#define YYFINAL 22
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 598
#if YYDEBUG
static char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BEFORE","BEGIN","BETWEEN","BLOB","BY","CAST",
"CHARACTER","CHECK","COLLATE","COMMA","COMMIT","COMMITTED","COMPUTED",
"CONCATENATE","CONDITIONAL","CONSTRAINT","CONTAINING","COUNT","CREATE",
"CSTRING","CURRENT","CURSOR","DATABASE","DATE","DB_KEY","KW_DEBUG","DECIMAL",
"DECLARE","DEFAULT","KW_DELETE","DESC","DISTINCT","DO","DOMAIN","DROP","ELSE",
"END","ENTRY_POINT","EQL","ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT",
"EXTERNAL","FILTER","FOR","FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ",
"GENERATOR","GEN_ID","GRANT","GROUP","GTR","HAVING","IF","KW_IN","INACTIVE",
"INNER","INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN",
"KEY","KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LPAREN","LEFT","LEQ",
"LEVEL","LIKE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT","MERGE","MINIMUM",
"MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR","NEQ","NO","NOT","NOT_GTR",
"NOT_LSS","OF","ON","ONLY","OPTION","OR","ORDER","OUTER","OUTPUT_TYPE",
"OVERFLOW","PAGE","PAGES","KW_PAGE_SIZE","PARAMETER","PASSWORD","PLAN",
"POSITION","POST_EVENT","PRECISION","PRIMARY","PRIVILEGES","PROCEDURE",
"PROTECTED","READ","REAL","REFERENCES","RESERVING","RETAIN","RETURNING_VALUES",
"RETURNS","REVOKE","RIGHT","RPAREN","ROLLBACK","SEGMENT","SELECT","SET",
"SHADOW","KW_SHARED","SINGULAR","KW_SIZE","SMALLINT","SNAPSHOT","SOME","SORT",
"SQLCODE","STABILITY","STARTING","STATISTICS","SUB_TYPE","SUSPEND","SUM",
"TABLE","THEN","TO","TRANSACTION","TRIGGER","UNCOMMITTED","UNION","UNIQUE",
"UPDATE","USER","VALUES","VARCHAR","VARIABLE","VARYING","VERSION","VIEW","WAIT",
"WHEN","WHERE","WHILE","WITH","WORK","WRITE","FLOAT_NUMBER","NUMBER","NUMERIC",
"SYMBOL","STRING","INTRODUCER","ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT",
"ROLE","COLUMN","TYPE","EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE","SECOND",
"WEEKDAY","YEARDAY","TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME",
"CURRENT_TIMESTAMP","NUMBER64BIT","SCALEDINT","CURRENT_USER","CURRENT_ROLE",
"KW_BREAK","SUBSTRING","RECREATE","KW_DESCRIPTOR","FIRST","SKIP",
"CURRENT_CONNECTION","CURRENT_TRANSACTION","BIGINT","CASE","NULLIF","COALESCE",
"USING","NULLS","LAST","ROW_COUNT","LOCK","SAVEPOINT","RELEASE","STATEMENT",
"LEAVE","INSERTING","UPDATING","DELETING","BACKUP","KW_DIFFERENCE","OPEN",
"CLOSE","FETCH","ROWS","BLOCK","IIF","SCALAR_ARRAY","CROSS","NEXT","SEQUENCE",
"RESTART","BOTH","COLLATION","COMMENT","BIT_LENGTH","CHAR_LENGTH",
"CHARACTER_LENGTH","LEADING","KW_LOWER","OCTET_LENGTH","TRAILING","TRIM",
"RETURNING","KW_IGNORE","LIMBO","UNDO","REQUESTS","TIMEOUT","ABS","ACCENT",
"ACOS","ALWAYS","ASCII_CHAR","ASCII_VAL","ASIN","ATAN","ATAN2","BIN_AND",
"BIN_OR","BIN_SHL","BIN_SHR","BIN_XOR","CEIL","CONNECT","COS","COSH","COT",
"DATEADD","DATEDIFF","DECODE","DISCONNECT","EXP","FLOOR","GEN_UUID","GENERATED",
"GLOBAL","HASH","INSENSITIVE","LIST","LN","LOG","LOG10","LPAD","MATCHED",
"MATCHING","MAXVALUE","MILLISECOND","MINVALUE","MOD","OVERLAY","PAD","PI",
"PLACING","POWER","PRESERVE","RAND","RECURSIVE","REPLACE","REVERSE","ROUND",
"RPAD","SENSITIVE","SIGN","SIN","SINH","SPACE","SQRT","START","TAN","TANH",
"TEMPORARY","TRUNC","WEEK",
};
static char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob_io",
"statement : comment",
"statement : commit",
"statement : create",
"statement : create_or_alter",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : merge",
"statement : exec_procedure",
"statement : exec_block",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : savepoint",
"statement : select",
"statement : set",
"statement : update",
"statement : update_or_insert",
"statement : KW_DEBUG signed_short_integer",
"grant : GRANT privileges ON table_noise simple_table_name TO non_role_grantee_list grant_option",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO non_role_grantee_list grant_option",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option",
"table_noise : TABLE",
"table_noise :",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : KW_DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON table_noise simple_table_name FROM non_role_grantee_list",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM non_role_grantee_list",
"revoke : REVOKE rev_admin_option role_name_list FROM role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"rev_grant_option :",
"rev_admin_option : ADMIN OPTION FOR",
"rev_admin_option :",
"non_role_grantee_list : grantee_list",
"non_role_grantee_list : user_grantee_list",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type param_mechanism",
"param_mechanism :",
"param_mechanism : BY KW_DESCRIPTOR",
"param_mechanism : BY SCALAR_ARRAY",
"param_mechanism : KW_NULL",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type return_mechanism",
"return_value : PARAMETER pos_short_integer",
"return_mechanism :",
"return_mechanism : BY KW_VALUE",
"return_mechanism : BY KW_DESCRIPTOR",
"return_mechanism : FREE_IT",
"return_mechanism : BY KW_DESCRIPTOR FREE_IT",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_filter_subtype OUTPUT_TYPE blob_filter_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"blob_filter_subtype : symbol_blob_subtype_name",
"blob_filter_subtype : signed_short_integer",
"create : CREATE create_clause",
"create_clause : EXCEPTION exception_clause",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : GLOBAL TEMPORARY TABLE gtt_table_clause",
"create_clause : TRIGGER trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : SEQUENCE generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"create_clause : COLLATION collation_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"recreate_clause : GLOBAL TEMPORARY TABLE gtt_recreate_clause",
"recreate_clause : VIEW rview_clause",
"recreate_clause : TRIGGER rtrigger_clause",
"recreate_clause : EXCEPTION rexception_clause",
"create_or_alter : CREATE OR ALTER replace_clause",
"replace_clause : PROCEDURE replace_procedure_clause",
"replace_clause : TRIGGER replace_trigger_clause",
"replace_clause : EXCEPTION replace_exception_clause",
"exception_clause : symbol_exception_name sql_string",
"rexception_clause : symbol_exception_name sql_string",
"replace_exception_clause : symbol_exception_name sql_string",
"alter_exception_clause : symbol_exception_name sql_string",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type begin_trigger domain_default_opt end_default_opt domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default : DEFAULT begin_trigger default_value",
"domain_default_opt : domain_default",
"domain_default_opt :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_clause :",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : check_constraint",
"null_constraint : NOT KW_NULL",
"check_constraint : CHECK begin_trigger '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"collation_clause : symbol_collation_name FOR symbol_character_set_name collation_sequence_definition collation_attribute_list_opt collation_specific_attribute_opt",
"collation_sequence_definition : FROM symbol_collation_name",
"collation_sequence_definition : FROM EXTERNAL '(' sql_string ')'",
"collation_sequence_definition :",
"collation_attribute_list_opt :",
"collation_attribute_list_opt : collation_attribute_list",
"collation_attribute_list : collation_attribute",
"collation_attribute_list : collation_attribute_list collation_attribute",
"collation_attribute : collation_pad_attribute",
"collation_attribute : collation_case_attribute",
"collation_attribute : collation_accent_attribute",
"collation_pad_attribute : NO PAD",
"collation_pad_attribute : PAD SPACE",
"collation_case_attribute : CASE SENSITIVE",
"collation_case_attribute : CASE INSENSITIVE",
"collation_accent_attribute : ACCENT SENSITIVE",
"collation_accent_attribute : ACCENT INSENSITIVE",
"collation_specific_attribute_opt :",
"collation_specific_attribute_opt : sql_string",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : KW_PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_rem_option : KW_DIFFERENCE KW_FILE sql_string",
"db_file : file1 sql_string file_desc1",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"gtt_table_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_recreate_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_scope : ON COMMIT PRESERVE ROWS",
"gtt_scope : ON COMMIT KW_DELETE ROWS",
"gtt_scope :",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain domain_default_opt end_default_opt column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_clause '(' begin_trigger value end_trigger ')'",
"computed_clause : computed_by",
"computed_clause : GENERATED ALWAYS AS",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type begin_trigger",
"data_type_or_domain : simple_column_name begin_string",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"data_type_descriptor : TYPE OF column_def_name",
"data_type_descriptor : column_def_name",
"init_data_type :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : internal_info",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : null_constraint",
"column_constraint : check_constraint",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"column_constraint : UNIQUE constraint_index_opt",
"column_constraint : PRIMARY KEY constraint_index_opt",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens constraint_index_opt",
"primary_constraint : PRIMARY KEY column_parens constraint_index_opt",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"constraint_index_opt : USING order_direction INDEX symbol_index_name",
"constraint_index_opt :",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON KW_DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"replace_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"input_parameters : '(' input_proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS '(' output_proc_parameters ')'",
"output_parameters :",
"input_proc_parameters : input_proc_parameter",
"input_proc_parameters : input_proc_parameters ',' input_proc_parameter",
"input_proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause begin_trigger default_par_opt end_default_opt",
"output_proc_parameters : proc_parameter",
"output_proc_parameters : output_proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause",
"default_par_opt : DEFAULT begin_trigger default_value",
"default_par_opt : '=' begin_trigger default_value",
"default_par_opt :",
"local_declaration_list : local_declarations",
"local_declaration_list :",
"local_declarations : local_declaration",
"local_declarations : local_declarations local_declaration",
"local_declaration : stmt_start_line stmt_start_column DECLARE var_decl_opt local_declaration_item ';'",
"local_declaration_item : var_declaration_item",
"local_declaration_item : cursor_declaration_item",
"var_declaration_item : column_def_name domain_or_non_array_type collate_clause var_init_opt",
"var_decl_opt : VARIABLE",
"var_decl_opt :",
"var_init_opt : DEFAULT default_value",
"var_init_opt : '=' default_value",
"var_init_opt :",
"cursor_declaration_item : symbol_cursor_name CURSOR FOR '(' select ')'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : stmt_start_line stmt_start_column BEGIN full_proc_block_body END",
"full_proc_block_body : proc_statements",
"full_proc_block_body : proc_statements excp_hndl_statements",
"full_proc_block_body :",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : stmt_start_line stmt_start_column simple_proc_statement ';'",
"proc_statement : stmt_start_line stmt_start_column complex_proc_statement",
"stmt_start_line :",
"stmt_start_column :",
"simple_proc_statement : assignment",
"simple_proc_statement : insert",
"simple_proc_statement : merge",
"simple_proc_statement : update",
"simple_proc_statement : update_or_insert",
"simple_proc_statement : delete",
"simple_proc_statement : singleton_select",
"simple_proc_statement : exec_procedure",
"simple_proc_statement : exec_sql",
"simple_proc_statement : exec_into",
"simple_proc_statement : exec_function",
"simple_proc_statement : excp_statement",
"simple_proc_statement : raise_statement",
"simple_proc_statement : post_event",
"simple_proc_statement : cursor_statement",
"simple_proc_statement : breakleave",
"simple_proc_statement : SUSPEND",
"simple_proc_statement : EXIT",
"complex_proc_statement : if_then_else",
"complex_proc_statement : while",
"complex_proc_statement : for_select",
"complex_proc_statement : for_exec_into",
"excp_statement : EXCEPTION symbol_exception_name",
"excp_statement : EXCEPTION symbol_exception_name value",
"raise_statement : EXCEPTION",
"exec_sql : EXECUTE STATEMENT value",
"for_select : label_opt FOR select INTO variable_list cursor_def DO proc_block",
"for_exec_into : label_opt FOR EXECUTE STATEMENT value INTO variable_list DO proc_block",
"exec_into : EXECUTE STATEMENT value INTO variable_list",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"post_event : POST_EVENT value event_argument_opt",
"event_argument_opt :",
"singleton_select : select INTO variable_list",
"variable : ':' symbol_variable_name",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : label_opt WHILE '(' search_condition ')' DO proc_block",
"label_opt : symbol_label_name ':'",
"label_opt :",
"breakleave : KW_BREAK",
"breakleave : LEAVE",
"breakleave : LEAVE symbol_label_name",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_hndl_statements : excp_hndl_statement",
"excp_hndl_statements : excp_hndl_statements excp_hndl_statement",
"excp_hndl_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"cursor_statement : open_cursor",
"cursor_statement : fetch_cursor",
"cursor_statement : close_cursor",
"open_cursor : OPEN symbol_cursor_name",
"close_cursor : CLOSE symbol_cursor_name",
"fetch_cursor : FETCH fetch_opt symbol_cursor_name INTO variable_list",
"fetch_opt :",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs_opt",
"proc_inputs : value_list",
"proc_inputs : '(' value_list ')'",
"proc_inputs :",
"proc_outputs_opt : RETURNING_VALUES variable_list",
"proc_outputs_opt : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs_opt :",
"exec_block : EXECUTE BLOCK block_input_params output_parameters AS local_declaration_list full_proc_block",
"block_input_params : '(' block_parameters ')'",
"block_input_params :",
"block_parameters : block_parameter",
"block_parameters : block_parameters ',' block_parameter",
"block_parameter : proc_parameter '=' parameter",
"view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"rview_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"begin_string :",
"begin_trigger :",
"end_trigger :",
"end_default_opt :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : trigger_type_prefix trigger_type_suffix",
"trigger_type : ON trigger_db_type",
"trigger_db_type : CONNECT",
"trigger_db_type : DISCONNECT",
"trigger_db_type : TRANSACTION START",
"trigger_db_type : TRANSACTION COMMIT",
"trigger_db_type : TRANSACTION ROLLBACK",
"trigger_type_prefix : BEFORE",
"trigger_type_prefix : AFTER",
"trigger_type_suffix : INSERT",
"trigger_type_suffix : UPDATE",
"trigger_type_suffix : KW_DELETE",
"trigger_type_suffix : INSERT OR UPDATE",
"trigger_type_suffix : INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR INSERT",
"trigger_type_suffix : UPDATE OR KW_DELETE",
"trigger_type_suffix : KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR UPDATE",
"trigger_type_suffix : INSERT OR UPDATE OR KW_DELETE",
"trigger_type_suffix : INSERT OR KW_DELETE OR UPDATE",
"trigger_type_suffix : UPDATE OR INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR INSERT OR UPDATE",
"trigger_type_suffix : KW_DELETE OR UPDATE OR INSERT",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger local_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION alter_exception_clause",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"alter_clause : SEQUENCE alter_sequence_clause",
"alter_clause : EXTERNAL FUNCTION alter_udf_clause",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET domain_default end_trigger",
"alter_domain_op : ADD CONSTRAINT check_constraint",
"alter_domain_op : ADD check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name TYPE alter_data_type_or_domain",
"alter_op : col_opt alter_col_name SET domain_default end_trigger",
"alter_op : col_opt alter_col_name DROP DEFAULT",
"alter_column_name : keyword_or_column",
"keyword_or_column : valid_symbol_name",
"keyword_or_column : ADMIN",
"keyword_or_column : COLUMN",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : RECREATE",
"keyword_or_column : CURRENT_CONNECTION",
"keyword_or_column : CURRENT_TRANSACTION",
"keyword_or_column : BIGINT",
"keyword_or_column : CASE",
"keyword_or_column : RELEASE",
"keyword_or_column : ROW_COUNT",
"keyword_or_column : SAVEPOINT",
"keyword_or_column : OPEN",
"keyword_or_column : CLOSE",
"keyword_or_column : FETCH",
"keyword_or_column : ROWS",
"keyword_or_column : USING",
"keyword_or_column : CROSS",
"keyword_or_column : BIT_LENGTH",
"keyword_or_column : BOTH",
"keyword_or_column : CHAR_LENGTH",
"keyword_or_column : CHARACTER_LENGTH",
"keyword_or_column : COMMENT",
"keyword_or_column : LEADING",
"keyword_or_column : KW_LOWER",
"keyword_or_column : OCTET_LENGTH",
"keyword_or_column : TRAILING",
"keyword_or_column : TRIM",
"keyword_or_column : CONNECT",
"keyword_or_column : DISCONNECT",
"keyword_or_column : GLOBAL",
"keyword_or_column : INSENSITIVE",
"keyword_or_column : RECURSIVE",
"keyword_or_column : SENSITIVE",
"keyword_or_column : START",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type",
"alter_data_type_or_domain : simple_column_name",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"alter_sequence_clause : symbol_generator_name RESTART WITH signed_long_integer",
"alter_sequence_clause : symbol_generator_name RESTART WITH NUMBER64BIT",
"alter_sequence_clause : symbol_generator_name RESTART WITH '-' NUMBER64BIT",
"alter_udf_clause : symbol_UDF_name entry_op module_op",
"entry_op : ENTRY_POINT sql_string",
"entry_op :",
"module_op : MODULE_NAME sql_string",
"module_op :",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : ADD KW_DIFFERENCE KW_FILE sql_string",
"db_alter_clause : DROP KW_DIFFERENCE KW_FILE",
"db_alter_clause : BEGIN BACKUP",
"db_alter_clause : END BACKUP",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"drop_clause : SEQUENCE symbol_generator_name",
"drop_clause : COLLATION symbol_collation_name",
"data_type : non_array_type",
"data_type : array_type",
"domain_or_non_array_type : domain_or_non_array_type_name",
"domain_or_non_array_type : domain_or_non_array_type_name NOT KW_NULL",
"domain_or_non_array_type_name : non_array_type",
"domain_or_non_array_type_name : domain_type",
"domain_type : TYPE OF symbol_column_name",
"domain_type : symbol_column_name",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : BIGINT",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT KW_SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"savepoint : set_savepoint",
"savepoint : release_savepoint",
"savepoint : undo_savepoint",
"set_savepoint : SAVEPOINT symbol_savepoint_name",
"release_savepoint : RELEASE SAVEPOINT symbol_savepoint_name release_only_opt",
"release_only_opt : ONLY",
"release_only_opt :",
"undo_savepoint : ROLLBACK optional_work TO optional_savepoint symbol_savepoint_name",
"optional_savepoint : SAVEPOINT",
"optional_savepoint :",
"commit : COMMIT optional_work optional_retain",
"rollback : ROLLBACK optional_work optional_retain",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tra_misc_options",
"tran_opt : tra_timeout",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tra_misc_options : NO AUTO UNDO",
"tra_misc_options : KW_IGNORE LIMBO",
"tra_misc_options : RESTART REQUESTS",
"tra_timeout : LOCK TIMEOUT nonneg_short_integer",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : KW_SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"comment : COMMENT ON ddl_type0 IS ddl_desc",
"comment : COMMENT ON ddl_type1 symbol_ddl_name IS ddl_desc",
"comment : COMMENT ON ddl_type2 symbol_ddl_name ddl_subname IS ddl_desc",
"ddl_type0 : DATABASE",
"ddl_type1 : DOMAIN",
"ddl_type1 : TABLE",
"ddl_type1 : VIEW",
"ddl_type1 : PROCEDURE",
"ddl_type1 : TRIGGER",
"ddl_type1 : EXTERNAL FUNCTION",
"ddl_type1 : FILTER",
"ddl_type1 : EXCEPTION",
"ddl_type1 : GENERATOR",
"ddl_type1 : SEQUENCE",
"ddl_type1 : INDEX",
"ddl_type1 : ROLE",
"ddl_type1 : CHARACTER SET",
"ddl_type1 : COLLATION",
"ddl_type2 : COLUMN",
"ddl_type2 : PARAMETER",
"ddl_subname : '.' symbol_ddl_name",
"ddl_desc : sql_string",
"ddl_desc : KW_NULL",
"select : select_expr for_update_clause lock_clause",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"lock_clause : WITH LOCK",
"lock_clause :",
"select_expr : with_clause select_expr_body order_clause rows_clause",
"with_clause : WITH RECURSIVE with_list",
"with_clause : WITH with_list",
"with_clause :",
"with_list : with_item",
"with_list : with_item ',' with_list",
"with_item : symbol_table_alias_name derived_column_list AS '(' select_expr ')'",
"column_select : with_clause select_expr_body order_clause rows_clause",
"column_singleton : with_clause select_expr_body order_clause rows_clause",
"select_expr_body : query_term",
"select_expr_body : select_expr_body UNION distinct_noise query_term",
"select_expr_body : select_expr_body UNION ALL query_term",
"query_term : query_spec",
"query_spec : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : value",
"select_item : value as_noise symbol_item_alias_name",
"as_noise : AS",
"as_noise :",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_primary",
"table_primary : table_proc",
"table_primary : derived_table",
"table_primary : '(' joined_table ')'",
"derived_table : '(' select_expr ')' as_noise correlation_name derived_column_list",
"correlation_name : symbol_table_alias_name",
"correlation_name :",
"derived_column_list : '(' alias_list ')'",
"derived_column_list :",
"alias_list : symbol_item_alias_name",
"alias_list : alias_list ',' symbol_item_alias_name",
"joined_table : cross_join",
"joined_table : natural_join",
"joined_table : qualified_join",
"cross_join : table_reference CROSS JOIN table_primary",
"natural_join : table_reference NATURAL join_type JOIN table_primary",
"qualified_join : table_reference join_type JOIN table_reference join_specification",
"join_specification : join_condition",
"join_specification : named_columns_join",
"join_condition : ON search_condition",
"named_columns_join : USING '(' column_list ')'",
"table_proc : symbol_procedure_name table_proc_inputs as_noise symbol_table_alias_name",
"table_proc : symbol_procedure_name table_proc_inputs",
"table_proc_inputs : '(' value_list ')'",
"table_proc_inputs :",
"table_name : simple_table_name",
"table_name : symbol_table_name as_noise symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT outer_noise",
"join_type : RIGHT outer_noise",
"join_type : FULL outer_noise",
"join_type :",
"outer_noise : OUTER",
"outer_noise :",
"group_clause : GROUP BY group_by_list",
"group_clause :",
"group_by_list : group_by_item",
"group_by_list : group_by_list ',' group_by_item",
"group_by_item : value",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name extra_indices_opt",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"extra_indices_opt : INDEX '(' index_list ')'",
"extra_indices_opt :",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : value order_direction nulls_clause",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"nulls_clause : NULLS nulls_placement",
"nulls_clause :",
"nulls_placement : FIRST",
"nulls_placement : LAST",
"rows_clause : ROWS value",
"rows_clause : ROWS value TO value",
"rows_clause :",
"insert : INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' returning_clause",
"insert : INSERT INTO simple_table_name ins_column_parens_opt select_expr returning_clause",
"insert : INSERT INTO simple_table_name DEFAULT VALUES returning_clause",
"merge : MERGE INTO table_name USING table_reference ON search_condition merge_when_clause",
"merge_when_clause : merge_when_matched_clause merge_when_not_matched_clause",
"merge_when_clause : merge_when_not_matched_clause merge_when_matched_clause",
"merge_when_clause : merge_when_matched_clause",
"merge_when_clause : merge_when_not_matched_clause",
"merge_when_matched_clause : WHEN MATCHED THEN merge_update_specification",
"merge_when_not_matched_clause : WHEN NOT MATCHED THEN merge_insert_specification",
"merge_update_specification : UPDATE SET assignments",
"merge_insert_specification : INSERT ins_column_parens_opt VALUES '(' value_list ')'",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : KW_DELETE FROM table_name where_clause plan_clause order_clause rows_clause returning_clause",
"delete_positioned : KW_DELETE FROM table_name cursor_clause",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause plan_clause order_clause rows_clause returning_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"update_or_insert : UPDATE OR INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' update_or_insert_matching_opt returning_clause",
"update_or_insert_matching_opt : MATCHING ins_column_parens",
"update_or_insert_matching_opt :",
"returning_clause : RETURNING value_list",
"returning_clause : RETURNING value_list INTO variable_list",
"returning_clause :",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' value",
"exec_function : udf",
"exec_function : non_aggregate_function",
"blob_io : READ BLOB simple_column_name FROM simple_table_name filter_clause_io segment_clause_io",
"blob_io : INSERT BLOB simple_column_name INTO simple_table_name filter_clause_io segment_clause_io",
"filter_clause_io : FILTER FROM blob_subtype_value_io TO blob_subtype_value_io",
"filter_clause_io : FILTER TO blob_subtype_value_io",
"filter_clause_io :",
"blob_subtype_value_io : blob_subtype_io",
"blob_subtype_value_io : parameter",
"blob_subtype_io : signed_short_integer",
"segment_clause_io : MAX_SEGMENT segment_length_io",
"segment_clause_io :",
"segment_length_io : unsigned_short_integer",
"segment_length_io : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"ins_column_parens_opt : ins_column_parens",
"ins_column_parens_opt :",
"ins_column_parens : '(' ins_column_list ')'",
"ins_column_list : update_column_name",
"ins_column_list : ins_column_list ',' update_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : distinct_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : starting_predicate",
"predicate : singular_predicate",
"predicate : trigger_action_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"distinct_predicate : value IS DISTINCT FROM value",
"distinct_predicate : value IS NOT DISTINCT FROM value",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value KW_IN in_predicate_value",
"in_predicate : value NOT KW_IN in_predicate_value",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"singular_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"trigger_action_predicate : INSERTING",
"trigger_action_predicate : UPDATING",
"trigger_action_predicate : DELETING",
"in_predicate_value : table_subquery",
"in_predicate_value : '(' value_list ')'",
"table_subquery : '(' column_select ')'",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : cast_specification",
"value : case_expression",
"value : next_value_expression",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : internal_info",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"value : null_value",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME sec_precision_opt",
"datetime_value_expression : CURRENT_TIMESTAMP sec_precision_opt",
"sec_precision_opt : '(' nonneg_short_integer ')'",
"sec_precision_opt :",
"array_element : column_name '[' value_list ']'",
"value_list_opt : value_list",
"value_list_opt :",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT_NUMBER",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"internal_info : CURRENT_CONNECTION",
"internal_info : CURRENT_TRANSACTION",
"internal_info : GDSCODE",
"internal_info : SQLCODE",
"internal_info : ROW_COUNT",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : aggregate_function",
"function : non_aggregate_function",
"non_aggregate_function : numeric_value_function",
"non_aggregate_function : string_value_function",
"non_aggregate_function : system_function_expression",
"aggregate_function : COUNT '(' '*' ')'",
"aggregate_function : COUNT '(' all_noise value ')'",
"aggregate_function : COUNT '(' DISTINCT value ')'",
"aggregate_function : SUM '(' all_noise value ')'",
"aggregate_function : SUM '(' DISTINCT value ')'",
"aggregate_function : AVG '(' all_noise value ')'",
"aggregate_function : AVG '(' DISTINCT value ')'",
"aggregate_function : MINIMUM '(' all_noise value ')'",
"aggregate_function : MINIMUM '(' DISTINCT value ')'",
"aggregate_function : MAXIMUM '(' all_noise value ')'",
"aggregate_function : MAXIMUM '(' DISTINCT value ')'",
"aggregate_function : LIST '(' all_noise value delimiter_opt ')'",
"aggregate_function : LIST '(' DISTINCT value delimiter_opt ')'",
"delimiter_opt : ',' delimiter_value",
"delimiter_opt :",
"delimiter_value : sql_string",
"delimiter_value : parameter",
"delimiter_value : variable",
"numeric_value_function : extract_expression",
"numeric_value_function : length_expression",
"extract_expression : EXTRACT '(' timestamp_part FROM value ')'",
"length_expression : bit_length_expression",
"length_expression : char_length_expression",
"length_expression : octet_length_expression",
"bit_length_expression : BIT_LENGTH '(' value ')'",
"char_length_expression : CHAR_LENGTH '(' value ')'",
"char_length_expression : CHARACTER_LENGTH '(' value ')'",
"octet_length_expression : OCTET_LENGTH '(' value ')'",
"system_function_expression : system_function_std_syntax '(' value_list_opt ')'",
"system_function_expression : system_function_special_syntax",
"system_function_std_syntax : ABS",
"system_function_std_syntax : ACOS",
"system_function_std_syntax : ASCII_CHAR",
"system_function_std_syntax : ASCII_VAL",
"system_function_std_syntax : ASIN",
"system_function_std_syntax : ATAN",
"system_function_std_syntax : ATAN2",
"system_function_std_syntax : BIN_AND",
"system_function_std_syntax : BIN_OR",
"system_function_std_syntax : BIN_SHL",
"system_function_std_syntax : BIN_SHR",
"system_function_std_syntax : BIN_XOR",
"system_function_std_syntax : CEIL",
"system_function_std_syntax : COS",
"system_function_std_syntax : COSH",
"system_function_std_syntax : COT",
"system_function_std_syntax : EXP",
"system_function_std_syntax : FLOOR",
"system_function_std_syntax : GEN_UUID",
"system_function_std_syntax : HASH",
"system_function_std_syntax : LEFT",
"system_function_std_syntax : LN",
"system_function_std_syntax : LOG",
"system_function_std_syntax : LOG10",
"system_function_std_syntax : LPAD",
"system_function_std_syntax : MAXVALUE",
"system_function_std_syntax : MINVALUE",
"system_function_std_syntax : MOD",
"system_function_std_syntax : PI",
"system_function_std_syntax : POSITION",
"system_function_std_syntax : POWER",
"system_function_std_syntax : RAND",
"system_function_std_syntax : REPLACE",
"system_function_std_syntax : REVERSE",
"system_function_std_syntax : RIGHT",
"system_function_std_syntax : ROUND",
"system_function_std_syntax : RPAD",
"system_function_std_syntax : SIGN",
"system_function_std_syntax : SIN",
"system_function_std_syntax : SINH",
"system_function_std_syntax : SQRT",
"system_function_std_syntax : TAN",
"system_function_std_syntax : TANH",
"system_function_std_syntax : TRUNC",
"system_function_special_syntax : DATEADD '(' value timestamp_part TO value ')'",
"system_function_special_syntax : DATEADD '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part FROM value TO value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value FOR value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value ')'",
"system_function_special_syntax : POSITION '(' value KW_IN value ')'",
"string_value_function : substring_function",
"string_value_function : trim_function",
"string_value_function : KW_UPPER '(' value ')'",
"string_value_function : KW_LOWER '(' value ')'",
"substring_function : SUBSTRING '(' value FROM value string_length_opt ')'",
"string_length_opt : FOR value",
"string_length_opt :",
"trim_function : TRIM '(' trim_specification value FROM value ')'",
"trim_function : TRIM '(' value FROM value ')'",
"trim_function : TRIM '(' trim_specification FROM value ')'",
"trim_function : TRIM '(' value ')'",
"trim_specification : BOTH",
"trim_specification : TRAILING",
"trim_specification : LEADING",
"udf : symbol_UDF_name '(' value_list ')'",
"udf : symbol_UDF_name '(' ')'",
"cast_specification : CAST '(' value AS data_type_descriptor ')'",
"case_expression : case_abbreviation",
"case_expression : case_specification",
"case_abbreviation : NULLIF '(' value ',' value ')'",
"case_abbreviation : IIF '(' search_condition ',' value ',' value ')'",
"case_abbreviation : COALESCE '(' value ',' value_list ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ',' value ')'",
"case_specification : simple_case",
"case_specification : searched_case",
"simple_case : CASE case_operand simple_when_clause END",
"simple_case : CASE case_operand simple_when_clause ELSE case_result END",
"simple_when_clause : WHEN when_operand THEN case_result",
"simple_when_clause : simple_when_clause WHEN when_operand THEN case_result",
"searched_case : CASE searched_when_clause END",
"searched_case : CASE searched_when_clause ELSE case_result END",
"searched_when_clause : WHEN search_condition THEN case_result",
"searched_when_clause : searched_when_clause WHEN search_condition THEN case_result",
"when_operand : value",
"case_operand : value",
"case_result : value",
"decode_pairs : value ',' value",
"decode_pairs : decode_pairs ',' value ',' value",
"next_value_expression : NEXT KW_VALUE FOR symbol_generator_name",
"next_value_expression : GEN_ID '(' symbol_generator_name ',' value ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : MILLISECOND",
"timestamp_part : WEEK",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"distinct_noise : DISTINCT",
"distinct_noise :",
"null_value : KW_NULL",
"symbol_UDF_name : SYMBOL",
"symbol_blob_subtype_name : valid_symbol_name",
"symbol_character_set_name : valid_symbol_name",
"symbol_collation_name : valid_symbol_name",
"symbol_column_name : valid_symbol_name",
"symbol_constraint_name : valid_symbol_name",
"symbol_cursor_name : valid_symbol_name",
"symbol_domain_name : valid_symbol_name",
"symbol_exception_name : valid_symbol_name",
"symbol_filter_name : valid_symbol_name",
"symbol_gdscode_name : valid_symbol_name",
"symbol_generator_name : valid_symbol_name",
"symbol_index_name : valid_symbol_name",
"symbol_item_alias_name : valid_symbol_name",
"symbol_label_name : valid_symbol_name",
"symbol_ddl_name : valid_symbol_name",
"symbol_procedure_name : valid_symbol_name",
"symbol_role_name : valid_symbol_name",
"symbol_table_alias_name : valid_symbol_name",
"symbol_table_name : valid_symbol_name",
"symbol_trigger_name : valid_symbol_name",
"symbol_user_name : valid_symbol_name",
"symbol_variable_name : valid_symbol_name",
"symbol_view_name : valid_symbol_name",
"symbol_savepoint_name : valid_symbol_name",
"valid_symbol_name : SYMBOL",
"valid_symbol_name : non_reserved_word",
"non_reserved_word : ACTION",
"non_reserved_word : CASCADE",
"non_reserved_word : FREE_IT",
"non_reserved_word : RESTRICT",
"non_reserved_word : ROLE",
"non_reserved_word : TYPE",
"non_reserved_word : KW_BREAK",
"non_reserved_word : KW_DESCRIPTOR",
"non_reserved_word : SUBSTRING",
"non_reserved_word : COALESCE",
"non_reserved_word : LAST",
"non_reserved_word : LEAVE",
"non_reserved_word : LOCK",
"non_reserved_word : NULLIF",
"non_reserved_word : NULLS",
"non_reserved_word : STATEMENT",
"non_reserved_word : INSERTING",
"non_reserved_word : UPDATING",
"non_reserved_word : DELETING",
"non_reserved_word : FIRST",
"non_reserved_word : SKIP",
"non_reserved_word : BLOCK",
"non_reserved_word : BACKUP",
"non_reserved_word : KW_DIFFERENCE",
"non_reserved_word : IIF",
"non_reserved_word : SCALAR_ARRAY",
"non_reserved_word : WEEKDAY",
"non_reserved_word : YEARDAY",
"non_reserved_word : SEQUENCE",
"non_reserved_word : NEXT",
"non_reserved_word : RESTART",
"non_reserved_word : COLLATION",
"non_reserved_word : RETURNING",
"non_reserved_word : KW_IGNORE",
"non_reserved_word : LIMBO",
"non_reserved_word : UNDO",
"non_reserved_word : REQUESTS",
"non_reserved_word : TIMEOUT",
"non_reserved_word : ABS",
"non_reserved_word : ACCENT",
"non_reserved_word : ACOS",
"non_reserved_word : ALWAYS",
"non_reserved_word : ASCII_CHAR",
"non_reserved_word : ASCII_VAL",
"non_reserved_word : ASIN",
"non_reserved_word : ATAN",
"non_reserved_word : ATAN2",
"non_reserved_word : BIN_AND",
"non_reserved_word : BIN_OR",
"non_reserved_word : BIN_SHL",
"non_reserved_word : BIN_SHR",
"non_reserved_word : BIN_XOR",
"non_reserved_word : CEIL",
"non_reserved_word : COS",
"non_reserved_word : COSH",
"non_reserved_word : COT",
"non_reserved_word : DATEADD",
"non_reserved_word : DATEDIFF",
"non_reserved_word : DECODE",
"non_reserved_word : EXP",
"non_reserved_word : FLOOR",
"non_reserved_word : GEN_UUID",
"non_reserved_word : GENERATED",
"non_reserved_word : HASH",
"non_reserved_word : LIST",
"non_reserved_word : LN",
"non_reserved_word : LOG",
"non_reserved_word : LOG10",
"non_reserved_word : LPAD",
"non_reserved_word : MATCHED",
"non_reserved_word : MATCHING",
"non_reserved_word : MAXVALUE",
"non_reserved_word : MILLISECOND",
"non_reserved_word : MINVALUE",
"non_reserved_word : MOD",
"non_reserved_word : OVERLAY",
"non_reserved_word : PAD",
"non_reserved_word : PI",
"non_reserved_word : PLACING",
"non_reserved_word : POWER",
"non_reserved_word : PRESERVE",
"non_reserved_word : RAND",
"non_reserved_word : REPLACE",
"non_reserved_word : REVERSE",
"non_reserved_word : ROUND",
"non_reserved_word : RPAD",
"non_reserved_word : SIGN",
"non_reserved_word : SIN",
"non_reserved_word : SINH",
"non_reserved_word : SPACE",
"non_reserved_word : SQRT",
"non_reserved_word : TAN",
"non_reserved_word : TANH",
"non_reserved_word : TEMPORARY",
"non_reserved_word : TRUNC",
"non_reserved_word : WEEK",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif

//
// YYPOSN is user-defined text position type.
//
#ifndef YYPOSN
#define YYPOSN int
#endif

#ifdef YYREDUCEPOSNFUNC
#define YYCALLREDUCEPOSN(e)   \
	if(reduce_posn) {     \
	  YYREDUCEPOSNFUNC(yyps->pos, &(yyps->psp)[1-yym], &(yyps->vsp)[1-yym], \
			   yym, yyps->psp - yyps->ps, yychar, yyposn, e);       \
	  reduce_posn = 0;    \
	}

#ifndef YYCALLREDUCEPOSNARG
#define YYCALLREDUCEPOSNARG yyps->val
#endif


#define YYPOSNARG(n) ((yyps->psp)[1-yym+(n)-1])
#define YYPOSNOUT    (yyps->pos)
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEVAL
#define YYDELETEVAL(v, n) 
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEPOSN
#define YYDELETEPOSN(v, n) 
#endif

#define yyclearin (yychar=(-1))

#define yyerrok (yyps->errflag=0)

#ifndef YYSTACKGROWTH
#define YYSTACKGROWTH 16
#endif

#ifndef YYDEFSTACKSIZE
#define YYDEFSTACKSIZE 12
#endif

#ifdef YYDEBUG
int yydebug;
#endif

int yynerrs;

/* These value/posn are taken from the lexer */
YYSTYPE yylval;
YYPOSN  yyposn;

/* These value/posn of the root non-terminal are returned to the caller */
YYSTYPE yyretlval;
YYPOSN  yyretposn;

#define YYABORT  goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#define YYVALID         do { if (yyps->save)          goto yyvalid; } while(0)
#define YYVALID_NESTED  do { if (yyps->save && \
                                 yyps->save->save==0) goto yyvalid; } while(0)

struct yyparsestate {
  yyparsestate *save;        // Previously saved parser state
  int           state;
  int           errflag;
  Yshort       *ssp;         // state stack pointer
  YYSTYPE      *vsp;         // value stack pointer
  YYPOSN       *psp;         // position stack pointer
  YYSTYPE       val;         // value as returned by actions
  YYPOSN        pos;         // position as returned by universal action
  Yshort       *ss;          // state stack base
  YYSTYPE      *vs;          // values stack base
  YYPOSN       *ps;          // position stack base
  int           lexeme;      // index of the conflict lexeme in the lexical queue
  unsigned int  stacksize;   // current maximum stack size
  Yshort        ctry;        // index in yyctable[] for this conflict
};

// Current parser state
static yyparsestate *yyps=0;

// yypath!=NULL: do the full parse, starting at *yypath parser state.
static yyparsestate *yypath=0;

// Base of the lexical value queue
static YYSTYPE *yylvals=0;

// Current posistion at lexical value queue
static YYSTYPE *yylvp=0;

// End position of lexical value queue
static YYSTYPE *yylve=0;

// The last allocated position at the lexical value queue
static YYSTYPE *yylvlim=0;

// Base of the lexical position queue
static YYPOSN *yylpsns=0;

// Current posistion at lexical position queue
static YYPOSN *yylpp=0;

// End position of lexical position queue
static YYPOSN *yylpe=0;

// The last allocated position at the lexical position queue
static YYPOSN *yylplim=0;

// Current position at lexical token queue
static Yshort *yylexp=0;

static Yshort *yylexemes=0;

//
// For use in generated program
//
#define yytrial (yyps->save)
#define yyvsp   (yyps->vsp)
#define yyval   (yyps->val)
#define yydepth (yyps->ssp - yyps->ss)


//
// Local prototypes.
//
int dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous);

int  YYLex1(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous);
int  yyexpand();
void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size);
void YYPCopy(YYPOSN  *to, YYPOSN  *from, int size);
void YYMoreStack(yyparsestate *yyps);
yyparsestate *YYNewState(int size);
void YYFreeState(yyparsestate *p);




/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */


void LEX_dsql_init (void)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
	for (const TOK* token = KEYWORD_getTokens(); token->tok_string; ++token)
	{
		DSQL_SYM symbol = FB_NEW_RPT(*DSQL_permanent_pool, 0) dsql_sym;
		symbol->sym_string = (TEXT *) token->tok_string;
		symbol->sym_length = strlen(token->tok_string);
		symbol->sym_type = SYM_keyword;
		symbol->sym_keyword = token->tok_ident;
		symbol->sym_version = token->tok_version;
		dsql_str* str = FB_NEW_RPT(*DSQL_permanent_pool, symbol->sym_length) dsql_str;
		str->str_length = symbol->sym_length;
		strncpy((char*)str->str_data, (char*)symbol->sym_string, symbol->sym_length);
		symbol->sym_object = (void *) str;
		HSHD_insert(symbol);
	}
}


void LEX_string (
	const TEXT* string,
	USHORT	length,
	SSHORT	character_set)
{
/**************************************
 *
 *	L E X _ s t r i n g
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX to process a string.
 *
 **************************************/

	lex.line_start = lex.ptr = string;
	lex.end = string + length;
	lex.lines = 1;
	lex.att_charset = character_set;
	lex.line_start_bk = lex.line_start;
	lex.lines_bk = lex.lines;
	lex.param_number = 1;
	lex.prev_keyword = -1;
#ifdef DSQL_DEBUG
	if (DSQL_debug & 32)
		dsql_trace("Source DSQL string:\n%.*s", (int)length, string);
#endif
}


static const TEXT* lex_position (void)
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX 
 *	in the input string.
 *
 **************************************/

	return lex.ptr;
}


#ifdef NOT_USED_OR_REPLACED
static bool long_int(dsql_nod* string,
					 SLONG *long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 * 
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/

	for (const UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; 
		 classes(*p) & CHR_DIGIT; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	*long_value = atol(((dsql_str*) string)->str_data);

	return true;
}
#endif

static dsql_fld* make_field (dsql_nod* field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	if (field_name == NULL)
	{
		dsql_fld* field =
			FB_NEW_RPT(*tdsql->getDefaultPool(), sizeof (INTERNAL_FIELD_NAME)) dsql_fld;
		strcpy (field->fld_name, INTERNAL_FIELD_NAME);
		return field;
	}
	const dsql_str* string = (dsql_str*) field_name->nod_arg[1];
	dsql_fld* field =
		FB_NEW_RPT(*tdsql->getDefaultPool(), strlen ((SCHAR*) string->str_data)) dsql_fld;
	strcpy (field->fld_name, (TEXT*) string->str_data);
	field->fld_type_of_name = NULL;
	field->fld_explicit_collation = false;
	field->fld_not_nullable = false;
	field->fld_full_domain = false;

	return field;
}


static dsql_fil* make_file()
{
/**************************************
 *
 *	m a k e _ f i l e 
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();
		   
	dsql_fil* temp_file = FB_NEW(*tdsql->getDefaultPool()) dsql_fil;

	return temp_file;
}


static dsql_nod* make_list (dsql_nod* node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	if (node)
	{
		DsqlNodStack stack;
		stack_nodes(node, stack);
		USHORT l = stack.getCount();

		const dsql_nod* old = node;
		node = FB_NEW_RPT(*tdsql->getDefaultPool(), l) dsql_nod;
		node->nod_count = l;
		node->nod_type = nod_list;
		node->nod_line = (USHORT) lex.lines_bk;
		node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
		if (MemoryPool::blk_type(old) == dsql_type_nod)
		{
			node->nod_flags = old->nod_flags;
		}
		dsql_nod** ptr = node->nod_arg + node->nod_count;

		while (stack.hasData())
			*--ptr = stack.pop();
	}

	return node;
}


static dsql_nod* make_parameter (void)
{
/**************************************
 *
 *	m a k e _ p a r a m e t e r
 *
 **************************************
 *
 * Functional description
 *	Make parameter node
 *	Any change should also be made to function below
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), e_par_count) dsql_nod;
	node->nod_type = nod_parameter;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = e_par_count;
	node->nod_arg[e_par_index] = (dsql_nod*)(IPTR) lex.param_number++;

	return node;
}


static dsql_nod* make_node (NOD_TYPE	type,
						   int count,
						   ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


static dsql_nod* make_flag_node (NOD_TYPE	type,
								SSHORT	flag,
								int		count,
								...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
	tsql* tdsql = DSQL_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdsql->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_flags = flag;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


static void prepare_console_debug (int level, int *yydeb)
{
/*************************************
 *
 *	p r e p a r e _ c o n s o l e _ d e b u g
 * 
 *************************************
 *
 * Functional description
 *	Activate debug info. In WinNT, redirect the standard
 *	output so one can see the generated information.
 *	Feel free to add your platform specific code.
 *
 *************************************/
#ifdef DSQL_DEBUG
	DSQL_debug = level;
#endif
	if (level >> 8)
		*yydeb = level >> 8;
}

#ifdef NOT_USED_OR_REPLACED
static bool short_int(dsql_nod* string,
					  SLONG *long_value,
					  SSHORT range)
{
/*************************************
 *
 *	s h o r t _ i n t
 * 
 *************************************
 *
 * Functional description
 *	is the string a valid representation 
 *	of a positive short int?
 *
 *************************************/

	if (((dsql_str*) string)->str_length > 5) {
		return false;
	}

	for (UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; 
		classes(*p) & CHR_DIGIT; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	/* there are 5 or fewer digits, it's value may still be greater
	 * than 32767... */

	SCHAR buf[10];	
	buf[0] = ((dsql_str*) string)->str_data[0];
	buf[1] = ((dsql_str*) string)->str_data[1];
	buf[2] = ((dsql_str*) string)->str_data[2];
	buf[3] = ((dsql_str*) string)->str_data[3];
	buf[4] = ((dsql_str*) string)->str_data[4];
	buf[5] = '\0';

	*long_value = atoi (buf);

	bool return_value;

	switch (range) 
	{
		case POSITIVE:
			return_value = *long_value > SHRT_POS_MAX;
			break;
		case NEGATIVE:
			return_value = *long_value > SHRT_NEG_MAX;
			break;
		case UNSIGNED:
			return_value = *long_value > SHRT_UNSIGNED_MAX;
			break;
	}
	return !return_value;
}
#endif

static void stack_nodes (dsql_nod*	node,
						 DsqlNodStack& stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
	if (node->nod_type != nod_list)
	{
		stack.push(node);
		return;
	}

	/* To take care of cases where long lists of nodes are in a chain
	   of list nodes with exactly one entry, this algorithm will look
	   for a pattern of repeated list nodes with two entries, the first
	   being a list node and the second being a non-list node.   Such
	   a list will be reverse linked, and then re-reversed, stacking the
	   non-list nodes in the process.   The purpose of this is to avoid
	   massive recursion of this function. */

	dsql_nod* start_chain = node;
	dsql_nod* end_chain = NULL;
	dsql_nod* curr_node = node;
	dsql_nod* next_node = node->nod_arg[0];
	while ( curr_node->nod_count == 2 &&
			curr_node->nod_arg[0]->nod_type == nod_list &&
			curr_node->nod_arg[1]->nod_type != nod_list &&
			next_node->nod_arg[0]->nod_type == nod_list &&
			next_node->nod_arg[1]->nod_type != nod_list)
	{

		/* pattern was found so reverse the links and go to next node */

		dsql_nod* save_link = next_node->nod_arg[0];
		next_node->nod_arg[0] = curr_node;
		curr_node = next_node;
		next_node = save_link;
		end_chain = curr_node;
	}

	/* see if any chain was found */

	if (end_chain)
	{

		/* first, handle the rest of the nodes */
		/* note that next_node still points to the first non-pattern node */

		stack_nodes (next_node, stack);

		/* stack the non-list nodes and reverse the chain on the way back */
		
		curr_node = end_chain;
		while (true)
		{
			stack.push(curr_node->nod_arg[1]);
			if ( curr_node == start_chain)
				break;
			dsql_nod* save_link = curr_node->nod_arg[0];
			curr_node->nod_arg[0] = next_node;
			next_node = curr_node;
			curr_node = save_link;
		}
		return;
	}

	dsql_nod** ptr = node->nod_arg;
	for (const dsql_nod* const* const end = ptr + node->nod_count; ptr < end; ptr++)
		stack_nodes (*ptr, stack);
}

inline static int yylex (
	USHORT	client_dialect,
	USHORT	db_dialect,
	USHORT	parser_version,
	bool* stmt_ambiguous)
{
	lex.prev_keyword =
		lex.yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
	return lex.prev_keyword;
}

int LexerState::yylex (
	USHORT	client_dialect,
	USHORT	db_dialect,
	USHORT	parser_version,
	bool* stmt_ambiguous)
{
/**************************************
 *
 *	y y l e x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
	UCHAR	tok_class;
	char  string[MAX_TOKEN_LEN];
	SSHORT	c;

	/* Find end of white space and skip comments */

	for (;;)
	{
		if (ptr >= end)
			return -1;

		c = *ptr++;

		/* Process comments */

		if (c == '\n') {
			lines++;
			line_start = ptr;
			continue;
		}

		if ((c == '-') && (*ptr == '-'))
		{
			
			/* single-line */
			
			ptr++;
			while (ptr < end) {
				if ((c = *ptr++) == '\n') {
					lines++;
					line_start = ptr /* + 1*/; /* CVC: +1 left out. */
					break;
				}
			}
			if (ptr >= end)
				return -1;
			continue;
		}
		else if ((c == '/') && (*ptr == '*'))
		{
			
			/* multi-line */
			
			const TEXT& start_block = ptr[-1];
			ptr++;
			while (ptr < end) {
				if ((c = *ptr++) == '*') {
					if (*ptr == '/')
						break;
				}
				if (c == '\n') {
					lines++;
					line_start = ptr /* + 1*/; /* CVC: +1 left out. */

				}
			}
			if (ptr >= end)
			{
				// I need this to report the correct beginning of the block,
				// since it's not a token really.
				last_token = &start_block;
				yyerror("unterminated block comment");
				return -1;
			}
			ptr++;
			continue;
		}

		tok_class = classes(c);

		if (!(tok_class & CHR_WHITE))
			break;
	}

	/* Depending on tok_class of token, parse token */

	last_token = ptr - 1;

	if (tok_class & CHR_INTRODUCER)
	{
		/* The Introducer (_) is skipped, all other idents are copied
		 * to become the name of the character set
		 */
		char* p = string;
		for (; ptr < end && classes(*ptr) & CHR_IDENT; ptr++)
		{
			if (ptr >= end)
				return -1;
			check_copy_incr(p, UPPER7(*ptr), string);
		}
		
		check_bound(p, string);
		*p = 0;

		/* make a string value to hold the name, the name 
		 * is resolved in pass1_constant */

		yylval = (dsql_nod*) (MAKE_string(string, p - string))->str_data;

		return INTRODUCER;
	}

	/* parse a quoted string, being sure to look for double quotes */

	if (tok_class & CHR_QUOTE)
	{
		char* buffer = string;
		size_t buffer_len = sizeof (string);
		const char* buffer_end = buffer + buffer_len - 1;
		char* p;
		for (p = buffer; ; ++p)
		{
			if (ptr >= end)
			{
				if (buffer != string)
					gds__free (buffer);
				yyerror("unterminated string");
				return -1;
			}
			// Care about multi-line constants and identifiers
			if (*ptr == '\n') {
				lines++;
				line_start = ptr + 1;
			}
			/* *ptr is quote - if next != quote we're at the end */
			if ((*ptr == c) && ((++ptr == end) || (*ptr != c)))
				break;
			if (p > buffer_end)
			{
				char* const new_buffer = (char*) gds__alloc (2 * buffer_len);
			/* FREE: at outer block */
				if (!new_buffer)		/* NOMEM: */
				{
					if (buffer != string)
						gds__free (buffer);
					return -1;
				}
				memcpy (new_buffer, buffer, buffer_len);
				if (buffer != string)
					gds__free (buffer);
				buffer = new_buffer;
				p = buffer + buffer_len;
				buffer_len = 2 * buffer_len;
				buffer_end = buffer + buffer_len - 1;
			}
			*p = *ptr++;
		}
		if (c == '"')
		{
			*stmt_ambiguous = true; /* string delimited by double quotes could be
					**   either a string constant or a SQL delimited
					**   identifier, therefore marks the SQL
					**   statement as ambiguous  */
			if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			{
				if (buffer != string)
					gds__free (buffer);
				yyabandon (-104, isc_invalid_string_constant);
			}
			else if (client_dialect >= SQL_DIALECT_V6)
			{
				if ((p - buffer) >= MAX_TOKEN_LEN)
				{
					if (buffer != string)
						gds__free (buffer);
					yyabandon (-104, isc_token_too_long);
				}
				yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
				dsql_str* delimited_id_str = (dsql_str*) yylval;
				delimited_id_str->str_flags |= STR_delimited_id;
				if (buffer != string)
					gds__free (buffer);
				return SYMBOL;
			}
		}
		yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
		if (buffer != string)
			gds__free (buffer);
		return STRING;
	}
												 
/* 
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 * 
 * This code recognizes the following token types:
 * 
 * NUMBER: string of digits which fits into a 32-bit integer
 * 
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

	fb_assert(ptr <= end);

	if ((tok_class & CHR_DIGIT) ||
		((c == '.') && (ptr < end) && (classes(*ptr) & CHR_DIGIT)))
	{
		/* The following variables are used to recognize kinds of numbers. */

		bool have_error	 = false;	/* syntax error or value too large */
		bool have_digit	 = false;	/* we've seen a digit			  */
		bool have_decimal   = false;	/* we've seen a '.'				*/
		bool have_exp	   = false;	/* digit ... [eE]				  */
		bool have_exp_sign  = false; /* digit ... [eE] {+-]			 */
		bool have_exp_digit = false; /* digit ... [eE] ... digit		*/
		FB_UINT64 number		= 0;
		FB_UINT64 limit_by_10	= MAX_SINT64 / 10;

		for (--ptr ; ptr < end ; ptr++)
		{
			c = *ptr;
			if (have_exp_digit && (! (classes(c) & CHR_DIGIT)))
				/* First non-digit after exponent and digit terminates
				 the token. */
				break;
			else if (have_exp_sign && (! (classes(c) & CHR_DIGIT)))
			{
				/* only digits can be accepted after "1E-" */
				have_error = true;
				break;
			}
			else if (have_exp)
			{
				/* We've seen e or E, but nothing beyond that. */
				if ( ('-' == c) || ('+' == c) )
					have_exp_sign = true;
				else if ( classes(c) & CHR_DIGIT )
					/* We have a digit: we haven't seen a sign yet,
					but it's too late now. */
					have_exp_digit = have_exp_sign  = true;
				else
				{
					/* end of the token */
					have_error = true;
					break;
				}
			}
			else if ('.' == c)
			{
				if (!have_decimal)
					have_decimal = true;
				else
				{
					have_error = true;
					break;
				}
			}
			else if (classes(c) & CHR_DIGIT)
			{
				/* Before computing the next value, make sure there will be
				   no overflow.  */

				have_digit = true;

				if (number >= limit_by_10)
				{
				/* possibility of an overflow */
					if ((number > limit_by_10) || (c > '8'))
					{
						have_error = true;
						break;
					}
				}
				number = number * 10 + (c - '0');
			}
			else if ( (('E' == c) || ('e' == c)) && have_digit )
				have_exp = true;
			else
				/* Unexpected character: this is the end of the number. */
				break;
		}

		/* We're done scanning the characters: now return the right kind
		   of number token, if any fits the bill. */

		if (!have_error)
		{
			fb_assert(have_digit);

			if (have_exp_digit)
			{
				yylval = (dsql_nod*) MAKE_string(last_token, ptr - last_token);
				last_token_bk = last_token;
				line_start_bk = line_start;
				lines_bk = lines;

				return FLOAT_NUMBER;
			}
			else if (!have_exp)
			{

				/* We should return some kind (scaled-) integer type
				   except perhaps in dialect 1. */

				if (!have_decimal && (number <= MAX_SLONG))
				{
					yylval = (dsql_nod*) (IPTR) number;
					//printf ("parse.y %p %d\n", yylval, number);
					return NUMBER;
				}
				else
				{
					/* We have either a decimal point with no exponent
					   or a string of digits whose value exceeds MAX_SLONG:
					   the returned type depends on the client dialect,
					   so warn of the difference if the client dialect is
					   SQL_DIALECT_V6_TRANSITION.
					*/

					if (SQL_DIALECT_V6_TRANSITION == client_dialect)
					{
						/* Issue a warning about the ambiguity of the numeric
						 * numeric literal.  There are multiple calls because
						 * the message text exceeds the 119-character limit
						 * of our message database.
						 */
						ERRD_post_warning( isc_dsql_warning_number_ambiguous,
							   isc_arg_string,
							   ERR_string( last_token, ptr - last_token ),
							   isc_arg_end );
						ERRD_post_warning( isc_dsql_warning_number_ambiguous1,
							   isc_arg_end );
					}

					yylval = (dsql_nod*) MAKE_string(last_token, ptr - last_token);

					last_token_bk = last_token;
					line_start_bk = line_start;
					lines_bk = lines;

					if (client_dialect < SQL_DIALECT_V6_TRANSITION)
						return FLOAT_NUMBER;
					else if (have_decimal)
						return SCALEDINT;
					else
						return NUMBER64BIT;
				}
			} /* else if (!have_exp) */
		} /* if (!have_error) */

		/* we got some kind of error or overflow, so don't recognize this
		 * as a number: just pass it through to the next part of the lexer.
		 */
	}

	/* Restore the status quo ante, before we started our unsuccessful
	   attempt to recognize a number. */
	ptr = last_token;
	c   = *ptr++;
	/* We never touched tok_class, so it doesn't need to be restored. */

	/* end of number-recognition code */


	if (tok_class & CHR_LETTER)
	{
		char* p = string;
		check_copy_incr(p, UPPER (c), string);
		for (; ptr < end && classes(*ptr) & CHR_IDENT; ptr++)
		{
			if (ptr >= end)
				return -1;
			check_copy_incr(p, UPPER (*ptr), string);
		}

		check_bound(p, string);
		*p = 0;
		dsql_sym* sym =
			HSHD_lookup (NULL, (TEXT *) string, (SSHORT)(p - string), SYM_keyword, parser_version);
		if (sym && (sym->sym_keyword != COMMENT || prev_keyword == -1))
		{
			yylval = (dsql_nod*) sym->sym_object;
			last_token_bk = last_token;
			line_start_bk = line_start;
			lines_bk = lines;
			return sym->sym_keyword;
		}
		yylval = (dsql_nod*) MAKE_string(string, p - string);
		last_token_bk = last_token;
		line_start_bk = line_start;
		lines_bk = lines;
		return SYMBOL;
	}

	/* Must be punctuation -- test for double character punctuation */

	if (last_token + 1 < end)
	{
		dsql_sym* sym =
			HSHD_lookup (NULL, last_token, (SSHORT) 2, SYM_keyword, (USHORT) parser_version);
		if (sym)
		{
			++ptr;
			return sym->sym_keyword;
		}
	}
		
	/* Single character punctuation are simply passed on */

	return (UCHAR) c;
}


static void yyerror_detailed(const TEXT* error_string, int yychar, YYSTYPE&, YYPOSN&)
{
/**************************************
 *
 *	y y e r r o r _ d e t a i l e d
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/
	const TEXT* line_start = lex.line_start;
	SLONG lines = lex.lines;
	if (lex.last_token < lex.line_start)
	{
		line_start = lex.line_start_bk;
		lines--;
	}

	if (yychar < 1)
		ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104,
			isc_arg_gds, isc_command_end_err2,	/* Unexpected end of command */
			isc_arg_number, lines,
			isc_arg_number, (SLONG) (lex.last_token - line_start + 1),
			0);
	else
	{
		ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104,
			/* Token unknown - line %d, column %d */
			isc_arg_gds, isc_dsql_token_unk_err,
			isc_arg_number, (SLONG) lines,
			isc_arg_number, (SLONG) (lex.last_token - line_start + 1), /*CVC: +1*/
			/* Show the token */
			isc_arg_gds, isc_random,
			isc_arg_cstring, (int) (lex.ptr - lex.last_token), lex.last_token,
			0);
	}
}


// The argument passed to this function is ignored. Therefore, messages like
// "syntax error" and "yacc stack overflow" are never seen.
static void yyerror(const TEXT* error_string)
{
	YYSTYPE errt_value =  0;
	YYPOSN errt_posn = -1;
	yyerror_detailed(error_string, -1, errt_value, errt_posn);
}


static void yyabandon (SLONG		sql_code,
					   ISC_STATUS	error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

	ERRD_post (isc_sqlerr, isc_arg_number, sql_code,
		isc_arg_gds, error_symbol, 0);
}


//
// Parser function
//
int dsql_yyparse(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous) {
  int yym, yyn, yystate, yychar, yynewerrflag;
  yyparsestate *yyerrctx = NULL;
  int reduce_posn;

#if YYDEBUG
  char *yys;
  
  if ((yys = getenv("YYDEBUG"))) {
    yyn = *yys;
    if (yyn >= '0' && yyn <= '9')
      yydebug = yyn - '0'; 
  }
#endif
  
  yyps = YYNewState(YYDEFSTACKSIZE);
  yyps->save = 0;
  yynerrs = 0;
  yyps->errflag = 0;
  yychar = (-1);
  
  yyps->ssp = yyps->ss;
  yyps->vsp = yyps->vs;
  yyps->psp = yyps->ps;
  *(yyps->ssp) = yystate = 0;
  

  //
  // Main parsing loop
  //
 yyloop:
  if ((yyn = yydefred[yystate])) {
    goto yyreduce;
  }

  //
  // Read one token
  //
  if (yychar < 0) {
    if ((yychar = YYLex1(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) yychar = 0;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, reading %d (%s)", 
	     int(yydepth), yytrial, yystate, yychar, yys);
#ifdef YYDBPR
      printf("<");
      YYDBPR(yylval);
      printf(">");
#endif
      printf("\n"); 
    }
#endif
  }

  //
  // Do we have a conflict?
  //
  if ((yyn = yycindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    int ctry;

    if (yypath) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d: following successful trial parse\n", 
	       int(yydepth), yytrial, yystate);
      }
#endif
      // Switch to the next conflict context
      yyparsestate *save = yypath;
      yypath = save->save;
      ctry = save->ctry;
      if (save->state != yystate) 
        goto yyabort;
      YYFreeState(save); 

    } else {

#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d. ", 
	       int(yydepth), yytrial, yystate);
        if(yyps->save) {
          printf("ALREADY in conflict. Continue trial parse.");
        } else {
          printf("Start trial parse.");
        }
        printf("\n");
      }
#endif
      yyparsestate *save = YYNewState(yyps->ssp - yyps->ss);
      save->save    = yyps->save;
      save->state   = yystate;
      save->errflag = yyps->errflag;
      save->ssp     = save->ss + (yyps->ssp - yyps->ss);
      save->vsp     = save->vs + (yyps->vsp - yyps->vs);
      save->psp     = save->ps + (yyps->psp - yyps->ps);
      memcpy (save->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(save->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(save->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      ctry = yytable[yyn];
      if (yyctable[ctry] == -1) {
#if YYDEBUG
        if (yydebug && yychar >= 0)
          printf("yydebug[%p]: backtracking 1 token\n", yytrial);
#endif
        ctry++; 
      }
      save->ctry = ctry;
      if (!yyps->save) {
        // If this is a first conflict in the stack, start saving lexemes
        if (!yylexemes) {
          yylexemes = new Yshort[YYSTACKGROWTH];
          yylvals = new YYSTYPE[YYSTACKGROWTH];
          yylvlim = yylvals + YYSTACKGROWTH; 
          yylpsns = new YYPOSN[YYSTACKGROWTH];
          yylplim = yylpsns + YYSTACKGROWTH; 
        }
        if (yylvp == yylve) {
          yylvp = yylve = yylvals;
	  yylpp = yylpe = yylpsns;
          yylexp = yylexemes;
          if (yychar >= 0) {
            *yylve++ = yylval;
            *yylpe++ = yyposn;
            *yylexp = yychar;
            yychar = -1; 
          } 
        } 
      }
      if (yychar >= 0) {
        yylvp--, yylpp--, yylexp--;
        yychar = -1; 
      }
      save->lexeme = yylvp - yylvals;
      yyps->save = save; 
    }
    if (yytable[yyn] == ctry) {
#if YYDEBUG
      if (yydebug)
        printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
               int(yydepth), yytrial, yystate, yyctable[ctry]);
#endif
      if (yychar < 0)
        yylvp++, yylpp++, yylexp++;
      yychar = -1;
      if (yyps->errflag > 0) --yyps->errflag;
      yystate = yyctable[ctry];
      goto yyshift; 
    } else {
      yyn = yyctable[ctry];
      goto yyreduce; 
    } 
  }

  //
  // Is action a shift?
  //
  if ((yyn = yysindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
             int(yydepth), yytrial, yystate, yytable[yyn]);
#endif
    yychar = (-1);
    if (yyps->errflag > 0)  --yyps->errflag;
    yystate = yytable[yyn];
  yyshift:
    if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
      YYMoreStack(yyps);
    }
    *++(yyps->ssp) = yystate;
    *++(yyps->vsp) = yylval;
    *++(yyps->psp) = yyposn;
    goto yyloop;
  }
  if ((yyn = yyrindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    yyn = yytable[yyn];
    goto yyreduce;
  }

  //
  // Action: error
  //
  if (yyps->errflag) goto yyinrecovery;
  yynewerrflag = 1;
  goto yyerrhandler;
yyerrlab:
  yynewerrflag = 0;
yyerrhandler:
  while (yyps->save) { 
    int ctry; 
    yyparsestate *save = yyps->save;
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
             int(yydepth), yytrial, yystate, yyps->save->state, int(yylvp - yylvals - yyps->save->lexeme));
#endif
    // Memorize most forward-looking error state in case
    // it's really an error.
    if(yyerrctx==NULL || yyerrctx->lexeme<yylvp-yylvals) {
      // Free old saved error context state
      if(yyerrctx) YYFreeState(yyerrctx);
      // Create and fill out new saved error context state
      yyerrctx = YYNewState(yyps->ssp - yyps->ss);
      yyerrctx->save = yyps->save;
      yyerrctx->state = yystate;
      yyerrctx->errflag = yyps->errflag;
      yyerrctx->ssp = yyerrctx->ss + (yyps->ssp - yyps->ss);
      yyerrctx->vsp = yyerrctx->vs + (yyps->vsp - yyps->vs);
      yyerrctx->psp = yyerrctx->ps + (yyps->psp - yyps->ps);
      memcpy (yyerrctx->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(yyerrctx->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(yyerrctx->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      yyerrctx->lexeme = yylvp - yylvals;
    }
    yylvp  = yylvals   + save->lexeme;
    yylpp  = yylpsns   + save->lexeme;
    yylexp = yylexemes + save->lexeme;
    yychar = -1;
    yyps->ssp = yyps->ss + (save->ssp - save->ss);
    yyps->vsp = yyps->vs + (save->vsp - save->vs);
    yyps->psp = yyps->ps + (save->psp - save->ps);
    memcpy (yyps->ss, save->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
    YYSCopy(yyps->vs, save->vs,  yyps->vsp - yyps->vs + 1);
    YYPCopy(yyps->ps, save->ps,  yyps->psp - yyps->ps + 1);
    ctry = ++save->ctry;
    yystate = save->state;
    // We tried shift, try reduce now
    if ((yyn = yyctable[ctry]) >= 0) {
      goto yyreduce;
    }
    yyps->save = save->save;
    YYFreeState(save);
    //
    // Nothing left on the stack -- error
    //
    if (!yyps->save) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%p]: trial parse FAILED, entering ERROR mode\n", 
	       yytrial);
      }
#endif
      // Restore state as it was in the most forward-advanced error
      yylvp  = yylvals   + yyerrctx->lexeme;
      yylpp  = yylpsns   + yyerrctx->lexeme;
      yylexp = yylexemes + yyerrctx->lexeme;
      yychar = yylexp[-1];
      yylval = yylvp[-1];
      yyposn = yylpp[-1];
      yyps->ssp = yyps->ss + (yyerrctx->ssp - yyerrctx->ss);
      yyps->vsp = yyps->vs + (yyerrctx->vsp - yyerrctx->vs);
      yyps->psp = yyps->ps + (yyerrctx->psp - yyerrctx->ps);
      memcpy (yyps->ss, yyerrctx->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      YYSCopy(yyps->vs, yyerrctx->vs,  yyps->vsp - yyps->vs + 1);
      YYPCopy(yyps->ps, yyerrctx->ps,  yyps->psp - yyps->ps + 1);
      yystate = yyerrctx->state;
      YYFreeState(yyerrctx);
      yyerrctx = NULL;
    }
    yynewerrflag = 1; 
  }
  if (yynewerrflag) {
#ifdef YYERROR_DETAILED
    yyerror_detailed("syntax error", yychar, yylval, yyposn);
#else
    yyerror("syntax error");
#endif
  }
  ++yynerrs;
 yyinrecovery:
  if (yyps->errflag < 3) {
    yyps->errflag = 3;
    for (;;) {
      if ((yyn = yysindex[*(yyps->ssp)]) && 
	  (yyn += YYERRCODE) >= 0 &&
          yyn <= YYTABLESIZE && 
	  yycheck[yyn] == YYERRCODE) {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: state %d, ERROR recovery shifts to state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp), yytable[yyn]);
#endif
        /* Use label yyerrlab, so that compiler does not warn */
        if(yyps->errflag != yyps->errflag) goto yyerrlab;
        yystate = yytable[yyn];
        goto yyshift; 
      } else {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: ERROR recovery discards state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp));
#endif
        if (yyps->ssp <= yyps->ss) {
	  goto yyabort;
	}
	if(!yytrial) {
	  YYDELETEVAL(yyps->vsp[0],1);
	  YYDELETEPOSN(yyps->psp[0],1);
	}
        --(yyps->ssp);
        --(yyps->vsp);
        --(yyps->psp);
      }
    }
  } else {
    if (yychar == 0) goto yyabort;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, ERROR recovery discards token %d (%s)\n",
             int(yydepth), yytrial, yystate, yychar, yys); 
    }
#endif
    if(!yytrial) {
      YYDELETEVAL(yylval,0);
      YYDELETEPOSN(yyposn,0);
    }
    yychar = (-1);
    goto yyloop;
  }

  //
  // Reduce the rule
  //
yyreduce:
  yym = yylen[yyn];
#if YYDEBUG
  if (yydebug) {
    printf("yydebug[%d,%p]: state %d, reducing by rule %d (%s)",
           int(yydepth), yytrial, yystate, yyn, yyrule[yyn]);
#ifdef YYDBPR
    if (yym) {
      int i;
      printf("<");
      for (i=yym; i>0; i--) {
        if (i!=yym) printf(", ");
        YYDBPR((yyps->vsp)[1-i]);
      }
      printf(">");
    }
#endif
    printf("\n");
  }
#endif
  if (yyps->ssp + 1 - yym >= yyps->ss + yyps->stacksize) {
    YYMoreStack(yyps);
  }

  /* default action - assign last argument as in standard yacc */
  yyps->val = yyvsp[1 - yym];

  /* default reduced position is NULL -- no position at all.
     no position will be assigned at trial time and if no position handling is present */
  memset(&yyps->pos, 0, sizeof(yyps->pos));

  reduce_posn = TRUE;

  switch (yyn) {

case 1:
  if (!yytrial)
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
  if (!yytrial)
{ DSQL_parse = yyvsp[-1]; }
break;
case 25:
  if (!yytrial)
{ prepare_console_debug ((IPTR) yyvsp[0], &yydebug);
			  yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 26:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 27:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 28:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count, 
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[0]); }
break;
case 31:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 32:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 33:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 35:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 36:
  if (!yytrial)
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 37:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 38:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 39:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 40:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 41:
  if (!yytrial)
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 42:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 43:
  if (!yytrial)
{ yyval = NULL; }
break;
case 44:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 45:
  if (!yytrial)
{ yyval = NULL; }
break;
case 46:
  if (!yytrial)
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 47:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 48:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-5], yyvsp[-2], make_list(yyvsp[0]), yyvsp[-6]); }
break;
case 49:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					make_list(yyvsp[-2]), make_list(yyvsp[0]), NULL, yyvsp[-3]); }
break;
case 50:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 51:
  if (!yytrial)
{ yyval = NULL; }
break;
case 52:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 53:
  if (!yytrial)
{ yyval = NULL; }
break;
case 57:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 58:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 59:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 60:
  if (!yytrial)
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 61:
  if (!yytrial)
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 62:
  if (!yytrial)
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 63:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 65:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 66:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 67:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 68:
  if (!yytrial)
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 70:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 71:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 73:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 74:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 75:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 76:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 77:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 78:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 79:
  if (!yytrial)
{ yyval = make_node (nod_def_udf, (int) e_udf_count, 
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 81:
  if (!yytrial)
{ lex.g_field->fld_dtype = dtype_blob; }
break;
case 82:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_cstring; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-2]; }
break;
case 83:
  if (!yytrial)
{ yyval = NULL; }
break;
case 85:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 87:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 88:
  if (!yytrial)
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 89:
  if (!yytrial)
{ yyval = NULL; }
break;
case 90:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_descriptor); }
break;
case 91:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_scalar_array); }
break;
case 92:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_ref_with_null); }
break;
case 94:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 95:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 96:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
				NULL, MAKE_const_slong ((IPTR) yyvsp[0]));}
break;
case 97:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_reference); }
break;
case 98:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_value); }
break;
case 99:
  if (!yytrial)
{ yyval = MAKE_const_slong (Jrd::FUN_descriptor); }
break;
case 100:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * Jrd::FUN_reference); }
break;
case 101:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * Jrd::FUN_descriptor); }
break;
case 102:
  if (!yytrial)
{ yyval = make_node (nod_def_filter, (int) e_filter_count, 
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 103:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 104:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 105:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 106:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 107:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 108:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 109:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 110:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 111:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 112:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 113:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 114:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 115:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 116:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 117:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 118:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 119:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 120:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 121:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 122:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 123:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 124:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 125:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 126:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 127:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 128:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 129:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 130:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 131:
  if (!yytrial)
{ yyval = make_node (nod_def_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 132:
  if (!yytrial)
{ yyval = make_node (nod_redef_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 133:
  if (!yytrial)
{ yyval = make_node (nod_replace_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 134:
  if (!yytrial)
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count, 
						yyvsp[-1], yyvsp[0]); }
break;
case 135:
  if (!yytrial)
{ yyval = make_node (nod_unique, 0, NULL); }
break;
case 136:
  if (!yytrial)
{ yyval = NULL; }
break;
case 137:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 139:
  if (!yytrial)
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 140:
  if (!yytrial)
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
				 yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 141:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 142:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 143:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 144:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 145:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 146:
  if (!yytrial)
{ yyval = (dsql_nod*) 0;}
break;
case 147:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 148:
  if (!yytrial)
{ yyval = NULL; }
break;
case 151:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 152:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
										  yyvsp[-7], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 153:
  if (!yytrial)
{ yyval = NULL; }
break;
case 154:
  if (!yytrial)
{ yyval = NULL; }
break;
case 155:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 157:
  if (!yytrial)
{ yyval = NULL; }
break;
case 159:
  if (!yytrial)
{ yyval = NULL; }
break;
case 161:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 162:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 165:
  if (!yytrial)
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 166:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, yyvsp[-2], NULL, yyvsp[0]); }
break;
case 167:
  if (!yytrial)
{ yyval = make_node (nod_def_generator, (int) e_gen_count, yyvsp[0]); }
break;
case 168:
  if (!yytrial)
{ yyval = make_node (nod_def_role, (int) 1, yyvsp[0]); }
break;
case 169:
  if (!yytrial)
{ yyval = make_node (nod_def_collation, 
						(int) e_def_coll_count, yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 170:
  if (!yytrial)
{ yyval = make_node(nod_collation_from, 1, yyvsp[0]); }
break;
case 171:
  if (!yytrial)
{ yyval = make_node(nod_collation_from_external, 1, yyvsp[-1]); }
break;
case 172:
  if (!yytrial)
{ yyval = NULL; }
break;
case 173:
  if (!yytrial)
{ yyval = NULL; }
break;
case 176:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 180:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 181:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 182:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 183:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 184:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 185:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 186:
  if (!yytrial)
{ yyval = NULL; }
break;
case 187:
  if (!yytrial)
{ yyval = make_node(nod_collation_specific_attr, 1,
				MAKE_constant((dsql_str*)yyvsp[0], CONSTANT_STRING)); }
break;
case 188:
  if (!yytrial)
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 191:
  if (!yytrial)
{ yyval = (dsql_nod*) yyvsp[0]; }
break;
case 192:
  if (!yytrial)
{yyval = NULL;}
break;
case 195:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 196:
  if (!yytrial)
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 197:
  if (!yytrial)
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 198:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 199:
  if (!yytrial)
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 200:
  if (!yytrial)
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 201:
  if (!yytrial)
{yyval = NULL;}
break;
case 204:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 206:
  if (!yytrial)
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 207:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, 1, yyvsp[0]); }
break;
case 208:
  if (!yytrial)
{ lex.g_file->fil_name = (dsql_str*) yyvsp[-1];
			  yyval = (dsql_nod*) make_node (nod_file_desc, (int) 1,
						(dsql_nod*) lex.g_file); }
break;
case 209:
  if (!yytrial)
{ lex.g_file  = make_file();}
break;
case 214:
  if (!yytrial)
{ lex.g_file->fil_start = (IPTR) yyvsp[0];}
break;
case 215:
  if (!yytrial)
{ lex.g_file->fil_length = (IPTR) yyvsp[-1];}
break;
case 222:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 223:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 224:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 225:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 226:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_PRESERVE_ROWS; }
break;
case 227:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 228:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 229:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 230:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 231:
  if (!yytrial)
{ yyval = NULL; }
break;
case 233:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 236:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-4], NULL); }
break;
case 237:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-2], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 238:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
					yyvsp[-1], NULL, NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 239:
  if (!yytrial)
{ 
			lex.g_field->fld_flags |= FLD_computed;
			yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 244:
  if (!yytrial)
{ yyval = NULL; }
break;
case 245:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
											yyvsp[-1], NULL, NULL, NULL, NULL); }
break;
case 246:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 247:
  if (!yytrial)
{ yyval = NULL; }
break;
case 248:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 249:
  if (!yytrial)
{ lex.g_field = make_field (yyvsp[0]);
				  yyval = (dsql_nod*) lex.g_field; }
break;
case 250:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 251:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				yyval = yyvsp[0];
			}
break;
case 252:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				((dsql_fld*) yyvsp[0])->fld_full_domain = true;
				yyval = yyvsp[0];
			}
break;
case 253:
  if (!yytrial)
{ lex.g_field = make_field (NULL);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 260:
  if (!yytrial)
{ yyval = NULL; }
break;
case 263:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 264:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 267:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count,
						make_node (nod_list, (int) 1, lex.g_field_name), yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 268:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, NULL, yyvsp[0]); }
break;
case 269:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, NULL, yyvsp[0]); }
break;
case 270:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 271:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 272:
  if (!yytrial)
{ yyval = NULL ;}
break;
case 277:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, yyvsp[-1], yyvsp[0]); }
break;
case 278:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, yyvsp[-1], yyvsp[0]); }
break;
case 279:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count, yyvsp[-5], yyvsp[-3], 
					 yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 280:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					NULL, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 281:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 282:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 283:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 284:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 285:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 286:
  if (!yytrial)
{ yyval = NULL;}
break;
case 287:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 288:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 289:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_CASCADE, (int) e_ref_trig_action_count, NULL);}
break;
case 290:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_DEFAULT, (int) e_ref_trig_action_count, NULL);}
break;
case 291:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_SET_NULL, (int) e_ref_trig_action_count, NULL);}
break;
case 292:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action, 
			 REF_ACTION_NONE, (int) e_ref_trig_action_count, NULL);}
break;
case 293:
  if (!yytrial)
{ yyval = make_node (nod_def_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 294:
  if (!yytrial)
{ yyval = make_node (nod_redef_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 295:
  if (!yytrial)
{ yyval = make_node (nod_replace_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 296:
  if (!yytrial)
{ yyval = make_node (nod_mod_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 297:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 298:
  if (!yytrial)
{ yyval = NULL; }
break;
case 299:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 300:
  if (!yytrial)
{ yyval = NULL; }
break;
case 302:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 303:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-5], yyvsp[-1], yyvsp[0], NULL, yyvsp[-3], NULL, NULL); }
break;
case 305:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 306:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-2], NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 307:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 308:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 309:
  if (!yytrial)
{ yyval = NULL; }
break;
case 310:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 311:
  if (!yytrial)
{ yyval = NULL; }
break;
case 313:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 314:
  if (!yytrial)
{
				yyval = yyvsp[-1];
				yyval->nod_line = (IPTR) yyvsp[-5];
				yyval->nod_column = (IPTR) yyvsp[-4];
			}
break;
case 317:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count, 
				yyvsp[-3], yyvsp[0], NULL, NULL, yyvsp[-1], NULL, NULL); }
break;
case 318:
  if (!yytrial)
{ yyval = NULL; }
break;
case 319:
  if (!yytrial)
{ yyval = NULL; }
break;
case 320:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 321:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 322:
  if (!yytrial)
{ yyval = NULL; }
break;
case 323:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_EXPLICIT,
				(int) e_cur_count, yyvsp[-5], yyvsp[-1], NULL, NULL); }
break;
case 326:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]);
			}
break;
case 327:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[0]), NULL); }
break;
case 328:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[-1]), make_list (yyvsp[0])); }
break;
case 329:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, NULL, NULL);}
break;
case 331:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 332:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-3], yyvsp[-2], yyvsp[-1]);
			}
break;
case 333:
  if (!yytrial)
{ 
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-2], yyvsp[-1], yyvsp[0]);
			}
break;
case 334:
  if (!yytrial)
{ yyval = (dsql_nod*) (IPTR) lex.lines_bk; }
break;
case 335:
  if (!yytrial)
{ 
			const USHORT column = (lex.last_token_bk - lex.line_start_bk + 1);
			yyval = (dsql_nod*) (IPTR) column;
		}
break;
case 352:
  if (!yytrial)
{ yyval = make_node (nod_return, (int) e_rtn_count, NULL); }
break;
case 353:
  if (!yytrial)
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 358:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[0], NULL); }
break;
case 359:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[-1], yyvsp[0]); }
break;
case 360:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, NULL, NULL); }
break;
case 361:
  if (!yytrial)
{ yyval = make_node (nod_exec_sql, (int) e_exec_sql_count, yyvsp[0]); }
break;
case 362:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], yyvsp[-7]); }
break;
case 363:
  if (!yytrial)
{ yyval = make_node (nod_exec_into, (int) e_exec_into_count, yyvsp[-4], yyvsp[0], make_list (yyvsp[-2]), yyvsp[-8]); }
break;
case 364:
  if (!yytrial)
{ yyval = make_node (nod_exec_into, (int) e_exec_into_count, yyvsp[-2], 0, make_list (yyvsp[0])); }
break;
case 365:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 366:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 367:
  if (!yytrial)
{ yyval = make_node (nod_post, (int) e_pst_count, yyvsp[-1], yyvsp[0]); }
break;
case 368:
  if (!yytrial)
{ yyval = NULL; }
break;
case 369:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-2],
					  make_list (yyvsp[0]), NULL, NULL, NULL); }
break;
case 370:
  if (!yytrial)
{ yyval = make_node (nod_var_name, (int) e_vrn_count, 
							yyvsp[0]); }
break;
case 373:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 374:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 375:
  if (!yytrial)
{ yyval = make_node (nod_while, (int) e_while_count, yyvsp[-3], yyvsp[0], yyvsp[-6]); }
break;
case 376:
  if (!yytrial)
{ yyval = make_node (nod_label, (int) e_label_count, yyvsp[-1], NULL); }
break;
case 377:
  if (!yytrial)
{ yyval = NULL; }
break;
case 378:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 379:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 380:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count,
				make_node (nod_label, (int) e_label_count, yyvsp[0], NULL)); }
break;
case 381:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_FOR,
				(int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 382:
  if (!yytrial)
{ yyval = NULL; }
break;
case 384:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 385:
  if (!yytrial)
{ yyval = make_node (nod_on_error, (int) e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 387:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 388:
  if (!yytrial)
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 389:
  if (!yytrial)
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 390:
  if (!yytrial)
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 391:
  if (!yytrial)
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 395:
  if (!yytrial)
{ yyval = make_node (nod_cursor_open, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 396:
  if (!yytrial)
{ yyval = make_node (nod_cursor_close, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 397:
  if (!yytrial)
{ yyval = make_node (nod_cursor_fetch, (int) e_cur_stmt_count, yyvsp[-2], yyvsp[-3], make_list (yyvsp[0])); }
break;
case 398:
  if (!yytrial)
{ yyval = NULL; }
break;
case 399:
  if (!yytrial)
{ yyval = make_node (nod_exec_procedure, (int) e_exe_count,
					yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 400:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 401:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 402:
  if (!yytrial)
{ yyval = NULL; }
break;
case 403:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 404:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 405:
  if (!yytrial)
{ yyval = NULL; }
break;
case 406:
  if (!yytrial)
{ yyval = make_node (nod_exec_block,
						  (int) e_exe_blk_count, 
					          yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 407:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 408:
  if (!yytrial)
{ yyval = NULL; }
break;
case 410:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 411:
  if (!yytrial)
{ yyval = make_node (nod_param_val, e_prm_val_count, yyvsp[-2], yyvsp[0]); }
break;
case 412:
  if (!yytrial)
{ yyval = make_node (nod_def_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 413:
  if (!yytrial)
{ yyval = make_node (nod_redef_view, (int) e_view_count, 
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 414:
  if (!yytrial)
{ lex.beginning = lex_position(); }
break;
case 415:
  if (!yytrial)
{ lex.beginning = lex.last_token; }
break;
case 416:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_string(lex.beginning,
					lex_position() - lex.beginning); }
break;
case 417:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_string(lex.beginning, 
					(yychar <= 0 ? lex_position() : lex.last_token) - lex.beginning); 
			}
break;
case 418:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count, 
					NULL, NULL, NULL, NULL, NULL); }
break;
case 419:
  if (!yytrial)
{ yyval = 0; }
break;
case 420:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 421:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 422:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 423:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 424:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 425:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 426:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 427:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 428:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 429:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 430:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 431:
  if (!yytrial)
{ yyval = NULL; }
break;
case 432:
  if (!yytrial)
{ yyval = MAKE_trigger_type (yyvsp[-1], yyvsp[0]); }
break;
case 433:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 434:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_CONNECT); }
break;
case 435:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_DISCONNECT); }
break;
case 436:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_START); }
break;
case 437:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_COMMIT); }
break;
case 438:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_ROLLBACK); }
break;
case 439:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 440:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 441:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 0, 0)); }
break;
case 442:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 0, 0)); }
break;
case 443:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 0, 0)); }
break;
case 444:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 0)); }
break;
case 445:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 0)); }
break;
case 446:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 0)); }
break;
case 447:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 0)); }
break;
case 448:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 0)); }
break;
case 449:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 0)); }
break;
case 450:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 3)); }
break;
case 451:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 2)); }
break;
case 452:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 3)); }
break;
case 453:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 1)); }
break;
case 454:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 2)); }
break;
case 455:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 1)); }
break;
case 456:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 457:
  if (!yytrial)
{ yyval = NULL; }
break;
case 458:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) e_trg_act_count, yyvsp[-1], yyvsp[0]); }
break;
case 459:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 460:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 461:
  if (!yytrial)
{ yyval = make_node (nod_mod_relation, (int) e_alt_count, 
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 462:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 463:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 464:
  if (!yytrial)
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 465:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
										  yyvsp[-1], make_list (yyvsp[0])); }
break;
case 466:
  if (!yytrial)
{ yyval = make_node (nod_mod_index, (int) e_mod_idx_count, yyvsp[0]); }
break;
case 467:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 468:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 470:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 471:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 472:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 473:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 474:
  if (!yytrial)
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 475:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 476:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 477:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 479:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 480:
  if (!yytrial)
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 481:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 482:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 483:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 484:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_const_slong((IPTR) yyvsp[0])); }
break;
case 485:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 486:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], yyvsp[0], NULL); }
break;
case 487:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-3], NULL,
					make_node(nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0])); }
break;
case 488:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL,
					make_node(nod_del_default, (int) 0, NULL)); }
break;
case 489:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 538:
  if (!yytrial)
{ yyval = NULL; }
break;
case 539:
  if (!yytrial)
{ yyval = NULL; }
break;
case 540:
  if (!yytrial)
{ yyval = NULL; }
break;
case 541:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count,
					yyvsp[0], NULL, NULL, NULL, NULL); }
break;
case 542:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 543:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 544:
  if (!yytrial)
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 545:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 546:
  if (!yytrial)
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 547:
  if (!yytrial)
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 548:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 549:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 550:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-4],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 551:
  if (!yytrial)
{ yyval = make_node(nod_mod_udf, e_mod_udf_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 552:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 553:
  if (!yytrial)
{ yyval = NULL; }
break;
case 554:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 555:
  if (!yytrial)
{ yyval = NULL; }
break;
case 556:
  if (!yytrial)
{ yyval = NULL; }
break;
case 558:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 559:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 560:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, (int) 1, yyvsp[0]); }
break;
case 561:
  if (!yytrial)
{ yyval = make_node (nod_drop_difference, (int) 0, NULL); }
break;
case 562:
  if (!yytrial)
{ yyval = make_node (nod_begin_backup, (int) 0, NULL); }
break;
case 563:
  if (!yytrial)
{ yyval = make_node (nod_end_backup, (int) 0, NULL); }
break;
case 564:
  if (!yytrial)
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 566:
  if (!yytrial)
{ yyval = NULL; }
break;
case 568:
  if (!yytrial)
{ yyval = NULL; }
break;
case 569:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 570:
  if (!yytrial)
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 571:
  if (!yytrial)
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 572:
  if (!yytrial)
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 573:
  if (!yytrial)
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 574:
  if (!yytrial)
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 575:
  if (!yytrial)
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 576:
  if (!yytrial)
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 577:
  if (!yytrial)
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 578:
  if (!yytrial)
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 579:
  if (!yytrial)
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 580:
  if (!yytrial)
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 581:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 582:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 583:
  if (!yytrial)
{ yyval = make_node (nod_del_collation, (int) 1, yyvsp[0]); }
break;
case 587:
  if (!yytrial)
{ lex.g_field->fld_not_nullable = true; }
break;
case 590:
  if (!yytrial)
{ lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data; }
break;
case 591:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_full_domain = true;
			}
break;
case 594:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-1]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-3]; }
break;
case 595:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-2]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-4]; }
break;
case 597:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 598:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] < 1)
			 		yyval = make_node (nod_list, (int) 2, 
					MAKE_const_slong ((IPTR) yyvsp[0]),
					MAKE_const_slong (1));
				  else
			 		yyval = make_node (nod_list, (int) 2, 
			   		MAKE_const_slong (1),
					MAKE_const_slong ((IPTR) yyvsp[0]) ); }
break;
case 599:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, 
			 	MAKE_const_slong ((IPTR) yyvsp[-2]),
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 605:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "BIGINT",
					0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "BIGINT",
					0);
			lex.g_field->fld_dtype = dtype_int64; 
			lex.g_field->fld_length = sizeof (SINT64); 
			}
break;
case 606:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_long; 
			lex.g_field->fld_length = sizeof (SLONG); 
			}
break;
case 607:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_short; 
			lex.g_field->fld_length = sizeof (SSHORT); 
			}
break;
case 608:
  if (!yytrial)
{ 
			*stmt_ambiguous = true;
			if (client_dialect <= SQL_DIALECT_V5)
				{
				/* Post warning saying that DATE is equivalent to TIMESTAMP */
					ERRD_post_warning (isc_sqlwarn, isc_arg_number, (SLONG) 301, 
											   isc_arg_warning, isc_dtype_renamed, 0);
				lex.g_field->fld_dtype = dtype_timestamp; 
				lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
				}
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				yyabandon (-104, isc_transitional_date);
			else
				{
				lex.g_field->fld_dtype = dtype_sql_date; 
				lex.g_field->fld_length = sizeof (ULONG);
				}
			}
break;
case 609:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					0);
			lex.g_field->fld_dtype = dtype_sql_time; 
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 610:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_timestamp; 
			lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 613:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			}
break;
case 614:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_sub_type = 0;
			}
break;
case 615:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 616:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_blob; 
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = 80;
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 617:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[0];
		  	}
break;
case 618:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT) 80;
		  	}
break;
case 619:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[0];
			}
break;
case 620:
  if (!yytrial)
{
			lex.g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 621:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT) 0;
			}
break;
case 622:
  if (!yytrial)
{
			lex.g_field->fld_character_set = yyvsp[0];
			}
break;
case 624:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 625:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = 1; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 626:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_varying; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 627:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			}
break;
case 628:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_text; 
			lex.g_field->fld_character_length = 1; 
			}
break;
case 629:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_varying; 
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1]; 
			}
break;
case 638:
  if (!yytrial)
{ 
			  lex.g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 639:
  if (!yytrial)
{  
			   lex.g_field->fld_sub_type = dsc_num_type_decimal;
			   if (lex.g_field->fld_dtype == dtype_short)
				{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 640:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_long; 
				lex.g_field->fld_length = sizeof (SLONG); 
			lex.g_field->fld_precision = 9;
				}
break;
case 641:
  if (!yytrial)
{		 
			if ( ((IPTR) yyvsp[-1] < 1) || ((IPTR) yyvsp[-1] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */ 
			if ((IPTR) yyvsp[-1] > 9)
				{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect	 >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect	 <= SQL_DIALECT_V5) ) )
					ERRD_post (isc_sqlerr,
					   isc_arg_number, (SLONG) -817,
					   isc_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   isc_arg_number, (SLONG) db_dialect,
					   0);
				if (client_dialect <= SQL_DIALECT_V5)
					{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double);
					}
				else
					{
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					isc_arg_end );

					}
				lex.g_field->fld_dtype = dtype_int64;
				lex.g_field->fld_length = sizeof (SINT64);
					}
				}
			else 
				if ((IPTR) yyvsp[-1] < 5)
					{
					lex.g_field->fld_dtype = dtype_short; 
					lex.g_field->fld_length = sizeof (SSHORT); 
					}
				else
					{
					lex.g_field->fld_dtype = dtype_long; 
					lex.g_field->fld_length = sizeof (SLONG); 
					}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 642:
  if (!yytrial)
{ 
			if ( ((IPTR) yyvsp[-3] < 1) || ((IPTR) yyvsp[-3] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */ 
			if (((IPTR) yyvsp[-1] > (IPTR) yyvsp[-3]) || ((IPTR) yyvsp[-1] < 0))
				yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((IPTR) yyvsp[-3] > 9)
				{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect	 >  SQL_DIALECT_V5) ) ||
				 ( (client_dialect >  SQL_DIALECT_V5) &&
				   (db_dialect	 <= SQL_DIALECT_V5) ) )
					ERRD_post (isc_sqlerr,
					   isc_arg_number, (SLONG) -817,
					   isc_arg_gds,
					   isc_ddl_not_allowed_by_db_sql_dial,
					   isc_arg_number, (SLONG) db_dialect,
					   0);
				if (client_dialect <= SQL_DIALECT_V5)
					{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double); 
					}
				else
					{
				if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				  {
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous1,
					isc_arg_end );
					ERRD_post_warning (
					isc_dsql_warn_precision_ambiguous2,
					isc_arg_end );
				  }
				  /* client_dialect >= SQL_DIALECT_V6 */
				lex.g_field->fld_dtype = dtype_int64;
				lex.g_field->fld_length = sizeof (SINT64);
					}
				}
			else
				{
				if ((IPTR) yyvsp[-3] < 5)
					{
					lex.g_field->fld_dtype = dtype_short; 
					lex.g_field->fld_length = sizeof (SSHORT); 
					}
				else
					{
					lex.g_field->fld_dtype = dtype_long; 
					lex.g_field->fld_length = sizeof (SLONG); 
					}
				}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_scale = - (SSHORT)(IPTR) yyvsp[-1];
			}
break;
case 645:
  if (!yytrial)
{ 
			if ((IPTR) yyvsp[0] > 7)
				{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double); 
				}
			else
				{
				lex.g_field->fld_dtype = dtype_real; 
				lex.g_field->fld_length = sizeof (float);
				}
			}
break;
case 646:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_double; 
			lex.g_field->fld_length = sizeof (double); 
			}
break;
case 647:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_real; 
			lex.g_field->fld_length = sizeof (float); 
			}
break;
case 648:
  if (!yytrial)
{ 
			lex.g_field->fld_dtype = dtype_double; 
			lex.g_field->fld_length = sizeof (double); 
			}
break;
case 649:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 650:
  if (!yytrial)
{ yyval = 0; }
break;
case 654:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 655:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 656:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 660:
  if (!yytrial)
{ yyval = make_node (nod_user_savepoint, 1, yyvsp[0]); }
break;
case 661:
  if (!yytrial)
{ yyval = make_node (nod_release_savepoint, 2, yyvsp[-1], yyvsp[0]); }
break;
case 662:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 663:
  if (!yytrial)
{ yyval = 0; }
break;
case 664:
  if (!yytrial)
{ yyval = make_node (nod_undo_savepoint, 1, yyvsp[0]); }
break;
case 667:
  if (!yytrial)
{ yyval = make_node (nod_commit, e_commit_count, yyvsp[0]); }
break;
case 668:
  if (!yytrial)
{ yyval = make_node (nod_rollback, e_rollback_count, yyvsp[0]); }
break;
case 671:
  if (!yytrial)
{ yyval = make_node (nod_retain, 0, NULL); }
break;
case 672:
  if (!yytrial)
{ yyval = NULL; }
break;
case 674:
  if (!yytrial)
{ yyval = NULL; }
break;
case 675:
  if (!yytrial)
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 677:
  if (!yytrial)
{ yyval = NULL; }
break;
case 679:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 686:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 687:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 688:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 689:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 690:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 692:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 693:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 694:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 695:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 696:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 697:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 698:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 699:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 700:
  if (!yytrial)
{ yyval = 0; }
break;
case 701:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_NO_AUTO_UNDO, 0, NULL); }
break;
case 702:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_IGNORE_LIMBO, 0, NULL); }
break;
case 703:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_RESTART_REQUESTS, 0, NULL); }
break;
case 704:
  if (!yytrial)
{ yyval = make_node(nod_lock_timeout, 1, MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 705:
  if (!yytrial)
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 706:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_SHARED; }
break;
case 707:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_PROTECTED ; }
break;
case 708:
  if (!yytrial)
{ yyval = (dsql_nod*) 0; }
break;
case 709:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_READ; }
break;
case 710:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_WRITE; }
break;
case 712:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 713:
  if (!yytrial)
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 714:
  if (!yytrial)
{ yyval = make_flag_node (nod_lock_mode, (SSHORT) ((SSHORT)(IPTR) yyvsp[-1] | (SSHORT)(IPTR) yyvsp[0]), (SSHORT) 0, NULL); }
break;
case 715:
  if (!yytrial)
{ yyval = 0; }
break;
case 717:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 718:
  if (!yytrial)
{ yyval = make_node (nod_set_statistics, (int) e_stat_count, yyvsp[0]); }
break;
case 719:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-2], NULL, NULL, yyvsp[0]); }
break;
case 720:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-3], yyvsp[-2], NULL, yyvsp[0]); }
break;
case 721:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]); }
break;
case 722:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_database); }
break;
case 723:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_domain); }
break;
case 724:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 725:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_view); }
break;
case 726:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 727:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_trigger); }
break;
case 728:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_udf); }
break;
case 729:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_blob_filter); }
break;
case 730:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_exception); }
break;
case 731:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 732:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 733:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_index); }
break;
case 734:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_role); }
break;
case 735:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_charset); }
break;
case 736:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_collation); }
break;
case 737:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 738:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 739:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 741:
  if (!yytrial)
{ yyval = NULL; }
break;
case 742:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) e_select_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 743:
  if (!yytrial)
{ yyval = make_node (nod_for_update, (int) e_fpd_count, yyvsp[0]); }
break;
case 744:
  if (!yytrial)
{ yyval = NULL; }
break;
case 745:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 746:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 747:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 748:
  if (!yytrial)
{ yyval = NULL; }
break;
case 749:
  if (!yytrial)
{ yyval = make_node (nod_select_expr, (int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 750:
  if (!yytrial)
{ yyval = make_flag_node (nod_with, NOD_UNION_RECURSIVE, 1, make_list(yyvsp[0])); }
break;
case 751:
  if (!yytrial)
{ yyval = make_node (nod_with, 1, make_list(yyvsp[0])); }
break;
case 752:
  if (!yytrial)
{ yyval = NULL; }
break;
case 754:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 755:
  if (!yytrial)
{ yyval = make_node (nod_derived_table, (int) e_derived_table_count, yyvsp[-1], yyvsp[-5], yyvsp[-4], NULL); }
break;
case 756:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 757:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE | NOD_SELECT_EXPR_SINGLETON,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 759:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 760:
  if (!yytrial)
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 762:
  if (!yytrial)
{ yyval = make_node (nod_query_spec, (int) e_qry_count, 
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 763:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 764:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, NULL, yyvsp[0]); }
break;
case 765:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], NULL); }
break;
case 766:
  if (!yytrial)
{ yyval = 0; }
break;
case 767:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 768:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 769:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 770:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 771:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 772:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 773:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 774:
  if (!yytrial)
{ yyval = 0; }
break;
case 775:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 776:
  if (!yytrial)
{ yyval = 0; }
break;
case 778:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 780:
  if (!yytrial)
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 783:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 785:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 790:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 791:
  if (!yytrial)
{ yyval = make_node(nod_derived_table, (int) e_derived_table_count, yyvsp[-4], yyvsp[-1], yyvsp[0], NULL); }
break;
case 793:
  if (!yytrial)
{ yyval = NULL; }
break;
case 794:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 795:
  if (!yytrial)
{ yyval = NULL; }
break;
case 797:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 801:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-3],
				make_node (nod_join_inner, (int) 0, NULL), yyvsp[0], NULL); }
break;
case 802:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-2], yyvsp[0],
					make_node (nod_flag, 0, NULL)); }
break;
case 803:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 806:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 807:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 808:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-3], yyvsp[0], yyvsp[-2]); }
break;
case 809:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name, 
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 810:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 811:
  if (!yytrial)
{ yyval = NULL; }
break;
case 813:
  if (!yytrial)
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[-2], yyvsp[0]); }
break;
case 814:
  if (!yytrial)
{ yyval = make_node (nod_relation_name, 
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 815:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 816:
  if (!yytrial)
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 817:
  if (!yytrial)
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 818:
  if (!yytrial)
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 819:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 822:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 823:
  if (!yytrial)
{ yyval = NULL; }
break;
case 825:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 827:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 828:
  if (!yytrial)
{ yyval = NULL; }
break;
case 829:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 830:
  if (!yytrial)
{ yyval = NULL; }
break;
case 831:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 832:
  if (!yytrial)
{ yyval = NULL; }
break;
case 833:
  if (!yytrial)
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 834:
  if (!yytrial)
{ yyval = 0; }
break;
case 835:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 836:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 837:
  if (!yytrial)
{ yyval = 0; }
break;
case 838:
  if (!yytrial)
{ yyval = 0; }
break;
case 840:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 841:
  if (!yytrial)
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 844:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 845:
  if (!yytrial)
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 846:
  if (!yytrial)
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 847:
  if (!yytrial)
{ yyval = make_node (nod_index_order, 2, yyvsp[-1], yyvsp[0]); }
break;
case 849:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 850:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 851:
  if (!yytrial)
{ yyval = 0; }
break;
case 852:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 853:
  if (!yytrial)
{ yyval = 0; }
break;
case 855:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 856:
  if (!yytrial)
{ yyval = make_node (nod_order, (int) e_order_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 857:
  if (!yytrial)
{ yyval = 0; }
break;
case 858:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 859:
  if (!yytrial)
{ yyval = 0; }
break;
case 860:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 861:
  if (!yytrial)
{ yyval = 0; }
break;
case 862:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_FIRST); }
break;
case 863:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_LAST); }
break;
case 864:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count, NULL, yyvsp[0]); }
break;
case 865:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count,
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)),
				make_node (nod_add, 2,
					make_node (nod_subtract, 2, yyvsp[0], yyvsp[-2]),
					MAKE_const_slong (1))); }
break;
case 866:
  if (!yytrial)
{ yyval = NULL; }
break;
case 867:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count, 
				yyvsp[-6], yyvsp[-5], make_list (yyvsp[-2]), NULL, yyvsp[0]); }
break;
case 868:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1], yyvsp[0]); }
break;
case 869:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], NULL, NULL, NULL, yyvsp[0]); }
break;
case 870:
  if (!yytrial)
{
			yyval = make_node(nod_merge, e_mrg_count, yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]);
		}
break;
case 871:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[-1], yyvsp[0]); }
break;
case 872:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], yyvsp[-1]); }
break;
case 873:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], NULL); }
break;
case 874:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, NULL, yyvsp[0]); }
break;
case 875:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 876:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 877:
  if (!yytrial)
{ yyval = make_node(nod_merge_update, e_mrg_update_count, make_list(yyvsp[0])); }
break;
case 878:
  if (!yytrial)
{ yyval = make_node(nod_merge_insert, e_mrg_insert_count, make_list(yyvsp[-4]), make_list(yyvsp[-1])); }
break;
case 881:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 882:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0], NULL); }
break;
case 885:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-7], make_list (yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0], NULL); }
break;
case 886:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-3], make_list (yyvsp[-1]), NULL, NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 887:
  if (!yytrial)
{
			yyval = make_node (nod_update_or_insert, (int) e_upi_count,
				yyvsp[-7], make_list (yyvsp[-6]), make_list (yyvsp[-3]), yyvsp[-1], yyvsp[0]);
		}
break;
case 888:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 889:
  if (!yytrial)
{ yyval = NULL; }
break;
case 890:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[0]), NULL); }
break;
case 891:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[-2]), make_list (yyvsp[0])); }
break;
case 892:
  if (!yytrial)
{ yyval = NULL; }
break;
case 893:
  if (!yytrial)
{ yyval = make_node (nod_cursor, (int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 895:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 896:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], yyvsp[-2]); }
break;
case 897:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 898:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 899:
  if (!yytrial)
{ yyval = make_node (nod_get_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 900:
  if (!yytrial)
{ yyval = make_node (nod_put_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 901:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 902:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 903:
  if (!yytrial)
{ yyval = NULL; }
break;
case 906:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 907:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 908:
  if (!yytrial)
{ yyval = NULL; }
break;
case 909:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 912:
  if (!yytrial)
{ yyval = NULL; }
break;
case 913:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 915:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 917:
  if (!yytrial)
{ yyval = NULL; }
break;
case 918:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 920:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 922:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 923:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], NULL); }
break;
case 924:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 926:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count, 
							yyvsp[-2], yyvsp[0]); }
break;
case 928:
  if (!yytrial)
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 929:
  if (!yytrial)
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 930:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 943:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 944:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 945:
  if (!yytrial)
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 946:
  if (!yytrial)
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 947:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 948:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 949:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 950:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 951:
  if (!yytrial)
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 952:
  if (!yytrial)
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 953:
  if (!yytrial)
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 954:
  if (!yytrial)
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 955:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 956:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 957:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 958:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 959:
  if (!yytrial)
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 960:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 961:
  if (!yytrial)
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 962:
  if (!yytrial)
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 963:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 964:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 965:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 966:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 967:
  if (!yytrial)
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 970:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_equiv, 2, yyvsp[-4], yyvsp[0])); }
break;
case 971:
  if (!yytrial)
{ yyval = make_node (nod_equiv, 2, yyvsp[-5], yyvsp[0]); }
break;
case 972:
  if (!yytrial)
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 973:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_between, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 974:
  if (!yytrial)
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 975:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 976:
  if (!yytrial)
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 977:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 978:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 979:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 980:
  if (!yytrial)
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 981:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 982:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 983:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 984:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 985:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 986:
  if (!yytrial)
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 987:
  if (!yytrial)
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 988:
  if (!yytrial)
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 989:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 990:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (1)); }
break;
case 991:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (2)); }
break;
case 992:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (3)); }
break;
case 994:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 995:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1006:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1007:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1008:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1009:
  if (!yytrial)
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1010:
  if (!yytrial)
{ yyval = make_node (nod_collate, (int) e_coll_count, (dsql_nod*) yyvsp[0], yyvsp[-2]); }
break;
case 1011:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else 
				  yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1012:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				   yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
				   yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1013:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1014:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1015:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1019:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 1020:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 1021:
  if (!yytrial)
{ 
			  yyval = make_node (nod_dom_value, 0, NULL);
						}
break;
case 1024:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "DATE",
					0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "DATE",
					0);
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 1025:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					0);
			yyval = make_node (nod_current_time, 1, yyvsp[0]);
			}
break;
case 1026:
  if (!yytrial)
{ yyval = make_node (nod_current_timestamp, 1, yyvsp[0]); }
break;
case 1027:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[-1]); }
break;
case 1028:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1029:
  if (!yytrial)
{ yyval = make_node (nod_array, (int) e_ary_count, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 1031:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1033:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1035:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1036:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 1037:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 1038:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 1039:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1040:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1042:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1043:
  if (!yytrial)
{ 
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "DATE",
					0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "DATE",
					0);
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DATE);
			}
break;
case 1044:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_dialect_datatype_unsupport,
					isc_arg_number, (SLONG) client_dialect,
					isc_arg_string, "TIME",
					0);
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (isc_sqlerr, isc_arg_number, (SLONG) -104, 
					isc_arg_gds, isc_sql_db_dialect_dtype_unsupport,
					isc_arg_number, (SLONG) db_dialect,
					isc_arg_string, "TIME",
					0);
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIME);
			}
break;
case 1045:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 1046:
  if (!yytrial)
{ yyval = make_parameter (); }
break;
case 1047:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1048:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1049:
  if (!yytrial)
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 1050:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_connection_id)); }
break;
case 1051:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_transaction_id)); }
break;
case 1052:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_gdscode)); }
break;
case 1053:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_sqlcode)); }
break;
case 1054:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_rows_affected)); }
break;
case 1055:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1056:
  if (!yytrial)
{ ((dsql_str*) yyvsp[0])->str_charset = (TEXT *) yyvsp[-1];
			  yyval = yyvsp[0]; }
break;
case 1058:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1059:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_POS_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1060:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_NEG_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1061:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] == 0)
				yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 1062:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_UNSIGNED_MAX)
				yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 1064:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1065:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 1071:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 1072:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 1073:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_count,
									   NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 1074:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 1075:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1076:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 1077:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1078:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1079:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1080:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1081:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1082:
  if (!yytrial)
{ yyval = make_node (nod_agg_list, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1083:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_list, NOD_AGG_DISTINCT, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1084:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1085:
  if (!yytrial)
{ yyval = MAKE_str_constant (MAKE_cstring(","), lex.att_charset); }
break;
case 1086:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1091:
  if (!yytrial)
{ yyval = make_node (nod_extract, (int) e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 1095:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_bit), yyvsp[-1]); }
break;
case 1096:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1097:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1098:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_octet), yyvsp[-1]); }
break;
case 1099:
  if (!yytrial)
{ yyval = make_node(nod_sys_function, e_sysfunc_count, yyvsp[-3], make_list(yyvsp[-1])); }
break;
case 1145:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-6], make_node(nod_list, 3, yyvsp[-4], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1146:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-3], yyvsp[-5], yyvsp[-1]));
		}
break;
case 1147:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1148:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1149:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-9], make_node(nod_list, 4, yyvsp[-7], yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1150:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1151:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-5], make_node(nod_list, 2, yyvsp[-3], yyvsp[-1]));
		}
break;
case 1154:
  if (!yytrial)
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 1155:
  if (!yytrial)
{ yyval = make_node (nod_lowcase, 1, yyvsp[-1]); }
break;
case 1156:
  if (!yytrial)
{ yyval = make_node (nod_substr, (int) e_substr_count, yyvsp[-4],
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)), yyvsp[-1]); }
break;
case 1157:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1158:
  if (!yytrial)
{ yyval = MAKE_const_slong (SHRT_POS_MAX); }
break;
case 1159:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]); }
break;
case 1160:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, 
				MAKE_const_slong (blr_trim_both), yyvsp[-3], yyvsp[-1]); }
break;
case 1161:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-3], NULL, yyvsp[-1]); }
break;
case 1162:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), NULL, yyvsp[-1]); }
break;
case 1163:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_both); }
break;
case 1164:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_trailing); }
break;
case 1165:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_leading); }
break;
case 1166:
  if (!yytrial)
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1167:
  if (!yytrial)
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 1168:
  if (!yytrial)
{ yyval = make_node (nod_cast, (int) e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 1171:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, 
				make_node (nod_list, 2, make_node (nod_eql, 2, yyvsp[-3], yyvsp[-1]), 
				make_node (nod_null, 0, NULL)), yyvsp[-3]); }
break;
case 1172:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, 
				make_node (nod_list, 2, yyvsp[-5], yyvsp[-3]), yyvsp[-1]); }
break;
case 1173:
  if (!yytrial)
{ yyval = make_node (nod_coalesce, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1174:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-3], make_list(yyvsp[-1]), make_node(nod_null, 0, NULL)); }
break;
case 1175:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-5], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1178:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-2], make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1179:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-4], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1180:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1181:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1182:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1183:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1184:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1185:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1189:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1190:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-4], make_node(nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1191:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[0],
						MAKE_const_slong(1));
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[0],
						MAKE_const_slong(1));
			}
break;
case 1192:
  if (!yytrial)
{ 
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 1193:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_year); }
break;
case 1194:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_month); }
break;
case 1195:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_day); }
break;
case 1196:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_hour); }
break;
case 1197:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_minute); }
break;
case 1198:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_second); }
break;
case 1199:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_millisecond); }
break;
case 1200:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_week); }
break;
case 1201:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_weekday); }
break;
case 1202:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_yearday); }
break;
case 1207:
  if (!yytrial)
{ yyval = make_node (nod_null, 0, NULL); }
break;

  default:
    break;
  }

#if YYDEBUG && defined(YYDBPR)
  if (yydebug) {
    printf("yydebug[%d]: after reduction, result is ", yytrial);
    YYDBPR(yyps->val);
    printf("\n");
  }
#endif

  // Perform user-defined position reduction
#ifdef YYREDUCEPOSNFUNC
  if(!yytrial) {
    YYCALLREDUCEPOSN(YYREDUCEPOSNFUNCARG);
  }
#endif

  yyps->ssp -= yym;
  yystate = *(yyps->ssp);
  yyps->vsp -= yym;
  yyps->psp -= yym;

  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0) {
#if YYDEBUG
    if (yydebug) {
      printf("yydebug[%d,%p]: after reduction, shifting from state 0 to state %d\n", 
	     int(yydepth), yytrial, YYFINAL);
    }
#endif
    yystate = YYFINAL;
    *++(yyps->ssp) = YYFINAL;
    *++(yyps->vsp) = yyps->val;
    yyretlval = yyps->val;	// return value of root non-terminal to yylval
    *++(yyps->psp) = yyps->pos;
    yyretposn = yyps->pos;	// return value of root position to yyposn
    if (yychar < 0) {
      if ((yychar = YYLex1(client_dialect, db_dialect, parser_version, stmt_ambiguous)) < 0) {
        yychar = 0;
      }
#if YYDEBUG
      if (yydebug) {
        yys = 0;
        if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
        if (!yys) yys = "illegal-symbol";
        printf("yydebug[%d,%p]: state %d, reading %d (%s)\n", 
	       int(yydepth), yytrial, YYFINAL, yychar, yys); 
      }
#endif
    }
    if (yychar == 0) goto yyaccept;
    goto yyloop;
  }

  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate) {
    yystate = yytable[yyn];
  } else {
    yystate = yydgoto[yym];
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: after reduction, shifting from state %d to state %d\n",
           int(yydepth), yytrial, *(yyps->ssp), yystate);
#endif
  if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
    YYMoreStack(yyps);
  }
  *++(yyps->ssp) = yystate;
  *++(yyps->vsp) = yyps->val;
  *++(yyps->psp) = yyps->pos;
  goto yyloop;


  //
  // Reduction declares that this path is valid.
  // Set yypath and do a full parse
  //
yyvalid:
  if (yypath) {
    goto yyabort;
  }
  while (yyps->save) {
    yyparsestate *save = yyps->save;
    yyps->save = save->save;
    save->save = yypath;
    yypath = save;
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: CONFLICT trial successful, backtracking to state %d, %d tokens\n",
           int(yydepth), yytrial, yypath->state, int(yylvp - yylvals - yypath->lexeme));
#endif
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  yychar = -1;
  yyps->ssp = yyps->ss + (yypath->ssp - yypath->ss);
  yyps->vsp = yyps->vs + (yypath->vsp - yypath->vs);
  yyps->psp = yyps->ps + (yypath->psp - yypath->ps);
  memcpy (yyps->ss, yypath->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
  YYSCopy(yyps->vs, yypath->vs,  yyps->vsp - yyps->vs + 1);
  YYPCopy(yyps->ps, yypath->ps,  yyps->psp - yyps->ps + 1);
  yylvp = yylvals + yypath->lexeme;
  yylpp = yylpsns + yypath->lexeme;
  yylexp = yylexemes + yypath->lexeme;
  yystate = yypath->state;
  goto yyloop;


yyabort:
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }

  YYSTYPE *pv;
  for(pv=yyps->vs; pv<yyps->vsp; pv++) {
    YYDELETEVAL(*pv,2);
  }

  YYPOSN *pp;
  for(pp=yyps->ps; pp<yyps->psp; pp++) {
    YYDELETEPOSN(*pp,2);
  }

  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (1);


yyaccept:
  if (yyps->save) goto yyvalid;
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (0);
}


int YYLex1(USHORT client_dialect, USHORT db_dialect, USHORT parser_version, bool* stmt_ambiguous) {
  if(yylvp<yylve) {
    yylval = *yylvp++;
    yyposn = *yylpp++;
    return *yylexp++;
  } else {
    if(yyps->save) {
      if(yylvp==yylvlim) {
	yyexpand();
      }
      *yylexp = yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
      *yylvp++ = yylval;
      yylve++;
      *yylpp++ = yyposn;
      yylpe++;
      return *yylexp++;
    } else {
      return yylex(client_dialect, db_dialect, parser_version, stmt_ambiguous);
    }
  }
}

int yyexpand() {
  int p = yylvp-yylvals;
  int s = yylvlim-yylvals;
  s += YYSTACKGROWTH;
  { Yshort  *tl = yylexemes; 
    YYSTYPE *tv = yylvals;
    YYPOSN  *tp = yylpsns;
    yylvals = new YYSTYPE[s];
    yylpsns = new YYPOSN[s];
    yylexemes = new Yshort[s];
    memcpy(yylexemes, tl, (s-YYSTACKGROWTH)*sizeof(Yshort));
    YYSCopy(yylvals, tv, s-YYSTACKGROWTH);
    YYPCopy(yylpsns, tp, s-YYSTACKGROWTH);
    delete[] tl;
    delete[] tv;
    delete[] tp;
  }
  yylvp = yylve = yylvals + p;
  yylvlim = yylvals + s;
  yylpp = yylpe = yylpsns + p;
  yylplim = yylpsns + s;
  yylexp = yylexemes + p;
  return 0;
}

void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYPCopy(YYPOSN *to, YYPOSN *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYMoreStack(yyparsestate *yyps) {
  int p = yyps->ssp - yyps->ss;                               
  Yshort  *tss = yyps->ss;
  YYSTYPE *tvs = yyps->vs;
  YYPOSN  *tps = yyps->ps;
  yyps->ss = new Yshort [yyps->stacksize + YYSTACKGROWTH];   
  yyps->vs = new YYSTYPE[yyps->stacksize + YYSTACKGROWTH];  
  yyps->ps = new YYPOSN [yyps->stacksize + YYSTACKGROWTH];  
  memcpy(yyps->ss, tss, yyps->stacksize * sizeof(Yshort));  
  YYSCopy(yyps->vs, tvs, yyps->stacksize);                  
  YYPCopy(yyps->ps, tps, yyps->stacksize);                  
  yyps->stacksize += YYSTACKGROWTH;                           
  delete[] tss;
  delete[] tvs;
  delete[] tps;
  yyps->ssp = yyps->ss + p;                                   
  yyps->vsp = yyps->vs + p;                                   
  yyps->psp = yyps->ps + p;                                   
}

yyparsestate *YYNewState(int size) {
  yyparsestate *p = new yyparsestate;
  p->stacksize = size+4;
  p->ss = new Yshort [size + 4];
  p->vs = new YYSTYPE[size + 4];
  p->ps = new YYPOSN [size + 4];
  memset(&p->vs[0], 0, (size+4)*sizeof(YYSTYPE));
  memset(&p->ps[0], 0, (size+4)*sizeof(YYPOSN));
  return p;
}

void YYFreeState(yyparsestate *p) {
  delete[] p->ss;
  delete[] p->vs;
  delete[] p->ps;
  delete p;
}
